define([
        "dojo",
        "dijit"
    ], function(dojo, dijit) {

    return dojo.declare("support.base.NameCheckMixin", null, {
        
        // these properties are intended to disallow saving any template with
        //   a name that already exists in the backend for the specified type

        // Check name of dialog or panel on save or create
        //type: ex. (template, ip pool, profile etc..)
       //subtype: ex. (Power, SystemInfo, etc...)
       //newName: ex. (New name trying to save)                
       dupNameChecker: function(type,subtype,newName){
           
           this.templateName.validator = function(value,constraints){ //Sets validator to false to send               
               return false;                                          //to send back if name found
           };
           
           if(this._getNames(type,subtype,newName)){   //Gets returned true if dup name found               
               this.templateName.invalidMessage = "A template with this name already exist.";                
               this.templateName.validator();  //Calls validator to return false because dup name found           
               this.templateName.focus(); //Sets focus to the name field
               
               this.templateName.validator = dojo.hitch(this,function(value,constraints){ //resets validator to 
                                                                                          //check for empty name field         
                   if(this.templateName.get("value").trim() == ""){
                       this.templateName.invalidMessage = "This value is required.";
                       return false;
                   }
                   
                   return true;
               });     
               
               return true;   //return true that a duplicate name was found
           }

           return false; //return false is a duplicate name was not found
           
       },
       //Called by dupName Checker, returns true is duplicate name found
       _getNames: function(type,subtype,newName){
         var nameFound = false; //Return value for found name
         var restExt = ""; //Rest call ext to get names
         var nameCount; //Number of names to loop through
         var counter;  //Loop control var
         
         if(type == "template"){       //if type type template 
             restExt = "template/list/"+subtype;
         }
                                 
         var xhrGet = dojo.xhrGet({   //Get list of names
             url: this.REST_PATH + restExt,
             handleAs: "json",
             sync: true,
             preventCache: true,
             load: function(response) {
                 this.store = response;
             },
             handle: function() {
                 templateStore = this.store;
             }
         });
            
         
         if (type == "template") {      //loop through names and break loop if dup name found
              namecount = templateStore.items.length;
              for(counter =0;counter < namecount;counter++){
                  if(newName == templateStore.items[counter].name){
                      nameFound = true;
                      break;
                  }
              }
         }
         
        // console.debug(namesArray);
/*            else if (type = "") {
             name.set("value", templateStore.items[0].profileName);
         }
         else {
             name.set("value", templateStore.items[0].name);
         }

         this.currentname = this.name.get("value").trim();
*/
         return nameFound;   //returns true if dup name found, else returns false
         
     }

    });
});