define([
        "dojo",
        "dijit",
        "support/dialogs/Dialog",
        "dojo/i18n!./nls/ManagementInterfaceTemplate",
        "dojo/text!./templates/ChassisManagementInterfaceTemplate.html",
        "dijit/Tooltip",
        "dijit/layout/BorderContainer",
        "dijit/layout/ContentPane",
        "dijit/form/Button",
        "dijit/form/CheckBox",
        "dijit/form/Form",
        "dijit/form/NumberTextBox",
        "dijit/form/RadioButton",
        "support/widgets/Select",
        "dijit/form/SimpleTextarea",
        "dojo/data/ItemFileReadStore",
        "support/panels/CheckLabelButton",
        "support/widgets/ButtonBar",
        "support/panels/EnhancedTable",
        "support/panels/SimpleTable",
        "support/panels/CheckButton",
        "support/widgets/OutlinePane",
        "support/dialogs/NewIPPool",
        "support/dialogs/ReDeployServerTemplate",
        "support/temp/ModalDialog",
        "support/panels/CustomNamingTable",
        "support/dialogs/SaveAs",
        "support/dialogs/ProgressDialog"
    ], function(dojo, dijit, dialog, mri, template) {

    return dojo.declare("support.dialogs.ChassisManagementInterfaceTemplate", [ support.dialogs.Dialog ], {

        // templateString: [protected] String
        // This widget's HTML template, provided.
        templateString: template,
    
        // locResources: [protected] Object
        // This widget's National Language Source (NLS) object.
        locResources: mri,
    
        widgetsInTemplate: true,
    
        // baseClass: [protected] String
        // The root CSS className to be placed on this widget's domNode.
        baseClass: "ManagementInterfaceTemplate",
    
        templateIDNum: null,

        _ipv4selectbox: null,
        _ipv6selectbox: null,
        _ipv4rangeselectbox: null,
        _ipv6rangeselectbox: null,
        _ipv4store: null,
        _ipv6store: null,
        _ipv4rangestore: null,
        _ipv6rangestore: null,
        _ipv4addndnstable: null,
        _ipv6addndnstable: null,
        maxPercent: .35,
        _ipv4rangedefault: "any",
        _ipv6rangedefault: "any",
        _mtutooltip_2: null,
        _mtutooltip_3: null,
        _customnametable: null,
        _isCustomNamePatternValid: true,
        _hostnametooltip: null,
        _ippoolListData: null,
        _portRange: null,
        autogenchecklabelbutton: null,
        ipv4checklabelbutton: null,
        ipv6checklabelbutton: null,
        dnssearchchecklabelbutton: null,
        addndnschecklabelbutton: null,
        mtuchecklabelbutton: null,
        httpchecklabelbutton: null,
        httpschecklabelbutton: null,
        telnetclichecklabelbutton: null,
        sshclichecklabelbutton: null,
        snmpagentchecklabelbutton: null,
        snmptrapschecklabelbutton: null,
        cimhttpschecklabelbutton: null,
        initialData: null,

        // the name of the CSS stylesheet of this page
        spCssPathAndName: "support/dialogs/themes/ChassisManagementInterfaceTemplate.css",

        // When this method is called, all variables inherited from
        // superclasses
        // are "mixed in".
        // Common operations for postMixInProperties
        // 1) Modify or assign values for widget property variables defined
        // in
        // the template HTML file
        postMixInProperties: function() {

            this.inherited(arguments);

            //this._mtutooltip_2 = this.locResources.MTUTOOLTIP_2.replace("%1", 68).replace("%2", 1500);
            //this._mtutooltip_3 = this.locResources.MTUTOOLTIP_3.replace("%1", 1280).replace("%2", 1500);
            this._hostnametooltip = this.locResources.HOSTNAMETOOLTIP_2.replace("%1", 63).replace("%2", this.locResources.CMM).replace("%3", 63);
            this._portRange = this.locResources.INVALID_NUMBER_BETWEEN.replace("%1", "1").replace("%2", "65535");

        },

        // postCreate() is called after buildRendering(). This is useful to
        // override when
        // you need to access and/or manipulate DOM nodes included with your
        // widget.
        // DOM nodes and widgets with the dojoAttachPoint attribute
        // specified
        // can now be
        // directly
        // accessed as fields on "this".
        // Common operations for postCreate
        // 1) Access and manipulate DOM nodes created in buildRendering()
        // 2) Add new DOM nodes or widgets
        postCreate: function() {

            this.inherited(arguments);              
        
            this._createCheckLabelButtons();

//            var availHeight = window.screen.availHeight;
//            var maxHeight = availHeight * this.maxPercent;
//            this.ethSettingsPane.setAttribute("style", "max-height:" + maxHeight + "px");

            this._connectCheckLabelButtonFunctions();
            this._getIPPooldata();
            this._createSelectBoxes();
            this._setDefaults();

            if (this.templateIDNum != null) {
                this._readSettingsFromService();

                // Setup for template new, edit, or copy mode
                this._setup();

            }
            else {

                // Setup for template new, edit, or copy mode
                this._setup();
                
                this._ipv4addndnstable = new support.panels.EnhancedTable(
                        {
                            id: this.get("id") + "_ipv4table",
                            max: 3,
                            addPosition: "left",
                            label: this.resources.IPV4,
                            placeHolder: "0.0.0.0",
                            addTitle: this.locResources.ADDTITLE,
                            removeTitle: this.locResources.REMOVETITLE,
                            regExp: "^([0-9]|[0-9][0-9]|[0-1][0-9][0-9]|2[0-4][0-9]|25[0-5])(\.([0-9]|[0-9][0-9]|[0-1][0-9][0-9]|2[0-4][0-9]|25[0-5])){3}$",
                            invalidMessage: this.locResources.IPV4INVALIDMESSAGE
                        }, this.get("id") + "_ipv4table");
                this._ipv6addndnstable = new support.panels.EnhancedTable(
                        {
                            id: this.get("id") + "_ipv6table",
                            addPosition: "left",
                            max: 3,
                            label: this.resources.IPV6,
                            placeHolder: "0::0",
                            addTitle: this.locResources.ADDTITLE,
                            removeTitle: this.locResources.REMOVETITLE,
                            regExp: "^\s*((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))(%.+)?\s*$",
                            invalidMessage: this.locResources.IPV6INVALIDMESSAGE
                        }, this.get("id") + "_ipv6table");
    
                this._selectall();
            }
    
            dojo.connect(this.dialogNode, "hide", this, function() {
                this.destroy();
            });
    
            this.subscribe("rowadded", function() {
                this._enableOk();
            });
            
            
            this.subscribe("customNamePattern", function(data) {               
                if (data == "none") {
                    this._isCustomNamePatternValid = false;                        
                    this._enableOk();              
                } else {
                    this._isCustomNamePatternValid = true;
                    this._enableOk();
                }
            });     

            this.subscribe("ippoolComplete", function(data) {
                if (isNaN(data) == true) {
                    data = this._ipv4selectbox.get("value");
                }
                
                var ipv6SelectedPool = this._ipv6selectbox.get("value");

                this._getIPPooldata();

                var responsedata = null;
                var xhrGet = dojo.xhrGet({
                    url: this.REST_PATH + "ippool/" + data,
                    handleAs: "json",
                    preventCache: true,
                    sync: true,
                    load: function(response) {
                        // alert(dojo.toJson(response));
                        responsedata = response;
                    },
                    error: function(error) {
                        //console.error(this.declaredClass + ": " + this.locResources.ERRORSERVICE + " " + error);
                        // Probably need to mock up some dummy data here
                    }

                });
                
                // Clear pool selection
                this._ipv6selectbox.set("value", "noselected");

                if (responsedata && responsedata.protocol == "IPv4") {
                    this._ipv4selectbox.setStore(this._ipv4store);
                    this._ipv4selectbox.addOption({
                        value: "noselected",
                        label: "&mdash; " + this.locResources.NOPOOLSELECTED + " &mdash;",
                        selected: true
                    });
                    this._ipv4selectbox.set("value", data);
                    this._ipv4selectbox.set("disabled", false);
                    this._ipv4rangeselectbox.set("disabled", false);
                }
                else {
                    this._ipv6selectbox.setStore(this._ipv6store);
                    this._ipv6selectbox.addOption({
                        value: "noselected",
                        label: "&mdash; " + this.locResources.NOPOOLSELECTED + " &mdash;",
                        selected: true
                    });
                    this._ipv6selectbox.set("value", data);
                    this._ipv6selectbox.set("disabled", false);
                    this._ipv6rangeselectbox.set("disabled", false);
                }
                
                if (this._ipv6selectbox.get("value") == "noselected") {
                    // Select previously selected pool
                    this._ipv6selectbox.set("value", ipv6SelectedPool);
                }
            });
        },
  
        _createCheckLabelButtons: function() {
            // Create the button bar
            var buttonProperties = {};
            
            buttonProperties["values"] = this.resources.CUSTOM + "|" + this.resources.DISABLE;
            
            this.autogenchecklabelbutton = new support.panels.CheckLabelButton({
                labelValue: this.locResources.AUTOGEN,
                buttonType: "support.widgets.ButtonBar",
                buttonProps: buttonProperties,
                toolTip: this.locResources.HOSTNAMETOOLTIP_1 + " <br /><br />" + this._hostnametooltip,
                onClick: dojo.hitch(this, this._hostnameButtonBarClicked)
            }).placeAt(this.autogenchecklabelbuttondiv);

            var buttonProperties2 = {};
            
            buttonProperties2["values"] = this.resources.ENABLE + "|" + this.resources.NO_CHANGE;
            buttonProperties2["titles"] = "|" + this.resources.NOCHANGE_TOOLTIP;
            
            this.ipv4checklabelbutton = new support.panels.CheckLabelButton({
                labelValue: this.resources.IPV4,
                buttonType: "support.widgets.ButtonBar",
                buttonProps: buttonProperties2,
                infoTip: this.locResources.RESTARTTIP
            }).placeAt(this.ipv4checklabelbuttondiv);
            
            var buttonProperties3 = {};
            
            buttonProperties3["values"] = this.resources.ENABLE + "|" + this.resources.NO_CHANGE;
            buttonProperties3["titles"] = "|" + this.resources.NOCHANGE_TOOLTIP;
            
            this.ipv6checklabelbutton = new support.panels.CheckLabelButton({
                labelValue: this.resources.IPV6,
                buttonType: "support.widgets.ButtonBar",
                buttonProps: buttonProperties3
            }).placeAt(this.ipv6checklabelbuttondiv);
            
            var buttonProperties4 = {};
            
            buttonProperties4["values"] = this.resources.IPV4 + "|" + this.resources.IPV6;
            buttonProperties4["titles"] = this.locResources.SEARCHIPV4 + "|" + "search ipv6";
            
            this.dnssearchchecklabelbutton = new support.panels.CheckLabelButton({
                labelValue: this.locResources.DNSSEARCHPREFERENCE,
                buttonType: "support.widgets.ButtonBar",
                buttonProps: buttonProperties4
            }).placeAt(this.dnssearchchecklabelbuttondiv);
            
            var buttonProperties5 = {};
            
            buttonProperties5["values"] = this.locResources.LIST + "|" + this.locResources.NONE;
            
            this.addndnschecklabelbutton = new support.panels.CheckLabelButton({
                labelValue: this.locResources.ADDITIONALDNSSERVERS,
                buttonType: "support.widgets.ButtonBar",
                buttonProps: buttonProperties5
            }).placeAt(this.addndnschecklabelbuttondiv);
            
            //  Function returns CheckLabelButton object
            this.mtuchecklabelbutton = this._createCheckLabelButtonNumberTextBox(
                     this.locResources.MTU,             // labelValue
                     1500,                              // value
                     null,                              // intermediateChanges
                     null,                              // required
                     "1500",                            // placeHolder
                     {min:68,max:1500,places:0},        // constraints 
                     this.locResources.MTUTOOLTIP_1,    // promptMessage
                     this.locResources.MTUTOOLTOP_1,    // rangeMessage
                     "width:125px;");                   // style
            
            this.mtuchecklabelbutton.placeAt(this.mtuchecklabelbuttondiv);
            
            //  Function returns CheckLabelButton object
            this.httpchecklabelbutton = this._createCheckLabelButtonNumberTextBox(
                     this.locResources.HTTP,            // labelValue
                     80,                                // value
                     true,                              // intermediateChanges
                     true,                              // required
                     "80",                              // placeHolder
                     {min:1,max:65535,places:0},        // constraints 
                     null,                              // promptMessage
                     this._portRange,                   // rangeMessage
                     "width:125px;");                   // style
            
            this.httpchecklabelbutton.set("checkedState", true);
            this.httpchecklabelbutton.set("labelColumnWidth", "200px");
            dojo.connect(this.httpchecklabelbutton, "onChange", this, this._enableOk);
            this.httpchecklabelbutton.placeAt(this.httpchecklabelbuttondiv);
            
            //  Function returns CheckLabelButton object
            this.httpschecklabelbutton = this._createCheckLabelButtonNumberTextBox(
                     this.locResources.HTTPS,           // labelValue
                     443,                                // value
                     true,                              // intermediateChanges
                     true,                              // required
                     "443",                              // placeHolder
                     {min:1,max:65535,places:0},        // constraints 
                     null,                              // promptMessage
                     this._portRange,                   // rangeMessage
                     "width:125px;");                   // style
            
            this.httpschecklabelbutton.set("checkedState", true);
            this.httpschecklabelbutton.set("labelColumnWidth", "200px");
            dojo.connect(this.httpschecklabelbutton, "onChange", this, this._enableOk);
            this.httpschecklabelbutton.placeAt(this.httpschecklabelbuttondiv);
            
            //  Function returns CheckLabelButton object
            this.telnetclichecklabelbutton = this._createCheckLabelButtonNumberTextBox(
                     this.locResources.TELNETCLI,       // labelValue
                     23,                                // value
                     true,                              // intermediateChanges
                     true,                              // required
                     "23",                              // placeHolder
                     {min:1,max:65535,places:0},        // constraints 
                     null,                              // promptMessage
                     this._portRange,                   // rangeMessage
                     "width:125px;");                   // style
            
            this.telnetclichecklabelbutton.set("checkedState", true);
            this.telnetclichecklabelbutton.set("labelColumnWidth", "200px");
            dojo.connect(this.telnetclichecklabelbutton, "onChange", this, this._enableOk);
            this.telnetclichecklabelbutton.placeAt(this.telnetclichecklabelbuttondiv);
            
            //  Function returns CheckLabelButton object
            this.sshclichecklabelbutton = this._createCheckLabelButtonNumberTextBox(
                     this.locResources.SSHCLI,          // labelValue
                     22,                                // value
                     true,                              // intermediateChanges
                     true,                              // required
                     "22",                              // placeHolder
                     {min:1,max:65535,places:0},        // constraints 
                     null,                              // promptMessage
                     this._portRange,                   // rangeMessage
                     "width:125px;");                   // style
            
            this.sshclichecklabelbutton.set("checkedState", true);
            this.sshclichecklabelbutton.set("labelColumnWidth", "200px");
            dojo.connect(this.sshclichecklabelbutton, "onChange", this, this._enableOk);
            this.sshclichecklabelbutton.placeAt(this.sshclichecklabelbuttondiv);
            
            //  Function returns CheckLabelButton object
            this.snmpagentchecklabelbutton = this._createCheckLabelButtonNumberTextBox(
                     this.locResources.SNMPAGENT,          // labelValue
                     161,                                // value
                     true,                              // intermediateChanges
                     true,                              // required
                     "161",                              // placeHolder
                     {min:1,max:65535,places:0},        // constraints 
                     null,                              // promptMessage
                     this._portRange,                   // rangeMessage
                     "width:125px;");                   // style
            
            this.snmpagentchecklabelbutton.set("checkedState", true);
            this.snmpagentchecklabelbutton.set("labelColumnWidth", "200px");
            dojo.connect(this.snmpagentchecklabelbutton, "onChange", this, this._enableOk);
            this.snmpagentchecklabelbutton.placeAt(this.snmpagentchecklabelbuttondiv);
            
            //  Function returns CheckLabelButton object
            this.snmptrapschecklabelbutton = this._createCheckLabelButtonNumberTextBox(
                     this.locResources.SNMPTRAPS,          // labelValue
                     162,                                // value
                     true,                              // intermediateChanges
                     true,                              // required
                     "162",                              // placeHolder
                     {min:1,max:65535,places:0},        // constraints 
                     null,                              // promptMessage
                     this._portRange,                   // rangeMessage
                     "width:125px;");                   // style
            
            this.snmptrapschecklabelbutton.set("checkedState", true);
            this.snmptrapschecklabelbutton.set("labelColumnWidth", "200px");
            dojo.connect(this.snmptrapschecklabelbutton, "onChange", this, this._enableOk);
            this.snmptrapschecklabelbutton.placeAt(this.snmptrapschecklabelbuttondiv);
            
            //  Function returns CheckLabelButton object
            this.cimhttpschecklabelbutton = this._createCheckLabelButtonNumberTextBox(
                     this.locResources.CIMHTTPS,          // labelValue
                     5989,                                // value
                     true,                              // intermediateChanges
                     true,                              // required
                     "5989",                              // placeHolder
                     {min:1,max:65535,places:0},        // constraints 
                     null,                              // promptMessage
                     this._portRange,                   // rangeMessage
                     "width:125px;");                   // style
            
            this.cimhttpschecklabelbutton.set("checkedState", true);
            this.cimhttpschecklabelbutton.set("labelColumnWidth", "200px");
            dojo.connect(this.cimhttpschecklabelbutton, "onChange", this, this._enableOk);
            this.cimhttpschecklabelbutton.placeAt(this.cimhttpschecklabelbuttondiv);            
        },
        
        // Parameters:
        // labelValue: string (translated)
        // value: numeric
        // intermediateChanges: boolean
        // required
        // placeHolder: string
        // constraints: object {min: , max:, places: }
        // promptMessage: string
        // rangeMessage: string
        // style:  string
        // Properties will not be set in map if null
        _createCheckLabelButtonNumberTextBox: function(labelValue, value, intermediateChanges, required, placeHolder, constraints, promptMessage, rangeMessage, style){
            var buttonProperties = {};           
            if (value) {
                buttonProperties["value"] = value;
            }            
            if (intermediateChanges != null) {
                buttonProperties["intermediateChanges"] = intermediateChanges;
            }            
            if (required != null) {
                buttonProperties["required"] = required;
            }
            if (placeHolder) {
                buttonProperties["placeHolder"] = placeHolder;
            }            
            if (constraints) {
                buttonProperties["constraints"] = constraints;
            }
            if (promptMessage) {
                buttonProperties["promptMessage"] = promptMessage;
            }
            if (rangeMessage) {
                buttonProperties["rangeMessage"] = rangeMessage;
            }
            if (style) {
                buttonProperties["style"] = style;
            }
            
            var checkLabelButton = new support.panels.CheckLabelButton({
                labelValue: labelValue,
                buttonType: "dijit.form.NumberTextBox",
                buttonProps: buttonProperties
            });
            
            return checkLabelButton;
            
        },

        _connectCheckLabelButtonFunctions: function() {
            dojo.connect(this.autogenchecklabelbutton, "onClick", this, function(evt) {
                this._toggleAutoGenHostname();
                this.layout();
            });
            dojo.connect(this.ipv4checklabelbutton, "onClick", this, 
                    function(evt) {
                        this._toggleMgmtIPAddrSettings();
                        this.layout();
                    });
            dojo.connect(this.ipv4checklabelbutton, "onButtonClick", this, 
                    function(evt) {
                        this._toggleMgmtIPAddrSettings();
                    });
            dojo.connect(this.ipv6checklabelbutton, "onClick", this, 
                    function(evt) {
                        this._toggleMgmtIPAddrSettings();
                        this.layout();
                });
            dojo.connect(this.ipv6checklabelbutton, "onButtonClick", this, 
                    function(evt) {
                        this._toggleMgmtIPAddrSettings();
                });
            dojo.connect(this.dnssearchchecklabelbutton, "onClick", this, function(evt) {
                this._toggleDNSSettings();
                this.layout();
            });
            dojo.connect(this.addndnschecklabelbutton, "onClick", this, function(evt) {
                this._toggleDNSSettings();
                this.layout();
            });
            dojo.connect(this.addndnschecklabelbutton, "onButtonClick", this, function(evt) {
                this._toggleDNSSettings();
            });
            dojo.connect(this.ddnschecklabelbutton, "onClick", this, function(evt) {
                this._toggleDNSSettings();
                this.layout();
            });
            dojo.connect(this.ddnschecklabelbutton, "onButtonClick", this, function(evt) {
                this._toggleDNSSettings();
            });
  /*          dojo.connect(this.ifspeedchecklabelbutton, "onClick", this, function(evt) {
                this._toggleInterfaceSpeedSettings();
                this.layout();
            });
            dojo.connect(this.ifspeedchecklabelbutton, "onButtonClick", this, function(evt) {
                this._toggleInterfaceSpeedSettings();
            });
            dojo.connect(this.mtuchecklabelbutton, "onClick", this, function(evt) {
                this._toggleInterfaceSpeedSettings();
                this.layout();
            });*/
            dojo.connect(this.mtuchecklabelbutton, "onChange", this, function(evt) {
                this._enableOk();
                this.layout();
            });
        },

        _createSelectBoxes: function() {
            this._ipv4selectbox = new support.widgets.Select({
                name: this.get("id") + "_ipv4Select",
                store: this._ipv4store,
                maxHeight: -1,
                emptyLabel: "&mdash; " + this.locResources.NOPOOLDEFINED + " &mdash;",
                disabled: true
            }, this.get("id") + "_ipv4Select");
            this._ipv4selectbox.startup();

            if (this._ipv4selectbox.get("value") != "") {
                this._ipv4selectbox.addOption({
                    value: "noselected",
                    label: "&mdash; " + this.locResources.NOPOOLSELECTED + " &mdash;",
                    selected: true
                });
            }
            this._ipv4selectbox.set("value", "noselected");

            dojo.connect(this._ipv4selectbox, "onChange", this, function() {
                this._setIPRangeSelect("IPv4", this._ipv4rangedefault);                                        
                if (this._ipv4selectbox.get("value") == "noselected") {
                    this._ipv4rangeselectbox.set("disabled", true);
                    dojo.replaceClass(this.ipv4editicon, "spEditInactiveIcon_v2", "spEditIcon_v2");
                }
                else {
                    this._ipv4rangeselectbox.set("disabled", false);
                    dojo.replaceClass(this.ipv4editicon, "spEditIcon_v2", "spEditInactiveIcon_v2");
                }
            });
            
            this._ipv4rangeselectbox = new support.widgets.Select({
                name: this.get("id") + "_ipv4RangeSelect",
                store: this._ipv4rangestore,
                maxHeight: -1,
                emptyLabel: "&mdash; " + this.locResources.NOPOOLSELECTED + " &mdash;",
                disabled: true
            }, this.get("id") + "_ipv4RangeSelect");
            this._ipv4rangeselectbox.startup();

            this._ipv6selectbox = new support.widgets.Select({
                name: this.get("id") + "_ipv6Select",
                store: this._ipv6store,
                maxHeight: -1,
                emptyLabel: "&mdash; " + this.locResources.NOPOOLDEFINED + " &mdash;",
                disabled: true
            }, this.get("id") + "_ipv6Select");
            this._ipv6selectbox.startup();

            if (this._ipv6selectbox.get("value") != "") {
                this._ipv6selectbox.addOption({
                    value: "noselected",
                    label: "&mdash; " + this.locResources.NOPOOLSELECTED + " &mdash;",
                    selected: true
                });
            }

            this._ipv6selectbox.set("value", "noselected");

            dojo.connect(this._ipv6selectbox, "onChange", this, function() {
                this._setIPRangeSelect("IPv6", this._ipv6rangedefault);

                if (this._ipv6selectbox.get("value") == "noselected") {
                    this._ipv6rangeselectbox.set("disabled", true);
                    dojo.replaceClass(this.ipv6editicon, "spEditInactiveIcon_v2", "spEditIcon_v2");
                }
                else {
                    this._ipv6rangeselectbox.set("disabled", false);
                    dojo.replaceClass(this.ipv6editicon, "spEditIcon_v2", "spEditInactiveIcon_v2");
                }
            });

            this._ipv6rangeselectbox = new support.widgets.Select({
                name: this.get("id") + "_ipv6RangeSelect",
                store: this._ipv6rangestore,
                emptyLabel: "&mdash; " + this.locResources.NOPOOLSELECTED + " &mdash;",
                maxHeight: -1
            }, this.get("id") + "_ipv6RangeSelect");
            this._ipv6rangeselectbox.startup();
        },

        _setIPRangeSelect: function(type, rangedefault) {
            var ipv4selectvalue = this._ipv4selectbox.get("value");
            var ipv4rangedata = null;
            var ipv6selectvalue = this._ipv6selectbox.get("value");
            var ipv6rangedata = null;

            if (rangedefault == null) {
                rangedefault = "any";
            }
            var response = this._ippoolListData;
            var count;
            var ipv4data = {
                    "identifier": "id",
                    "label": "name",
                    "items": []
            };
            var ipv6data = {
                    "identifier": "id",
                    "label": "name",
                    "items": []
            };
            for (count = 0; count < response.items.length; ++count) {
                if (response.items[count].protocol == "IPv4") {
                    ipv4data.items.push(response.items[count]);
                }
                if (response.items[count].protocol == "IPv6") {
                    ipv6data.items.push(response.items[count]);
                }
            }
            var ippoolcount = 0;
            var rangeheader = {
                    "identifier": "id",
                    "label": "name",
                    "items": []
            };
            for (ippoolcount = 0; ippoolcount < ipv4data.items.length; ++ippoolcount) {
                var rangecount = 0;
                if (ipv4data.items[ippoolcount].id == ipv4selectvalue) {
                    for (rangecount = 0; rangecount < ipv4data.items[ippoolcount].ranges.length; ++rangecount) {
                        rangeheader.items.push(ipv4data.items[ippoolcount].ranges[rangecount]);
                        rangeheader.items[rangecount].name = ipv4data.items[ippoolcount].ranges[rangecount].range;
                    }
                }
            }
            ipv4rangedata = rangeheader;
            
            var rangeheaderipv6 = {
                    "identifier": "id",
                    "label": "name",
                    "items": []
            };

            for (ippoolcount = 0; ippoolcount < ipv6data.items.length; ++ippoolcount) {
                var rangecount = 0;
                if (ipv6data.items[ippoolcount].id == ipv6selectvalue) {
                    for (rangecount = 0; rangecount < ipv6data.items[ippoolcount].ranges.length; ++rangecount) {
                        rangeheaderipv6.items.push(ipv6data.items[ippoolcount].ranges[rangecount]);
                        rangeheaderipv6.items[rangecount].name = ipv6data.items[ippoolcount].ranges[rangecount].range;
                    }
                }
            }
            ipv6rangedata = rangeheaderipv6;
                                  
            if (type == "IPv4") {
                this._ipv4rangestore = new dojo.data.ItemFileReadStore({
                    data: ipv4rangedata
                });

                this._ipv4rangeselectbox.setStore(this._ipv4rangestore);

                /*this._ipv4rangeselectbox.addOption({
                    value: "any",
                    label: this.locResources.ANYRANGE,
                    selected: true
                });

                this._ipv4rangeselectbox.addOption({
                    value: "chassis",
                    label: this.resources.BY_CHASSIS,
                    selected: true
                });*/
                this._ipv4rangeselectbox.set("value", rangedefault);
            }

            if (type == "IPv6") {
                this._ipv6rangestore = new dojo.data.ItemFileReadStore({
                    data: ipv6rangedata
                });

                this._ipv6rangeselectbox.setStore(this._ipv6rangestore);

                /*this._ipv6rangeselectbox.addOption({
                    value: "any",
                    label: this.locResources.ANYRANGE,
                    selected: true
                });

                this._ipv6rangeselectbox.addOption({
                    value: "chassis",
                    label: this.resources.BY_CHASSIS,
                    selected: true
                });*/
                this._ipv6rangeselectbox.set("value", rangedefault);
            }
        },

        _readSettingsFromService: function() {
            var settings = null;
            var mode = this.templateMode;

            var xhrGet = dojo.xhrGet({
                url: this.REST_PATH + "template/" + this.templateIDNum,
                handleAs: "json",
                sync: true,
                load: function(response) {
                    settings = response;
                },
                error: function(error) {
                    console.error(this.declaredClass + ": " + this.locResources.ERRORSERVICE + " " + error);
                }
            });

            this.initialData = settings.items;
            
            // Set dialog title to reflect Editing and display the warning
            // message
            // this.ethwarningMessage.style.display = "block";

            this.templateInUse = settings.items[0].inUse;

            if (mode == "copy") {
                this.dialogNode.set("title", this.locResources.COPYTITLE + " - "
                        + settings.items[0].name + " - " + this.resources.COPY);
                this.templateName.set("value", settings.items[0].name + " - " + this.resources.COPY);
            }
            else {
                this.dialogNode.set("title", this.locResources.EDITTITLE + " - "
                        + settings.items[0].name);
                this.templateName.set("value", settings.items[0].name);
            }
            var descriptionvalue = settings.items[0].description;
            var description = this.decodeSpecialCharacters(descriptionvalue);
            this.ethadapDesc.set("value", description);
            
            this.autogenchecklabelbutton.set("checkBox", "on");
            if (settings.items[0].autogenhostnamebuttonvalue == 0) {
                this.autogenchecklabelbutton.set("buttonState", settings.items[0].autogenhostnamebuttonvalue);
                //this._hyphenCheckBox.set("checked", settings.items[0].hyphenChecked);
                var patternData = settings.items[0].CMM__NetworkSettings_autogen_hostname.pattern;                                        
                if (this._customnametable == null) {                                            
                    this._customnametable = new support.panels.CustomNamingTable({
                        id: "cp_chassismanagementinterfacetemplate_customnamingtable",
                        templateType: "chassismgmt",
                        namepattern: patternData
                    }, this.get("id") + "_customname");
                }
            }
            
            this.ipv4checklabelbutton.set("checkBox", "on");
            if (settings.items[0].ipv4settings == "No Change") {
                this.ipv4checklabelbutton.set("buttonState", 1);  //IPv4 buttonState 1 is No Change
            } else {
                this.ipv4checklabelbutton.set("buttonState", 0);  //IPv4 buttonState 0 is Enabled
                if (settings.items[0].CMM__ifconfig__c == "dhcp") {
                    this.ipv4dynamicradiobutton.set("checked", true);
                    this._ipv4selectbox.set("disabled", true);
                    this._ipv4rangeselectbox.set("disabled", true);
                    this.ipv4addresspoolselections.style.display = "none";
                }
                else if (settings.items[0].CMM__ifconfig__c == "static") {
                    this.ipv4staticradiobutton.set("checked", true);
                    this._ipv4selectbox.set("disabled", false);
                    this._ipv4rangeselectbox.set("disabled", false);
                    this.ipv4addresspoolselections.style.display = "block";
                }
                else if (settings.items[0].CMM__ifconfig__c == "dthens") {
                    this.ipv4firstdhcpradiobutton.set("checked", true);
                    this._ipv4selectbox.set("disabled", false);
                    this._ipv4rangeselectbox.set("disabled", false);
                    this.ipv4addresspoolselections.style.display = "block";
                }
                this._ipv4selectbox.set("value", settings.items[0].ipv4settingsaddresspoolvalue);
                this._ipv4rangedefault = settings.items[0].ipv4settingsrangevalue;
                this._setIPRangeSelect("IPv4", settings.items[0].ipv4settingsrangevalue);
            }
            
            this.ipv6checklabelbutton.set("checkBox", "on");
            if (settings.items[0].ipv6settings == "No Change") {
                this.ipv6checklabelbutton.set("buttonState", 1);  //IPv6 buttonState 1 is No Change
            } else {
                this.ipv6checklabelbutton.set("buttonState", 0);  //IPv6 buttonState 0 is Enabled
                if (settings.items[0].CMM__ifconfig__dhcp6 == "enabled") {
                    this.ipv6dynamicradiobutton.set("checked", true);
                    this._ipv6selectbox.set("disabled", true);
                    this.ipv6addresspoolselections.style.display = "none";
                } else{
                 this.ipv6dynamicradiobutton.set("checked", false);
                }
                if (settings.items[0].CMM__ifconfig__sa6 == "enabled") {
                    this.ipv6statelessradiobutton.set("checked", true);
                    this._ipv6selectbox.set("disabled", true);
                    this.ipv6addresspoolselections.style.display = "none";
                } else{
                 this.ipv6statelessradiobutton.set("checked", false);
                }
                if (settings.items[0].CMM__ifconfig__ipv6static == "enabled") {
                    this.ipv6staticradiobutton.set("checked", true);
                    this._ipv6selectbox.set("disabled", false);
                    this.ipv6addresspoolselections.style.display = "block";
                } else{
                 this.ipv6staticradiobutton.set("checked", false);
                }
                this._ipv6selectbox.set("value", settings.items[0].ipv6settingsaddresspoolvalue);
                this._ipv6rangedefault = settings.items[0].ipv6settingsrangevalue;
                this._setIPRangeSelect("IPv6", settings.items[0].ipv6settingsrangevalue);    
            }

            if (settings.items[0].DNSsearchsettingscheckvalue == true) {
                this.dnssearchchecklabelbutton.set("checkBox", "on");
                // this.dnssearchchecklabelbutton.set("buttonState",
                // settings.items[0].DNSsearchsettingsbuttonvalue);
                if (settings.items[0].CMM__dns__p == "ipv4") {
                    this.dnssearchchecklabelbutton.set("buttonState", 0);
                }
                else if (settings.items[0].CMM__dns__p == "ipv6") {
                    this.dnssearchchecklabelbutton.set("buttonState", 1);
                }
            }

            if (settings.items[0].additionalDNScheckvalue == true) {
                this.addndnschecklabelbutton.set("checkBox", "on");
                this.addndnschecklabelbutton.set("buttonState", settings.items[0].additionalDNSbuttonvalue);
                // Add any items to the table
               // if (settings.items[0].additionalDNSbuttonvalue == 1) {
                    // var ipv4dnsobj =
                    // settings.items[0].ipv4dnstableentries;
                    var ipv4dnsobj = {
                        "items": []
                    };
                    var ipv6dnsobj = {
                        "items": []
                    };
                    //If dns -off is present, ignore any inputted dns ip's
                    if (settings.items[0].CMM__dns__off && settings.items[0].CMM__dns__off == true) {
                        //nothing for now
                    }
                    else {
                        if (settings.items[0].CMM__dns__i1 != undefined) {
                            ipv4dnsobj.items.push({
                                field: null,
                                icons: true
                            });
                            ipv4dnsobj.items[0].field = settings.items[0].CMM__dns__i1;
                            ipv4dnsobj.items[0].icons = true;
                        }
                        
                        if (settings.items[0].CMM__dns__i2 != undefined) {
                            ipv4dnsobj.items.push({
                                field: null,
                                icons: true
                            });
                            ipv4dnsobj.items[1].field = settings.items[0].CMM__dns__i2;
                            ipv4dnsobj.items[1].icons = true;
                        }
                        
                        if (settings.items[0].CMM__dns__i3 != undefined) {
                            ipv4dnsobj.items.push({
                                field: null,
                                icons: true
                            });
                            ipv4dnsobj.items[2].field = settings.items[0].CMM__dns__i3;
                            ipv4dnsobj.items[2].icons = true;
                        }
                        
                        if (settings.items[0].CMM__dns__i61 != undefined) {
                            ipv6dnsobj.items.push({
                                field: null,
                                icons: true
                            });
                            ipv6dnsobj.items[0].field = settings.items[0].CMM__dns__i61;
                            ipv6dnsobj.items[0].icons = true;
                        }
                        
                        if (settings.items[0].CMM__dns__i62 != undefined) {
                            ipv6dnsobj.items.push({
                                field: null,
                                icons: true
                            });
                            ipv6dnsobj.items[1].field = settings.items[0].CMM__dns__i62;
                            ipv6dnsobj.items[1].icons = true;
                        }
                        
                        if (settings.items[0].CMM__dns__i63 != undefined) {
                            ipv6dnsobj.items.push({
                                field: null,
                                icons: true
                            });
                            ipv6dnsobj.items[2].field = settings.items[0].CMM__dns__i63;
                            ipv6dnsobj.items[2].icons = true;
                        }
                    }
                    
                    /*
                     * for(ipv4dnscount = 0; ipv4dnscount <
                     * ipv4dnsobj.items.length; ++ipv4dnscount) {
                     * ipv4dnsobj.items[ipv4dnscount].icons = true; }
                     * 
                     * var ipv6dnsobj =
                     * settings.items[0].ipv6dnstableentries; var
                     * ipv6dnscount = 0;
                     * 
                     * for(ipv6dnscount = 0; ipv6dnscount <
                     * ipv6dnsobj.items.length; ++ipv6dnscount) {
                     * ipv6dnsobj.items[ipv6dnscount].icons = true; }
                     */
                    if (ipv4dnsobj.items[0] == undefined) {
                        ipv4dnsobj = undefined;
                    }

                    this._ipv4addndnstable = new support.panels.EnhancedTable(
                            {
                                id: this.get("id") + "_ipv4table",
                                addPosition: "left",
                                max: 3,
                                label: this.resources.IPV4,
                                placeHolder: "0.0.0.0",
                                jsonData: ipv4dnsobj,
                                addTitle: this.locResources.ADDTITLE,
                                removeTitle: this.locResources.REMOVETITLE,
                                regExp: "^([0-9]|[0-9][0-9]|[0-1][0-9][0-9]|2[0-4][0-9]|25[0-5])(\.([0-9]|[0-9][0-9]|[0-1][0-9][0-9]|2[0-4][0-9]|25[0-5])){3}$",
                                invalidMessage: this.locResources.IPV4INVALIDMESSAGE
                            }, this.get("id") + "_ipv4table");

                    if (ipv6dnsobj.items[0] == undefined) {
                        ipv6dnsobj = undefined;
                    }
                    this._ipv6addndnstable = new support.panels.EnhancedTable(
                            {
                                id: this.get("id") + "_ipv6table",
                                addPosition: "left",
                                max: 3,
                                label: this.resources.IPV6,
                                placeHolder: "0::0",
                                jsonData: ipv6dnsobj,
                                addTitle: this.locResources.ADDTITLE,
                                removeTitle: this.locResources.REMOVETITLE,
                                regExp: "^\s*((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))(%.+)?\s*$",
                                invalidMessage: this.locResources.IPV6INVALIDMESSAGE
                            }, this.get("id") + "_ipv6table");

                }
            //}

            if (settings.items[0].DDNSsettingscheckvalue == true) {
                this.ddnschecklabelbutton.set("checkBox", "on");
                var DDNSsettingsbuttonvaluefromservice = (settings.items[0].CMM__dns__ddns == "enabled") ? true
                        : false;
                this.ddnschecklabelbutton.set("buttonState", DDNSsettingsbuttonvaluefromservice);
                if (DDNSsettingsbuttonvaluefromservice == true) {
                    if (!settings.items[0].CMM__ifconfig__dn) {
                        this.ddnsradiodynamic.set("checked", true);
                        this.ddnsradiostatictextbox.style.display = "none";
                    }
                    else {
                        this.ddnsradiostatic.set("checked", true);
                        this.ddnstextbox.set("value", settings.items[0].CMM__ifconfig__dn);
                        this.ddnsradiostatictextbox.style.display = "inline";
                    }
                }
            }

       /*     if (settings.items[0].interfacespeedsettingscheckvalue == true) {
              //  this.ifspeedchecklabelbutton.set("checkBox", "on");
                var interfacespeedsettingsbuttonvaluefromservice = (settings.items[0].CMM__ifconfig__auto == "true") ? 0
                        : 1;
           //     this.ifspeedchecklabelbutton.set("buttonState",
                        interfacespeedsettingsbuttonvaluefromservice);
                if (interfacespeedsettingsbuttonvaluefromservice == 1) {
                    if (settings.items[0].CMM__ifconfig__r == "10") {
                        this.dataRateButtonBar.set("selIndex", 0);
                    }
                    else {
                        this.dataRateButtonBar.set("selIndex", 1);
                    }
                    if (settings.items[0].CMM__ifconfig__d == "half") {
                        this.duplexButtonBar.set("selIndex", 0);
                    }
                    else {
                        this.duplexButtonBar.set("selIndex", 1);
                    }
                }
            }*/

            if (settings.items[0].MTUsettingscheckvalue == true) {
                this.mtuchecklabelbutton.set("checkBox", "on");
                this.mtuchecklabelbutton.set("buttonState", settings.items[0].CMM__ifconfig__m);
            }
            

            // Ports
            if (settings.items[0]["CMM Ports"]) {
                if (settings.items[0]["CMM Ports"].CMM__ports__httpp) {
                    this.httpchecklabelbutton.set("buttonState", settings.items[0]["CMM Ports"].CMM__ports__httpp);
                }
                if (settings.items[0]["CMM Ports"].CMM__ports__httpsp) {
                    this.httpschecklabelbutton.set("buttonState", settings.items[0]["CMM Ports"].CMM__ports__httpsp);
                }
                if (settings.items[0]["CMM Ports"].CMM__ports__telnetp) {
                    this.telnetclichecklabelbutton.set("buttonState", settings.items[0]["CMM Ports"].CMM__ports__telnetp);
                }
                if (settings.items[0]["CMM Ports"].CMM__ports__sshp) {
                    this.sshclichecklabelbutton.set("buttonState", settings.items[0]["CMM Ports"].CMM__ports__sshp);
                }
                if (settings.items[0]["CMM Ports"].CMM__ports__snmpap) {
                    this.snmpagentchecklabelbutton.set("buttonState", settings.items[0]["CMM Ports"].CMM__ports__snmpap);
                }
                if (settings.items[0]["CMM Ports"].CMM__ports__snmptp) {
                    this.snmptrapschecklabelbutton.set("buttonState", settings.items[0]["CMM Ports"].CMM__ports__snmptp);
                }
                if (settings.items[0]["CMM Ports"].CMM__ports__cimp) {
                    this.cimhttpschecklabelbutton.set("buttonState", settings.items[0]["CMM Ports"].CMM__ports__cimp);
                }
            }

        },

        _saveandhideDialog: function(evt) {
            if (!this._validateFields()) {
                return;
            }

            var ethernetTemplateObj = this._generateSavedData();

            // If doing an edit, need to add the id
            if (this.templateIDNum != null && this.templateMode != "copy") {
                ethernetTemplateObj.id = this.templateIDNum;
            }
            else {
                this.templateIDNum = null;
            }

            var argJSONString = dojo.toJson({
                "identifier": "id",
                "label": "name",
                "items": [ ethernetTemplateObj ]
            }, true);

            this.getProgressDialog("save").show(); // Show progress dialog for save request.
            var xhrPost = dojo.xhrPost({
                url: this.REST_PATH + "template/create",
                handleAs: "json", // <<<< Required
                headers: {
                    "Content-Type": "application/json; charset=utf-8" // <<<< Required
                },
                postData: argJSONString,     //Template Data to Post
                load: dojo.hitch(this, function(response, ioArgs) {
                    // Happy path! We received a 2xx status code from the API.
                                            
                    dojo.publish("ProgressComplete", response.id);
                    dojo.publish("ChassisManagementComplete", response.id);
                    this.hide();   
                }),
                error: dojo.hitch(this, function(error, ioArgs) {
                    // Failure path! We received a non-2xx status code (ie: 3xx/4xx/5xx status code) from the API.

                    dojo.publish("ProgressFailed", error);
                    console.log(this.declaredClass + ": ", error, ioArgs);
                    
                    var response = dojo.fromJson(ioArgs.xhr.responseText);
                    if ((ioArgs.xhr.status >= 400) && (response.message == "service_error_name_in_use")) {
                        // Error Template name in use
                        this.getModalDialog("Error", this.resources.ERROR_400_NAME).show();
                    }
                    else if(ioArgs.xhr.status == 404) {
                        // Edit Template ID doesn't exist
                        this.getModalDialog("Error", this.resources.ERROR_404_ID).show();
                        this.hide();
                    }
                    else if(ioArgs.xhr.status >= 500) {
                        // Internal Programming Error
                        this.getModalDialog("Error", this.resources.ERROR_500_INTERNAL).show();
                        this.hide();
                    }
                    else {
                        this.getModalDialog("Error", this.resources.ERROR_TEMPLATE_CREATE).show();
                        this.hide();
                    }
                    
                }),
                handle: dojo.hitch(this, function(data, ioArgs) {
                    // - The 1st param ("data") is either the response data (on success) or Error object (on failure).
                    // - The 2nd param ("ioArgs") contains detail about the xhr request, including a reference to the
                    // native xhr object. Check ioArgs.xhr.status to determine success or failure, and handle "data"
                    // accordingly.
                })
            });

        },

        saveClicked: function() {

            if (!this._validateFields()) {
                return;
            }

            var ethernetTemplateObj = this._generateSavedData();
            ethernetTemplateObj.id = this.templateIDNum;

            var argJSONString = dojo.toJson({
                "identifier": "id",
                "label": "name",
                "items": [ ethernetTemplateObj ]
            }, true);

            var saveTemplate = true;
            
            if (this.templateInUse.toString() == "true") {
                //  Need to remove extra properties that aren't included in the dialog
                delete this.initialData[0].inUse;
                delete this.initialData[0].uri;
                delete this.initialData[0].referencedBy;
                delete this.initialData[0].useCount;
                delete this.initialData[0].userDefined;
                
                // Remove description since it shouldn't force a redeploy
                delete this.initialData[0].description;
                delete ethernetTemplateObj.description;
                
                var preData = this.sortAndFlatten(this.initialData[0]);
                var postData = this.sortAndFlatten(ethernetTemplateObj);
                
                if(preData != postData){
                    this.rdstDialog.set("templateID", this.templateIDNum);
                    this.rdstDialog.set("templateType", "Category");
                    this.rdstDialog.set("templateData", argJSONString);

                    this.rdstDialog.show();
                    saveTemplate = false;
                }

            }
            if (saveTemplate){

                this.getProgressDialog("save").show(); // Show progress dialog for save request.
                var xhrPost = dojo.xhrPost({
                    url: this.REST_PATH + "template/create",
                    handleAs: "json", // <<<< Required
                    headers: {
                        "Content-Type": "application/json; charset=utf-8" // <<<< Required
                    },
                    postData: argJSONString,     //Template Data to Post
                    load: dojo.hitch(this, function(response, ioArgs) {
                        // Happy path! We received a 2xx status code from the API.
                                                
                        dojo.publish("ProgressComplete", response.id);
                        dojo.publish("ChassisManagementComplete", response.id);
                        this.hide();   
                    }),
                    error: dojo.hitch(this, function(error, ioArgs) {
                        // Failure path! We received a non-2xx status code (ie: 3xx/4xx/5xx status code) from the API.

                        dojo.publish("ProgressFailed", error);
                        console.log(this.declaredClass + ": ", error, ioArgs);
                        
                        var response = dojo.fromJson(ioArgs.xhr.responseText);
                        if ((ioArgs.xhr.status >= 400) && (response.message == "service_error_name_in_use")) {
                            // Error Template name in use
                            this.getModalDialog("Error", this.resources.ERROR_400_NAME).show();
                        }
                        else if(ioArgs.xhr.status == 404) {
                            // Edit Template ID doesn't exist
                            this.getModalDialog("Error", this.resources.ERROR_404_ID).show();
                            this.hide();
                        }
                        else if(ioArgs.xhr.status >= 500) {
                            // Internal Programming Error
                            this.getModalDialog("Error", this.resources.ERROR_500_INTERNAL).show();
                            this.hide();
                        }
                        else {
                            this.getModalDialog("Error", this.resources.ERROR_TEMPLATE_CREATE).show();
                            this.hide();
                        }
                        
                    }),
                    handle: dojo.hitch(this, function(data, ioArgs) {
                        // - The 1st param ("data") is either the response data (on success) or Error object (on failure).
                        // - The 2nd param ("ioArgs") contains detail about the xhr request, including a reference to the
                        // native xhr object. Check ioArgs.xhr.status to determine success or failure, and handle "data"
                        // accordingly.
                    })
                });

            }

        },

        saveasClicked: function() {

            if (!this._validateFields()) {
                return;
            }
            var ethernetTemplateObj = this._generateSavedData();

            this.saveasDialog.set("templateObject", ethernetTemplateObj);
            this.saveasDialog.show();

        },

        _getIPPooldata: function() {
            var ipv4data = null;
            var ipv6data = null;
            var ipv4store = null;
            var ipv6store = null;
            var ippoollistdata = null;

            var xhrGet = dojo.xhrGet({
                url: this.REST_PATH + "ippool/list",
                handleAs: "json",
                preventCache: true,
                sync: true,
                load: function(response) {
                    ippoollistdata = response;
                    var count;
                    ipv4data = {
                        "identifier": "id",
                        "label": "name",
                        "items": []
                    };
                    ipv6data = {
                        "identifier": "id",
                        "label": "name",
                        "items": []
                    };
                    for (count = 0; count < response.items.length; ++count) {
                        if (response.items[count].protocol == "IPv4") {
                            ipv4data.items.push(response.items[count]);
                        }
                        if (response.items[count].protocol == "IPv6") {
                            ipv6data.items.push(response.items[count]);
                        }
                    }

                    ipv4store = new dojo.data.ItemFileReadStore({
                        data: ipv4data
                    });

                    ipv6store = new dojo.data.ItemFileReadStore({
                        data: ipv6data
                    });

                },
                error: function(error) {
                    console.error(this.declaredClass + ": error getting data from service");
                    // Probably need to mock up some dummy data here
                }

            });
            this._ipv4store = ipv4store;
            this._ipv6store = ipv6store;
            this._ippoolListData = ippoollistdata;
        },

        _validateFields: function(evt) {
            var validationpopup = new support.temp.ModalDialog({
                type: "Error",
                text: this.locResources.ERRORSELECTADDRESSPOOL
            });

            if (this.ipv4checklabelbutton.get("checkBox") == "on" && this.ipv4checklabelbutton.get("buttonState") == 0) {  // IPv4 buttonState 0 is Enabled
                if (this.ipv4staticradiobutton.get("checked") == true) {
                    if (this._ipv4selectbox.get("value") == "noselected"
                            || this._ipv4selectbox.get("disabled") == true) {
                        validationpopup.show();
                        return false;
                    }
                }
            }

            if (this.ipv6checklabelbutton.get("checkBox") == "on" && this.ipv6checklabelbutton.get("buttonState") == 0) {  // IPv6 buttonState 0 is Enabled
                if (this.ipv6staticradiobutton.get("checked") == true) {
                    if (this._ipv6selectbox.get("value") == "noselected"
                            || this._ipv6selectbox.get("disabled") == true) {
                        validationpopup.show();
                        return false;
                    }
                }
            }

            if (this.ddnschecklabelbutton.get("checkBox") == "on") {
                if (this.ddnsradiostatic.get("checked") == true) {
                    if (this.ddnstextbox.get("value") == "") {
                        var validationpopup2 = new support.temp.ModalDialog({
                            type: "Error",
                            text: this.locResources.ERRORDOMAINNAME
                        });
                        validationpopup2.show();
                        return false;
                    }
                }
            }

            if (this._checkDNSEntryAdded() == false) {
                var dnsvalidationpopup = new support.temp.ModalDialog({
                    type: "Error",
                    text: this.locResources.ERRORADDDNS
                });
                dnsvalidationpopup.show();
                return false;
                
            }
            
            // I'm going to just comment this out for now since there are
            // a number of issues with profile creation and activation which
            // prevent full unit testing of this change.
            // TODO:  Once chassis deploy is working properly, need to come back
            //        and test this path out (set IPv6 DNS without IPv4).
            //        Note, the CMM fix is in their 21L level of fw.
            //        Once the change is confirmed, this can all be deleted.
            /*if (this._checkDNSIpv6Added() == false) {
                var dnsvalidationpopup = new support.temp.ModalDialog({
                    type: "Error",
                    text: this.locResources.ERRORADDDNS_IPV6
                });
                dnsvalidationpopup.show();
                return false;
                
            }*/

            if (this._checkDNS() == false) {
                var dnsvalidationpopup = new support.temp.ModalDialog({
                    type: "Error",
                    text: this.locResources.ERRORIPINVALID
                });
                dnsvalidationpopup.show();
                return false;

            }

            return true;
        },

        _cancelDialog: function() {
            this.hide();
            // this.dialogNode.destroy();
        },

        _selectall: function() {
            this.autogenchecklabelbutton.set("checkBox", "on");
            this._toggleAutoGenHostname();
            this.ipv4checklabelbutton.set("checkBox", "on");
            this.ipv6checklabelbutton.set("checkBox", "on");
            this._toggleMgmtIPAddrSettings();
            this.dnssearchchecklabelbutton.set("checkBox", "on");
            this.addndnschecklabelbutton.set("checkBox", "on");
            this.ddnschecklabelbutton.set("checkBox", "on");
            this._toggleDNSSettings();
         //   this.ifspeedchecklabelbutton.set("checkBox", "on");
            this.mtuchecklabelbutton.set("checkBox", "on");
           // this._toggleInterfaceSpeedSettings();
            this._togglePortAssignmentSettings();
            this._expandall();
            this.layout();
            
        },

        _deselectall: function() {
            this.autogenchecklabelbutton.set("checkBox", false);
            this._toggleAutoGenHostname();
            this._toggleMgmtIPAddrSettings();
            this.dnssearchchecklabelbutton.set("checkBox", false);
            this.addndnschecklabelbutton.set("checkBox", false);
            this.ddnschecklabelbutton.set("checkBox", false);
            this._toggleDNSSettings();
     //       this.ifspeedchecklabelbutton.set("checkBox", false);
            this.mtuchecklabelbutton.set("checkBox", false);
            this.portassignmentCheckBoxId.set("checked", false);
         //   this._toggleInterfaceSpeedSettings();
            this._togglePortAssignmentSettings();
            this.layout();
        },

        _expandall: function(evt) {
            this.hostnameCheckBoxId.set("checked", "on");
            this.mgmtipaddrCheckBoxId.set("checked", "on");
            this.dnsCheckBoxId.set("checked", "on");
     //       this.interfacespeedCheckBoxId.set("checked", "on");
            this.portassignmentCheckBoxId.set("checked", "on");
            this.expandall.style.display = "none";
            this.collapseall.style.display = "inline";
            this.mixedexpandcollapse.style.display = "none";
            this._toggleAutoGenHostname();
            this._toggleMgmtIPAddrSettings();
            this._toggleDNSSettings();
         //   this._toggleInterfaceSpeedSettings();
            this._togglePortAssignmentSettings();
            this.layout();
        },

        _collapseall: function() {
            this.hostnameCheckBoxId.set("checked", false);
            this.mgmtipaddrCheckBoxId.set("checked", false);
            this.dnsCheckBoxId.set("checked", false);
//            this.interfacespeedCheckBoxId.set("checked", false);
            this.portassignmentCheckBoxId.set("checked", false);
            this.expandall.style.display = "inline";
            this.collapseall.style.display = "none";
            this.mixedexpandcollapse.style.display = "none";
            this._toggleAutoGenHostname();
            this._toggleMgmtIPAddrSettings();
            this._toggleDNSSettings();
     //       this._toggleInterfaceSpeedSettings();
            this._togglePortAssignmentSettings();
            this.layout();
        },

        _checkExpandCollapseState: function() {
            var hostnameCheckBoxState = this.hostnameCheckBoxId.get("value");
            var mgmtipaddrCheckBoxState = this.mgmtipaddrCheckBoxId.get("value");
            var dnsCheckBoxState = this.dnsCheckBoxId.get("value");
    //        var interfacespeedCheckBoxState = this.interfacespeedCheckBoxId.get("value");
            var portCheckBoxState = this.portassignmentCheckBoxId.get("value");
            /* value on = checked, false = unchecked */

            if (hostnameCheckBoxState == "on" && mgmtipaddrCheckBoxState == "on"
                    && dnsCheckBoxState == "on" && portCheckBoxState == "on") {
                return "allon";
            }
            if (hostnameCheckBoxState == false && mgmtipaddrCheckBoxState == false
                    && dnsCheckBoxState == false && portCheckBoxState == false) {
                return "alloff";
            }

            return "mixed";
        },

        _setExpandCollapseIcon: function() {
            if (this._checkExpandCollapseState() == "mixed") {
                this.expandall.style.display = "none";
                this.collapseall.style.display = "none";
                this.mixedexpandcollapse.style.display = "inline";
            }
            if (this._checkExpandCollapseState() == "allon") {
                this.expandall.style.display = "none";
                this.collapseall.style.display = "inline";
                this.mixedexpandcollapse.style.display = "none";
            }
            if (this._checkExpandCollapseState() == "alloff") {
                this.expandall.style.display = "inline";
                this.collapseall.style.display = "none";
                this.mixedexpandcollapse.style.display = "none";
            }
        },

        _displayHostnameSettings: function(evt) {
            this._setExpandCollapseIcon();
            this._toggleAutoGenHostname();
            this.layout();
        },

        _toggleAutoGenHostname: function() {
            // iHot Changes:
            // Check value of button bar. If "Disable", then hide the
            // section
            // If anything else, then section should be displayed
            if (this.hideuncheckedToggleButtonId.get("checked") == true) {
                if (this.autogenchecklabelbutton.get("checkbox") == false) {
                    this.autogenhostnametr.style.display = "none";
                    this.hostnametr.style.display = "none";
                    return;
                }
                if (this.autogenchecklabelbutton.get("buttonState") == 1) {
                    this.autogenhostnametr.style.display = "none";
                }
                else {
                    if (this._customnametable == null) {
                        this._customnametable = new support.panels.CustomNamingTable({
                            id: "cp_chassismanagementinterfacetemplate_customnamingtable1",
                            templateType: "chassismgmt"
                        }, this.get("id") + "_customname");
                    }
                    this.autogenhostnametr.style.display = "block";
                }
                this.hostnametr.style.display = "block";
                return;
            }
            else {
                this.hostnametr.style.display = "block";
                if (this.hostnameCheckBoxId.get("value") == false) {
                    this.autogenhostnametr.style.display = "none";
                }
                else {
                    if (this._customnametable == null) {
                        this._customnametable = new support.panels.CustomNamingTable({
                            id: "cp_chassismanagementinterfacetemplate_customnamingtable2",                            
                            templateType: "chassismgmt"
                        }, this.get("id") + "_customname");
                    }
                    this.autogenhostnametr.style.display = "block";
                }
                return;
            }
        },

        _displayMgmtIPAddrSettings: function() {
            this._setExpandCollapseIcon();
            this._toggleMgmtIPAddrSettings();
            this.layout();
        },

        _ipv4radioClicked: function() {
            if (this.ipv4form.get("value").ipv4 == "dynamicip") {
                this._ipv4selectbox.set("disabled", true);
                this._ipv4rangeselectbox.set("disabled", true);
                this.ipv4addresspoolselections.style.display = "none";
            }
            if (this.ipv4form.get("value").ipv4 == "staticip"
                    || this.ipv4form.get("value").ipv4 == "firstdynamicip") {
                if (this._ipv4selectbox.get("value") != "") {
                    this._ipv4selectbox.set("disabled", false);
                    this._ipv4rangeselectbox.set("disabled", false);
                    if (this._ipv4selectbox.get("value") == "noselected") {
                        this._ipv4rangeselectbox.set("disabled", true);
                        dojo.replaceClass(this.ipv4editicon, "spEditInactiveIcon_v2", "spEditIcon_v2");
                    }
                    else {
                        dojo.replaceClass(this.ipv4editicon, "spEditIcon_v2", "spEditInactiveIcon_v2");
                    }
                }
                else {
                    this._ipv4selectbox.set("disabled", true);
                    this._ipv4rangeselectbox.set("disabled", true);
                    dojo.replaceClass(this.ipv4editicon, "spEditInactiveIcon_v2", "spEditIcon_v2");
                }
                this.ipv4addresspoolselections.style.display = "block";
            }
            this.layout();
        },

        _ipv6radioClicked: function() {
            if (this.ipv6staticradiobutton.get("checked") == true) {
                if (this._ipv6selectbox.get("value") != "") {
                    this._ipv6selectbox.set("disabled", false);
                    //this._ipv6rangeselectbox.set("disabled", false);
                    
                    if (this._ipv6selectbox.get("value") == "noselected") {
                        this._ipv6rangeselectbox.set("disabled", true);
                        dojo.replaceClass(this.ipv6editicon, "spEditInactiveIcon_v2", "spEditIcon_v2");
                    } else {
                        dojo.replaceClass(this.ipv6editicon, "spEditIcon_v2", "spEditInactiveIcon_v2");
                    }                   
                } else {
                    this._ipv6selectbox.set("disabled", true);
                    this._ipv6rangeselectbox.set("disabled", true);
                    dojo.replaceClass(this.ipv6editicon, "spEditInactiveIcon_v2", "spEditIcon_v2");
                }
                this.ipv6addresspoolselections.style.display = "block";

            } else {
                this.ipv6addresspoolselections.style.display = "none";
            }
            this._enableOk();
            this.layout();
        },

        _toggleMgmtIPAddrSettings: function() { 
            if (this.hideuncheckedToggleButtonId.get("checked") == true) {
                this.mgmtipaddrtr.style.display = "block";
                if (this.mgmtipaddrCheckBoxId.get("value") == false) {
                    this.mgmtipaddripv4tr.style.display = "none";
                    this.mgmtipaddripv6tr.style.display = "none";
                    return;
                }
                else {
                    this.mgmtipaddripv4tr.style.display = "block";
                    this.mgmtipaddripv6tr.style.display = "block";
                }

                if (this.ipv4checklabelbutton.get("buttonState") == 0) {
                    this.mgmtipaddripv4tr.style.display = "block";

                }
                else {
                    this.mgmtipaddripv4tr.style.display = "none";
                }

                //var defaultOps = (this.ipv6statelessradiobutton.get("checked") == true && this.ipv6dynamicradiobutton
                //        .get("checked") == true);
                if (this.ipv6checklabelbutton.get("buttonState") == 0) {
                    this.mgmtipaddripv6tr.style.display = "block";
                }
                else {
                    this.mgmtipaddripv6tr.style.display = "none";
                }
                return;
            }
            else {
                this.ipv4outlinepane.style.display = "block";
                this.mgmtipaddrtr.style.display = "block";
                if (this.mgmtipaddrCheckBoxId.get("value") == false) {
                    this.mgmtipaddripv4tr.style.display = "none";
                    this.ipv4outlinepane.style.display = "block";
                    this.mgmtipaddripv6tr.style.display = "none";
                }
                else {
                    this.mgmtipaddripv4tr.style.display = "block";
                    if (this.ipv4checklabelbutton.get("checkBox") == "on") {
                        if (this.ipv4checklabelbutton.get("buttonState") == 0) {
                            this.ipv4outlinepane.style.display = "block";
                        } else {
                            this.ipv4outlinepane.style.display = "none";
                        }
                    }
                    this.mgmtipaddripv6tr.style.display = "block";
                    if (this.ipv6checklabelbutton.get("checkBox") == "on") {
                        if (this.ipv6checklabelbutton.get("buttonState") == 0) {
                            this.ipv6outlinepane.style.display = "block";
                        } else {
                            this.ipv6outlinepane.style.display = "none";
                        }
                    }
                }
                return;
            }
        },

        _displayDNSSettings: function(evt) {
            // Unhide DNS settings
            this._setExpandCollapseIcon();
            this._toggleDNSSettings();
            this.layout();
        },

        _toggleDNSSettings: function() {
            if (this.hideuncheckedToggleButtonId.get("checked") == true) {
                // Both checkboxes are unchecked, hide the whole section
                if (this.dnssearchchecklabelbutton.get("checkBox") == false
                        && this.addndnschecklabelbutton.get("checkBox") == false
                        && this.ddnschecklabelbutton.get("checkBox") == false) {
                    this.dnssearchpreferencetr.style.display = "none";
                    this.additionaldnsserverstr.style.display = "none";
                    this.ddnstr.style.display = "none";
                    this.dnstr.style.display = "none";
                    return;
                }

                this.dnstr.style.display = "block";
                if (this.dnsCheckBoxId.get("value") == false) {
                    this.dnssearchpreferencetr.style.display = "none";
                    this.additionaldnsserverstr.style.display = "none";
                    this.ddnstr.style.display = "none";
                    return;
                }
                else {
                    this.dnssearchpreferencetr.style.display = "block";
                    this.additionaldnsserverstr.style.display = "block";
                    this.ddnstr.style.display = "block";
                }
                if (this.dnssearchchecklabelbutton.get("checkBox") == "on"
                        && this.dnssearchchecklabelbutton.get("buttonState") == 1) {
                    this.dnssearchpreferencetr.style.display = "block";
                }
                else {
                    this.dnssearchpreferencetr.style.display = "none";
                }
                if (this.addndnschecklabelbutton.get("checkBox") == "on"
                        && this.addndnschecklabelbutton.get("buttonState") == false) {
                    this.additionaldnsserverstr.style.display = "block";
                }
                else {
                    this.additionaldnsserverstr.style.display = "none";
                }
                if (this.ddnschecklabelbutton.get("checkBox") == "on" && ((this.ddnschecklabelbutton.get("buttonState") == 0) ||
                        (this.ddnschecklabelbutton.get("buttonState") == 1 && this.ddnsradiodynamic.get("checked") == false))) {
                     this.ddnstr.style.display = "block";
                }
                else {
                    this.ddnstr.style.display = "none";
                }
                return;
            }
            else {
                this.dnstr.style.display = "block";
                if (this.dnsCheckBoxId.get("value") == false) {
                    this.dnssearchpreferencetr.style.display = "none";
                    this.additionaldnsserverstr.style.display = "none";
                    this.ddnstr.style.display = "none";
                }
                else {
                    this.dnssearchpreferencetr.style.display = "block";
                    this.additionaldnsserverstr.style.display = "block";
                    if (this.addndnschecklabelbutton.get("checkBox") == "on") {
                        if (this.addndnschecklabelbutton.get("buttonState") == 0) {
                            this.adddnstable.style.display = "block";
                            this.layout();
                        }
                        else {
                            this.adddnstable.style.display = "none";
                        }
                    }
                    else {
                        this.adddnstable.style.display = "none";
                    }
                    this.ddnstr.style.display = "block";
                    if (this.ddnschecklabelbutton.get("checkBox") == "on") {
                        if (this.ddnschecklabelbutton.get("buttonState") == true) {
                            this.ddnsoutlinepane.style.display = "block";
                        }
                        else {
                            this.ddnsoutlinepane.style.display = "none";
                        }
                    }
                    else {
                        this.ddnsoutlinepane.style.display = "none";
                    }
                }
                return;
            }
    },

    /*    _displayInterfaceSpeedSettings: function() {
            // Unhide Interface Speed settings
            this._setExpandCollapseIcon();
   //         this._toggleInterfaceSpeedSettings();
            this.layout();
        },*/

        _hideUncheckedClicked: function(evt) {
            this._toggleAutoGenHostname();
            this._toggleMgmtIPAddrSettings();
            this._toggleDNSSettings();
    //        this._toggleInterfaceSpeedSettings();
            this._togglePortAssignmentSettings();
            this.layout();
            return;
        },

        _dhcpDDNSTextBox: function() {
            this.ddnsradiostatictextbox.style.display = "none";
            this.ddnsradiodynamic.set("checked", true);
            this._enableOk();
        },

        _specifyDDNSTextBox: function() {
            this.ddnsradiostatictextbox.style.display = "inline";
            this.ddnsradiodynamic.set("checked", false);
            this._enableOk();
        },

      /*  _toggleInterfaceSpeedSettings: function() {
            if (this.hideuncheckedToggleButtonId.get("checked") == true) {
                // Both checkboxes are unchecked, hide the whole section
                if (this.ifspeedchecklabelbutton.get("checkBox") == false
                        && this.mtuchecklabelbutton.get("checkBox") == false) {
                    this.interfacespeedchecktr.style.display = "none";
                    this.mtutr.style.display = "none";
                   // this.interfacespeedtr.style.display = "none";
                    return;
                }

               // this.interfacespeedtr.style.display = "block";
                if (this.interfacespeedCheckBoxId.get("value") == false) {
                    this.interfacespeedchecktr.style.display = "none";
                    this.mtutr.style.display = "none";
                    return;
                }
                else {
                    this.interfacespeedchecktr.style.display = "block";
                    this.mtutr.style.display = "block";
                }

                if (this.ifspeedchecklabelbutton.get("checkBox") == "on") {
                    if (this.ifspeedchecklabelbutton.get("buttonState") == 1) {
                        this.interfacespeedchecktr.style.display = "block";
                    }
                    else {
                        this.interfacespeedchecktr.style.display = "none";
                    }
                }
                else {
                    this.interfacespeedchecktr.style.display = "none";
                }

                if (this.mtuchecklabelbutton.get("checkBox") == "on"
                        && this.mtuchecklabelbutton.get("buttonState") != 1500) {
                    this.mtutr.style.display = "block";
                }
                else {
                    this.mtutr.style.display = "none";
                }

                return;
            }
            else {
                this.interfacespeedtr.style.display = "block";
                if (this.interfacespeedCheckBoxId.get("value") == false) {
                    this.interfacespeedchecktr.style.display = "none";
                    this.mtutr.style.display = "none";
                }
                else {
                    this.interfacespeedchecktr.style.display = "block";
                    if (this.ifspeedchecklabelbutton.get("checkBox") == "on") {
                        if (this.ifspeedchecklabelbutton.get("buttonState") == 1) {
                            this.ifspeedoutlinepane.style.display = "block";
                        }
                        else {
                            this.ifspeedoutlinepane.style.display = "none";
                        }
                    }
                    else {
                        this.ifspeedoutlinepane.style.display = "none";
                    }
                    this.mtutr.style.display = "block";
                }
                return;
            }
        },*/

        _showIPPoolDialog: function(evt) {
            var ippooldialog = new support.dialogs.NewIPPool({
                id: "cp_chassismanagementinterfacetemplate_newippool"                
            });
            ippooldialog.show();
        },
        
        _showIPv6PoolDialog: function(evt) {
            var ipv6pooldialog = new support.dialogs.NewIPPool({
                id: "cp_chassismanagementinterfacetemplate_newipv6pool"                
            });
            ipv6pooldialog.set("version", "IPv6");
            ipv6pooldialog.show();
        },                                

        _editIPPoolDialog: function(evt) {
            var poolID = this._ipv4selectbox.get("value");
            console.log(this.declaredClass + ": ipv4pool:" + poolID);
            if(poolID == "noselected" || poolID == "") {
                return;
            }                                    
            var ippooldialog = new support.dialogs.NewIPPool({
                id: "cp_chassismanagementinterfacetemplate_editippool",                                
                poolIDNum: poolID
            });
            ippooldialog.show();
        },

        _editIPv6PoolDialog: function(evt) {
            var poolID = this._ipv6selectbox.get("value");
            console.log(this.declaredClass + ": ipv6pool:" + poolID);
            if(poolID == "noselected" || poolID == "") {
                return;
            }                                    
            var ipv6pooldialog = new support.dialogs.NewIPPool({
                id: "cp_chassismanagementinterfacetemplate_editipv6pool",                                
                poolIDNum: poolID                                        
            });
            ipv6pooldialog.set("version", "IPv6");
            ipv6pooldialog.show();
        },

        _displayDnsHoverHelp: function() {
            var ipv4row = this._ipv4addndnstable.getStoreAsJson();
            var ipv6row = this._ipv6addndnstable.getStoreAsJson();

            if (ipv4row == undefined && ipv6row == undefined) {
                return;
            }

            if (ipv4row != undefined) {
                var ipv4rowobj = dojo.fromJson(ipv4row);
                if (ipv4rowobj.items.length > 0) {
                    this.dnstooltip.close();
                }
            }

            if (ipv6row != undefined) {
                var ipv6rowobj = dojo.fromJson(ipv6row);
                if (ipv6rowobj.items.length > 0) {
                    this.dnstooltip.close();
                }
            }
            this._enableOk();
        },
        exitParent: function() {
            var data = "ChassisManagement";

            dojo.publish("ChassisManagementComplete", data);

            if(this.rdstDialog != null){
                var deployClicked = this.rdstDialog.get("closeParent");
                if(deployClicked) {
                    this.hide();
                }
            }
        },

        _setDefaults: function() {
            this.autogenchecklabelbutton.set("buttonState", 1);
            this.ipv4checklabelbutton.set("buttonState", 1);
            this.ipv6checklabelbutton.set("buttonState", 1);
            this.dnssearchchecklabelbutton.set("buttonState",0);
            this.addndnschecklabelbutton.set("buttonState",0);
         //   this.ifspeedchecklabelbutton.set("buttonState",0);
            this.disableautogentext.style.display = "block";
            this.predefinedautogentext.style.display = "none";
        },

        _hostnameButtonBarClicked: function() {
            // Removing the predefined option for this release
            
            switch (this.autogenchecklabelbutton.get("buttonState")) {
                case 0:
                    this.disableautogentext.style.display = "none";
                    this.predefinedautogentext.style.display = "none";
                    this.customautogentext.style.display = "block";
                    this._enableOk();
                    break;
                case 1:
                    this.disableautogentext.style.display = "block";
                    this.predefinedautogentext.style.display = "none";
                    this.customautogentext.style.display = "none";                                            
                    this._enableOk();
                    break;
                /*case 2:
                    this.disableautogentext.style.display = "block";
                    this.predefinedautogentext.style.display = "none";
                    this.customautogentext.style.display = "none";
                    break;*/
            }
        },

        _checkName: function() {
            if ((this.templateName.get("value").trim() != "") && this.mtuchecklabelbutton.isValid() && (this.mtuchecklabelbutton.get("buttonState") != null)) {
                return true;
            }
            return false;
        },
        
        // this function checks to see whether the user added any DNS entries
        _checkDNSEntryAdded: function(){
            if((this.addndnschecklabelbutton.get("buttonState") == false) && (this._ipv4addndnstable != null) && (this._ipv6addndnstable != null)){
                var ipv4row = this._ipv4addndnstable.getStoreAsJson();
                var ipv6row = this._ipv6addndnstable.getStoreAsJson();
                
                var ipv4rowobj = dojo.fromJson(ipv4row);
                var ipv6rowobj = dojo.fromJson(ipv6row);
                
                if ((ipv4row != undefined && ipv4rowobj.items.length > 0 && ipv4rowobj.items[0].field != null && ipv4rowobj.items[0].field != "") ||
                        (ipv6row != undefined && ipv6rowobj.items.length > 0 && ipv6rowobj.items[0].field != null && ipv6rowobj.items[0].field != "")) {
                    return true;
                } else{
                    return false;
                }
            } else {
                return true;
            }                
        },

        // this function checks to see whether the user added any DNS entries
        _checkDNSIpv6Added: function(){
            if(this.addndnschecklabelbutton.get("buttonState") == false && this._ipv4addndnstable != null
                    && this._ipv6addndnstable != null){
                var ipv4row = this._ipv4addndnstable.getStoreAsJson();
                var ipv6row = this._ipv6addndnstable.getStoreAsJson();
                
                var ipv4rowobj = dojo.fromJson(ipv4row);
                var ipv6rowobj = dojo.fromJson(ipv6row);
                
                if ((ipv6row != undefined && ipv6rowobj.items.length > 0 && ipv6rowobj.items[0].field != null && ipv6rowobj.items[0].field != "")) {
                    if((ipv4row != undefined && ipv4rowobj.items.length > 0 && ipv4rowobj.items[0].field != null && ipv4rowobj.items[0].field != "")){
                        return true;
                    }
                    else{
                        return false;
                    }
                } 
                } else {
                    return true;
                }                
        },
        
        _checkDDNS: function(){
            //console.log("Static:" + this.ddnsradiostatic.get("checked") + " Valid:" + this.ddnstextbox.isValid() + " Dynamic:" + this.ddnsradiodynamic.get("checked"));
            if((this.ddnsradiostatic.get("checked") == true && this.ddnstextbox.isValid() == true) ||
                    this.ddnsradiodynamic.get("checked") == true){
                return true;
            } else {
                return false;
            }
        },

        // this function checks to see whether any of
        //   the DNS entries are are invalid
        _checkDNS: function() {
            // checks if an entry has been added
            if (this.addndnschecklabelbutton.get("buttonState") == 0) {
                if(this._checkDNSEntryAdded() == true){
                    var ipv4row = this._ipv4addndnstable.getStoreAsJson();
                    var ipv6row = this._ipv6addndnstable.getStoreAsJson();
                    
                    var ipv4rowobj = dojo.fromJson(ipv4row);
                    var ipv6rowobj = dojo.fromJson(ipv6row);
                                    
                    // checks that each entry that exists is valid
                    if ((ipv4row == undefined || ipv4rowobj.items.length <= 0 || this._ipv4addndnstable.isValid() == true) && 
                            (ipv6row = undefined || ipv6rowobj.items.length <= 0 || this._ipv6addndnstable.isValid() == true)) {
                        return true;
                    } else{
                        return false;
                    }
                } else {
                    return true;
                }
            }
            else {
                return true;
            }
        },
        
        _checkIPv6MgmtAddress: function(){
            if (this.ipv6staticradiobutton.get("checked") == true || this.ipv6dynamicradiobutton.get("checked") == true || 
                    this.ipv6statelessradiobutton.get("checked") == true) {
                return true;
            } else {
                return false;
            }
        },
        
        _checkPortAssignments: function() {
          var passed = this.httpchecklabelbutton.isValid() &&
              this.httpschecklabelbutton.isValid() &&
              this.telnetclichecklabelbutton.isValid() &&
              this.sshclichecklabelbutton.isValid() &&
              this.snmpagentchecklabelbutton.isValid() &&
              this.snmptrapschecklabelbutton.isValid() &&
              this.cimhttpschecklabelbutton.isValid();
          return passed;
        },

        _enableOk: function() {
            if (!this._isCustomNamePatternValid && (this.autogenchecklabelbutton.get("buttonState") == 0)) {
                this.okButton.set("disabled", true);
                this.saveBtn.set("disabled", true);
                this.saveasBtn.set("disabled", true);
                return;
            }
            
            if (this._checkName() && this._checkIPv6MgmtAddress() && this._checkDDNS() && this._checkPortAssignments()) {
                this.okButton.set("disabled", false);
                this.saveBtn.set("disabled", false);
                this.saveasBtn.set("disabled", false);
            }
            else {
                this.okButton.set("disabled", true);
                this.saveBtn.set("disabled", true);
                this.saveasBtn.set("disabled", true);
            }
        },

        _setup: function() {

            // Set Template Field to catch intermediate changes
            this.templateName.intermediateChanges = true;

            // Set Description Label
            this._descLimit.innerHTML = this.resources.LIMIT.replace("%500", "500");

            // Set Information Messages and Load Previous Settings
            if (this.templateIDNum != null && this.templateMode == "edit") { // if
                // dialog
                // in
                // edit
                // mode

                // this.loadprevSettings();

                // alert(this.templateInUse);

                if (this.templateInUse.toString() == "true") {

                    if (this.templateLaunchPoint == "table") {

                        this.warningMessage.style.display = "block";
                        this.warningMessageText.innerHTML = this.resources.INUSE;
                        this.saveBtnContainer.style.display = "inline";
                        this.saveasBtnContainer.style.display = "inline";

                    }
                    else if (this.templateLaunchPoint == "wizard") {

                        this.informationMessage.style.display = "block";
                        this.informationMessageText.innerHTML = this.resources.INUSEWIZARD;
                        this.saveasBtnContainer.style.display = "inline";

                    }
                    else {
                        this.informationMessage.style.display = "block";
                        this.informationMessageText.innerHTML = this.resources.INUSEWIZARD;
                        this.saveasBtnContainer.style.display = "inline";
                    }

                }
                else {

                    this.saveBtnContainer.style.display = "inline";
                    this.saveasBtnContainer.style.display = "inline";

                }

                this.templateName.set("disabled", true);

            }
            else if (this.templateIDNum != null && this.templateMode == "copy") { // if
                // dialog
                // in
                // copy
                // mode

                // this.loadprevSettings();
                this.templateIDNum = null; // set template ID to null in
                // order to create new template
                this.okBtnContainer.style.display = "inline";

            }
            else { // if dialog in create new mode

                this.okBtnContainer.style.display = "inline";
                this.addndnschecklabelbutton.set("buttonState", 1); //Set DNS list to none as default


            }

        },

        _generateSavedData: function() {
            var ethernetTemplateObj = new Object();

            ethernetTemplateObj.name = this.templateName.get("value").trim();
            ethernetTemplateObj.type = "cmmManagement";

            var description = this.ethadapDesc.get("value").trim();
            ethernetTemplateObj.description = this.encodeSpecialCharacters(description);

            // Needed for profile command generation
            //ethernetTemplateObj.CMM__ifconfig__eth = 0;
            // ethernetTemplateObj.ipv4settingsbuttonvalue =
            // this.ipv4checklabelbutton.get("buttonState");
            
            ethernetTemplateObj.autogenhostnamecheckvalue = 
                (this.autogenchecklabelbutton.get("checkBox") == false) ? false : true;
            ethernetTemplateObj.autogenhostnamebuttonvalue = this.autogenchecklabelbutton.get("buttonState");
            
            var autogenObject = new Object();
            if (this._customnametable){
                autogenObject.pattern = this._customnametable.get("pattern");
            }
            autogenObject.checked = true;
            //autogenObject.hyphenChecked = this._hyphenCheckBox.checked;
            ethernetTemplateObj.CMM__NetworkSettings_autogen_hostname = autogenObject;                                    

            if (this.ipv4checklabelbutton.get("buttonState") == 1) {  //IPv4 buttonState 1 is No Change
                ethernetTemplateObj.ipv4settings = "No Change";
            } else {
                ethernetTemplateObj.ipv4settings = "Enabled";
                // dynamic static
                var ipv4radiobutton = this.ipv4form.get("value").ipv4;
                // ethernetTemplateObj.ipv4settingsradiovalue = ipv4radiobutton;

                if (ipv4radiobutton == "staticip") {
                    ethernetTemplateObj.CMM__ifconfig__c = "static";
                    ethernetTemplateObj.ipv4settingsaddresspoolvalue = this._ipv4selectbox.get("value");
                    var ipv4rangevalue = this._ipv4rangeselectbox.get("value");
                    if (ipv4rangevalue == "any") {
                        ethernetTemplateObj.ipv4settingsrangevalue = null;
                    }
                    else {
                        ethernetTemplateObj.ipv4settingsrangevalue = ipv4rangevalue;
                    }
                }
                else if (ipv4radiobutton == "firstdynamicip") {
                    ethernetTemplateObj.CMM__ifconfig__c = "dthens";
                    ethernetTemplateObj.ipv4settingsaddresspoolvalue = this._ipv4selectbox.get("value");
                    var ipv4rangevalue = this._ipv4rangeselectbox.get("value");
                    if (ipv4rangevalue == "any") {
                        ethernetTemplateObj.ipv4settingsrangevalue = null;
                    }
                    else {
                        ethernetTemplateObj.ipv4settingsrangevalue = ipv4rangevalue;
                    }
                }
                else {
                    ethernetTemplateObj.CMM__ifconfig__c = "dhcp";
                }
            }
            
            if (this.ipv6checklabelbutton.get("buttonState") == 1) {  //IPv6 buttonState 1 is No Change
                ethernetTemplateObj.ipv6settings = "No Change";
            } else {
                ethernetTemplateObj.ipv6settings = "Enabled";
                if (this.ipv6staticradiobutton.get("checked") == true) {
                    // stateless dynamic static
                    ethernetTemplateObj.ipv6settingsaddresspoolvalue = this._ipv6selectbox.get("value");
                    ethernetTemplateObj.CMM__ifconfig__ipv6static = "enabled";
                    var ipv6rangevalue = this._ipv6rangeselectbox.get("value");
                    if (ipv6rangevalue == "any") {
                        ethernetTemplateObj.ipv6settingsrangevalue = null;
                    } else {
                        ethernetTemplateObj.ipv6settingsrangevalue = ipv6rangevalue;
                    }
                } else {
                    ethernetTemplateObj.ipv6settingsaddresspoolvalue = this._ipv6selectbox.get("value");
                    ethernetTemplateObj.CMM__ifconfig__ipv6static = "disabled";
                    var ipv6rangevalue = this._ipv6rangeselectbox.get("value");
                    if (ipv6rangevalue == "any") {
                        ethernetTemplateObj.ipv6settingsrangevalue = null;
                    } else {
                        ethernetTemplateObj.ipv6settingsrangevalue = ipv6rangevalue;
                    }
                    
                }
                
                if (this.ipv6statelessradiobutton.get("checked") == true) {
                    ethernetTemplateObj.CMM__ifconfig__sa6 = "enabled";
                } else{
                    ethernetTemplateObj.CMM__ifconfig__sa6 = "disabled";
                }
                if (this.ipv6dynamicradiobutton.get("checked") == true) {
                    ethernetTemplateObj.CMM__ifconfig__dhcp6 = "enabled";
                } else{
                    ethernetTemplateObj.CMM__ifconfig__dhcp6 = "disabled";
                }
            }
            

            // DNS server search preference settings

            ethernetTemplateObj.DNSsearchsettingscheckvalue = (this.dnssearchchecklabelbutton
                    .get("checkBox") == false) ? false : true;
            /*
            if (this.dnssearchchecklabelbutton.get("checkBox") == false) {
                ethernetTemplateObj.CMM__dns__on = true;
            }
            else {
                ethernetTemplateObj.CMM__dns__off = true;
            }
            */
            // ethernetTemplateObj.DNSsearchsettingsbuttonvalue =
            // this.dnssearchchecklabelbutton.get("buttonState");
            ethernetTemplateObj.CMM__dns__p = (this.dnssearchchecklabelbutton.get("buttonState") == 0) ? "ipv4"
                    : "ipv6";

            // Additional DNS servers

            ethernetTemplateObj.additionalDNScheckvalue = (this.addndnschecklabelbutton.get("checkBox") == false) ? false
                    : true;
            ethernetTemplateObj.additionalDNSbuttonvalue = this.addndnschecklabelbutton.get("buttonState");

            // if buttonstate is List
            // ethernetTemplateObj.additionalDNSipv4
            if (this.addndnschecklabelbutton.get("checkBox") == "on") {
                if (this.addndnschecklabelbutton.get("buttonState") == 0) {
                    // var ipv4dnstablejsonobj =
                    // dojo.fromJson(this.ipv4dnstableentry.getStoreAsJson());
                    var ipv4dnstablejsonobj = dojo.fromJson(this._ipv4addndnstable.getStoreAsJson());

                    if (ipv4dnstablejsonobj != undefined) {
                        // ethernetTemplateObj.ipv4dnstableentries =
                        // ipv4dnstablejsonobj;
                        var ipv4counter;
                        for (ipv4counter = 0; ipv4counter < ipv4dnstablejsonobj.items.length; ++ipv4counter) {
                            switch (ipv4counter) {
                                case 0:
                                    ethernetTemplateObj.CMM__dns__i1 = ipv4dnstablejsonobj.items[0].field;
                                    break;
                                case 1:
                                    ethernetTemplateObj.CMM__dns__i2 = ipv4dnstablejsonobj.items[1].field;
                                    break;
                                case 2:
                                    ethernetTemplateObj.CMM__dns__i3 = ipv4dnstablejsonobj.items[2].field;
                                    break;
                            }
                        }
                    }

                    var ipv6dnstablejsonobj = dojo.fromJson(this._ipv6addndnstable.getStoreAsJson());

                    if (ipv6dnstablejsonobj != undefined) {
                        // ethernetTemplateObj.ipv6dnstableentries =
                        // ipv6dnstablejsonobj;
                        var ipv6counter;
                        for (ipv6counter = 0; ipv6counter < ipv6dnstablejsonobj.items.length; ++ipv6counter) {
                            switch (ipv6counter) {
                                case 0:
                                    ethernetTemplateObj.CMM__dns__i61 = ipv6dnstablejsonobj.items[0].field;
                                    break;
                                case 1:
                                    ethernetTemplateObj.CMM__dns__i62 = ipv6dnstablejsonobj.items[1].field;
                                    break;
                                case 2:
                                    ethernetTemplateObj.CMM__dns__i63 = ipv6dnstablejsonobj.items[2].field;
                                    break;
                            }
                        }
                    }
                    
                }
            }

            //If any dns servers are configured, enable these dns servers on CMM
            if(ethernetTemplateObj.CMM__dns__i61 || ethernetTemplateObj.CMM__dns__i62 || ethernetTemplateObj.CMM__dns__i63
                    || ethernetTemplateObj.CMM__dns__i1 || ethernetTemplateObj.CMM__dns__i2 || ethernetTemplateObj.CMM__dns__i3){
                ethernetTemplateObj.CMM__dns__on = true;
            }
            else{
                ethernetTemplateObj.CMM__dns__off = true;
            }
            // DDNS settings

            ethernetTemplateObj.DDNSsettingscheckvalue = (this.ddnschecklabelbutton.get("checkBox") == false) ? false
                    : true;
            // ethernetTemplateObj.DDNSsettingsbuttonvalue =
            // this.ddnschecklabelbutton.get("buttonState");
            ethernetTemplateObj.CMM__dns__ddns = (this.ddnschecklabelbutton.get("buttonState") == true) ? "enabled"
                    : "disabled";
            // dhcp or domain name
            // var ddnsradiobutton = this.ddnsform.attr("value").ddns;
            // alert(ddnsradiobutton);
            if (this.ddnschecklabelbutton.get("checkBox") == "on") {
                if (this.ddnschecklabelbutton.get("buttonState") == true) {
                    var ddnsradiobutton = this.ddnsradiodynamic.get("value");
                    if (ddnsradiobutton != false) {
                        // ethernetTemplateObj.DDNSsettingsradiovalue =
                        // "dhcp";
                        // ethernetTemplateObj.CMM__dns__dnsrc = "dhcp";
                    }
                    else {
                        // ethernetTemplateObj.CMM__dns__dnsrc = "manual";
                        // ethernetTemplateObj.DDNSsettingsradiovalue =
                        // this.ddnstextbox.get("value");
                        ethernetTemplateObj.CMM__ifconfig__dn = this.ddnstextbox.get("value");
                    }
                }
            }

            // Interface speed

         //   ethernetTemplateObj.interfacespeedsettingscheckvalue = (this.ifspeedchecklabelbutton
           //         .get("checkBox") == false) ? false : true;
            // ethernetTemplateObj.interfacespeedsettingsbuttonvalue =
            // this.ifspeedchecklabelbutton.get("buttonState");

           /* if (this.ifspeedchecklabelbutton.get("checkBox") == "on") {
                if (this.ifspeedchecklabelbutton.get("buttonState") == 1) {
                    ethernetTemplateObj.CMM__ifconfig__auto = "false";
                    // if buttonstate is Manual = 1
                    if (this.dataRateButtonBar.get("selIndex") == 0) {
                        // ethernetTemplateObj.interfacespeedsettingsdataratevalue
                        // = "10Mb";
                        ethernetTemplateObj.CMM__ifconfig__r = "10";
                    }
                    else {
                        // ethernetTemplateObj.interfacespeedsettingsdataratevalue
                        // = "100Mb";
                        ethernetTemplateObj.CMM__ifconfig__r = "100";
                    }
                    if (this.duplexButtonBar.get("selIndex") == 0) {
                        // ethernetTemplateObj.interfacespeedsettingsduplexvalue
                        // = "Half";
                        ethernetTemplateObj.CMM__ifconfig__d = "half";
                    }
                    else {
                        // ethernetTemplateObj.interfacespeedsettingsduplexvalue
                        // = "Full";
                        ethernetTemplateObj.CMM__ifconfig__d = "full";
                    }
                }
                else {
                    ethernetTemplateObj.CMM__ifconfig__auto = "true";
                    ethernetTemplateObj.CMM__ifconfig__r = "auto";
                    ethernetTemplateObj.CMM__ifconfig__d = "auto";
                }
            }*/

            // MTU

            ethernetTemplateObj.MTUsettingscheckvalue = (this.mtuchecklabelbutton.get("checkBox") == false) ? false
                    : true;
            if (this.mtuchecklabelbutton.get("checkBox") == "on") {
                // ethernetTemplateObj.MTUsettingsmtuvalue =
                // this.mtuchecklabelbutton.get("buttonState");
                ethernetTemplateObj.CMM__ifconfig__m = this.mtuchecklabelbutton.get("buttonState");
            }

            ethernetTemplateObj.CMM__ifconfig__T = "mm[P]";
            ethernetTemplateObj.CMM__dns__T = "mm[P]";
            
            var portsObj = new Object();
            if(this.httpchecklabelbutton.isValid() && !isNaN(this.httpchecklabelbutton.get("buttonState"))){
                portsObj.CMM__ports__httpp = this.httpchecklabelbutton.get("buttonState");   
            }
            if(this.httpschecklabelbutton.isValid() && !isNaN(this.httpschecklabelbutton.get("buttonState"))){
                portsObj.CMM__ports__httpsp = this.httpschecklabelbutton.get("buttonState");   
            }
            if(this.telnetclichecklabelbutton.isValid() && !isNaN(this.telnetclichecklabelbutton.get("buttonState"))){
                portsObj.CMM__ports__telnetp = this.telnetclichecklabelbutton.get("buttonState");   
            }
            if(this.sshclichecklabelbutton.isValid() && !isNaN(this.sshclichecklabelbutton.get("buttonState"))){
                portsObj.CMM__ports__sshp = this.sshclichecklabelbutton.get("buttonState");   
            }
            if(this.snmpagentchecklabelbutton.isValid() && !isNaN(this.snmpagentchecklabelbutton.get("buttonState"))){
                portsObj.CMM__ports__snmpap = this.snmpagentchecklabelbutton.get("buttonState");   
            }
            if(this.snmptrapschecklabelbutton.isValid() && !isNaN(this.snmptrapschecklabelbutton.get("buttonState"))){
                portsObj.CMM__ports__snmptp = this.snmptrapschecklabelbutton.get("buttonState");   
            }
            if(this.cimhttpschecklabelbutton.isValid() && !isNaN(this.cimhttpschecklabelbutton.get("buttonState"))){
                portsObj.CMM__ports__cimp = this.cimhttpschecklabelbutton.get("buttonState");   
            }
            portsObj.CMM__ports__T = "mm[p]";
            ethernetTemplateObj["CMM Ports"] = portsObj;
            return ethernetTemplateObj;
        },
        
        _displayPortAssignmentSettings: function(evt) {
            this._setExpandCollapseIcon();
            this._togglePortAssignmentSettings();
            this.layout();
        },

        _togglePortAssignmentSettings: function() {console.log(this.declaredClass + ": ", this.httptr);
            if (this.hideuncheckedToggleButtonId.get("checked") == true && this.portassignmentCheckBoxId.get("value") == "on") {
                if(this.httpchecklabelbutton.get("buttonState") == 80){
                    this.httptr.style.display = "none";
                }
                if(this.httpschecklabelbutton.get("buttonState") == 443){
                    this.httpstr.style.display = "none";
                }
                if(this.telnetclichecklabelbutton.get("buttonState") == 23){
                    this.telnetclitr.style.display = "none";
                }
                if(this.sshclichecklabelbutton.get("buttonState") == 22){
                    this.sshclitr.style.display = "none";
                }
                if(this.snmpagentchecklabelbutton.get("buttonState") == 161){
                    this.snmpagenttr.style.display = "none";
                }
                if(this.snmptrapschecklabelbutton.get("buttonState") == 162){
                    this.snmptrapstr.style.display = "none";
                }
                if(this.cimhttpschecklabelbutton.get("buttonState") == 5989){
                    this.cimhttpstr.style.display = "none";
                }
            } 
            else if(this.portassignmentCheckBoxId.get("value") == "on"){
                this.httptr.style.display = "block";
                this.httpstr.style.display = "block";
                this.telnetclitr.style.display = "block";
                this.sshclitr.style.display = "block";
                this.snmpagenttr.style.display = "block";
                this.snmptrapstr.style.display = "block";
                this.cimhttpstr.style.display = "block";
            }
            else if(this.portassignmentCheckBoxId.get("value") == false){
                this.httptr.style.display = "none";
                this.httpstr.style.display = "none";
                this.telnetclitr.style.display = "none";
                this.sshclitr.style.display = "none";
                this.snmpagenttr.style.display = "none";
                this.snmptrapstr.style.display = "none";
                this.cimhttpstr.style.display = "none";
            }
            
        }

    });
});