define([
    "dojo",
    "dijit",
    "support/dialogs/Dialog",
    "dojo/i18n!./nls/ChassisNodePopup",
    "dojo/text!./templates/ChassisNodePopup.html",
    "dojo/parser",    
    "support/widgets/Select",
    "dojo/data/ItemFileReadStore",
    "dijit/form/Button",
    "dijit/layout/BorderContainer",
    "dijit/layout/ContentPane"
	], function(dojo, dijit, dialog, mri, template) {
    
    return dojo.declare("support.dialogs.ChassisNodePopup", [ support.dialogs.Dialog ], {
        
        // templateString: [protected] String
        // This widget's HTML template, provided.
        templateString: template,
             
        // locResources: [protected] Object
        // This widget's National Language Source (NLS) object.
        locResources: mri,
        
        baseClass: "ChassisNodePopup",
        
        bayNum: "",
        baySelections: null,
                
        _typeStore: null,
        _ffStore: null,
        _typeStore_even: null,
        _ffStore_even: null,
        _ffDefaults: null,
        _ffDefaults_even: null,
        _ffDefaults_4: null,
        _typeDefaults: null,
        _typeDefaults_even: null,
        
        POWER_NODE: 1,
        STORAGE_NODE: 2,
        
        // the name of the CSS stylesheet of this page
        spCssPathAndName: "support/dialogs/themes/ChassisNodePopup.css",

        // When this method is called, all variables inherited from superclasses are "mixed in".
        // Common operations for postMixInProperties
        // 1) Modify or assign values for widget property variables defined in the template HTML
        // file
        postMixInProperties: function() {
            this.inherited(arguments);
        },

        // postCreate() is called after buildRendering(). This is useful to override when
        // you need to access and/or manipulate DOM nodes included with your widget.
        // DOM nodes and widgets with the dojoAttachPoint attribute specified can now be directly
        // accessed as fields on "this".
        // Common operations for postCreate
        // 1) Access and manipulate DOM nodes created in buildRendering()
        // 2) Add new DOM nodes or widgets
        postCreate: function() {
            this.inherited(arguments);
            
            dojo.connect(this.dialogNode, "hide", this, function() {        
                this.destroy();
            });

            this._connectDataModels();
            this._createSelectBoxes();
            
        },
        
        _createSelectBoxes: function() {

            //if even then load even store
                if(this.bayNum%2 == 0){

                    this._typeSelector = new support.widgets.Select({
                        //id: this.get("id") + "_typeSelector",
                        name : "_typeSelector",
                        store : this._typeStore_even,
                        emptyLabel : "",
                        onChange: dojo.hitch(this,function(newVal){
                            this._ffSelector.setStore(this._ffStore_even);                                                                 
                            
                        })
                    }).placeAt(this._typeSelector);

                    this._ffSelector = new support.widgets.Select({
                        //id: this.get("id") + "_ffSelector",
                        name : "_ffSelector",
                        store : this._ffStore_even,
                        emptyLabel : ""
                    }).placeAt(this._ffSelector);
                
                }else if(this.bayNum == 13){
                    
                    this._typeSelector = new support.widgets.Select({
                        //id: this.get("id") + "_typeSelector",
                        name : "_typeSelector",
                        store : this._typeStore_even,
                        emptyLabel : "",
                        onChange: dojo.hitch(this,function(newVal){
                            this._ffSelector.setStore(this._ffStore);                                                                 
                            
                        })
                    }).placeAt(this._typeSelector);

                    this._ffSelector = new support.widgets.Select({
                        //id: this.get("id") + "_ffSelector",
                        name : "_ffSelector",
                        store : this._ffStore,
                        emptyLabel : ""
                    }).placeAt(this._ffSelector);

                
                }else{

                    this._typeSelector = new support.widgets.Select({
                        //id: this.get("id") + "_typeSelector",
                        name : "_typeSelector",
                        store : this._typeStore,
                        emptyLabel : "",
                        onChange: dojo.hitch(this,function(newVal){
                            if(newVal == this.STORAGE_NODE){
                                this._ffSelector.setStore(this._ffStore_4); 
                            }
                            else{
                                this._ffSelector.setStore(this._ffStore);                                 
                            }
                        })
                    }).placeAt(this._typeSelector);

                    this._ffSelector = new support.widgets.Select({
                        //id: this.get("id") + "_ffSelector",
                        name : "_ffSelector",
                        store : this._ffStore,
                        emptyLabel : ""
                    }).placeAt(this._ffSelector);

                }
     
        },
        
        _connectDataModels: function() {
                this.dialogNode.set("title",this.locResources.TITLE.replace("%1", this.bayNum));
                this._ffDefaults = {
                    "identifier": "id",
                    "label": "name",
                    "items": [{
                        "id": 1,
                        "name": this.locResources.FF.replace("%1",1)
                    },
                    {
                        "id": 2,
                        "name": this.locResources.FF.replace("%1",2)
                    }]
                };
                
                this._ffDefaults_even = {
                        "identifier": "id",
                        "label": "name",
                        "items": [{
                            "id": 1,
                            "name": this.locResources.FF.replace("%1",1)
                        }]
                };

                this._ffDefaults_4 = {
                        "identifier": "id",
                        "label": "name",
                        "items": [{
                            "id": 4,
                            "name": this.locResources.FF.replace("%1",4)
                        }]
                };
                this._typeDefaults = {
                        "identifier": "id",
                        "label": "name",
                        "items": [ {
                            "id": this.POWER_NODE,
                            "name": this.locResources.NODE_TYPE_1
                        }, {
                            "id": this.STORAGE_NODE,
                            "name": this.locResources.NODE_TYPE_2
                        } ]
            };
                this._typeDefaults_even = {
                        "identifier": "id",
                        "label": "name",
                        "items": [ {
                            "id": this.POWER_NODE,
                            "name": this.locResources.NODE_TYPE_1
                        } ]
            };

                this._typeStore = new dojo.data.ItemFileReadStore({
                    data: this._typeDefaults
                });
                this._typeStore_even = new dojo.data.ItemFileReadStore({
                    data: this._typeDefaults_even
                });
                this._ffStore = new dojo.data.ItemFileReadStore({
                    data: this._ffDefaults
                });
                this._ffStore_even = new dojo.data.ItemFileReadStore({
                    data: this._ffDefaults_even
                });
                this._ffStore_4 = new dojo.data.ItemFileReadStore({
                    data: this._ffDefaults_4
                });
        },
        
        _saveandhideDialog: function() {
            var ff = this._ffSelector.get("value");
            var type = this._typeSelector.get("value");
            var returnData = {
                    type: type,
                    formFactor: ff,
                    bayNum: this.bayNum
            };
            dojo.publish("NodeFormatComplete",returnData),
            this.hide();
        },
        
        _cancelDialog: function() {
            this.hide();
        }          
    });
});
