define(["dojo",
	    "dijit",
	    "support/dialogs/Dialog",
        "dojo/i18n!./nls/ChassisPowerAndAcousticsTemplate",                                                  
        "dojo/text!./templates/ChassisPowerAndAcousticsTemplate.html",
        "dijit/form/SimpleTextarea",
        "dijit/form/NumberSpinner",
        "dijit/form/RadioButton",
        "dijit/form/Select",
        "dijit/form/TimeTextBox", 
        "dijit/Dialog", 
        "dojo/parser",
        "support/widgets/ToggleButton",
        "support/widgets/ButtonBar", 
        "dijit/layout/BorderContainer", 
        "dijit/layout/ContentPane", 
        "dijit/Tooltip",
        "support/panels/CheckButton",
        "support/dialogs/ReDeployServerTemplate",
        "support/dialogs/SaveAs",
        "support/dialogs/ProgressDialog"
        ], function(dojo, dijit, dialog, mri, template) {

    return dojo.declare("support.dialogs.ChassisPowerAndAcousticsTemplate", [ support.dialogs.Dialog], {

        // templateString: [protected] String
        // This widget's HTML template, provided.
        templateString: template,
            
        // locResources: [protected] Object
        // This widget's National Language Source (NLS) object.
        locResources: mri, 
        
        // baseClass: [protected] String
        // The root CSS className to be placed on this widget's domNode.
        baseClass: "ChassisPowerAndAcousticsTemplate",
        
        repeatVar: null,
        mycheckVar: null,
        hidecheckVar: null,
        maxPercent: .40,
        store: "",
        templateIDNum: null,
        initialData: null,
        
        OPT1_NAME: "acred",
        OPT2_NAME: "acredov",
        OPT3_NAME: "redwoperf",
        OPT4_NAME: "redwperf",
        OPT5_NAME: "nonred",

        // the name of the CSS stylesheet of this page
        spCssPathAndName: "support/dialogs/themes/ChassisPowerAndAcousticsTemplate.css",

        // When this method is called, all variables inherited from superclasses are "mixed in".
        // Common operations for postMixInProperties
        // 1) Modify or assign values for widget property variables defined in the template HTML
        // file
        postMixInProperties: function() {
            this.inherited(arguments);
        },

        // postCreate() is called after buildRendering(). This is useful to override when
        // you need to access and/or manipulate DOM nodes included with your widget.
        // DOM nodes and widgets with the dojoAttachPoint attribute specified can now be directly
        // accessed as fields on "this".
        // Common operations for postCreate
        // 1) Access and manipulate DOM nodes created in buildRendering()
        // 2) Add new DOM nodes or widgets
        postCreate: function() {
            
            this.inherited(arguments);

            dojo.connect(this.dialogNode, "hide", this, function() {        
                this.destroy();
            });

            //Setup for template new, edit, or copy mode 
            this._setup();
                    
            //Controls dialog dynamic resizing max height 
        //    var availHeight = window.screen.availHeight;
          //  var maxHeight = availHeight * this.maxPercent;
            //this.settingsContainer.setAttribute("style", "max-height:" + maxHeight + "px");
          
            //Resizes dialog
            this.layout(); 
  
        },
        toggle1: function(){
            
            if(this.mycheck1.get("checked") == true){
                this.settingsSelectionArea1.style.display = "block";
                //this.settingsButton1_1.style.display = "inline";
                this.togglesettingsBorder1_1();
            }else{
                this.settingsSelectionArea1.style.display = "none";
                //this.settingsButton1_1.style.display = "none";
                this.settingsBorder1_1.style.display = "none";
            }
            
            this._setExpandCollapseIcon();                                  
            this.layout();

        },
        togglesettingsBorder1_1: function(){
            
                this.settingsBorder1_1.style.display = "inline-block";           
            this.layout();           
        },

        _togglePowerCapping: function(){
            if(this.powerCappingBorder.style.display == "none"){
                this.powerCappingBorder.style.display = "";
            }
            else {
                this.powerCappingBorder.style.display = "none";
            }
            
        },
        
        _toggleAttenuation: function(){
            if(this._attenuationArea.style.display == "none"){
                this._attenuationArea.style.display = "";
            }
            else {
                this._attenuationArea.style.display = "none";
            }
        },
       
        _checkExpandCollapseState: function() {
            var mycheck1BoxState = this.mycheck1.get("value");
            var mycheck6BoxState = this.mycheck6.get("value");
         
            /* value on = checked, false = unchecked */

            if (mycheck1BoxState == "on" && mycheck6BoxState == "on") {
                return "allon";
            }
            if (mycheck1BoxState == false && mycheck6BoxState == false) {
                return "alloff";
            }

            return "mixed";
        },

        _setExpandCollapseIcon: function() {
            if (this._checkExpandCollapseState() == "mixed") {
                this.expandall.style.display = "none";
                this.collapseall.style.display = "none";
                this.mixedexpandcollapse.style.display = "inline";
            }
            if (this._checkExpandCollapseState() == "allon") {
                this.expandall.style.display = "none";
                this.collapseall.style.display = "inline";
                this.mixedexpandcollapse.style.display = "none";
            }
            if (this._checkExpandCollapseState() == "alloff") {
                this.expandall.style.display = "inline";
                this.collapseall.style.display = "none";
                this.mixedexpandcollapse.style.display = "none";
            }
        },

        hideDefaultSettings: function() {

            if (this.hideButton.get("checked")) {
                if (this.pwr1.get("checked")) {
                    //this.settingsSelectionArea1.style.display = "none";
                    //this.mygroup1_1.style.display = "none";
                    this.settingsBorder1_1.style.display = "none";
                }
                if (this.powerCappingBorder.style.display == "none") {
                    //this.powerCappingArea.style.display = "none";
                    this.settingsPowerCapping.style.display = "none";
                }
                if (this.attenuationSelector.get("value") == "off") {
                    this._attenuationArea.style.display = "none";
                }
            }
            else {
                //this.settingsSelectionArea1.style.display = "";
                //this.mygroup1_1.style.display = "";
                this.settingsBorder1_1.style.display = "inline-block";
                //this.powerCappingArea.style.display = "inline";
                this.settingsPowerCapping.style.display = "inline-block";
                this._attenuationArea.style.display = "";
            }
        },
        
        cancelClicked: function() {
            this.hide();
        },
        
        createClicked: function() {

            var templateObject = this._generateSaveData();
                
            var argJSONString = dojo.toJson({ 
                "identifier":"id",
                  "label":"name",
                  "items":[ templateObject ]
            }, true);



            this.getProgressDialog("save").show(); // Show progress dialog for save request.
            var xhrPost = dojo.xhrPost({
                url: this.REST_PATH + "template/create",
                handleAs: "json", // <<<< Required
                headers: {
                    "Content-Type": "application/json; charset=utf-8" // <<<< Required
                },
                postData: argJSONString,     //Template Data to Post
                load: dojo.hitch(this, function(response, ioArgs) {
                    // Happy path! We received a 2xx status code from the API.
                                            
                    dojo.publish("ProgressComplete", response.id);
                    dojo.publish("ChassisPowerComplete", response.id);
                    this.hide();   
                }),
                error: dojo.hitch(this, function(error, ioArgs) {
                    // Failure path! We received a non-2xx status code (ie: 3xx/4xx/5xx status code) from the API.

                    dojo.publish("ProgressFailed", error);
                    console.log(this.declaredClass + ": ", error, ioArgs);
                    
                    var response = dojo.fromJson(ioArgs.xhr.responseText);
                    if ((ioArgs.xhr.status >= 400) && (response.message == "service_error_name_in_use")) {
                        // Error Template name in use
                        this.getModalDialog("Error", this.resources.ERROR_400_NAME).show();
                    }
                    else if(ioArgs.xhr.status == 404) {
                        // Edit Template ID doesn't exist
                        this.getModalDialog("Error", this.resources.ERROR_404_ID).show();
                        this.hide();
                    }
                    else if(ioArgs.xhr.status >= 500) {
                        // Internal Programming Error
                        this.getModalDialog("Error", this.resources.ERROR_500_INTERNAL).show();
                        this.hide();
                    }
                    else {
                        this.getModalDialog("Error", this.resources.ERROR_TEMPLATE_CREATE).show();
                        this.hide();
                    }
                    
                }),
                handle: dojo.hitch(this, function(data, ioArgs) {
                    // - The 1st param ("data") is either the response data (on success) or Error object (on failure).
                    // - The 2nd param ("ioArgs") contains detail about the xhr request, including a reference to the
                    // native xhr object. Check ioArgs.xhr.status to determine success or failure, and handle "data"
                    // accordingly.
                })
            });

          },          
          saveClicked: function() {

              var templateObject = this._generateSaveData();
              var argJSONString = dojo.toJson({ 
                  "identifier":"id",
                    "label":"name",
                    "items":[ templateObject ]
              }, true);

//              alert(argJSONString);

              var saveTemplate = true;
              
              if(this.templateInUse.toString() == "true"){
              //  Need to remove extra properties that aren't included in the dialog
                  delete this.initialData[0].inUse;
                  delete this.initialData[0].uri;
                  delete this.initialData[0].referencedBy;
                  delete this.initialData[0].useCount;
                  delete this.initialData[0].userDefined;
                  
                  // Remove description since it shouldn't force a redeploy
                  delete this.initialData[0].description;
                  delete templateObject.description;
                  
                  var preData = this.sortAndFlatten(this.initialData[0]);
                  var postData = this.sortAndFlatten(templateObject);
                  
                  if(preData != postData){
                      this.rdstDialog.set("templateID",this.templateIDNum);
                      this.rdstDialog.set("templateType","Category");
                      this.rdstDialog.set("templateData",argJSONString);

                      this.rdstDialog.show();
                      
                      saveTemplate = false;
                  }
              }
              if (saveTemplate){

                  this.getProgressDialog("save").show(); // Show progress dialog for save request.
                  var xhrPost = dojo.xhrPost({
                      url: this.REST_PATH + "template/create",
                      handleAs: "json", // <<<< Required
                      headers: {
                          "Content-Type": "application/json; charset=utf-8" // <<<< Required
                      },
                      postData: argJSONString,     //Template Data to Post
                      load: dojo.hitch(this, function(response, ioArgs) {
                          // Happy path! We received a 2xx status code from the API.
                                                  
                          dojo.publish("ProgressComplete", response.id);
                          dojo.publish("ChassisPowerComplete", response.id);
                          this.hide();   
                      }),
                      error: dojo.hitch(this, function(error, ioArgs) {
                          // Failure path! We received a non-2xx status code (ie: 3xx/4xx/5xx status code) from the API.

                          dojo.publish("ProgressFailed", error);
                          console.log(this.declaredClass + ": ", error, ioArgs);
                          
                          var response = dojo.fromJson(ioArgs.xhr.responseText);
                          if ((ioArgs.xhr.status >= 400) && (response.message == "service_error_name_in_use")) {
                              // Error Template name in use
                              this.getModalDialog("Error", this.resources.ERROR_400_NAME).show();
                          }
                          else if(ioArgs.xhr.status == 404) {
                              // Edit Template ID doesn't exist
                              this.getModalDialog("Error", this.resources.ERROR_404_ID).show();
                              this.hide();
                          }
                          else if(ioArgs.xhr.status >= 500) {
                              // Internal Programming Error
                              this.getModalDialog("Error", this.resources.ERROR_500_INTERNAL).show();
                              this.hide();
                          }
                          else {
                              this.getModalDialog("Error", this.resources.ERROR_TEMPLATE_CREATE).show();
                              this.hide();
                          }
                          
                      }),
                      handle: dojo.hitch(this, function(data, ioArgs) {
                          // - The 1st param ("data") is either the response data (on success) or Error object (on failure).
                          // - The 2nd param ("ioArgs") contains detail about the xhr request, including a reference to the
                          // native xhr object. Check ioArgs.xhr.status to determine success or failure, and handle "data"
                          // accordingly.
                      })
                  });
        
              }

              
              
              
            },
            saveasClicked: function() {      
                var templateObject = this._generateSaveData();
                this.saveasDialog.set("templateObject",templateObject);
                this.saveasDialog.show();

            },          
            loadprevSettings: function() {
                
                var mode = this.templateMode;
                var inUse = false;           
                
                var xhrGet = dojo.xhrGet({
                    url: this.REST_PATH + "template/"+this.templateIDNum,
                    handleAs: "json",
                    sync: true,
                    preventCache: true,
                    load: dojo.hitch(this,function(response){
                        this.store = response;
                        inUse = this.store.items[0].inUse;

                        if(mode == "copy"){
                            this.dialogNode.set("title", this.locResources.TITLE + " - " + this.store.items[0].name + " - " + this.resources.COPY);
                            this.templateName.set("value", this.store.items[0].name + " - " + this.resources.COPY);
                        }else{
                            this.dialogNode.set("title", this.locResources.EDIT_TITLE + " - " + this.store.items[0].name);
                            this.templateName.set("value", this.store.items[0].name);
                        }
            
                        var descriptionvalue = this.decodeSpecialCharacters(this.store.items[0].description);
                        this.description.set("value", descriptionvalue);
                        //Power Settings

                        if(this.store.items[0].powerSettings.CMM__pmpolicy__pm == this.OPT1_NAME){
                            this.pwr1.set("checked",true);           
                        }else if(this.store.items[0].powerSettings.CMM__pmpolicy__pm == this.OPT2_NAME){
                            this.pwr2.set("checked",true);                                        
                        }else if(this.store.items[0].powerSettings.CMM__pmpolicy__pm == this.OPT3_NAME){
                            this.pwr3.set("checked",true);                    
                        }else if(this.store.items[0].powerSettings.CMM__pmpolicy__pm == this.OPT4_NAME){
                            this.pwr4.set("checked",true);           
                        }else if(this.store.items[0].powerSettings.CMM__pmpolicy__pm == this.OPT5_NAME){
                            this.pwr5.set("checked",true);           
                        }
                        //Capping
                        if(this.store.items[0].powerCapping.CMM__fuelg__pme == "static"){
                            this.staticNumSpinner.set("value",this.store.items[0].powerCapping.CMM__fuelg__spl);
                            this.togglePowerCapping.set("enabled", true);
                            this._togglePowerCapping();
                            
                        }
                        //Attenuation
                        if(this.store.items[0].acousticSettings){
                            if(this.store.items[0].acousticSettings.CMM__fuelg__am){
                                    this.attenuationSelector.set("value",this.store.items[0].acousticSettings.CMM__fuelg__am);
                            }
                            else {
                                this.attenuationSelector.set("value","off");
                            }
                        }
                        
                })
                
            });

            this.initialData = this.store.items;
            
            this.templateInUse = inUse;

            return this.templateName.get("value").trim();

        },
        exitParent: function() {
            var data = "performance";
            
            dojo.publish("ChassisPowerComplete", data);

            if(this.rdstDialog != null){
                var deployClicked = this.rdstDialog.get("closeParent");
                if(deployClicked) {
                    this.hide();
                }
            }
        },
        _expandall: function() {
            this.mycheck1.set("checked", true);
            this.mycheck6.set("checked", true);
 
            this.expandall.style.display = "none";
            this.collapseall.style.display = "inline";
            this.mixedexpandcollapse.style.display = "none";
                  
            this.toggle1();
            this._attenuationArea.style.display = "none";
            
            this.layout();
        },
        
        _collapseall: function() {
            this.mycheck1.set("checked", false);
            this.mycheck6.set("checked", false);
 
            this.expandall.style.display = "inline";
            this.collapseall.style.display = "none";
            this.mixedexpandcollapse.style.display = "none";
           
            this.toggle1();
            this._attenuationArea.style.display = "";
            
            this.layout();

        },        
        _nameChanged: function() {                        

            if ((this.templateName.get("value").trim() != "") 
                    && (this.settingsPowerCapping.enabled == false 
                            || this.staticNumSpinner.get("displayedValue").trim() != "")) {
                this.okBtn.set("disabled", false);
                this.saveBtn.set("disabled", false);
                this.saveasBtn.set("disabled", false);
            }
            else {
                this.okBtn.set("disabled", true);
                this.saveBtn.set("disabled", true);
                this.saveasBtn.set("disabled", true);
            }
           
        },
        _setup: function(){

            //Set Template Field to catch intermediate changes
            this.templateName.intermediateChanges = true;

            // Set Description Label
            this._descLimit.innerHTML = this.resources.LIMIT.replace("%500","500");
            
            // Set Power Capping Number Spinner (values are % of power available)
            this.staticNumSpinner = new dijit.form.NumberSpinner({
                id: "cp_chassispowerandacousticstemplate_staticnumspinner",
                value: 100,
                constraints: {
                    min: 1,
                    max: 100
                },
                onChange: dojo.hitch(this, function() {
                    this._nameChanged();
                })
            }).placeAt(this._staticNumSpinner);
            
            //Set attenuation selector
            this.attenuationSelector = new dijit.form.Select({
                id: "cp_chassispowerandacousticstemplate_attenuationselector",
                options: [
                          { label: "5 - " + this.locResources.MOST_ATTENUATION, value: "5"},
                          { label: "4", value: "4" },
                          { label: "3", value: "3" },
                          { label: "2", value: "2" },
                          { label: "1 - " + this.locResources.LEAST_ATTENUATION, value: "1"},
                          { label: this.resources.OFF + " - " + this.locResources.NO_ATTENUATION, value: "off", selected: true}
                      ]
            }).placeAt(this._attenuationSelector);

            //Set Information Messages and Load Previous Settings                      
            if(this.templateIDNum != null && this.templateMode == "edit"){     //if dialog in edit mode    

                this.loadprevSettings();

                if(this.templateInUse.toString() == "true"){
                   
                    if(this.templateLaunchPoint == "table"){
                        
                        this.warningMessage.style.display = "block";
                        this.warningMessageText.innerHTML = this.resources.INUSE;
                        this.saveBtnContainer.style.display = "inline";
                        this.saveasBtnContainer.style.display = "inline";
                        
                    }else if(this.templateLaunchPoint == "wizard"){
                        
                        this.informationMessage.style.display = "block";
                        this.informationMessageText.innerHTML = this.resources.INUSEWIZARD;
                        this.saveasBtnContainer.style.display = "inline";
                        
                    }else{
                        this.informationMessage.style.display = "block";
                        this.informationMessageText.innerHTML = this.resources.INUSEWIZARD;
                        this.saveasBtnContainer.style.display = "inline";
                    }
                    this.templateName.set("disabled",true);
                }else{
                    
                    this.saveBtnContainer.style.display = "inline";
                    this.saveasBtnContainer.style.display = "inline";
                                        
                }    

                this._expandall();

             }else if(this.templateIDNum != null && this.templateMode == "copy"){    //if dialog in copy mode     
                 this.loadprevSettings();
                 this.templateIDNum = null;  //set template ID to null in order to create new template
                 this.okBtnContainer.style.display = "inline";
                 
                 this._collapseall();

             }else{     //if dialog in create new mode                
                 this.okBtnContainer.style.display = "inline";
                 this._expandall();

             } 

        },
        
        _generateSaveData: function(){
            var templateObject = new Object();
            
            var namevalue = this.templateName.get("value").trim();
            templateObject.name = namevalue;
            
            templateObject.type = "cmmPower";
            
            var descriptionvalue = this.description.get("value").trim();
            templateObject.description = this.encodeSpecialCharacters(descriptionvalue);

            // Power settings
            var pwrSettingsObject = new Object();

            if(this.pwr1.get("checked") == true){
                pwrSettingsObject.CMM__pmpolicy__pm = this.OPT1_NAME;                    
            }else if(this.pwr2.get("checked") == true){
                pwrSettingsObject.CMM__pmpolicy__pm = this.OPT2_NAME;                            
            }else if(this.pwr3.get("checked") == true){
                pwrSettingsObject.CMM__pmpolicy__pm = this.OPT3_NAME;                                       
            }else if(this.pwr4.get("checked") == true){
                pwrSettingsObject.CMM__pmpolicy__pm = this.OPT4_NAME;                                       
            }else if(this.pwr5.get("checked") == true){
                pwrSettingsObject.CMM__pmpolicy__pm = this.OPT5_NAME;                                         
            }
            pwrSettingsObject.CMM__pmpolicy__T = "system";
            pwrSettingsObject.CMM__pmpolicy__pd = true;
            templateObject.powerSettings = pwrSettingsObject;
            
            // Power capping
            var pwrCappingObject = new Object();
            pwrCappingObject.CMM__fuelg__pme = (this.togglePowerCapping.get("enabled"))? "static":"none";
            if(this.togglePowerCapping.get("enabled")){
                pwrCappingObject.CMM__fuelg__spl = this.staticNumSpinner.get("value").toString();
            }
            else {
                pwrCappingObject.CMM__fuelg__spl = null;
            }
            pwrCappingObject.CMM__fuelg__T = "system";
            templateObject.powerCapping = pwrCappingObject;
            
            var attObject = new Object;
            attObject.CMM__fuelg__am = this.attenuationSelector.get("value");
            attObject.CMM__fuelg__T = "system";
            
            templateObject.acousticSettings = attObject;
            
            // If doing an edit, need to add the id
            if (this.templateIDNum != null && this.templateMode != "copy") {
                templateObject.id = this.templateIDNum;
            }
            else {
                this.templateIDNum = null;
            }

            
            return templateObject;

        }
   
    });
});