define([ "dojo", 
         "dijit", 
         "support/dialogs/Dialog", 
         "dojo/i18n!./nls/DevicesAndIOPortsTemplate",
         "dojo/text!./templates/DevicesAndIOPortsTemplate.html", 
         "dijit/form/SimpleTextarea",
         "dijit/form/Select", 
         "dijit/form/TimeTextBox", 
         "dijit/Dialog", 
         "dojo/parser",
         "support/widgets/ToggleButton",
         "support/widgets/ButtonBar", 
         "dijit/layout/BorderContainer", 
         "dijit/layout/ContentPane", 
         "dijit/Tooltip", 
         "dojo/parser", 
         "support/panels/CheckButton",
         "support/dialogs/ReDeployServerTemplate", 
         "support/dialogs/SaveAs", 
         "support/dialogs/ProgressDialog"
        ], function(dojo, dijit, dialog, mri, template) {

    return dojo.declare("support.dialogs.DevicesAndIOPortsTemplate", [ support.dialogs.Dialog], {

        // templateString: [protected] String
        // This widget's HTML template, provided.
        templateString: template,
             
        // locResources: [protected] Object
        // This widget's National Language Source (NLS) object.
        locResources: mri,  
        
        repeatVar: null,
        mycheckVar: null,
        hidecheckVar: null,
        maxPercent: .40,
        store: "",
        templateIDNum: null,
        initialData: null,
        
        buttonBar1: null,
        
        // the name of the CSS stylesheet of this page
        spCssPathAndName: "support/dialogs/themes/DevicesAndIOPortsTemplate.css",

        // When this method is called, all variables inherited from superclasses are "mixed in".
        // Common operations for postMixInProperties
        // 1) Modify or assign values for widget property variables defined in the template HTML
        // file
        postMixInProperties: function() {
            this.inherited(arguments);
        },

        // postCreate() is called after buildRendering(). This is useful to override when
        // you need to access and/or manipulate DOM nodes included with your widget.
        // DOM nodes and widgets with the dojoAttachPoint attribute specified can now be directly
        // accessed as fields on "this".
        // Common operations for postCreate
        // 1) Access and manipulate DOM nodes created in buildRendering()
        // 2) Add new DOM nodes or widgets
        postCreate: function() {         
            this.inherited(arguments);

             // Create the button bar
            this.buttonBar1 = new support.widgets.ButtonBar({
                values: "COM Port 1|COM Port 2",
                labels: this.locResources.Buttonbar1.replace("%1","1").replace("%2","2")                    
            }).placeAt(this.buttonBar1div);
                
            dojo.connect(this.dialogNode, "hide", this, function() {        
                this.destroy();
            });

            
            //Setup for template new, edit, or copy mode 
            this._setup();

            //Controls dialog dynamic resizing max height 
//            var availHeight = window.screen.availHeight;
  //          var maxHeight = availHeight * this.maxPercent;
    //        this.settingsContainer.setAttribute("style", "max-height:" + maxHeight + "px");
          
            //Resizes dialog
            this.layout(); 
                    
         /*   this.templateName = this.createNameField();             //Create Name Field
            this.templateName.placeAt(this._nameField);             //Place Name Field 
         
            this.description = this.createDescTextArea();   //Create Description Text Area
            this.description.placeAt(this._descriptionTextArea); //Place Description TextArea
            this._descLabel.innerHTML = this.resources.DESC_LIMIT.replace("%500","500");  //Setup Description Title
            */
                       
        },
        toggle4: function(){

            if(this.mycheck4.get("checked") == true){
                this.settingsSelectionArea4.style.display = "block";

                this.settingsButton4_1.style.display = "inline";
                this.settingsBorder4_1.style.display = "inline";
                this.togglesettingsBorder4_1();
                
                this.settingsButton4_2.style.display = "inline";
                this.togglesettingsBorder4_2();

            }else{
                this.settingsSelectionArea4.style.display = "none";
                
                this.settingsButton4_1.style.display = "none";
                this.settingsBorder4_1.style.display = "none";
                this.togglebutton4_2.set("disabled", false);
                this.mygroup4_2_1.style.display = "none";           
                this.comport1Enabled.style.display = "none";
                this.comport1ToggleButton.style.display = "inline";
                this.mygroup4_2.style.display = "table";                

                this.settingsButton4_2.style.display = "none";
                this.settingsBorder4_2.style.display = "none";                              

            }
            
            this._setExpandCollapseIcon();                                  
            this.layout();

        },
        togglesettingsBorder4_1: function(){

            var buttonvalue = this.togglebutton4_1.get("enabled");

            if (buttonvalue == true) {
                this.consoleredirectionEnabled.style.display = "inline-block";                          
                this.consoleredirectionDisabled.style.display = "none";                             
                this.serialoverlanToggle();
            }else {
                this.consoleredirectionEnabled.style.display = "none";                          
                this.consoleredirectionDisabled.style.display = "inline-block";
                this.togglebutton4_2.set("disabled", false); 
                this.mygroup4_2_1.style.display = "none";
                this.comport1Enabled.style.display = "none";
                this.comport1ToggleButton.style.display = "inline";
                this.mygroup4_2.style.display = "table";                
            }

            this.serviceprocessorToggle();
            
            this.layout();
        },  
        togglesettingsBorder4_2: function(){

            var buttonvalue = this.togglebutton4_2.get("enabled");

            if (buttonvalue == true) {
                this.settingsBorder4_2.style.display = "inline-block";                          
            }else {
                this.settingsBorder4_2.style.display = "none";                              
            }

            this.layout();
        },
        serialoverlanToggle: function(){
            var buttonvalue = this.consoletogglebutton1.get("enabled");
            
            if (buttonvalue == true) {
                this.serialoverEnabled.style.display = "block";
                this.serialoverDisabled.style.display = "none";
                
                this.togglebutton4_2.set("enabled", true);
                this.togglebutton4_2.set("disabled", true);

                this.comport1ToggleButton.style.display = "none";
                this.mygroup4_2.style.display = "block";                
                this.comport1Enabled.style.display = "block";

            }else{
                this.serialoverDisabled.style.display = "block";
                this.serialoverEnabled.style.display = "none";

                this.togglebutton4_2.set("disabled", false);  


                this.comport1Enabled.style.display = "none";
                this.mygroup4_2.style.display = "table";                
                this.comport1ToggleButton.style.display = "inline";
            }

            this.legacyoptionROMToggle();
        },
        serviceprocessorToggle: function(){
            var buttonvalue = this.consoletogglebutton2.get("enabled");
            
            if (buttonvalue == true) {
                this.climode.style.display = "block";
                this.mygroup4_2_1.style.display = "block";              
            }else{
                this.climode.style.display = "none";            
                this.mygroup4_2_1.style.display = "none";               
            }
            
            this.climodeToggle();
            this.legacyoptionROMToggle();
        },
        climodeToggle: function(){
            // If the Console Redirection and Service Processor Redirection 
            // toggle buttons are enabled and "Enable with user defined keystroke"
            // is selected, show the CLI keystroke sequence text box.
            if (this.togglebutton4_1.get("enabled") &&              // Console Redirection toggle button
                    this.consoletogglebutton2.get("enabled")) {     // Service Processor Redirection toggle button
                var value = this.climodeCombobox.get("value");
                if(value == 2){
                    this.clikeystroke.style.display = "block";
                }else{
                    this.clikeystroke.style.display = "none";               
                }
            } else {
                this.clikeystroke.style.display = "none";
            }
            
            // Validate required fields to enable/disable ok button
            this._nameChanged();
        },
        legacyoptionROMToggle: function(){
            var serialOverLANbutton = this.consoletogglebutton1.get("enabled");
            var serviceProcessorbutton = this.consoletogglebutton2.get("enabled");

            if(serialOverLANbutton == true && serviceProcessorbutton == true){
                
                this.COMport1Display.style.display = "none";
                this.COMport2Display.style.display = "none";
                this.COMportDisplay.style.display = "block";
                
            }else if(serialOverLANbutton == true && serviceProcessorbutton == false){

                this.COMport1Display.style.display = "block";
                this.COMport2Display.style.display = "none";
                this.COMportDisplay.style.display = "none";
                
            }else if(serialOverLANbutton == false && serviceProcessorbutton == true){

                this.COMport1Display.style.display = "none";
                this.COMport2Display.style.display = "block";
                this.COMportDisplay.style.display = "none";

            }else if(serialOverLANbutton == false && serviceProcessorbutton == false){

                this.COMport1Display.style.display = "block";
                this.COMport2Display.style.display = "none";
                this.COMportDisplay.style.display = "none";

            }
            
        },
       
        _checkExpandCollapseState: function() {
            var mycheck4BoxState = this.mycheck4.get("value");
           
            /* value on = checked, false = unchecked */

            if (mycheck4BoxState == "on" ) {
                return "allon";
            }
            if (mycheck4BoxState == false ) {
                return "alloff";
            }

            return "mixed";
        },

        _setExpandCollapseIcon: function() {
            if (this._checkExpandCollapseState() == "mixed") {
                this.expandall.style.display = "none";
                this.collapseall.style.display = "none";
                this.mixedexpandcollapse.style.display = "inline";
            }
            if (this._checkExpandCollapseState() == "allon") {
                this.expandall.style.display = "none";
                this.collapseall.style.display = "inline";
                this.mixedexpandcollapse.style.display = "none";
            }
            if (this._checkExpandCollapseState() == "alloff") {
                this.expandall.style.display = "inline";
                this.collapseall.style.display = "none";
                this.mixedexpandcollapse.style.display = "none";
            }
        },
        hideunchecked2: function() {

          var checkvalue = this.hideunchecked.get("checked");

          var buttonvalue4_1 = this.togglebutton4_1.get("enabled"); //Console redirection button

          var buttonvalue4_2 = this.togglebutton4_2.get("enabled"); //Com port 1
          var comport1Combo1 = this.comport1Combo1.get("value");  //Baude rate
          var comport1Combo2 = this.comport1Combo2.get("value");  //Data bits
          var comport1Combo3 = this.comport1Combo3.get("value");  //Parity               
          var comport1Combo4 = this.comport1Combo4.get("value");  //Stop bits
          var comport1Combo5 = this.comport1Combo5.get("value");  //Text Emulation
          var comport1Combo6 = this.comport1Combo6.get("value");  //Active after boot
          var comport1Combo7 = this.comport1Combo7.get("value");  //Flow control                

          if(checkvalue == true) {
              
             if(buttonvalue4_1 == false){
                this.mygroup4_1.style.display = "none";
              }   
             

             if(buttonvalue4_2 == true){
                 
                 if(comport1Combo1 == "115200" && comport1Combo2 == "8" && comport1Combo3 == "None" && comport1Combo4 == "1" 
                 && comport1Combo5 == "ANSI" && comport1Combo6 == "Disable" && comport1Combo7 == "Disable"){
                     
                     this.mygroup4_2.style.display = "none";
                     
                 }
                 
                 
              }
             
          }else {

                this.mygroup4_1.style.display = "table";
                this.mygroup4_2.style.display = "table";
          }

        this.layout(); 

        },
        cancelClicked: function() {
            this.hide();
        },
        createClicked: function() {

            var templateObject = new Object();
            
            var namevalue = this.templateName.get("value").trim();
            templateObject.name = namevalue;
                                   
            templateObject.type = "DevicesAndIOPorts";
            
            var descriptionvalue = this.description.get("value").trim();
            templateObject.description = this.encodeSpecialCharacters(descriptionvalue);


         // Console Redirection and COM ports
            var serialportsharingvalue;
            var serialportaccessmodevalue;
            
            var settings4Object = new Object();
            settings4Object.setconsoleredirection = true;
            var checkvalue4 = this.mycheck4.get("value");
            settings4Object.checkvalue4 = checkvalue4;

                //Console Redirection
            var buttonvalue4_1 = this.togglebutton4_1.get("enabled");
            settings4Object.buttonvalue4_1 = buttonvalue4_1;
            var consolebutton2 = "";
            
            if(buttonvalue4_1 == false){
                settings4Object.remoteconsolevalue = "Disable";
                settings4Object.serialoverlanvalue = "Disable";
                serialportsharingvalue = "Disable";
                serialportaccessmodevalue = "Disable";

        //        settings4Object.serialportsharingvalue = "Disable";
        //        settings4Object.serialportaccessmodevalue = "Disable";
        //        settings4Object.sprvalue = "Disable";
                settings4Object.legacyoptionevalue = "COM Port 1";                
            }else{
                settings4Object.remoteconsolevalue = "Enable";
                
                var consolebutton1 = this.consoletogglebutton1.get("enabled");
                settings4Object.consolebutton1 = consolebutton1;
                
                if(consolebutton1 == false){
                    settings4Object.serialoverlanvalue = "Disable";
                    settings4Object.serialportsharingvalue = "Disable";
                    settings4Object.serialportaccessmodevalue = "Disable";
                    serialportsharingvalue = "Disable";
                    serialportaccessmodevalue = "Disable";
                }else{
                    settings4Object.serialoverlanvalue = "Enable";
                    settings4Object.serialportsharingvalue = "Enable";
                    settings4Object.serialportaccessmodevalue = "Dedicated";
                    serialportsharingvalue = "Enable";
                    serialportaccessmodevalue = "Dedicated";
                }             
                
                consolebutton2 = this.consoletogglebutton2.get("enabled");
                settings4Object.consolebutton2 = consolebutton2;

                if(consolebutton2 == false){
                    settings4Object.sprvalue = "Disable";                     
                }else{
                    settings4Object.sprvalue = "Enable";
                    settings4Object.sprCLI = this.climodeCombobox.get("value");
                    if(this.climodeCombobox.get("value") == 2){
                        settings4Object.sprCLIvalue = this.cliValue.get("value");                        
                    }
                }
                
                
                if(consolebutton1 == true && consolebutton2 == true){
                    settings4Object.legacyoptionevalue = this.buttonBar1.get("selected");               
                }else if(consolebutton1 == true && consolebutton2 == false){
                    settings4Object.legacyoptionevalue = "COM Port 1";                          
                }else if(consolebutton1 == false && consolebutton2 == true){
                    settings4Object.legacyoptionevalue = "COM Port 2";                                    
                }else{
                    settings4Object.legacyoptionevalue = "COM Port1";                
                }
                
            }
            
                //Com port 1
            var buttonvalue4_2 = this.togglebutton4_2.get("enabled");
            settings4Object.buttonvalue4_2 = buttonvalue4_2;
            
            if(buttonvalue4_2 == true){
                settings4Object.comport1 = "Enable";
                settings4Object.comport1Combo1 = this.comport1Combo1.get("value");  //Baude rate
                settings4Object.comport1Combo2 = this.comport1Combo2.get("value");  //Data bits
                settings4Object.comport1Combo3 = this.comport1Combo3.get("value");  //Parity               
                settings4Object.comport1Combo4 = this.comport1Combo4.get("value");  //Stop bits
                settings4Object.comport1Combo5 = this.comport1Combo5.get("value");  //Text Emulation
                settings4Object.comport1Combo6 = this.comport1Combo6.get("value");  //Active after boot
                settings4Object.comport1Combo7 = this.comport1Combo7.get("value");  //Flow control
                settings4Object.serialportsharingvalue = serialportsharingvalue;
                settings4Object.serialportaccessmodevalue = serialportaccessmodevalue;
            }else{
                settings4Object.comport1 = "Disable";
            }
            
                //Com port 2                        
            if(consolebutton2 == true){
                settings4Object.comport2 = "Enable";

                settings4Object.comport2Combo1 = this.comport2Combo1.get("value");  //Baude rate
                settings4Object.comport2Combo2 = this.comport2Combo2.get("value");  //Data bits
                settings4Object.comport2Combo3 = this.comport2Combo3.get("value");  //Parity               
                settings4Object.comport2Combo4 = this.comport2Combo4.get("value");  //Stop bits
                settings4Object.comport2Combo5 = this.comport2Combo5.get("value");  //Text Emulation
                settings4Object.comport2Combo6 = this.comport2Combo6.get("value");  //Active after boot
                settings4Object.comport2Combo7 = this.comport2Combo7.get("value");  //Flow control                
            }else{
                settings4Object.comport2 = "Disable";
            }
            
            templateObject.consoleredirection = settings4Object;


         // Onboard Devices
         // Adaper Option ROM
         // Option ROM Execution Order
            
            var argJSONString = dojo.toJson({ 
                "identifier":"id",
                  "label":"name",
                  "items":[ templateObject ]
            }, true);


        //    alert(argJSONString);

            this.getProgressDialog("save").show(); // Show progress dialog for save request.
                    var xhrPost = dojo.xhrPost({
                        url: this.REST_PATH + "template/create",
                        handleAs: "json", // <<<< Required
                        headers: {
                            "Content-Type": "application/json; charset=utf-8" // <<<< Required
                        },
                        postData: argJSONString,     //Template Data to Post
                        load: dojo.hitch(this, function(response, ioArgs) {
                            // Happy path! We received a 2xx status code from the API.
                                                    
                            dojo.publish("ProgressComplete", response.id);
                            dojo.publish("DevicesAndIOPortsComplete", response.id);
                            this.hide();             
                        }),
                        error: dojo.hitch(this, function(error, ioArgs) {
                            // Failure path! We received a non-2xx status code (ie: 3xx/4xx/5xx status code) from the API.

                            dojo.publish("ProgressFailed", error);
                            console.log(this.declaredClass + ": ", error, ioArgs);
                            
                            var response = dojo.fromJson(ioArgs.xhr.responseText);
                            if ((ioArgs.xhr.status >= 400) && (response.message == "service_error_name_in_use")) {
                                // Error Template name in use
                                this.getModalDialog("Error", this.resources.ERROR_400_NAME).show();
                            }
                            else if(ioArgs.xhr.status == 404) {
                                // Edit Template ID doesn't exist
                                this.getModalDialog("Error", this.resources.ERROR_404_ID).show();
                                this.hide();
                            }
                            else if(ioArgs.xhr.status >= 500) {
                                // Internal Programming Error
                                this.getModalDialog("Error", this.resources.ERROR_500_INTERNAL).show();
                                this.hide();
                            }
                            else {
                                this.getModalDialog("Error", this.resources.ERROR_TEMPLATE_CREATE).show();
                                this.hide();
                            }
                            
                        }),
                        handle: dojo.hitch(this, function(data, ioArgs) {
                            // - The 1st param ("data") is either the response data (on success) or Error object (on failure).
                            // - The 2nd param ("ioArgs") contains detail about the xhr request, including a reference to the
                            // native xhr object. Check ioArgs.xhr.status to determine success or failure, and handle "data"
                            // accordingly.
                        })
                    });

          },
          
          saveClicked: function() {

              var templateObject = new Object();
              
              var namevalue = this.templateName.get("value").trim();
              templateObject.name = namevalue;

              templateObject.id = this.templateIDNum;
              
              templateObject.type = "DevicesAndIOPorts";
              
              var descriptionvalue = this.description.get("value").trim();
              templateObject.description = this.encodeSpecialCharacters(descriptionvalue);


           // Console Redirection and COM ports
              var serialportsharingvalue;
              var serialportaccessmodevalue;

              var settings4Object = new Object();
              settings4Object.setconsoleredirection = true;
              var checkvalue4 = this.mycheck4.get("value");
              settings4Object.checkvalue4 = checkvalue4;

                  //Console Redirection
              var buttonvalue4_1 = this.togglebutton4_1.get("enabled");
              settings4Object.buttonvalue4_1 = buttonvalue4_1;
              var consolebutton2 = "";
              
              if(buttonvalue4_1 == false){
                  settings4Object.remoteconsolevalue = "Disable";
                  settings4Object.serialoverlanvalue = "Disable";
                  serialportsharingvalue = "Disable";
                  serialportaccessmodevalue = "Disable";
         //         settings4Object.serialportsharingvalue = "Disable";
         //         settings4Object.serialportaccessmodevalue = "Disable";
         //         settings4Object.sprvalue = "Disable";
                  settings4Object.legacyoptionevalue = "COM Port 1";                
              }else{
                  settings4Object.remoteconsolevalue = "Enable";
                  
                  var consolebutton1 = this.consoletogglebutton1.get("enabled");
                  settings4Object.consolebutton1 = consolebutton1;
                  
                  if(consolebutton1 == false){
                      settings4Object.serialoverlanvalue = "Disable";
                      settings4Object.serialportsharingvalue = "Disable";
                      settings4Object.serialportaccessmodevalue = "Disable"; 
                      serialportsharingvalue = "Disable";
                      serialportaccessmodevalue = "Disable";
                  }else{
                      settings4Object.serialoverlanvalue = "Enable";
                      settings4Object.serialportsharingvalue = "Enable";
                      settings4Object.serialportaccessmodevalue = "Dedicated";
                      serialportsharingvalue = "Enable";
                      serialportaccessmodevalue = "Dedicated";
                  }             
                  
                  consolebutton2 = this.consoletogglebutton2.get("enabled");
                  settings4Object.consolebutton2 = consolebutton2;

                  if(consolebutton2 == false){
                      settings4Object.sprvalue = "Disable";                     
                  }else{
                      settings4Object.sprvalue = "Enable";
                      settings4Object.sprCLI = this.climodeCombobox.get("value");
                      if(this.climodeCombobox.get("value") == 2){
                          settings4Object.sprCLIvalue = this.cliValue.get("value");                        
                      }
                  }
                  
                  
                  if(consolebutton1 == true && consolebutton2 == true){
                      settings4Object.legacyoptionevalue = this.buttonBar1.get("selected");               
                  }else if(consolebutton1 == true && consolebutton2 == false){
                      settings4Object.legacyoptionevalue = "COM Port 1";                          
                  }else if(consolebutton1 == false && consolebutton2 == true){
                      settings4Object.legacyoptionevalue = "COM Port 2";                                    
                  }else{
                      settings4Object.legacyoptionevalue = "COM Port 1";                
                  }
                  
              }
              
              //Com port 1
              var buttonvalue4_2 = this.togglebutton4_2.get("enabled");
              settings4Object.buttonvalue4_2 = buttonvalue4_2;
              
              if(buttonvalue4_2 == true){
                  settings4Object.comport1 = "Enable";
                  settings4Object.comport1Combo1 = this.comport1Combo1.get("value");  //Baude rate
                  settings4Object.comport1Combo2 = this.comport1Combo2.get("value");  //Data bits
                  settings4Object.comport1Combo3 = this.comport1Combo3.get("value");  //Parity               
                  settings4Object.comport1Combo4 = this.comport1Combo4.get("value");  //Stop bits
                  settings4Object.comport1Combo5 = this.comport1Combo5.get("value");  //Text Emulation
                  settings4Object.comport1Combo6 = this.comport1Combo6.get("value");  //Active after boot
                  settings4Object.comport1Combo7 = this.comport1Combo7.get("value");  //Flow control
                  settings4Object.serialportsharingvalue = serialportsharingvalue;
                  settings4Object.serialportaccessmodevalue = serialportaccessmodevalue;
              }else{
                  settings4Object.comport1 = "Disable";
              }
              
                  //Com port 2                        
              if(consolebutton2 == true){
                  settings4Object.comport2 = "Enable";

                  settings4Object.comport2Combo1 = this.comport2Combo1.get("value");  //Baude rate
                  settings4Object.comport2Combo2 = this.comport2Combo2.get("value");  //Data bits
                  settings4Object.comport2Combo3 = this.comport2Combo3.get("value");  //Parity               
                  settings4Object.comport2Combo4 = this.comport2Combo4.get("value");  //Stop bits
                  settings4Object.comport2Combo5 = this.comport2Combo5.get("value");  //Text Emulation
                  settings4Object.comport2Combo6 = this.comport2Combo6.get("value");  //Active after boot
                  settings4Object.comport2Combo7 = this.comport2Combo7.get("value");  //Flow control
                  
              }else{
                  settings4Object.comport2 = "Disable";
              }
              
              templateObject.consoleredirection = settings4Object;


           // Onboard Devices
           // Adaper Option ROM
           // Option ROM Execution Order
              
              var argJSONString = dojo.toJson({ 
                  "identifier":"id",
                    "label":"name",
                    "items":[ templateObject ]
              }, true);


              //alert(argJSONString);

              var saveTemplate = true;
              
              if(this.templateInUse.toString() == "true"){
              //  Need to remove extra properties that aren't included in the dialog
                  delete this.initialData[0].inUse;
                  delete this.initialData[0].uri;
                  delete this.initialData[0].referencedBy;
                  delete this.initialData[0].useCount;
                  delete this.initialData[0].userDefined;
                  
                  // Remove description since it shouldn't force a redeploy
                  delete this.initialData[0].description;
                  delete templateObject.description;
                  
                  var preData = this.sortAndFlatten(this.initialData[0]);
                  var postData = this.sortAndFlatten(templateObject);
                  
                  if(preData != postData){
                      this.rdstDialog.set("templateID",this.templateIDNum);
                      this.rdstDialog.set("templateType","Category");
                      this.rdstDialog.set("templateData",argJSONString);

                      this.rdstDialog.show();
                  
                      saveTemplate = false;
                  }
              }
              if (saveTemplate) {
                  this.getProgressDialog("save").show(); // Show progress dialog for save request.
                      var xhrPost = dojo.xhrPost({
                          url: this.REST_PATH + "template/create",
                          handleAs: "json", // <<<< Required
                          headers: {
                              "Content-Type": "application/json; charset=utf-8" // <<<< Required
                          },
                          postData: argJSONString,     //Template Data to Post
                          load: dojo.hitch(this, function(response, ioArgs) {
                              // Happy path! We received a 2xx status code from the API.
                                                      
                              dojo.publish("ProgressComplete", response.id);
                              dojo.publish("DevicesAndIOPortsComplete", response.id);
                              this.hide();
                          }),
                          error: dojo.hitch(this, function(error, ioArgs) {
                              // Failure path! We received a non-2xx status code (ie: 3xx/4xx/5xx status code) from the API.

                              dojo.publish("ProgressFailed", error);
                              console.log(this.declaredClass + ": ", error, ioArgs);
                              
                              var response = dojo.fromJson(ioArgs.xhr.responseText);
                              if ((ioArgs.xhr.status >= 400) && (response.message == "service_error_name_in_use")) {
                                  // Error Template name in use
                                  this.getModalDialog("Error", this.resources.ERROR_400_NAME).show();
                              }
                              else if(ioArgs.xhr.status == 404) {
                                  // Edit Template ID doesn't exist
                                  this.getModalDialog("Error", this.resources.ERROR_404_ID).show();
                                  this.hide();
                              }
                              else if(ioArgs.xhr.status >= 500) {
                                  // Internal Programming Error
                                  this.getModalDialog("Error", this.resources.ERROR_500_INTERNAL).show();
                                  this.hide();
                              }
                              else {
                                  this.getModalDialog("Error", this.resources.ERROR_TEMPLATE_CREATE).show();
                                  this.hide();
                              }
                              
                          }),
                          handle: dojo.hitch(this, function(data, ioArgs) {
                              // - The 1st param ("data") is either the response data (on success) or Error object (on failure).
                              // - The 2nd param ("ioArgs") contains detail about the xhr request, including a reference to the
                              // native xhr object. Check ioArgs.xhr.status to determine success or failure, and handle "data"
                              // accordingly.
                          })
                      });

              }

            },            
            saveasClicked: function() {      

                var templateObject = new Object();
                
                var namevalue = this.templateName.get("value").trim();
                templateObject.name = namevalue;
                
                templateObject.type = "DevicesAndIOPorts";
                
                var descriptionvalue = this.description.get("value").trim();
                templateObject.description = this.encodeSpecialCharacters(descriptionvalue);


             // Console Redirection and COM ports
                var serialportsharingvalue;
                var serialportaccessmodevalue;

                var settings4Object = new Object();
                settings4Object.setconsoleredirection = true;
                var checkvalue4 = this.mycheck4.get("value");
                settings4Object.checkvalue4 = checkvalue4;

                    //Console Redirection
                var buttonvalue4_1 = this.togglebutton4_1.get("enabled");
                settings4Object.buttonvalue4_1 = buttonvalue4_1;
                var consolebutton2 = "";
                
                if(buttonvalue4_1 == false){
                    settings4Object.remoteconsolevalue = "Disable";
                    settings4Object.serialoverlanvalue = "Disable";
                    serialportsharingvalue = "Disable";
                    serialportaccessmodevalue = "Disable";
             //       settings4Object.serialportsharingvalue = "Disable";
             //       settings4Object.serialportaccessmodevalue = "Disable";
             //       settings4Object.sprvalue = "Disable";
                    settings4Object.legacyoptionevalue = "COM Port 1";                
                }else{
                    settings4Object.remoteconsolevalue = "Enable";
                    
                    var consolebutton1 = this.consoletogglebutton1.get("enabled");
                    settings4Object.consolebutton1 = consolebutton1;
                    
                    if(consolebutton1 == false){
                        settings4Object.serialoverlanvalue = "Disable";
                        settings4Object.serialportsharingvalue = "Disable";
                        settings4Object.serialportaccessmodevalue = "Disable"; 
                        serialportsharingvalue = "Disable";
                        serialportaccessmodevalue = "Disable";
                    }else{
                        settings4Object.serialoverlanvalue = "Enable";
                        settings4Object.serialportsharingvalue = "Enable";
                        settings4Object.serialportaccessmodevalue = "Dedicated";
                        serialportsharingvalue = "Enable";
                        serialportaccessmodevalue = "Dedicated";
                    }             
                    
                    consolebutton2 = this.consoletogglebutton2.get("enabled");
                    settings4Object.consolebutton2 = consolebutton2;

                    if(consolebutton2 == false){
                        settings4Object.sprvalue = "Disable";                     
                    }else{
                        settings4Object.sprvalue = "Enable";
                        settings4Object.sprCLI = this.climodeCombobox.get("value");
                        if(this.climodeCombobox.get("value") == 2){
                            settings4Object.sprCLIvalue = this.cliValue.get("value");                        
                        }
                    }
                    
                    
                    if(consolebutton1 == true && consolebutton2 == true){
                        settings4Object.legacyoptionevalue = this.buttonBar1.get("selected");               
                    }else if(consolebutton1 == true && consolebutton2 == false){
                        settings4Object.legacyoptionevalue = "COM Port 1";                          
                    }else if(consolebutton1 == false && consolebutton2 == true){
                        settings4Object.legacyoptionevalue = "COM Port 2";                                    
                    }else{
                        settings4Object.legacyoptionevalue = "COM Port 1";                
                    }
                    
                }
                
                //Com port 1
                var buttonvalue4_2 = this.togglebutton4_2.get("enabled");
                settings4Object.buttonvalue4_2 = buttonvalue4_2;
                
                if(buttonvalue4_2 == true){
                    settings4Object.comport1 = "Enable";
                    settings4Object.comport1Combo1 = this.comport1Combo1.get("value");  //Baude rate
                    settings4Object.comport1Combo2 = this.comport1Combo2.get("value");  //Data bits
                    settings4Object.comport1Combo3 = this.comport1Combo3.get("value");  //Parity               
                    settings4Object.comport1Combo4 = this.comport1Combo4.get("value");  //Stop bits
                    settings4Object.comport1Combo5 = this.comport1Combo5.get("value");  //Text Emulation
                    settings4Object.comport1Combo6 = this.comport1Combo6.get("value");  //Active after boot
                    settings4Object.comport1Combo7 = this.comport1Combo7.get("value");  //Flow control
                    settings4Object.serialportsharingvalue = serialportsharingvalue;
                    settings4Object.serialportaccessmodevalue = serialportaccessmodevalue;
                }else{
                    settings4Object.comport1 = "Disable";
                }
                
                    //Com port 2                        
                if(consolebutton2 == true){
                    settings4Object.comport2 = "Enable";

                    settings4Object.comport2Combo1 = this.comport2Combo1.get("value");  //Baude rate
                    settings4Object.comport2Combo2 = this.comport2Combo2.get("value");  //Data bits
                    settings4Object.comport2Combo3 = this.comport2Combo3.get("value");  //Parity               
                    settings4Object.comport2Combo4 = this.comport2Combo4.get("value");  //Stop bits
                    settings4Object.comport2Combo5 = this.comport2Combo5.get("value");  //Text Emulation
                    settings4Object.comport2Combo6 = this.comport2Combo6.get("value");  //Active after boot
                    settings4Object.comport2Combo7 = this.comport2Combo7.get("value");  //Flow control                
                }else{
                    settings4Object.comport2 = "Disable";
                }
                
                templateObject.consoleredirection = settings4Object;


                this.saveasDialog.set("templateObject",templateObject);
                this.saveasDialog.show();
                
            },
        loadprevSettings: function() {
            var widget = this;
            var locResources = this.locResources;

            var resources = this.resources;

            var mode = this.templateMode;

            var inUse = false;

            var name = this.templateName;
            var description = this.description;
            
            var mycheck4 = this.mycheck4;
            var buttonvalue4_1 = this.togglebutton4_1;
            var consolebutton1 = this.consoletogglebutton1;            
            var consolebutton2 = this.consoletogglebutton2;
            var sprCLI = this.climodeCombobox;
            var sprCLIvalue = this.cliValue;                        
            var comport2Combo1 = this.comport2Combo1;
            var comport2Combo2 = this.comport2Combo2;
            var comport2Combo3 = this.comport2Combo3;
            var comport2Combo4 = this.comport2Combo4;
            var comport2Combo5 = this.comport2Combo5;
            var comport2Combo6 = this.comport2Combo6;
            var comport2Combo7 = this.comport2Combo7;                           
            var legacyoptionevalue = this.buttonBar1;               
            var buttonvalue4_2 = this.togglebutton4_2;
            var comport1Combo1 = this.comport1Combo1;
            var comport1Combo2 = this.comport1Combo2;
            var comport1Combo3 = this.comport1Combo3;
            var comport1Combo4 = this.comport1Combo4;
            var comport1Combo5 = this.comport1Combo5;
            var comport1Combo6 = this.comport1Combo6;
            var comport1Combo7 = this.comport1Combo7;                           

                       
            var dialogNode = this.dialogNode;
            
            var xhrGet = dojo.xhrGet({
                url: this.REST_PATH + "template/"+this.templateIDNum,
                handleAs: "json",
                sync: true,
                preventCache: true,
                load: dojo.hitch(this, function(response) {
                    this.store = response; 
                    //alert(this.store.items[0].IMM_GeneralSettings_power_off.IMM_GeneralSettings_power_off);
                }),
                handle: dojo.hitch(this, function(){

                    inUse = this.store.items[0].inUse;

                    if(mode == "copy"){
                        dialogNode.set("title", locResources.Title + this.store.items[0].name + " - " + resources.COPY);
                        name.set("value", this.store.items[0].name + " - " + resources.COPY);
                    }else{
                        dialogNode.set("title", locResources.EditTitle + " - " + this.store.items[0].name);
                        name.set("value", this.store.items[0].name);
                    }
            
                    
                    var descriptionvalue = widget.decodeSpecialCharacters(this.store.items[0].description);
                    description.set("value", descriptionvalue);                                                        

                    //Console Redirection and COM ports
                    mycheck4.set("value",true);
                                        
                    if(this.store.items[0].consoleredirection.remoteconsolevalue == "Enable"){
                        buttonvalue4_1.set("enabled",true);
                               
                        if(this.store.items[0].consoleredirection.serialoverlanvalue == "Enable"){
                            consolebutton1.set("enabled",true);                            
                        }else{
                            consolebutton1.set("enabled",false);                                                        
                        }
                        

                        if(this.store.items[0].consoleredirection.sprCLI){
                            consolebutton2.set("enabled",true);

                            sprCLI.set("value",this.store.items[0].consoleredirection.sprCLI);
                            
                            if(this.store.items[0].consoleredirection.sprCLI == 2){
                                sprCLIvalue.set("value",this.store.items[0].consoleredirection.sprCLIvalue);                                                                
                            }
                            
                            comport2Combo1.set("value",this.store.items[0].consoleredirection.comport2Combo1);
                            comport2Combo2.set("value",this.store.items[0].consoleredirection.comport2Combo2);
                            comport2Combo3.set("value",this.store.items[0].consoleredirection.comport2Combo3);
                            comport2Combo4.set("value",this.store.items[0].consoleredirection.comport2Combo4);
                            comport2Combo5.set("value",this.store.items[0].consoleredirection.comport2Combo5);
                            comport2Combo6.set("value",this.store.items[0].consoleredirection.comport2Combo6);
                            comport2Combo7.set("value",this.store.items[0].consoleredirection.comport2Combo7);                             

                        }else{
                            consolebutton2.set("enabled",false);
                        }
                        
                        
                        if(this.store.items[0].consoleredirection.consolebutton1 == true && this.store.items[0].consoleredirection.consolebutton2 == true){
                            legacyoptionevalue.set("selected",this.store.items[0].consoleredirection.legacyoptionevalue);                         
                        }
                        
                    }else{
                        buttonvalue4_1.set("enabled",false);
                    }
                                        
                   if(this.store.items[0].consoleredirection.comport1 == "Enable"){
                       buttonvalue4_2.set("enabled",true);                   
                       comport1Combo1.set("value",this.store.items[0].consoleredirection.comport1Combo1);
                       comport1Combo2.set("value",this.store.items[0].consoleredirection.comport1Combo2);
                       comport1Combo3.set("value",this.store.items[0].consoleredirection.comport1Combo3);
                       comport1Combo4.set("value",this.store.items[0].consoleredirection.comport1Combo4);
                       comport1Combo5.set("value",this.store.items[0].consoleredirection.comport1Combo5);
                       comport1Combo6.set("value",this.store.items[0].consoleredirection.comport1Combo6);
                       comport1Combo7.set("value",this.store.items[0].consoleredirection.comport1Combo7);                             
                    }else{
                        buttonvalue4_2.set("enabled",false);                   
                    }
                })
            });

            this.initialData = this.store.items;
            
            this.templateInUse = inUse;

            return this.templateName.get("value").trim();
            
        },
        exitParent: function() {
            var data = "DevicesAndIOPorts";
            
            dojo.publish("DevicesAndIOPortsComplete", data);

            if(this.rdstDialog != null){
                var deployClicked = this.rdstDialog.get("closeParent");
                if(deployClicked) {
                    this.hide();
                }
            }
        },
        _expandall: function() {
            this.mycheck4.set("checked", true);
                    
            this.expandall.style.display = "none";
            this.collapseall.style.display = "inline";
            this.mixedexpandcollapse.style.display = "none";
                  
            this.toggle4();
                      
            this.layout();
        },
        
        _collapseall: function() {
            this.mycheck4.set("checked", false);
          
            this.expandall.style.display = "inline";
            this.collapseall.style.display = "none";
            this.mixedexpandcollapse.style.display = "none";

            this.toggle4();
                       
            this.layout();

        },        
        _nameChanged: function() {                        
			// Added Cli keystroke field validation (if it is displayed)
            if (this.templateName.get("value").trim() != "" && (this.cliValue.isValid() || this.clikeystroke.style.display == "none")) {
                this.okBtn.set("disabled", false);
            }
            else {
                this.okBtn.set("disabled", true);
            }
           
        },
        _setup: function(){

            //Set Template Field to catch intermediate changes
            this.templateName.intermediateChanges = true;

            // Set Description Label
            this._descLimit.innerHTML = this.resources.LIMIT.replace("%500","500");

            this.com1.innerHTML = this.locResources.Comport.replace("%1","1");
            this.com1_1.innerHTML = this.locResources.Comport.replace("%1","1");
            this.com2.innerHTML = this.locResources.Comport.replace("%1","2");
            this.com1_2.innerHTML = this.locResources.Comport.replace("%1","1");
            this.com2_1.innerHTML = this.locResources.Comport.replace("%1","2");
                                              
                        
            //Set Information Messages and Load Previous Settings                      
            if(this.templateIDNum != null && this.templateMode == "edit"){     //if dialog in edit mode    

                this.loadprevSettings();

                if(this.templateInUse.toString() == "true"){
                
                    if(this.templateLaunchPoint == "table"){
                        
                        this.warningMessage.style.display = "block";
                        this.warningMessageText.innerHTML = this.resources.INUSE;
                        this.saveBtnContainer.style.display = "inline";
                        this.saveasBtnContainer.style.display = "inline";
                        
                    }else if(this.templateLaunchPoint == "wizard"){
                        
                        this.informationMessage.style.display = "block";
                        this.informationMessageText.innerHTML = this.resources.INUSEWIZARD;
                        this.saveasBtnContainer.style.display = "inline";
                        
                    }else{
                        this.informationMessage.style.display = "block";
                        this.informationMessageText.innerHTML = this.resources.INUSEWIZARD;
                        this.saveasBtnContainer.style.display = "inline";
                    }
                    
                }else{
                    
                    this.saveBtnContainer.style.display = "inline";
                    this.saveasBtnContainer.style.display = "inline";
                                        
                }    

                this.templateName.set("disabled",true);
                

             }else if(this.templateIDNum != null && this.templateMode == "copy"){    //if dialog in copy mode     
                 
                 this.loadprevSettings();
                 this.templateIDNum = null;  //set template ID to null in order to create new template
                 this.okBtnContainer.style.display = "inline";

             }else{     //if dialog in create new mode
                 
                 this.okBtnContainer.style.display = "inline";
                 this._expandall();

             } 

        }
   
        
    });
});