define([ 
        "dojo", 
        "dijit", 
        "support/dialogs/Dialog", 
        "dojo/i18n!./nls/FibreChannelAddressPool", 
        "dojo/text!./templates/FibreChannelAddressPool.html",
        "dijit/layout/BorderContainer", 
        "dijit/layout/ContentPane", 
        "dijit/Tooltip", 
        "dojox/grid/LazyTreeGrid", 
        "dojo/store/Memory",
        "dojo/data/ItemFileWriteStore", 
        "dijit/ProgressBar", 
        "support/widgets/HoverButton", 
        "support/dialogs/FibreChannelSubrangePopup",
        "dojox/grid/LazyTreeGridStoreModel",
        "dijit/tree/ForestStoreModel",
        "dojo/data/ItemFileReadStore",
        "dojo/html"
        ],function(dojo, dijit, dialog, mri, template) {

    return dojo.declare("support.dialogs.FibreChannelAddressPool", [ support.dialogs.Dialog ], {

        // templateString: [protected] String
         // This widget's HTML template, provided.
        templateString: template,
             
        // locResources: [protected] Object
        // This widget's National Language Source (NLS) object.
        locResources: mri, 
        
		maxPercent: .50,
		overallTable: null,
        overallStore: null,
        overallLayout: null,
        network: null,
        rangeTable: null,
        rangeStore: null,
        rangeLayout: null,
        version: "IPv6",
        vendorprefixFirst: "",
        vendorprefixLast: "",
        vendor: "",
        rangemodel: null,
        overallmodel: null,
        fabricAwwnnFirst: "",
        fabricAwwpnFirst: "",
        fabricBwwnnFirst: "",
        fabricBwwpnFirst: "",

        fabricAwwnnLast: "",
        fabricAwwpnLast: "",
        fabricBwwnnLast: "",
        fabricBwwpnLast: "",

        vendorRangeSize: "",
        
        firstNoChar:"",
        lastNoChar:"",
        
        preloadedData:"",
        
        rangeCheckerArray: new Array,
        // the name of the CSS stylesheet of this page
        spCssPathAndName: "support/dialogs/themes/FibreChannelAddressPool.css",

        // When this method is called, all variables inherited from superclasses are "mixed in".
        // Common operations for postMixInProperties
        // 1) Modify or assign values for widget property variables defined in the template HTML
        // file
        postMixInProperties: function() {
            this.inherited(arguments);
            this._setvendor();
            this.loadprevSettings();
            this._connectDataModels();
        },

        // postCreate() is called after buildRendering(). This is useful to override when
        // you need to access and/or manipulate DOM nodes included with your widget.
        // DOM nodes and widgets with the dojoAttachPoint attribute specified can now be directly
        // accessed as fields on "this".
        // Common operations for postCreate
        // 1) Access and manipulate DOM nodes created in buildRendering()
        // 2) Add new DOM nodes or widgets
        postCreate: function() {

            this.inherited(arguments);

            this.rangeCheckerArray = new Array; //reset range checker array

            dojo.connect(this.dialogNode, "show", this, function() {
                               
                var availHeight = window.screen.availHeight;
                var maxHeight = availHeight * this.maxPercent;
                this.settingsContainer.setAttribute("style", "max-height:" + maxHeight + "px");

                this.layout();

             });

            dojo.connect(this.dialogNode, "hide", this, function() {        
                this.destroy();
            });

            
            this.showoverallTable();
            this.showRangeTable();
            this._addSubrangeButton.set("style", "display:block");

            if(this.vendor == "Emulex"){                
                dojo.html.set(this.vendorTitle,this.locResources.EMULEXNAME);
            }else if(this.vendor == "Qlogic"){
                dojo.html.set(this.vendorTitle,this.locResources.QLOGICNAME);
            }else if(this.vendor == "Brocade"){
                dojo.html.set(this.vendorTitle,this.locResources.BROCADENAME);
            }else if(this.vendor == "IBM"){
                dojo.html.set(this.vendorTitle,this.locResources.IBMNAME);
            }else if(this.vendor == "Mellanox"){
                dojo.html.set(this.vendorTitle,this.locResources.MELLANOXNAME);
            }    
            
            if(this.preloadedData.items){
                this.setprevData();
            }
        },
        _setvendor : function(){              
            
            var vendorStore=null;
            
            var xhrGet = dojo.xhrGet({
                url: this.REST_PATH + "addresspool/vendordefaults/"+"FIBRE/"+ this.vendor,
                handleAs: "json",
                sync: true,
                preventCache: true,
                load: function(response) {
                    vendorStore = response; 
                },
                handle: function(){


                }
            });  
            
            if(this.vendor == "Emulex"){                
                
                this.fabricAwwnnFirst = vendorStore.fabricAwwnnFirst.substr(0,15);
                this.fabricAwwpnFirst = vendorStore.fabricAwwpnFirst.substr(0,15);
                this.fabricBwwnnFirst = vendorStore.fabricBwwnnFirst.substr(0,15);
                this.fabricBwwpnFirst = vendorStore.fabricBwwpnFirst.substr(0,15);

                this.fabricAwwnnLast = vendorStore.fabricAwwnnLast;
                this.fabricAwwpnLast = vendorStore.fabricAwwpnLast;
                this.fabricBwwnnLast = vendorStore.fabricBwwnnLast;
                this.fabricBwwpnLast = vendorStore.fabricBwwpnLast;
                
                this.vendorprefixFirst = vendorStore.vendorprefixFirst;
                this.vendorprefixLast = vendorStore.vendorprefixLast;
                this.vendorRangeSize = vendorStore.vendorRangeSize;

                
                /*   this.fabricAwwnnFirst = "2F:FE:00:00:C9:";
                this.fabricAwwpnFirst = "2F:FC:00:00:C9:";
                this.fabricBwwnnFirst = "2F:FF:00:00:C9:";
                this.fabricBwwpnFirst = "2F:FD:00:00:C9:";

                this.fabricAwwnnLast = "2F:FE:00:00:C9:FF:FF:FF";
                this.fabricAwwpnLast = "2F:FC:00:00:C9:FF:FF:FF";
                this.fabricBwwnnLast = "2F:FF:00:00:C9:FF:FF:FF";
                this.fabricBwwpnLast = "2F:FD:00:00:C9:FF:FF:FF";
                
                this.vendorprefixFirst = "2F:F#:00:00:C9:";
                this.vendorprefixLast = "2F:F#:00:00:C9:FF:FF:FF";
                this.vendorRangeSize = "16777215";*/
                
            }else if(this.vendor == "Qlogic"){

                this.fabricAwwnnFirst = "";
                this.fabricAwwpnFirst = vendorStore.fabricAwwpnFirst.substr(0,16);
                this.fabricBwwnnFirst = "";
                this.fabricBwwpnFirst = vendorStore.fabricBwwpnFirst.substr(0,16);

                this.fabricAwwnnLast = "";
                this.fabricAwwpnLast = vendorStore.fabricAwwpnLast;
                this.fabricBwwnnLast = "";
                this.fabricBwwpnLast = vendorStore.fabricBwwpnLast;
                
                this.vendorprefixFirst = vendorStore.vendorprefixFirst;
                this.vendorprefixLast = vendorStore.vendorprefixLast;
                this.vendorRangeSize = vendorStore.vendorRangeSize;

                
/*                this.fabricAwwnnFirst = "";
                this.fabricAwwpnFirst = "21:80:00:E0:8B:0";
                this.fabricBwwnnFirst = "";
                this.fabricBwwpnFirst = "21:81:00:E0:8B:2";

                this.fabricAwwnnLast = "";
                this.fabricAwwpnLast = "21:80:00:E0:8B:0F:FF:FF";
                this.fabricBwwnnLast = "";
                this.fabricBwwpnLast = "21:81:00:E0:8B:2F:FF:FF";
                */
                //this.vendorprefixFirst = "21:8#:00:E0:8B:#";
                //this.vendorprefixLast = "21:8#:00:E0:8B:#F:FF:FF";
                //this.vendorRangeSize = "16777215";
            }else if(this.vendor == "Brocade"){
            
                this.fabricAwwnnFirst = vendorStore.fabricAwwnnFirst.substr(0,15);
                this.fabricAwwpnFirst = vendorStore.fabricAwwpnFirst.substr(0,15);
                this.fabricBwwnnFirst = vendorStore.fabricBwwnnFirst.substr(0,15);
                this.fabricBwwpnFirst = vendorStore.fabricBwwpnFirst.substr(0,15);

                this.fabricAwwnnLast = vendorStore.fabricAwwnnLast;
                this.fabricAwwpnLast = vendorStore.fabricAwwpnLast;
                this.fabricBwwnnLast = vendorStore.fabricBwwnnLast;
                this.fabricBwwpnLast = vendorStore.fabricBwwpnLast;
                
                this.vendorprefixFirst = vendorStore.vendorprefixFirst;
                this.vendorprefixLast = vendorStore.vendorprefixLast;
                this.vendorRangeSize = vendorStore.vendorRangeSize;
                
       /*         this.fabricAwwnnFirst = "2B:FA:00:05:1E:";
                this.fabricAwwpnFirst = "2B:FC:00:05:1E:";
                this.fabricBwwnnFirst = "2B:FB:00:05:1E:";
                this.fabricBwwpnFirst = "2B:FD:00:05:1E:";

                this.fabricAwwnnLast = "2B:FA:00:05:1E:FF:FF:FF";
                this.fabricAwwpnLast = "2B:FC:00:05:1E:FF:FF:FF";
                this.fabricBwwnnLast = "2B:FB:00:05:1E:FF:FF:FF";
                this.fabricBwwpnLast = "2B:FD:00:05:1E:FF:FF:FF";
                
                this.vendorprefixFirst = "2B:F#:00:05:1E:";
                this.vendorprefixLast = "2B:F#:00:05:1E:FF:FF:FF";
                this.vendorRangeSize = "16777215";*/

            }else if(this.vendor == "IBM"){
            
                this.fabricAwwnnFirst = vendorStore.fabricAwwnnFirst.substr(0,16);
                this.fabricAwwpnFirst = vendorStore.fabricAwwpnFirst.substr(0,16);
                this.fabricBwwnnFirst = vendorStore.fabricBwwnnFirst.substr(0,16);
                this.fabricBwwpnFirst = vendorStore.fabricBwwpnFirst.substr(0,16);

                this.fabricAwwnnLast = vendorStore.fabricAwwnnLast;
                this.fabricAwwpnLast = vendorStore.fabricAwwpnLast;
                this.fabricBwwnnLast = vendorStore.fabricBwwnnLast;
                this.fabricBwwpnLast = vendorStore.fabricBwwpnLast;
                
                this.vendorprefixFirst = vendorStore.vendorprefixFirst;
                this.vendorprefixLast = vendorStore.vendorprefixLast;
                this.vendorRangeSize = vendorStore.vendorRangeSize;
                
                /*this.fabricAwwnnFirst = "20:80:00:50:76:0";
                this.fabricAwwpnFirst = "21:80:00:50:76:0";
                this.fabricBwwnnFirst = "20:81:00:50:76:2";
                this.fabricBwwpnFirst = "21:81:00:50:76:2";

                this.fabricAwwnnLast = "20:80:00:50:76:0F:FF:FF";
                this.fabricAwwpnLast = "21:80:00:50:76:0F:FF:FF";
                this.fabricBwwnnLast = "20:81:00:50:76:2F:FF:FF";
                this.fabricBwwpnLast = "21:81:00:50:76:2F:FF:FF";
                
                this.vendorprefixFirst = "2#:8#:00:50:76:#";
                this.vendorprefixLast = "2#:8#:00:50:76:#F:FF:FF";
                this.vendorRangeSize = "16777215";*/

            }else if(this.vendor == "Mellanox"){

                this.fabricAwwnnFirst = "";
                this.fabricAwwpnFirst = "";
                this.fabricBwwnnFirst = "";
                this.fabricBwwpnFirst = "";

                this.fabricAwwnnLast = "";
                this.fabricAwwpnLast = "";
                this.fabricBwwnnLast = "";
                this.fabricBwwpnLast = "";
                
                this.vendorprefixFirst = "";
                this.vendorprefixLast = "";
                this.vendorRangeSize = "";

                
                //                this.vendorprefixFirst = "5F:3E:F0:01:A4:";
  //              this.vendorprefixLast = "2F:FE:00:00:C9:FF:FF:FE";
            }

    


        },
        _connectDataModels : function(){
            
            //console.log(this.declaredClass + ": ", this.preloadedData.items);
            
            //rangeTable
            this.rangeStore = new dojo.data.ItemFileWriteStore({
                data: {"items" : []}                    
            });
            this.rangemodel = new dijit.tree.ForestStoreModel({store: this.rangeStore, childrenAttrs: [ "children" ]});
            
            if (this.rangeLayout == null) {
                this.rangeLayout = [
      //              { name: "<button class=\"collapseicon\"></button>",  field: \"expand\", width: \"5%\", editable:false, formatter: this.displayExpand},
                    { name: this.locResources.RANGE, field: "range", width:"50%", editable:false },
                    { name: this.locResources.FIRST, field: "first", width:"70%", editable:false },
                    { name: this.locResources.SIZE, field: "size", width:"60%", editable:false },
                    { name: this.locResources.LAST, field: "last", width:"70%", editable:false },
                    {name: this.locResources.ALLOC, field: "allocated",formatter: this.displayAllocation, width: "30%", editable:false },
                    { name: " ",  field: "icons", width: "20%", editable:false, formatter: dojo.hitch(this, "_formatIcons")}
                   // { name: " ",  field: "icons", width: "20%", editable:false, formatter: this._formatIcons}
                  
                ];
            }

           //overallTable
            
            if(this.vendor == "IBM"){

              this.overallStore = new dojo.data.ItemFileWriteStore({
                  data: {"items" : [ 
                          { fabric: this.locResources.FabricX.replace("%1","A"), wwn: this.locResources.WWNN, firstaddress: this.fabricAwwnnFirst+"0:00:00", rangesize: this.vendorRangeSize, lastaddress: this.fabricAwwnnLast, allocated: "15::100" }, 
                          { fabric: this.locResources.FabricX.replace("%1","A"), wwn: this.locResources.WWPN, firstaddress: this.fabricAwwpnFirst+"0:00:00", rangesize: this.vendorRangeSize, lastaddress: this.fabricAwwpnLast, allocated: "15::100" }, 
                          { fabric: this.locResources.FabricX.replace("%1","B"), wwn: this.locResources.WWNN, firstaddress: this.fabricBwwnnFirst+"0:00:00", rangesize: this.vendorRangeSize, lastaddress: this.fabricBwwnnLast, allocated: "15::100" },
                          { fabric: this.locResources.FabricX.replace("%1","B"), wwn: this.locResources.WWPN, firstaddress: this.fabricBwwpnFirst+"0:00:00", rangesize: this.vendorRangeSize, lastaddress: this.fabricBwwpnLast, allocated: "15::100" } 
                          ]}                    
              });
              
            }else if(this.vendor == "Qlogic"){
             
                this.overallStore = new dojo.data.ItemFileWriteStore({
                    data: {"items" : [ 
                            { fabric: this.locResources.FabricX.replace("%1","A"), wwn: this.locResources.WWPN, firstaddress: this.fabricAwwpnFirst+"0:00:00", rangesize: this.vendorRangeSize, lastaddress: this.fabricAwwpnLast, allocated: "15::100" }, 
                            { fabric: this.locResources.FabricX.replace("%1","B"), wwn: this.locResources.WWPN, firstaddress: this.fabricBwwpnFirst+"0:00:00", rangesize: this.vendorRangeSize, lastaddress: this.fabricBwwpnLast, allocated: "15::100" }
                            ]}                    
                });                
                
            }else{

                this.overallStore = new dojo.data.ItemFileWriteStore({
                    data: {"items" : [ 
                            { fabric: this.locResources.FabricX.replace("%1","A"), wwn: this.locResources.WWNN, firstaddress: this.fabricAwwnnFirst+"00:00:00", rangesize: this.vendorRangeSize, lastaddress: this.fabricAwwnnLast, allocated: "00::100" }, 
                            { fabric: this.locResources.FabricX.replace("%1","A"), wwn: this.locResources.WWPN, firstaddress: this.fabricAwwpnFirst+"00:00:00", rangesize: this.vendorRangeSize, lastaddress: this.fabricAwwpnLast, allocated: "00::100" }, 
                            { fabric: this.locResources.FabricX.replace("%1","B"), wwn: this.locResources.WWNN, firstaddress: this.fabricBwwnnFirst+"00:00:00", rangesize: this.vendorRangeSize, lastaddress: this.fabricBwwnnLast, allocated: "00::100" },
                            { fabric: this.locResources.FabricX.replace("%1","B"), wwn: this.locResources.WWPN, firstaddress: this.fabricBwwpnFirst+"00:00:00", rangesize: this.vendorRangeSize, lastaddress: this.fabricBwwpnLast, allocated: "00::100" }
                            ]}                    
                });

                
            } 
              
              if (this.overallLayout == null) {
                  this.overallLayout = this.getOverallLayout();
              }
              
              this.overallmodel = new dijit.tree.ForestStoreModel({store: this.overallStore, childrenAttrs: ["children"]});

              
        },
        cancelClicked: function() {      
            this.hide();
        },
        okClicked: function() {
  
            var grid = this.rangeTable;
            var store = grid.store;
            var topLevelItems = store._arrayOfTopLevelItems;
            //store._arrayOfAllItems;
            var loopcount;
                        
            var items = new Array; // Array that holds ranges

            if(this.vendor == "Qlogic"){

                for (loopcount = 0; loopcount < topLevelItems.length; loopcount++) {
                    var rangeObject = new Object();
                    rangeObject.name = topLevelItems[loopcount].range[0];
                    rangeObject.firstAddress = topLevelItems[loopcount].first[0];
                    rangeObject.poolRangeSize = topLevelItems[loopcount].size[0];
                    rangeObject.lastAddress = topLevelItems[loopcount].last[0];
                    rangeObject.allocated = topLevelItems[loopcount].allocated[0];
                    
                    rangeObject.WWNNAfirst = "";
                    rangeObject.WWNNAlast = "";

                    rangeObject.WWPNAfirst = topLevelItems[loopcount].children[0].children[0].first[0];
                    rangeObject.WWPNAlast = topLevelItems[loopcount].children[0].children[0].last[0];

                    rangeObject.WWNNBfirst = "";
                    rangeObject.WWNNBlast = "";

                    rangeObject.WWPNBfirst = topLevelItems[loopcount].children[1].children[0].first[0];
                    rangeObject.WWPNBlast = topLevelItems[loopcount].children[1].children[0].last[0];
            
                    
                    items.push(rangeObject);
                }

                
            }else{

                for (loopcount = 0; loopcount < topLevelItems.length; loopcount++) {
                    rangeObject = new Object();
                    rangeObject.name = topLevelItems[loopcount].range[0];
                    rangeObject.firstAddress = topLevelItems[loopcount].first[0];
                    rangeObject.poolRangeSize = topLevelItems[loopcount].size[0];
                    rangeObject.lastAddress = topLevelItems[loopcount].last[0];
                    rangeObject.allocated = topLevelItems[loopcount].allocated[0];
                    
                    rangeObject.WWNNAfirst = topLevelItems[loopcount].children[0].children[0].first[0];
                    rangeObject.WWNNAlast = topLevelItems[loopcount].children[0].children[0].last[0];

                    rangeObject.WWPNAfirst = topLevelItems[loopcount].children[0].children[1].first[0];
                    rangeObject.WWPNAlast = topLevelItems[loopcount].children[0].children[1].last[0];

                    rangeObject.WWNNBfirst = topLevelItems[loopcount].children[1].children[0].first[0];
                    rangeObject.WWNNBlast = topLevelItems[loopcount].children[1].children[0].last[0];

                    rangeObject.WWPNBfirst = topLevelItems[loopcount].children[1].children[1].first[0];
                    rangeObject.WWPNBlast = topLevelItems[loopcount].children[1].children[1].last[0];
                    
                    items.push(rangeObject);
                }

                
            }
                        

            var argJSONString = dojo.toJson({ 
                "vendorName":this.vendor,
                "identifier":this.vendor,
                  "vendorRangeSize":this.vendorRangeSize,
                  "items": items
            }, true);
            
            //alert(argJSONString);

            var xhrArgs = {
                    url:  this.REST_PATH + "addresspool/setpoolranges/FIBRE/"+this.vendor,
                    handleAs: "json",
                    sync: true,
                    headers: {
                        "Content-Type": "application/json; charset=utf-8"
                    },
                    postData: argJSONString,
                    load : function(data) {
                    },
                    error : function(error) {
                        alert("Post failed: " + error);
                    }
                };
                dojo.xhrPost(xhrArgs);

                this.hide();

            
        },
        setprevData: function(){

            var pool = this;
            var loopcount;
            
            var grid = pool.rangeTable;
            var store = grid.store;

            var firstAdd ="";  //Variable to add to range Checker Array
            var lastAdd = "";  //Variable to add to range Checker Array
            
            var locResources = this.locResources;
            
            if(this.vendor == "Qlogic"){

                for (loopcount = 0; loopcount < this.preloadedData.items.length; loopcount++) {

                    var meparent = store.newItem(
                            {range:this.preloadedData.items[loopcount].range, first:this.preloadedData.items[loopcount].first, size:this.preloadedData.items[loopcount].size, last:this.preloadedData.items[loopcount].last,allocated:this.preloadedData.items[loopcount].allocated, icons:true}
                            );

                    var childA = store.newItem(
                            { range: locResources.FabricX.replace("%1","A"), first:this.preloadedData.items[loopcount].first, size:this.preloadedData.items[loopcount].size, last:this.preloadedData.items[loopcount].last,allocated:this.preloadedData.items[loopcount].allocated, icons:false},{parent: meparent, attribute: "children"}
                    );
                                                                            
                    var child = store.newItem(
                            { range: locResources.WWPN, first:this.preloadedData.items[loopcount].WWPNAfirst, size:this.preloadedData.items[loopcount].size, last:this.preloadedData.items[loopcount].WWPNAlast ,allocated:"", icons:false},{parent: childA, attribute: "children"}
                    );
                    
                    var childB = store.newItem(
                            { range: locResources.FabricX.replace("%1","B"), first:this.preloadedData.items[loopcount].first, size:this.preloadedData.items[loopcount].size, last:this.preloadedData.items[loopcount].last,allocated:this.preloadedData.items[loopcount].allocated, icons:false},{parent: meparent, attribute: "children"}
                    );

                    var child = store.newItem(
                            { range: locResources.WWPN, first:this.preloadedData.items[loopcount].WWPNBfirst, size:this.preloadedData.items[loopcount].size, last:this.preloadedData.items[loopcount].WWPNBlast ,allocated:"", icons:false},{parent: childB, attribute: "children"}
                    );

                    firstAdd = this.preloadedData.items[loopcount].first;
                    
                    firstAdd = firstAdd.substr(-7);
                    firstAdd = firstAdd.replace(/:/g, "");  //take out :
                    
                    this.rangeCheckerArray.push(parseInt(firstAdd,16));                    

                    lastAdd = this.preloadedData.items[loopcount].last;
                    
                    lastAdd = lastAdd.substr(-7);
                    lastAdd = lastAdd.replace(/:/g, "");  //take out :

                    this.rangeCheckerArray.push(parseInt(lastAdd,16));                    

                }                   
            }else{

              for (loopcount = 0; loopcount < this.preloadedData.items.length; loopcount++) {

                var meparent = store.newItem(
                        {range:this.preloadedData.items[loopcount].range, first:this.preloadedData.items[loopcount].first, size:this.preloadedData.items[loopcount].size, last:this.preloadedData.items[loopcount].last,allocated:this.preloadedData.items[loopcount].allocated, icons:true}
                        );

                    var childA = store.newItem(
                            { range: locResources.FabricX.replace("%1","A"), first:this.preloadedData.items[loopcount].first, size:this.preloadedData.items[loopcount].size, last:this.preloadedData.items[loopcount].last,allocated:this.preloadedData.items[loopcount].allocated, icons:false},{parent: meparent, attribute: "children"}
                    );
                                                                                                                       
                    var child = store.newItem(
                            { range: locResources.WWNN, first:this.preloadedData.items[loopcount].WWNNAfirst, size:this.preloadedData.items[loopcount].size, last:this.preloadedData.items[loopcount].WWNNAlast ,allocated:"", icons:false},{parent: childA, attribute: "children"}
                    );

                    var child = store.newItem(
                            { range: locResources.WWPN, first:this.preloadedData.items[loopcount].WWPNAfirst, size:this.preloadedData.items[loopcount].size, last:this.preloadedData.items[loopcount].WWPNAlast ,allocated:"", icons:false},{parent: childA, attribute: "children"}
                    );
                    
                    var childB = store.newItem(
                            { range: locResources.FabricX.replace("%1","B"), first:this.preloadedData.items[loopcount].first, size:this.preloadedData.items[loopcount].size, last:this.preloadedData.items[loopcount].last,allocated:this.preloadedData.items[loopcount].allocated, icons:false},{parent: meparent, attribute: "children"}
                    );

                    var child = store.newItem(
                            { range: locResources.WWNN, first:this.preloadedData.items[loopcount].WWNNBfirst, size:this.preloadedData.items[loopcount].size, last:this.preloadedData.items[loopcount].WWNNBlast ,allocated:"", icons:false},{parent: childB, attribute: "children"}
                    );

                    var child = store.newItem(
                            { range: locResources.WWPN, first:this.preloadedData.items[loopcount].WWPNBfirst, size:this.preloadedData.items[loopcount].size, last:this.preloadedData.items[loopcount].WWPNBlast ,allocated:"", icons:false},{parent: childB, attribute: "children"}
                    );


                    if(this.vendor == "IBM"){

                        firstAdd = this.preloadedData.items[loopcount].first;
                        
                        firstAdd = firstAdd.substr(-7);
                        firstAdd = firstAdd.replace(/:/g, "");  //take out :
                        
                        this.rangeCheckerArray.push(parseInt(firstAdd,16));                    

                        lastAdd = this.preloadedData.items[loopcount].last;
                    
                        lastAdd = lastAdd.substr(-7);
                        lastAdd = lastAdd.replace(/:/g, "");  //take out :

                        this.rangeCheckerArray.push(parseInt(lastAdd,16));                    

                    }else{

                        firstAdd = this.preloadedData.items[loopcount].first;
                        
                        firstAdd = firstAdd.substr(-8);
                        firstAdd = firstAdd.replace(/:/g, "");  //take out :
                        
                        this.rangeCheckerArray.push(parseInt(firstAdd,16));                    

                        lastAdd = this.preloadedData.items[loopcount].last;
                        
                        lastAdd = lastAdd.substr(-8);
                        lastAdd = lastAdd.replace(/:/g, "");  //take out :

                        this.rangeCheckerArray.push(parseInt(lastAdd,16));                    

                    }
                    

               }    
                    
            }  
            
            store.save();            
            grid.setStore(store);      
            grid.render();
                       
            pool._enableOk();
            pool._setRangeIcons();
            
            
            this.layout(); 

        },
        loadprevSettings: function() {
            
            var preloadedData = "";
            
            var xhrGet = dojo.xhrGet({
                url: this.REST_PATH + "addresspool/getpoolranges/FIBRE/"+this.vendor,
                handleAs: "json",
                sync: true,
                preventCache: true,
                load: function(response) {
                    preloadedData = response; 
                },
                handle: function(){
                    
                                                           
                       
                }
            });
            
            this.preloadedData = preloadedData;
                            	   
        },       
        showoverallTable : function(){
            if(this.overallTable == null){
                this.overallTable = new dojox.grid.LazyTreeGrid({
                    store: this.overallStore,
                    treeModel: this.overallmodel,
                    structure: this.overallLayout,
                    autoWidth: false,
                    autoHeight: true,
                    singleClickEdit: true,
                    columnReordering: false,
                    style: "width: 100%; height: 50px;",
                    noDataMessage: this.locResources.NO_DATA
                }).placeAt(this._overallTableDiv);
                this.overallTable.startup();
                this.overallTable.canSort = function(col){ return false; };
                this.overallTable.update();
            }
            
            this.layout(); 

        },  
        getOverallLayout : function(){
                return [
                        {name: this.locResources.Fabric,field: "fabric", width:"20%", editable:false},
                        {name: this.locResources.WWN, field: "wwn", width:"20%", editable:false },
                        {name: this.locResources.FIRST, field: "firstaddress", width:"50%", editable:false },
                        {name: this.locResources.SIZE, field: "rangesize", width:"40%", editable:false },
                        {name: this.locResources.LAST, field: "lastaddress", width: "50%", editable:false },
                        {name: this.locResources.ALLOC, field: "allocated",formatter: this.displayAllocation, width: "20%", editable:false }
                    ];
      },
      displayAllocation : function(value) {
          if (!value) {
              return "";
          }
          var strVal = new String(value);
          var sepIdx = strVal.indexOf("::");
          if (sepIdx > 0) {
              var alloc = strVal.substring(0, sepIdx);
              var total = strVal.substring(sepIdx + 2);
              var props = {
                  value: alloc / total * 100,
                  style: "width: 100%;"
                  //,title: alloc + " of " + total + " addresses allocated."
              };
              var progressBar = new dijit.ProgressBar(props);
              progressBar._destroyOnRemove = true;
              return progressBar;
          }
          return value;
      },
      displayExpand : function(value) {
          return "<button class=\"expandicon\"></button>";
      },
      showRangeTable : function(){
          if(this.rangeTable == null){
              this.rangeTable = new dojox.grid.LazyTreeGrid({
                  store: this.rangeStore,
                  treeModel: this.rangemodel,
                  structure: this.rangeLayout,
                  autoWidth: false,
                  autoHeight: 6,
                  singleClickEdit: true,
                  columnReordering: false,
                  style: "width: 100%;",
                  noDataMessage: this.locResources.NORANGES
              }).placeAt(this._subrangeTableDiv);
              this.rangeTable.startup();
              this.rangeTable.canSort = function(col){ return false; };
              this.rangeTable.update();
          }
          
          var availHeight = window.screen.availHeight;
          var maxHeight = availHeight * 0.25;
          var maxRows = maxHeight/35;
          this.rangeTable.set("autoHeight", maxRows);
          
          this.layout(); 

      },
      addRange : function(){
          
          var firstAWWNN = this.fabricAwwnnFirst;
          var firstAWWPN = this.fabricAwwpnFirst;
          var firstBWWNN = this.fabricBwwnnFirst;
          var firstBWWPN = this.fabricBwwpnFirst;
          var vendor = this.vendor;
          var locResources = this.locResources;

          /*alert(this.rangeCheckerArray[0]);
          alert(this.rangeCheckerArray[1]);
          alert(this.rangeCheckerArray[2]);
          alert(this.rangeCheckerArray[3]);                            
          alert(this.rangeCheckerArray[4]);
          alert(this.rangeCheckerArray[5]);*/

          var pool = this;

          var popup = new support.dialogs.FibreChannelSubrangePopup({
              mode: "add",
              title: locResources.ADDTITLE,
              newPool: pool,
              subrangeStore: this.rangeStore,
              overallStore: this.overallStore,
              dropDown: this.dropDown,
              version: this.version,
              network: this.network,
              gateway: this.gateway,
              vendorprefixFirst: this.vendorprefixFirst,
              vendorprefixLast: this.vendorprefixLast,
              vendorRangeSize: this.vendorRangeSize,
              rangeCheckerArray: this.rangeCheckerArray,
              vendor: this.vendor,
              addNewSubrange : function(){
                 var grid = pool.rangeTable;
                  var store = grid.store;
                  
               // vars to set in range checker array
                  var firstNoChar = this.first.replace(/:/g, "");  //take out :
                  var lastNoChar = this.last;   
                  
                  this.rangeCheckerArray.push(parseInt(firstNoChar,16));  //push new first address to address checker


                  //var grid = this.rangeTable;
                  //var store = this.rangeTable.grid.store;
                  //var topLevelItems = store._arrayOfTopLevelItems;
                  //grid.setItems(topLevelItems);
                  var firstCombine = this.vendorprefixFirst+this.first;

//                  alert(firstAWWNN);

                  if(vendor == "Qlogic"){

                      var lastAWWPN = firstAWWPN+this.last.substr(-7); 
                      var lastBWWPN = firstBWWPN+this.last.substr(-7); 

                      lastNoChar = lastNoChar.substr(-7);
                      lastNoChar = lastNoChar.replace(/:/g, "");  //take out :
                                            
                      this.rangeCheckerArray.push(parseInt(lastNoChar,16));

                  }else if(vendor == "IBM"){
                      
                      var lastAWWNN = firstAWWNN+this.last.substr(-7);
                      var lastAWWPN = firstAWWPN+this.last.substr(-7); 
                      var lastBWWNN = firstBWWNN+this.last.substr(-7); 
                      var lastBWWPN = firstBWWPN+this.last.substr(-7); 

                      lastNoChar = lastNoChar.substr(-7);
                      lastNoChar = lastNoChar.replace(/:/g, "");  //take out :
                      
                      this.rangeCheckerArray.push(parseInt(lastNoChar,16));
                      
                  }else{
                      var lastAWWNN = firstAWWNN+this.last.substr(-8);
                      var lastAWWPN = firstAWWPN+this.last.substr(-8); 
                      var lastBWWNN = firstBWWNN+this.last.substr(-8); 
                      var lastBWWPN = firstBWWPN+this.last.substr(-8);

                      lastNoChar = lastNoChar.substr(-8);
                      lastNoChar = lastNoChar.replace(/:/g, "");  //take out :
                      
                      this.rangeCheckerArray.push(parseInt(lastNoChar,16));
                  }

                  
                  
                  //alert(lastAWWNN);
                  
                  //if(this.vendor == "Qlogic" || this.vendor == "IBM"){
                    //  hexString = hexString.substr(-7);            
                  //}


/*                  if(firstAWWNN != null)
                          var firstAWWNNExpNoChar = firstAWWNN.replace(/:/g, "");   //take out :

                  alert(firstAWWNNExpNoChar);

                     // console.log(this.declaredClass + ": ", firstExpNoChar);   
                      
                      var firstAWWNNintNumber = parseInt(firstAWWNNExpNoChar,16);   //turn hex into decemical 
                  
                      var firstAWWNNlasthexNumber = parseInt(firstAWWNNintNumber) + parseInt(this.size);  //get last number hex as decimal 
                      
                      //console.log(this.declaredClass + ": NUM:::::->"+this.hexNumber);
                      
                      var firstAWWNNhexString = firstAWWNNlasthexNumber.toString(16);  // convert decimal to hex
*/
                      
                  firstAWWNN = firstAWWNN+this.first;                      
                  firstAWWPN = firstAWWPN+this.first;
                  firstBWWNN = firstBWWNN+this.first;
                  firstBWWPN = firstBWWPN+this.first;

                  if(vendor == "Qlogic"){

                      var meparent = store.newItem(
                              {range:this.range, first:firstCombine, size:this.size, last:this.last,allocated:this.allocated, icons:true}
                              );

                      var childA = store.newItem(
                              { range: locResources.FabricX.replace("%1","A"), first:firstCombine, size:this.size, last:this.last,allocated:this.allocated, icons:false},{parent: meparent, attribute: "children"}
//                              {range:this.range, first:firstCombine, size:this.size, last:this.last,allocated:this.allocated, remove:true},{parent: meparent, attribute: "children"}                          
                      );
                                                                              
                      var child = store.newItem(
                              { range: locResources.WWPN, first:firstAWWPN, size:this.size, last:lastAWWPN ,allocated:"", icons:false},{parent: childA, attribute: "children"}
                      );
                      
                      var childB = store.newItem(
                              { range: locResources.FabricX.replace("%1","B"), first:firstCombine, size:this.size, last:this.last,allocated:this.allocated, icons:false},{parent: meparent, attribute: "children"}
//                              {range:this.range, first:firstCombine, size:this.size, last:this.last,allocated:this.allocated, remove:true},{parent: meparent, attribute: "children"}                          
                      );

                      var child = store.newItem(
                              { range: locResources.WWPN, first:firstBWWPN, size:this.size, last:lastBWWPN ,allocated:"", icons:false},{parent: childB, attribute: "children"}
                      );
                                                                 
                  }else{

                      var meparent = store.newItem(
                              {range:this.range, first:firstCombine, size:this.size, last:this.last,allocated:this.allocated, icons:true}
                              );

                          var childA = store.newItem(
                                  { range: locResources.FabricX.replace("%1","A"), first:firstCombine, size:this.size, last:this.last,allocated:this.allocated, icons:false},{parent: meparent, attribute: "children"}
//                                  {range:this.range, first:firstCombine, size:this.size, last:this.last,allocated:this.allocated, remove:true},{parent: meparent, attribute: "children"}                          
                          );
                                                                                                                             
                          var child = store.newItem(
                                  { range: locResources.WWNN, first:firstAWWNN, size:this.size, last:lastAWWNN ,allocated:"", icons:false},{parent: childA, attribute: "children"}
                          );

                          var child = store.newItem(
                                  { range: locResources.WWPN, first:firstAWWPN, size:this.size, last:lastAWWPN ,allocated:"", icons:false},{parent: childA, attribute: "children"}
                          );
                          
                          var childB = store.newItem(
                                  { range: locResources.FabricX.replace("%1","B"), first:firstCombine, size:this.size, last:this.last,allocated:this.allocated, icons:false},{parent: meparent, attribute: "children"}
//                                  {range:this.range, first:firstCombine, size:this.size, last:this.last,allocated:this.allocated, remove:true},{parent: meparent, attribute: "children"}                          
                          );

                          var child = store.newItem(
                                  { range: locResources.WWNN, first:firstBWWNN, size:this.size, last:lastBWWNN ,allocated:"", icons:false},{parent: childB, attribute: "children"}
                          );

                          var child = store.newItem(
                                  { range: locResources.WWPN, first:firstBWWPN, size:this.size, last:lastBWWPN ,allocated:"", icons:false},{parent: childB, attribute: "children"}
                          );
                          
                  }  
                //  var itemID = grid.getItem(0).range.toString();
               //   alert(itemID);
                                   
                  
//                  console.log(this.declaredClass + ": ", store);
                  
                  store.save();
                  grid.setStore(store);
                  //grid.update();
                  //grid._refresh();

                  //var itemID = grid.getItem(0).range.toString();
                  //alert(itemID);
                  
                  //var children = store.getValues(0,"children");

                  
                  //alert(children);
                  
                  
                 //grid.setItems(topLevelItems);
                  pool._enableOk();
                  pool._setRangeIcons();

/*                  store.newItem(
                     {range:this.locResources.FabricA, first:firstCombine, size:this.size, last:this.last,allocated:this.allocated, remove:false }
                   );
                  store.newItem(
                          {range:this.locResources.WWNN, first:firstCombine, size:this.size, last:this.last,allocated:"", remove:false }
                   );*/
                  
/*                  { fabric: this.locResources.FabricA, wwn: this.locResources.WWNN, firstaddress: "2F:FE:00:00:C9:00:00:00", rangesize: "16777215", lastaddress: "2F:FE:00:00:C9:FF:FF:FF", allocated: "15::100" }, 
                  { fabric: this.locResources.FabricA, wwn: this.locResources.WWPN, firstaddress: "2F:FE:00:00:C9:00:00:00", rangesize: "16777215", lastaddress: "2F:FE:00:00:C9:FF:FF:FF", allocated: "15::100" }, 
                  { fabric: this.locResources.FabricB, wwn: this.locResources.WWNN, firstaddress: "2F:FE:00:00:C9:00:00:00", rangesize: "16777215", lastaddress: "2F:FE:00:00:C9:FF:FF:FF", allocated: "15::100" },
                  { fabric: this.locResources.FabricB, wwn: this.locResources.WWPN, firstaddress: "2F:FE:00:00:C9:00:00:00", rangesize: "16777215", lastaddress: "2F:FE:00:00:C9:FF:FF:FF", allocated: "15::100" }, 
*/
/*                  alert(this.rangeCheckerArray[0]);
                  alert(this.rangeCheckerArray[1]);
                  alert(this.rangeCheckerArray[2]);
                  alert(this.rangeCheckerArray[3]);                            
                  alert(this.rangeCheckerArray[4]);
                  alert(this.rangeCheckerArray[5]);*/
                  
         //         pool.checkForNetworkID();
        //          pool.reposition();
                  
                  this.layout(); 

              },
              _destroyOnRemove: true
          });  
          popup.show();
      },
      
      //Removes a row from the subrange table
      removeRow : function(row){
          var grid = this.rangeTable;
          var store = grid.store;
//          var topLevelItems = store._arrayOfTopLevelItems;
  //        var item = topLevelItems[row];
          var item = grid.getItem(row);
          var range = store.getValue(item, "range");

          var confirmedDelete = function() {

              grid.store.deleteItem(item);

              store.save();
              grid.setStore(store);
              grid.update();
              grid._refresh();
              
              grid.setItems(store._arrayOfTopLevelItems);

              if(this.vendor == "Qlogic" || this.vendor == "IBM"){

                  var firstNoChar = item.first[0];              //First address to remove 
                  firstNoChar = firstNoChar.substr(-7);
                  firstNoChar = firstNoChar.replace(/:/g, "");  //take out :
                  firstNoChar = parseInt(firstNoChar,16);
                  
                  var lastNoChar = item.last[0];                //Last address to remove
                  lastNoChar = lastNoChar.substr(-7);
                  lastNoChar = lastNoChar.replace(/:/g, "");  //take out :
                  lastNoChar = parseInt(lastNoChar,16);


              }else{
               
                  var firstNoChar = item.first[0];              //First address to remove 
                  firstNoChar = firstNoChar.substr(-8);
                  firstNoChar = firstNoChar.replace(/:/g, "");  //take out :
                  firstNoChar = parseInt(firstNoChar,16);
                  
                  var lastNoChar = item.last[0];                //Last address to remove
                  lastNoChar = lastNoChar.substr(-8);
                  lastNoChar = lastNoChar.replace(/:/g, "");  //take out :
                  lastNoChar = parseInt(lastNoChar,16);

              }
              
              var rangeCheckerCount = this.rangeCheckerArray.length;   //Remove Deleted Range from rangeCheckArray
              var counter;
              var counterPlusOne;
              
              for(counter = 0;counter < rangeCheckerCount;counter=counter+2){

                  counterPlusOne = counter + 1;

                  if(this.rangeCheckerArray[counter] == firstNoChar && this.rangeCheckerArray[counterPlusOne] == lastNoChar){                                            

                      //alert(firstNoChar);
                      //alert(this.rangeCheckerArray[counter]);
                      //alert(lastNoChar);                      
                      //alert(this.rangeCheckerArray[counterPlusOne]);
                      
                      this.rangeCheckerArray.splice(counter,2);
                      //this.rangeCheckerArray.splice(counterPlusOne,1);
                      
                  }
                  
              }
                                                        
/*              alert(this.rangeCheckerArray.length);
              alert(this.rangeCheckerArray[0]);
              alert(this.rangeCheckerArray[1]);
              alert(this.rangeCheckerArray[2]);
              alert(this.rangeCheckerArray[3]);                            
              alert(this.rangeCheckerArray[4]);
              alert(this.rangeCheckerArray[5]);*/
              
              this._setRangeIcons();
             // this._enableOk();
              
              this.layout(); 


          };
          
          
          if(this.CP_RUN_ENVIRONMENT == "fsm"){

              require([ "support/temp/ConfirmationDialog" ], dojo.hitch(this, function() {

                  var confirmDialog = new support.temp.ConfirmationDialog({
                      buttonLabel: this.resources.DELETE,
                      type: "Warning",
                      info: this.locResources.DELETEINFO                    
                  });

                  confirmDialog.set("content", this.locResources.DELETE.replace("%1", range));                      
                  confirmDialog.startup();
                  confirmDialog.confirm(confirmedDelete,this);
              
              }));

              
          }else if(this.CP_RUN_ENVIRONMENT == "augusta"){

              require([ "idx/widget/ConfirmationDialog" ], dojo.hitch(this, function() {

                  var confirmDialog = new idx.temp.ConfirmationDialog({
                      buttonLabel: this.resources.DELETE,
                      type: "Warning",
                      info: this.locResources.DELETEINFO                    
                  });

                  confirmDialog.set("content", this.locResources.DELETE.replace("%1", range));                      
                  confirmDialog.startup();
                  confirmDialog.confirm(confirmedDelete,this);
              
              }));
              
          }

          
          //var remove = confirm(this.locResources.DELETE.replace("%1", range));
/*          if(remove){
              grid.store.deleteItem(item);

              store.save();
              grid.setStore(store);
              grid.update();
              grid._refresh();
              
              grid.setItems(store._arrayOfTopLevelItems);
     
              
              this._setRangeIcons();
              this._enableOk();
              
              this.layout(); 

          }*/ 
      },
      
      //Format for the "remove" column, icon
      _formatIcons : function(value, rowIndex, cell){         
          

          if(value == false) {
              return "";
          }

          return "<div id=\"edit_" + rowIndex + "\" class=\"spEditLgIcon pointer\"" + //edit
              "onClick=\"dijit.byId('" + this.id + "').editRow(\"" + rowIndex + "\")\"" +
              "title=\""+this.locResources.EDIT+"\" style=\"display:inline-block;\"></div>" +
              "<div style=\"display:inline-block; width:5px\"></div>" + //spacing
              "<div id=\"remove_" + rowIndex + "\" class=\"spDeleteIcon pointer\"" + //remove
              "onClick=\"dijit.byId('" + this.id + "').removeRow(\"" + rowIndex + "\")\"" +
              "title=\""+this.locResources.REMOVE+"\" style=\"display:inline-block;\">";

      },
      
      editRow : function(row){
                              
          var pool = this;
          var store = this.rangeTable.store;          
          //var item = store._arrayOfTopLevelItems[row];
          var grid = this.rangeTable;
          var item = grid.getItem(row);
          var vendor = this.vendor;
          var locResources = this.locResources;
          var rangeCheckerArray = this.rangeCheckerArray;
          var firstNoCharPrev = this.firstNoChar;  //Holds Prev first range when editing
          var lastNoCharPrev = this.lastNoChar;  //Holds Prev last range when editing
          
          var firstUncombined = item.first[0].replace(this.vendorprefixFirst,"");

          var rangeCheckerTempArray = dojo.clone(this.rangeCheckerArray); //Temp array to send to edit
                                                              //Should be able to choose current range 
                                                                  //during edit

          var firstNoChar = item.first[0];              //First address to remove 
          var lastNoChar = item.last[0];                //Last address to remove

          if(this.vendor == "Qlogic" || this.vendor == "IBM"){

              firstNoChar = firstNoChar.substr(-7);
              firstNoChar = firstNoChar.replace(/:/g, "");  //take out :
              firstNoChar = parseInt(firstNoChar,16);
              
              lastNoChar = lastNoChar.substr(-7);
              lastNoChar = lastNoChar.replace(/:/g, "");  //take out :
              lastNoChar = parseInt(lastNoChar,16);


          }else{
           
              firstNoChar = firstNoChar.substr(-8);
              firstNoChar = firstNoChar.replace(/:/g, "");  //take out :
              firstNoChar = parseInt(firstNoChar,16);
              
              lastNoChar = lastNoChar.substr(-8);
              lastNoChar = lastNoChar.replace(/:/g, "");  //take out :
              lastNoChar = parseInt(lastNoChar,16);

          }
          
          firstNoCharPrev = firstNoChar;   //Set Prev Range
          lastNoCharPrev = lastNoChar;      //Set Prev Range
          
          var rangeCheckerCount = rangeCheckerTempArray.length;   //Remove Deleted Range from rangeCheckArray
          var counter;
          var counterPlusOne;

        //  alert(firstNoChar);

          for(counter = 0;counter < rangeCheckerCount;counter=counter+2){

              counterPlusOne = counter + 1;

              if(rangeCheckerTempArray[counter] == firstNoChar && rangeCheckerTempArray[counterPlusOne] == lastNoChar){                                            
                  rangeCheckerTempArray.splice(counter,2);
              }
              
          }

          
        //  alert(this.rangeCheckerArray.length);   //Remove Deleted Range from rangeCheckArray
          
          
          var popup = new support.dialogs.FibreChannelSubrangePopup({
              mode: "Edit",
              title: locResources.EDITTITLE,
              newPool: pool,
              network: this.network,
              gateway: this.gateway,
              dropDown: this.dropDown,
              range: item.range[0],
              first: firstUncombined,
              size: item.size[0],
              index: row,
              subrangeStore: this.rangeStore,
              overallStore: this.overallStore,
              version: this.version,
              vendorprefixFirst: this.vendorprefixFirst,
              vendorprefixLast: this.vendorprefixLast,
              vendorRangeSize: this.vendorRangeSize,
              rangeCheckerArray: rangeCheckerTempArray,
              vendor: this.vendor,
              editSubrange : function(){
                  var firstCombine = this.vendorprefixFirst+this.first;

                  store.setValue(item, "range", this.range);
                  store.setValue(item, "first", firstCombine);
                  store.setValue(item, "size", this.size);
                  store.setValue(item, "last", this.last);
                  store.setValue(item, "allocated", this.allocated);

                 // alert(rangeCheckerArray.length);   //Remove Deleted Range from rangeCheckArray

                  //Remove old Edited Range from rangeCheckArray if different                                    
                  var rangeCheckerCount = rangeCheckerArray.length;   
                  var counter;
                  var counterPlusOne;
                  
                  for(counter = 0;counter < rangeCheckerCount;counter=counter+2){

                      counterPlusOne = counter + 1;

                      if(rangeCheckerArray[counter] == firstNoCharPrev && rangeCheckerArray[counterPlusOne] == lastNoCharPrev){                                            
                          rangeCheckerArray.splice(counter,2);
                      }
                      
                  }

                //  alert(rangeCheckerArray.length);   //Remove Deleted Range from rangeCheckArray

                  //Convert new First and Last To Integers
                  if(vendor == "Qlogic" || vendor == "IBM"){

                      var firstNoChar = firstCombine;              //First address to remove 
                      firstNoChar = firstNoChar.substr(-7);
                      firstNoChar = firstNoChar.replace(/:/g, "");  //take out :
                      firstNoChar = parseInt(firstNoChar,16);
                      
                      var lastNoChar = this.last;                //Last address to remove
                      lastNoChar = lastNoChar.substr(-7);
                      lastNoChar = lastNoChar.replace(/:/g, "");  //take out :
                      lastNoChar = parseInt(lastNoChar,16);


                  }else{
                   
                      var firstNoChar = firstCombine;              //First address to remove 
                      firstNoChar = firstNoChar.substr(-8);
                      firstNoChar = firstNoChar.replace(/:/g, "");  //take out :
                      firstNoChar = parseInt(firstNoChar,16);
                      
                      var lastNoChar = this.last;                //Last address to remove
                      lastNoChar = lastNoChar.substr(-8);
                      lastNoChar = lastNoChar.replace(/:/g, "");  //take out :
                      lastNoChar = parseInt(lastNoChar,16);

                  }
                  
                 // alert(firstNoChar);
                  
                  //Add new First and Last to rangeCheckArray
                  rangeCheckerArray.push(firstNoChar);  //push new first address to address checker
                  rangeCheckerArray.push(lastNoChar);  //push new last address to address checker

             //     alert(rangeCheckerArray.length);   //Remove Deleted Range from rangeCheckArray


/*                  // vars to set in range checker array
                  var firstNoChar = this.first.replace(/:/g, "");  //take out :
                  var lastNoChar = this.last;   
                  
                  this.rangeCheckerArray.push(parseInt(firstNoChar,16));  //push new first address to address checker
*/
                  
                  //alert(item);
                  
                  //grid.store.deleteItem(item, "children");

//                  store.setValues(item, "children", this.range);
                  
                  var children = store.getValues(item, "children");
                  
                  var numofchildren = children.length;
                  
                  var x;
                  var y;
                  
                  for(x=0;x < numofchildren;x++){
                      
                      store.setValue(children[x],"first",firstCombine);                  
                      store.setValue(children[x],"size",this.size);                  
                      store.setValue(children[x],"last",this.last);

                      var children2 = store.getValues(children[x], "children");
                      var numofchildren2 = children2.length;

                      
                      for(y=0;y < numofchildren2;y++){                          

                          if(vendor == "Qlogic" || this.vendor == "IBM"){
                              store.setValue(children2[y],"first",children2[y]["first"].toString().substr(0,16)+this.first);
                              store.setValue(children2[y],"last",children2[y]["last"].toString().substr(0,16)+this.last.substr(-7));
                          }else{
                              store.setValue(children2[y],"first",children2[y]["first"].toString().substr(0,15)+this.first);                              
                              store.setValue(children2[y],"last",children2[y]["last"].toString().substr(0,15)+this.last.substr(-8));
                          }   
                          
                          store.setValue(children2[y],"size",this.size);                  
                                                
                      }

                  }
                                                     
                  
                  
/*                  store.setValue(children[0],"size",this.size);                  
                  store.setValue(children[1],"size",this.size);

                  store.setValue(children[0],"last",this.last);
                  store.setValue(children[1],"last",this.last);*/
                  
                  store.setValues(item, "children", children);

                  //alert(children[0]["size"]);

                  //alert(store.getValues(item, this.rangeModel.childrenAttrs[0]));
                  
                  //        pool.checkForNetworkID();
                  pool._setRangeIcons();
                  
                  this.layout(); 

              },
              _destroyOnRemove: true
          });  
          popup.show(); 
      },
      
      _enableOk : function(){
          var hasItem = false;
          if(this.rangeTable != null){
                  var store = this.rangeTable.store;
                  var items = store._arrayOfTopLevelItems;
                  hasItem = (items.length > 0);
          }
          if(hasItem)
              this.okBtn.set("disabled", false);
          else
              this.okBtn.set("disabled", true);
      },
      
      checkForNetworkID : function(){
          var network = this.calculateNetworkID();
          this.set("network", network);
          this.updateOverallTable();
      },
      
      //Sets certain icons as enabled/disabled
      _setRangeIcons : function(){
          var min = 1;
          var grid = this.rangeTable;
          var store = grid.store;
          var topLevelItems = store._arrayOfTopLevelItems;
          for(var i=0; i<topLevelItems.length; i++){
              var item = topLevelItems[i];
              if(topLevelItems.length <= min) //disable remove
                  store.setValue(item, "remove", false);
              else //enable remove
                  store.setValue(item, "remove", true);
          }
          grid.setItems(topLevelItems);
      },      
      updateOverallTable : function(){
          var pool = this;
          //needs network, broadcast, first, host, highest
          var grid = this.overallTable;
          if(grid != null){
              var store = grid.store;
              var gotItems = function(items){ 
                  //pool.networkTable.setItems(items);
                  var item = items[0];
                  if(pool.version == "IPv4"){
                      var network = pool.calculateNetworkID();
                      var broadcast = pool.calculateBroadcastAddress(network);
                      var lowest = pool.calculateLowestAddress(network);
                      var host = pool.calculateHostAddress();
                      var highest = pool.calculateHighestAddress(network, broadcast, lowest, host);
                      store.setValue(item, "network", network);
                      store.setValue(item, "broadcast", broadcast);
                      store.setValue(item, "lowest", lowest);
                      store.setValue(item, "host", host);
                      store.setValue(item, "highest", highest);
                      grid.update();
                  }
              };
              this.layout(); 

              store.fetch({onComplete:gotItems}); 
          }
      }

    });
});