define([
        "dojo",
        "dijit",
        "support/dialogs/Dialog",
        "dojo/i18n!./nls/FibreChannelBootTargetTemplate",
        "dojo/text!./templates/FibreChannelBootTargetTemplate.html",
        "dijit/form/SimpleTextarea",
        "dijit/form/CheckBox",
        "dijit/form/ComboBox",
        "dijit/form/TimeTextBox",
        "dijit/Dialog",
        "dojo/parser",
        "support/panels/BootTargetsTable",
        "support/panels/CheckButton",
        "support/panels/Panel",
        "support/dialogs/ReDeployServerTemplate",
        "support/temp/ModalDialog",
        "support/dialogs/SaveAs",
        "support/dialogs/ProgressDialog"
    ], function(dojo, dijit, dialog, mri, template) {
    
    return dojo.declare("support.dialogs.FibreChannelBootTargetTemplate", [ support.dialogs.Dialog], {
        
        // templateString: [protected] String
         // This widget's HTML template, provided.
        templateString: template,
             
        // locResources: [protected] Object
        // This widget's National Language Source (NLS) object.
        locResources: mri, 
        
        store: "",
        templateIDNum: null,
        maxPercent: .40,
        btt1:null,
        btt2:null,

        // the name of the CSS stylesheet of this page
        spCssPathAndName: "support/dialogs/themes/FibreChannelBootTargetTemplate.css",

        // When this method is called, all variables inherited from superclasses are "mixed in".
        // Common operations for postMixInProperties
        // 1) Modify or assign values for widget property variables defined in the template HTML
        // file
        postMixInProperties: function() {
            this.inherited(arguments);
        },

        // postCreate() is called after buildRendering(). This is useful to override when
        // you need to access and/or manipulate DOM nodes included with your widget.
        // DOM nodes and widgets with the dojoAttachPoint attribute specified can now be directly
        // accessed as fields on "this".
        // Common operations for postCreate
        // 1) Access and manipulate DOM nodes created in buildRendering()
        // 2) Add new DOM nodes or widgets
        postCreate: function() {

            this.inherited(arguments);
            
            dojo.connect(this.dialogNode, "hide", this, function() {        
                this.destroy();
            });
            
            //Setup for template new, edit, or copy mode 
            this._setup();

            // Apply env specific tooltip for the page
            // NOTE: For dijit/Tooltip dijits, set the label, not innerHTML.
            this._sysTmplTooltip.label = "<div style=\"width: 30em;\">" + this.locResources.PAGETOOLTIP.replace("%1", this.PRODUCT_NAME_LONG) + "</div>";
                                                                                             
            //Resizes dialog
            this.layout(); 
            
        },
        _setupBootTable1: function() {

            if (this.btt1 == null) {

                var data1 = {
                        "items": [ {
                            "order": "0",
                            "wwpn": "",
                            "lun": "0",
                            "drag": false,
                            "add": true,
                            "remove": false
                        } ]
                    };

                    var fibre = this;            
                    this.btt1 = new support.panels.BootTargetsTable({       
                        id: "cp_fibrechannelboottargettemplate_btt1table",                        
                        lunDisabled: true,
                        jsonData: data1,
                        _bootLauncher: "dialog"
                    }).placeAt(this._boottable1);
                    
                    this.btt1.reposition = function(){
                        fibre.dialogNode._position();
                    };
                
                
            }else{
                this._boottable1.style.display = "inline-block";
            }

            this.allowMultipleLUN();

        },
        togglesecondbootDisplay: function() {
        	
            var checkvalue = this.secondbootcheck.get("value");

            if (checkvalue == "on") {
                if (this.btt2 == null) {

                    var data2 = {
                            "items": [ {
                                "order": "0",
                                "wwpn": "",
                                "lun": "0",
                                "drag": false,
                                "add": true,
                                "remove": false
                            } ]
                        };

                	var fibre = this;
                    
                	this.btt2 = new support.panels.BootTargetsTable({
                	    id: "cp_fibrechannelboottargettemplate_btt2table",
                        lunDisabled: true,
                        jsonData: data2,
                        _bootLauncher: "dialog"
                    }).placeAt(this._boottable2);

                    this.btt2.reposition = function(){
                    	fibre.dialogNode._position();
                    };

                    this._boottable2.style.display = "inline-block";
                    
                }else {
                    this._boottable2.style.display = "inline-block";
                }

                this.allowMultipleLUN();

            }else {
                this._boottable2.style.display = "none";
            }

            this.layout();
        },
        loadprevSettings: function() {
            var widget = this;
            var mode = this.templateMode;

            var inUse = false;

            var name = this.templateName;
            var description = this.description;
            var checkvalue = this.secondbootcheck; 
            var lunbuttonvalue = this.allowMultiLun;
            var checkValueCheck = null;

            var tableinfo1 =  {
                    "items": [ {
                        "order": "0",
                        "wwpn": "",
                        "lun": "0",
                        "drag": false,
                        "add": true,
                        "remove": false
                    } ]
                };
            
            var tableinfo2 = {
                    "items": [ {
                        "order": "0",
                        "wwpn": "",
                        "lun": "0",
                        "drag": false,
                        "add": true,
                        "remove": false
                    } ]
                };

            
            var dialogNode = this.dialogNode;

            var xhrGet = dojo.xhrGet({
                url: this.REST_PATH + "template/"+this.templateIDNum,
                handleAs: "json",
                sync: true,
                preventCache: true,
                load: dojo.hitch(this, function(response) {
                    this.store = response; 
                    //alert(this.store.items[0].IMM_GeneralSettings_power_off.IMM_GeneralSettings_power_off);
                }),                
                handle: dojo.hitch(this, function() {
                    
                    inUse = this.store.items[0].inUse;
                    
                    if(mode == "copy"){
                        dialogNode.set("title", this.locResources.FIBRE + " - " + this.store.items[0].name + " - " + this.resources.COPY);
                        name.set("value", this.store.items[0].name + " - " + this.resources.COPY);
                    }else{
                        dialogNode.set("title", this.locResources.EDIT + " - " + this.store.items[0].name);
                        name.set("value", this.store.items[0].name);
                    }
                   
                    var descriptionvalue = this.decodeSpecialCharacters(this.store.items[0].description);
                    description.set("value", descriptionvalue);
                    
                    tableinfo1 = this.store.items[0].primary;
                    
                    if(this.store.items[0].checkvalue == true){
                        checkValueCheck = "on";
                        tableinfo2 = this.store.items[0].secondary;                        
                        
                    }

                    lunbuttonvalue.setAttrChecked(this.store.items[0].lunbuttonvalue);
                })
                
            });
            
            this._setupBootTable1();

            if(this.btt1 != null){
                this.btt1.resetTable(dojo.fromJson(tableinfo1));
            }
            
            if(checkValueCheck == "on"){
                checkvalue.set("value","on");
            }
            
            this.togglesecondbootDisplay();
            
            if(this.btt2 != null){
                this.btt2.resetTable(dojo.fromJson(tableinfo2));    
            }
            
            this.templateInUse = inUse;


        },
        exitParent: function() {

            var data ="fibre";
            
            dojo.publish("FibreBootTemplateComplete", data);

            if(dijit.byId(this.get("id") +"rdstDialog" ,this) != null){
                var deployClicked = dijit.byId(this.get("id") +"rdstDialog",this).get("closeParent");
                if(deployClicked) {
                    this.hide();
                }
            }
        },
        cancelClicked: function() {
            this.hide();
        },
        createClicked: function() {

            if(this.btt1.isValid() == false){
              // alert(this.locResources.VALID);
               
               var validationpopup = new support.temp.ModalDialog({
                   type: "Error",
                   text: this.locResources.VALID
               });
               validationpopup.show();

                return;
            }

            if(this.btt2){
                if(this.btt2.isValid() == false && this.secondbootcheck.get("value") == "on"){
                    //alert(this.locResources.VALID2);
                    
                    var validationpopup = new support.temp.ModalDialog({
                        type: "Error",
                        text: this.locResources.VALID2
                    });
                    validationpopup.show();
                    
                    return;
                }
            }
            
            var templateObject = new Object();

            var templatename = this.templateName;
            var namevalue = templatename.get("value").trim();
            templateObject.name = namevalue;                     
            
            templateObject.type = "FibreChannel";
            
            var templatedescription = this.description;
            var descriptionvalue = templatedescription.get("value").trim();
            templateObject.description = this.encodeSpecialCharacters(descriptionvalue);


            // Table 1 - Primary Boot Targets
            templateObject.primary = this.btt1.getStoreAsJson();

            // Table 2 - Secondary Boot Targets
            var checkvalue = this.secondbootcheck.get("value");

            if(checkvalue == "on"){
                templateObject.checkvalue = true;
                templateObject.secondary = this.btt2.getStoreAsJson();
            }else{
                templateObject.checkvalue = checkvalue;
            }

         // Allow Multiple LUN Button
            var multLUNbuttonObject = new Object();
             
            var lunbuttonvalue = this.allowMultiLun.get("checked");
            templateObject.lunbuttonvalue = lunbuttonvalue;


            var argJSONString = dojo.toJson({ 
                "identifier":"id",
                  "label":"name",
                  "items":[ templateObject ]
            }, true);

            //alert(argJSONString);
            this.getProgressDialog("save").show(); // Show progress dialog for save request.
            var xhrPost = dojo.xhrPost({
                        url: this.REST_PATH + "template/create",
                        handleAs: "json", // <<<< Required
                        headers: {
                            "Content-Type": "application/json; charset=utf-8" // <<<< Required
                        },
                        postData: argJSONString,     //Template Data to Post
                        load: dojo.hitch(this, function(response, ioArgs) {
                            // Happy path! We received a 2xx status code from the API.
                                                    
                            dojo.publish("ProgressComplete", response.id);
                            dojo.publish("FibreBootTemplateComplete", response.id);
                            this.hide();
                        }),
                        error: dojo.hitch(this, function(error, ioArgs) {
                            // Failure path! We received a non-2xx status code (ie: 3xx/4xx/5xx status code) from the API.

                            dojo.publish("ProgressFailed", error);
                            console.log(this.declaredClass + ": ", error, ioArgs);
                            
                            var response = dojo.fromJson(ioArgs.xhr.responseText);
                            if ((ioArgs.xhr.status >= 400) && (response.message == "service_error_name_in_use")) {
                                // Error Template name in use
                                this.getModalDialog("Error", this.resources.ERROR_400_NAME).show();
                            }
                            else if(ioArgs.xhr.status == 404) {
                                // Edit Template ID doesn't exist
                                this.getModalDialog("Error", this.resources.ERROR_404_ID).show();
                                this.hide();
                            }
                            else if(ioArgs.xhr.status >= 500) {
                                // Internal Programming Error
                                this.getModalDialog("Error", this.resources.ERROR_500_INTERNAL).show();
                                this.hide();
                            }
                            else {
                                this.getModalDialog("Error", this.resources.ERROR_TEMPLATE_CREATE).show();
                                this.hide();
                            }
                            
                        }),
                        handle: dojo.hitch(this, function(data, ioArgs) {
                            // - The 1st param ("data") is either the response data (on success) or Error object (on failure).
                            // - The 2nd param ("ioArgs") contains detail about the xhr request, including a reference to the
                            // native xhr object. Check ioArgs.xhr.status to determine success or failure, and handle "data"
                            // accordingly.
                        })
                    });


        },        
        saveClicked: function() {      

            if(this.btt1.isValid() == false){
                //alert(this.locResources.VALID);
                
                var validationpopup = new support.temp.ModalDialog({
                    type: "Error",
                    text: this.locResources.VALID
                });
                validationpopup.show();
                
                 return;
             }

            if(this.btt2){
                if(this.btt2.isValid() == false && this.secondbootcheck.get("value") == "on"){
                    //alert(this.locResources.VALID2);
                  
                    var validationpopup = new support.temp.ModalDialog({
                        type: "Error",
                        text: this.locResources.VALID2
                    });
                    validationpopup.show();
                    
                    return;
                }
            }
            
             var templateObject = new Object();

             var templatename = this.templateName;
             var namevalue = templatename.get("value").trim();
             templateObject.name = namevalue;

             templateObject.id = this.templateIDNum;
             
             templateObject.type = "FibreChannel";
             
             var templatedescription = this.description;
             var descriptionvalue = templatedescription.get("value").trim();
             templateObject.description = this.encodeSpecialCharacters(descriptionvalue);

             // Table 1 - Primary Boot Targets
             templateObject.primary = this.btt1.getStoreAsJson();

             // Table 2 - Secondary Boot Targets
             var checkvalue = this.secondbootcheck.get("value");

             if(checkvalue == "on"){
                 templateObject.checkvalue = true;
                 templateObject.secondary = this.btt2.getStoreAsJson();
             }else{
                 templateObject.checkvalue = checkvalue;
             }

             
          // Allow Multiple LUN Button
             var multLUNbuttonObject = new Object();
              
             var lunbuttonvalue = this.allowMultiLun.get("checked");
             templateObject.lunbuttonvalue = lunbuttonvalue;


             var argJSONString = dojo.toJson({ 
                 "identifier":"id",
                   "label":"name",
                   "items":[ templateObject ]
             }, true);

            // alert(argJSONString);
             
             if(this.templateInUse.toString() == "true"){
                 
                 dijit.byId(this.get("id") +"rdstDialog",this).set("templateID",this.templateIDNum);
                 dijit.byId(this.get("id") +"rdstDialog",this).set("templateType","Category");
                 dijit.byId(this.get("id") +"rdstDialog",this).set("templateData",argJSONString);

                 dijit.byId(this.get("id") +"rdstDialog",this).show();
                 
                 
             }else{
                 this.getProgressDialog("save").show(); // Show progress dialog for save request.
                     var xhrPost = dojo.xhrPost({
                         url: this.REST_PATH + "template/create",
                         handleAs: "json", // <<<< Required
                         headers: {
                             "Content-Type": "application/json; charset=utf-8" // <<<< Required
                         },
                         postData: argJSONString,     //Template Data to Post
                         load: dojo.hitch(this, function(response, ioArgs) {
                             // Happy path! We received a 2xx status code from the API.
                                                     
                             dojo.publish("ProgressComplete", response.id);
                             dojo.publish("FibreBootTemplateComplete", response.id);
                             this.hide();
                         }),
                         error: dojo.hitch(this, function(error, ioArgs) {
                             // Failure path! We received a non-2xx status code (ie: 3xx/4xx/5xx status code) from the API.

                             dojo.publish("ProgressFailed", error);
                             console.log(this.declaredClass + ": ", error, ioArgs);
                             
                             var response = dojo.fromJson(ioArgs.xhr.responseText);
                             if ((ioArgs.xhr.status >= 400) && (response.message == "service_error_name_in_use")) {
                                 // Error Template name in use
                                 this.getModalDialog("Error", this.resources.ERROR_400_NAME).show();
                             }
                             else if(ioArgs.xhr.status == 404) {
                                 // Edit Template ID doesn't exist
                                 this.getModalDialog("Error", this.resources.ERROR_404_ID).show();
                                 this.hide();
                             }
                             else if(ioArgs.xhr.status >= 500) {
                                 // Internal Programming Error
                                 this.getModalDialog("Error", this.resources.ERROR_500_INTERNAL).show();
                                 this.hide();
                             }
                             else {
                                 this.getModalDialog("Error", this.resources.ERROR_TEMPLATE_CREATE).show();
                                 this.hide();
                             }
                             
                         }),
                         handle: dojo.hitch(this, function(data, ioArgs) {
                             // - The 1st param ("data") is either the response data (on success) or Error object (on failure).
                             // - The 2nd param ("ioArgs") contains detail about the xhr request, including a reference to the
                             // native xhr object. Check ioArgs.xhr.status to determine success or failure, and handle "data"
                             // accordingly.
                         })
                     });

             }

             
        },       
        saveasClicked: function() {      

            if(this.btt1.isValid() == false){
                //alert(this.locResources.VALID);
                
                var validationpopup = new support.temp.ModalDialog({
                    type: "Error",
                    text: this.locResources.VALID
                });
                validationpopup.show();
                
                 return;
             }

            if(this.btt2){
                if(this.btt2.isValid() == false && this.secondbootcheck.get("value") == "on"){
                    //alert(this.locResources.VALID2);
                    
                    var validationpopup = new support.temp.ModalDialog({
                        type: "Error",
                        text: this.locResources.VALID2
                    });
                    validationpopup.show();
                    
                    return;
                }
            }
            
             var templateObject = new Object();

             var templatename = this.templateName;
             var namevalue = templatename.get("value").trim();
             templateObject.name = namevalue;
             
             templateObject.type = "FibreChannel";
             
             var templatedescription = this.description;
             var descriptionvalue = templatedescription.get("value").trim();
             templateObject.description = this.encodeSpecialCharacters(descriptionvalue);

             // Table 1 - Primary Boot Targets
             templateObject.primary = this.btt1.getStoreAsJson();

             // Table 2 - Secondary Boot Targets
             var checkvalue = this.secondbootcheck.get("value");

             if(checkvalue == "on"){
                 templateObject.checkvalue = true;
                 templateObject.secondary = this.btt2.getStoreAsJson();
             }else{
                 templateObject.checkvalue = checkvalue;
             }

             
          // Allow Multiple LUN Button
             var multLUNbuttonObject = new Object();
              
             var lunbuttonvalue = this.allowMultiLun.get("checked");
             templateObject.lunbuttonvalue = lunbuttonvalue;

             this.saveasDialog.set("templateObject",templateObject);
             this.saveasDialog.show();

        },
        allowMultipleLUN : function(){
        	
            var checkvalue = this.allowMultiLun.get("checked");
            var checkvalue2 = this.secondbootcheck.get("value");

            if(checkvalue == true){
                this.btt1.set("lunDisabled", false);

                if (checkvalue2 == "on") {
                    this.btt2.set("lunDisabled", false);
                }   
            }else{
                this.btt1.set("lunDisabled", true);

                if (checkvalue2 == "on") {
                    this.btt2.set("lunDisabled", true);
                }   
            }


        },        
        _nameChanged: function() {                        

            if (this.templateName.get("value").trim() != "") {
                this.okBtn.set("disabled", false);
            }
            else {
                this.okBtn.set("disabled", true);
            }
           
        },
        _setup: function(){

            //Set Template Field to catch intermediate changes
            this.templateName.intermediateChanges = true;

            // Set Description Label
            this._descLimit.innerHTML = this.resources.LIMIT.replace("%500","500");

            //Set Information Messages and Load Previous Settings                      
            if(this.templateIDNum != null && this.templateMode == "edit"){     //if dialog in edit mode    
                
                this.loadprevSettings();
                
                if(this.templateInUse.toString() == "true"){
                
                    if(this.templateLaunchPoint == "table"){
                        
                        this.warningMessage.style.display = "block";
                        this.warningMessageText.innerHTML = this.resources.INUSE;
                        this.saveBtnContainer.style.display = "inline";
                        this.saveasBtnContainer.style.display = "inline";
                        
                    }else if(this.templateLaunchPoint == "wizard"){
                        
                        this.informationMessage.style.display = "block";
                        this.informationMessageText.innerHTML = this.resources.INUSEWIZARD;
                        this.saveasBtnContainer.style.display = "inline";
                        
                    }else{
                        this.informationMessage.style.display = "block";
                        this.informationMessageText.innerHTML = this.resources.INUSEWIZARD;
                        this.saveasBtnContainer.style.display = "inline";
                    }
                    
                }else{
                    
                    this.saveBtnContainer.style.display = "inline";
                    this.saveasBtnContainer.style.display = "inline";
                                        
                }    

                this.templateName.set("disabled",true);
                

             }else if(this.templateIDNum != null && this.templateMode == "copy"){    //if dialog in copy mode     
                 
                 this.loadprevSettings();
                 this.templateIDNum = null;  //set template ID to null in order to create new template
                 this.okBtnContainer.style.display = "inline";

             }else{     //if dialog in create new mode
                 
                 this.okBtnContainer.style.display = "inline";

                 this._setupBootTable1();

             } 

        }
   

    });
});