define([
        "dojo",
        "dijit",
        "support/dialogs/Dialog",
        "dojo/i18n!./nls/Import",
        "dojo/text!./templates/Import.html",
        "dijit/form/ValidationTextBox",
        "dojox/form/Uploader",
        "dojox/form/uploader/FileList",
        "support/panels/ImportConfirmation"
        ], function(dojo, dijit, dialog, mri, template) {
    
    return dojo.declare("support.dialogs.Import", [ support.dialogs.Dialog ], {
        
        // templateString: [protected] String
        // This widget's HTML template, provided.
        templateString: template,
            
        // locResources: [protected] Object
        // This widget's National Language Source (NLS) object.
        locResources: mri,
        
        // baseClass: [protected] String
        // The root CSS className to be placed on this widget's domNode.
        baseClass: "Import",
        
        // the name of the CSS stylesheet of this page
        spCssPathAndName: "support/dialogs/themes/Import.css",

        // When this method is called, all variables inherited from superclasses
        // are "mixed in".
        // Common operations for postMixInProperties
        // 1) Modify or assign values for widget property variables defined in
        // the template HTML file
        postMixInProperties: function() {
            this.inherited(arguments);
        },
        
        // postCreate() is called after buildRendering(). This is useful to
        // override when
        // you need to access and/or manipulate DOM nodes included with your
        // widget.
        // DOM nodes and widgets with the dojoAttachPoint attribute specified
        // can now be
        // directly
        // accessed as fields on "this".
        // Common operations for postCreate
        // 1) Access and manipulate DOM nodes created in buildRendering()
        // 2) Add new DOM nodes or widgets
        postCreate: function() {
            this.inherited(arguments);
        },
        
        _nameChanged: function() {
            var name = this.fileName.get("value");
            if(name != undefined && name != null && name != "") {
                this.importButton.set("disabled", false);
            } else {
                this.importButton.set("disabled", true);
            }
            
        },
        
        _fileSelected: function() {
            console.log(this.browser.getFileList()[0]);
            this.fileName.set("value", this.browser.getFileList()[0].name);
        },
        
        _importFile: function() {            
            
            var importResults = new support.panels.ImportConfirmation();
                                  
            if(this.CP_RUN_ENVIRONMENT == "fsm"){

                require([ "support/temp/ConfirmationDialog" ], dojo.hitch(this, function() {

                    var confirmDialog = new support.temp.ConfirmationDialog({
                        buttonLabel: this.resources.CLOSE,
                        type: "Warning",
                        style: "width: 800px !important; height:600px; overflow-y:auto",
                        text: this.locResources.IMPORT_CONFIRM,
                        info: this.resources.INFO                    
                    });

                    confirmDialog.set("content", importResults);
                    confirmDialog.startup();
                    confirmDialog.confirm(this._cancelImport());
                
                }));
 
                
            }else if(this.CP_RUN_ENVIRONMENT == "augusta"){

                require([ "idx/widget/ConfirmationDialog" ], dojo.hitch(this, function() {

                    var confirmDialog = new idx.widget.ConfirmationDialog({
                        buttonLabel: this.resources.CLOSE,
                        type: "Warning",
                        style: "width: 800px !important; height:600px; overflow-y:auto",
                        text: this.locResources.IMPORT_CONFIRM,
                        info: this.resources.INFO                    
                    });

                    confirmDialog.set("content", importResults);
                    confirmDialog.startup();
                    confirmDialog.confirm(this._cancelImport());
                
                }));
                
            }

            
        },
        
        _cancelImport: function() {
            this.hide();
            this.dialogNode.destroyRecursive();
        }
        
    });
});