define([
        "dojo",
        "dijit",
        "support/dialogs/Dialog",
        "dojo/i18n!./nls/ManagementInterfaceTemplate",
        "dojo/text!./templates/ManagementInterfaceTemplate.html",
        "dijit/Tooltip",
        "dijit/layout/BorderContainer",
        "dijit/layout/ContentPane",
        "dijit/form/Button",
        "dijit/form/CheckBox",
        "dijit/form/Form",
        "dijit/form/NumberTextBox",
        "dijit/form/RadioButton",
        "support/widgets/Select",
        "dijit/form/SimpleTextarea",
        "dojo/data/ItemFileReadStore",
        "support/panels/CheckLabelButton",
        "support/widgets/ButtonBar",
        "support/panels/SimpleTable",
        "support/panels/CheckButton",
        "support/widgets/OutlinePane",
        "support/dialogs/NewIPPool",
        "support/dialogs/ReDeployServerTemplate",
        "support/temp/ModalDialog",
        "support/panels/CustomNamingTable",
        "support/dialogs/SaveAs",
        "support/dialogs/ProgressDialog"
      ], function(dojo, dijit, dialog, mri, template) {

    return dojo.declare("support.dialogs.ManagementInterfaceTemplate", [ support.dialogs.Dialog], {

        // templateString: [protected] String
        // This widget's HTML template, provided.
        templateString: template,
            
        // locResources: [protected] Object
        // This widget's National Language Source (NLS) object.
        locResources: mri, 
        
        widgetsInTemplate: true,

        // baseClass: [protected] String
        // The root CSS className to be placed on this widget's domNode.
        baseClass: "ManagementInterfaceTemplate",

        templateIDNum: null,
        
        _ipv4selectbox: null,
        _ipv6selectbox: null,
        _ipv4rangeselectbox: null,
        _ipv6rangeselectbox: null,
        _ipv4store: null,
        _ipv6store: null,
        _ipv4rangestore: null,
        _ipv6rangestore: null,
        maxPercent: .35,
        _ipv4rangedefault: "any",
        _ipv6rangedefault: "any",
        _mtutooltip_2: null,
        _hostnametooltip: null,
        _customnametable: null,
        _isCustomNamePatternValid: true,
        _ippoolListData: null,
        _portRange: null,
        autogenchecklabelbutton: null,
        ipv4checklabelbutton: null,
        ipv6checklabelbutton: null,
        ifspeedchecklabelbutton: null,
        dataRateButtonBar: null,
        duplexButtonBar: null,
        mtuchecklabelbutton: null,
        httpchecklabelbutton: null,
        httpschecklabelbutton: null,
        telnetclichecklabelbutton: null,
        sshclichecklabelbutton: null,
        snmpagentchecklabelbutton: null,
        snmptrapschecklabelbutton: null,
        remotecontrolchecklabelbutton: null,
        cimhttpchecklabelbutton: null,
        cimhttpschecklabelbutton: null,
        initialData: null,
        
        
        // the name of the CSS stylesheet of this page
        spCssPathAndName: "support/dialogs/themes/ManagementInterfaceTemplate.css",

        // When this method is called, all variables inherited from superclasses
		// are "mixed in".
        // Common operations for postMixInProperties
        // 1) Modify or assign values for widget property variables defined in
        // the template HTML file
        postMixInProperties: function() {

            this.inherited(arguments);
            
            this._mtutooltip_2 = this.locResources.MTUTOOLTIP_2.replace("%1", 1280).replace("%2", 1500);
            this._hostnametooltip = this.locResources.HOSTNAMETOOLTIP_2.replace("%1", 63).replace("%2", this.locResources.IMM).replace("%3", 63);
            this._portRange = this.locResources.INVALID_NUMBER_BETWEEN.replace("%1", "1").replace("%2", "65535");

        },

        // postCreate() is called after buildRendering(). This is useful to
		// override when
        // you need to access and/or manipulate DOM nodes included with your
		// widget.
        // DOM nodes and widgets with the dojoAttachPoint attribute specified
		// can now be
        // directly
        // accessed as fields on "this".
        // Common operations for postCreate
        // 1) Access and manipulate DOM nodes created in buildRendering()
        // 2) Add new DOM nodes or widgets
        postCreate: function() {

            this.inherited(arguments);
            
            this._createCheckLabelButtons();
            
            this.subscribe("customNamePattern", function(data) {                
                if (data == "none") {
                    this._isCustomNamePatternValid = false;                        
                    this._enableOk();              
                } else {
                    this._isCustomNamePatternValid = true;
                    this._enableOk();
                }
             }); 
                        
         //   var availHeight = window.screen.availHeight;
           // var maxHeight = availHeight * this.maxPercent;
            //this.ethSettingsPane.setAttribute("style", "max-height:" + maxHeight + "px");
         
           // this.dialogNode.resize();            
            
            this._connectCheckLabelButtonFunctions();
    		this._getIPPooldata();
    		this._createSelectBoxes();
    		this._setDefaults();
    		
    		if (this.templateIDNum != null) {
            	this._readSettingsFromService();
            	
                //Setup for template new, edit, or copy mode 
                this._setup();
                

            } else {
                
                //Setup for template new, edit, or copy mode 
                this._setup();

                this._selectall();
            }
    		
            dojo.connect(this.dialogNode, "hide", this, function() {
                this.destroy();
            });
                		
            this.subscribe("ippoolComplete", function(data) {
        	    if (isNaN(data) == true) {
        	        data = this._ipv4selectbox.get("value");
        	    }
        	    
        	    var ipv6SelectedPool = this._ipv6selectbox.get("value");
        	    
        		this._getIPPooldata();
        		
        		var responsedata = null;
                var xhrGet = dojo.xhrGet({
                    url: this.REST_PATH + "ippool/" + data,
                    handleAs: "json",
                    preventCache: true,
                    sync: true,
                    load: function(response) {
                        //alert(dojo.toJson(response));
                        responsedata = response;
                    },
                    error: function(error) {
                        alert(this.locResources.ERRORSERVICE);
                        // Probably need to mock up some dummy data here
                    }
                    
                });
                
                // Clear pool selection
                this._ipv6selectbox.set("value", "noselected");
        		
        		if (responsedata && responsedata.protocol == "IPv4") {
        			this._ipv4selectbox.setStore(this._ipv4store);
                    this._ipv4selectbox.addOption({
                        value: "noselected",
                        label: "&mdash; " + this.locResources.NOPOOLSELECTED + " &mdash;",
                        selected: true
                    });
        			this._ipv4selectbox.set("value", data);
        			this._ipv4selectbox.set("disabled", false);     
        			this._ipv4rangeselectbox.set("disabled", false);
        		} else {
        			this._ipv6selectbox.setStore(this._ipv6store);
                    this._ipv6selectbox.addOption({
                        value: "noselected",
                        label: "&mdash; " + this.locResources.NOPOOLSELECTED + " &mdash;",
                        selected: true
                    });
        			this._ipv6selectbox.set("value", data);
        			this._ipv6selectbox.set("disabled", false);
        			this._ipv6rangeselectbox.set("disabled", false);
        		}
        		        		
        		if (this._ipv6selectbox.get("value") == "noselected") {
        		    // Select previously selected pool
        		    this._ipv6selectbox.set("value", ipv6SelectedPool);
        		}
        	});	
        	
        },

        _createCheckLabelButtons: function() {
            var buttonProperties = {};
            
            buttonProperties["values"] = this.resources.CUSTOM + "|" + this.resources.DISABLE;            
            
            this.autogenchecklabelbutton = new support.panels.CheckLabelButton({
                labelValue: this.locResources.AUTOGEN,
                buttonType: "support.widgets.ButtonBar",
                buttonProps: buttonProperties,
                toolTip: this.locResources.HOSTNAMETOOLTIP_1 + "<br /><br />" + this._hostnametooltip,
                onClick: dojo.hitch(this, this._hostnameButtonBarClicked)
            }).placeAt(this.autogenchecklabelbuttondiv);
            
            var buttonProperties2 = {};
            buttonProperties2["values"] = this.resources.ENABLE + "|" + this.resources.DISABLE + "|" + this.resources.NO_CHANGE;
            buttonProperties2["titles"] = "||" + this.resources.NOCHANGE_TOOLTIP;
            
            this.ipv4checklabelbutton = new support.panels.CheckLabelButton({
                labelValue: this.resources.IPV4,
                buttonType: "support.widgets.ButtonBar",
                buttonProps: buttonProperties2
            }).placeAt(this.ipv4checklabelbuttondiv);
            
            var buttonProperties3 = {};
            buttonProperties3["values"] = this.resources.ENABLE + "|" + this.resources.NO_CHANGE;
            buttonProperties3["titles"] = "|" + this.resources.NOCHANGE_TOOLTIP;
            
            this.ipv6checklabelbutton = new support.panels.CheckLabelButton({
                labelValue: this.resources.IPV6,
                buttonType: "support.widgets.ButtonBar",
                buttonProps: buttonProperties3
            }).placeAt(this.ipv6checklabelbuttondiv);

            var buttonProperties4 = {};
            buttonProperties4["values"] = this.locResources.AUTO + "|" + this.locResources.MANUAL;
            
            this.ifspeedchecklabelbutton = new support.panels.CheckLabelButton({
                labelValue: this.locResources.INTERFACESPEEDLOWER,
                buttonType: "support.widgets.ButtonBar",
                buttonProps: buttonProperties4
            }).placeAt(this.ifspeedchecklabelbuttondiv);
            
            var buttonProperties5 = {};
            buttonProperties5["values"] = this.locResources.TENMB + "|" + this.locResources.HUNDREDMB;
            
            this.dataRateButtonBar = new support.panels.CheckLabelButton({                
                buttonType: "support.widgets.ButtonBar",
                buttonProps: buttonProperties5,
                selected: this.locResources.HUNDREDMB
            }).placeAt(this.dataRateButtonBardiv);
            
            var buttonProperties6 = {};
            buttonProperties6["values"] = this.locResources.HALF + "|" + this.locResources.FULL;
            
            this.duplexButtonBar = new support.panels.CheckLabelButton({
                buttonType: "support.widgets.ButtonBar",
                buttonProps: buttonProperties6,
                selected: this.locResources.FULL
            }).placeAt(this.duplexButtonBardiv);
            
            var buttonProperties7 = {};           
            buttonProperties7["value"] = 1500;
            buttonProperties7["intermediateChanges"] = true;
            buttonProperties7["placeHolder"] = "1500";           
            buttonProperties7["constraints"] = {min:1280,max:1500,places:0};
            buttonProperties7["promptMessage"] = this.locResources.MTUTOOLTIP_1 + "<br />" + this._mtutooltip_2;
            buttonProperties7["rangeMessage"] = this.locResources.MTUTOOLTIP_1 + "<br />" + this._mtutooltip_2; 
            buttonProperties7["style"] = "width:125px;";  
            
            this.mtuchecklabelbutton = new support.panels.CheckLabelButton({
                labelValue: this.locResources.MTU,
                buttonType: "dijit.form.NumberTextBox",
                buttonProps: buttonProperties7,
                onChange: dojo.hitch(this, this._enableOk)
            }).placeAt(this.mtuchecklabelbuttondiv);
            
            var buttonProperties8 = {};
            buttonProperties8["id"] = "cp_managementinterfacetemplate_httptr";
            buttonProperties8["value"] = 80;
            buttonProperties8["intermediateChanges"] = true;
            buttonProperties8["placeHolder"] = "80";           
            buttonProperties8["constraints"] = {min:1,max:65535,places:0};
            buttonProperties8["required"] = true;
            buttonProperties8["rangeMessage"] = this._portRange;
            buttonProperties8["style"] = "width:125px;";  
            
            this.httpchecklabelbutton = new support.panels.CheckLabelButton({
                labelValue: this.locResources.HTTP,
                labelColumnWidth: "200px",
                buttonType: "dijit.form.NumberTextBox",
                buttonProps: buttonProperties8,
                onChange: dojo.hitch(this, this._enableOk)
            }).placeAt(this.httpchecklabelbuttondiv);

            var buttonProperties9 = {};
            buttonProperties9["value"] = 443;
            buttonProperties9["intermediateChanges"] = true;
            buttonProperties9["placeHolder"] = "443";           
            buttonProperties9["constraints"] = {min:1,max:65535,places:0};
            buttonProperties9["required"] = true;
            buttonProperties9["rangeMessage"] = this._portRange;
            buttonProperties9["style"] = "width:125px;";  
            
            this.httpschecklabelbutton = new support.panels.CheckLabelButton({
                labelValue: this.locResources.HTTPS,
                labelColumnWidth: "200px",
                buttonType: "dijit.form.NumberTextBox",
                buttonProps: buttonProperties9,
                onChange: dojo.hitch(this, this._enableOk)
            }).placeAt(this.httpschecklabelbuttondiv);
            
            var buttonProperties10 = {};
            buttonProperties10["value"] = 23;
            buttonProperties10["intermediateChanges"] = true;
            buttonProperties10["placeHolder"] = "23";           
            buttonProperties10["constraints"] = {min:1,max:65535,places:0};
            buttonProperties10["required"] = true;
            buttonProperties10["rangeMessage"] = this._portRange;
            buttonProperties10["style"] = "width:125px;";  
            
            this.telnetclichecklabelbutton = new support.panels.CheckLabelButton({
                labelValue: this.locResources.TELNETCLI,
                labelColumnWidth: "200px",
                buttonType: "dijit.form.NumberTextBox",
                buttonProps: buttonProperties10,
                onChange: dojo.hitch(this, this._enableOk)
            }).placeAt(this.telnetclichecklabelbuttondiv);
        
            var buttonProperties11 = {};
            buttonProperties11["value"] = 22;
            buttonProperties11["intermediateChanges"] = true;
            buttonProperties11["placeHolder"] = "22";           
            buttonProperties11["constraints"] = {min:1,max:65535,places:0};
            buttonProperties11["required"] = true;
            buttonProperties11["rangeMessage"] = this._portRange;
            buttonProperties11["style"] = "width:125px;";  
            
            this.sshclichecklabelbutton = new support.panels.CheckLabelButton({
                labelValue: this.locResources.SSHCLI,
                labelColumnWidth: "200px",
                buttonType: "dijit.form.NumberTextBox",
                buttonProps: buttonProperties11,
                onChange: dojo.hitch(this, this._enableOk)
            }).placeAt(this.sshclichecklabelbuttondiv);
            
            var buttonProperties12 = {};
            buttonProperties12["value"] = 161;
            buttonProperties12["intermediateChanges"] = true;
            buttonProperties12["placeHolder"] = "161";           
            buttonProperties12["constraints"] = {min:1,max:65535,places:0};
            buttonProperties12["required"] = true;
            buttonProperties12["rangeMessage"] = this._portRange;
            buttonProperties12["style"] = "width:125px;";  
            
            this.snmpagentchecklabelbutton = new support.panels.CheckLabelButton({
                labelValue: this.locResources.SNMPAGENT,
                labelColumnWidth: "200px",
                buttonType: "dijit.form.NumberTextBox",
                buttonProps: buttonProperties12,
                onChange: dojo.hitch(this, this._enableOk)
            }).placeAt(this.snmpagentchecklabelbuttondiv);
            
            var buttonProperties13 = {};
            buttonProperties13["value"] = 162;
            buttonProperties13["intermediateChanges"] = true;
            buttonProperties13["placeHolder"] = "162";           
            buttonProperties13["constraints"] = {min:1,max:65535,places:0};
            buttonProperties13["required"] = true;
            buttonProperties13["rangeMessage"] = this._portRange;
            buttonProperties13["style"] = "width:125px;";  
            
            this.snmptrapschecklabelbutton = new support.panels.CheckLabelButton({
                labelValue: this.locResources.SNMPTRAPS,
                labelColumnWidth: "200px",
                buttonType: "dijit.form.NumberTextBox",
                buttonProps: buttonProperties13,
                onChange: dojo.hitch(this, this._enableOk)
            }).placeAt(this.snmptrapschecklabelbuttondiv);
            
            var buttonProperties14 = {};
            buttonProperties14["value"] = 3900;
            buttonProperties14["intermediateChanges"] = true;
            buttonProperties14["placeHolder"] = "3900";           
            buttonProperties14["constraints"] = {min:1,max:65535,places:0};
            buttonProperties14["required"] = true;
            buttonProperties14["rangeMessage"] = this._portRange;
            buttonProperties14["style"] = "width:125px;";  
            
            this.remotecontrolchecklabelbutton = new support.panels.CheckLabelButton({
                labelValue: this.locResources.REMOTECONTROL,
                labelColumnWidth: "200px",
                buttonType: "dijit.form.NumberTextBox",
                buttonProps: buttonProperties14,
                onChange: dojo.hitch(this, this._enableOk)
            }).placeAt(this.remotecontrolchecklabelbuttondiv);
            
            var buttonProperties15 = {};
            buttonProperties15["value"] = 5988;
            buttonProperties15["intermediateChanges"] = true;
            buttonProperties15["placeHolder"] = "5988";           
            buttonProperties15["constraints"] = {min:1,max:65535,places:0};
            buttonProperties15["required"] = true;
            buttonProperties15["rangeMessage"] = this._portRange;
            buttonProperties15["style"] = "width:125px;";  
            
            this.cimhttpchecklabelbutton = new support.panels.CheckLabelButton({
                labelValue: this.locResources.CIMHTTP,
                labelColumnWidth: "200px",
                buttonType: "dijit.form.NumberTextBox",
                buttonProps: buttonProperties15,
                onChange: dojo.hitch(this, this._enableOk)
            }).placeAt(this.cimhttpchecklabelbuttondiv);
            
            var buttonProperties16 = {};
            buttonProperties16["value"] = 5989;
            buttonProperties16["intermediateChanges"] = true;
            buttonProperties16["placeHolder"] = "5989";           
            buttonProperties16["constraints"] = {min:1,max:65535,places:0};
            buttonProperties16["required"] = true;
            buttonProperties16["rangeMessage"] = this._portRange;
            buttonProperties16["style"] = "width:125px;";  
            
            this.cimhttpschecklabelbutton = new support.panels.CheckLabelButton({
                labelValue: this.locResources.CIMHTTPS,
                labelColumnWidth: "200px",
                buttonType: "dijit.form.NumberTextBox",
                buttonProps: buttonProperties16,
                onChange: dojo.hitch(this, this._enableOk)
            }).placeAt(this.cimhttpschecklabelbuttondiv);            
        },
        
        _connectCheckLabelButtonFunctions: function() {
    		dojo.connect(this.autogenchecklabelbutton, "onClick", this, 
    				function(evt) {
    					this._toggleAutoGenHostname();
    					this.layout();
    				});
    		dojo.connect(this.ipv4checklabelbutton, "onClick", this, 
    				function(evt) {
    					this._toggleMgmtIPAddrSettings();
    					this.layout();
    				});
    		dojo.connect(this.ipv4checklabelbutton, "onButtonClick", this, 
    				function(evt) {
    					this._toggleMgmtIPAddrSettings();
    				});
    		dojo.connect(this.ipv6checklabelbutton, "onClick", this, 
    				function(evt) {
	    				this._toggleMgmtIPAddrSettings();
	    				this.layout();
    			});
    		dojo.connect(this.ipv6checklabelbutton, "onButtonClick", this, 
    				function(evt) {
    					this._toggleMgmtIPAddrSettings();
    			});
    		dojo.connect(this.ddnschecklabelbutton, "onClick", this,
    				function(evt) {
    					this._toggleDNSSettings();
    					this.layout();
    				});
    		dojo.connect(this.ddnschecklabelbutton, "onButtonClick", this,
    				function(evt) {
    					this._toggleDNSSettings();
    				});
    		dojo.connect(this.ifspeedchecklabelbutton, "onClick", this,
    				function(evt) {
    					this._toggleInterfaceSpeedSettings();
    					this.layout();
    				});
    		dojo.connect(this.ifspeedchecklabelbutton, "onButtonClick", this,
    				function(evt) {
    					this._toggleInterfaceSpeedSettings();
    				});
    		dojo.connect(this.mtuchecklabelbutton, "onClick", this,
    				function(evt) {
    					this._toggleInterfaceSpeedSettings();
    					this.layout();
    				});
            dojo.connect(this.mtuchecklabelbutton, "onChange", this,
                    function(evt) {                        
                        this._enableOk();
                        this.layout();
                    });
        },
        
        _createSelectBoxes: function() {
    		this._ipv4selectbox = new support.widgets.Select({
    			name : this.get("id") + "_ipv4Select",
    			store : this._ipv4store,
    			maxHeight : -1,
    			emptyLabel : "&mdash; " + this.locResources.NOPOOLDEFINED + " &mdash;",
    			disabled : true
    		}, this.get("id") + "_ipv4Select");
    		this._ipv4selectbox.startup();
    		
    		if (this._ipv4selectbox.get("value") != "") {
    			this._ipv4selectbox.addOption({
    				value: "noselected",
    				label: "&mdash; " + this.locResources.NOPOOLSELECTED + " &mdash;",
    				selected: true
    			});
    		}
	    	this._ipv4selectbox.set("value", "noselected");
	    	    		
    		dojo.connect(this._ipv4selectbox, "onChange", this, function() {
    			this. _setIPRangeSelect("IPv4", this._ipv4rangedefault);
    			if (this._ipv4selectbox.get("value") == "noselected") {
    			    this._ipv4rangeselectbox.set("disabled", true);
    				dojo.replaceClass(this.ipv4editicon, "spEditInactiveIcon_v2", "spEditIcon_v2");
    			} else {
    			    this._ipv4rangeselectbox.set("disabled", false);
    				dojo.replaceClass(this.ipv4editicon, "spEditIcon_v2", "spEditInactiveIcon_v2");
    			}
    		});
    		
    		this._ipv4rangeselectbox = new support.widgets.Select({
    			name : this.get("id") + "_ipv4RangeSelect",
    			store : this._ipv4rangestore,
    			maxHeight : -1,
    			emptyLabel : "&mdash; " + this.locResources.NOPOOLSELECTED + " &mdash;", //this.locResources.ANYRANGE,
    			disabled : true
    		}, this.get("id") + "_ipv4RangeSelect");
    		this._ipv4rangeselectbox.startup();

    		this._ipv6selectbox = new support.widgets.Select({
    			name : this.get("id") + "_ipv6Select",
    			store : this._ipv6store,
    			maxHeight : -1,
    			emptyLabel : "&mdash; " + this.locResources.NOPOOLDEFINED + " &mdash;",
    			disabled : true
    		}, this.get("id") + "_ipv6Select");
    		this._ipv6selectbox.startup();
    		
    		if (this._ipv6selectbox.get("value") != "") {
    			this._ipv6selectbox.addOption({
    				value: "noselected",
    				label: "&mdash; " + this.locResources.NOPOOLSELECTED + " &mdash;",
    				selected: true
    			});
    		}
    		
	    	this._ipv6selectbox.set("value", "noselected");
	    	
    		dojo.connect(this._ipv6selectbox, "onChange", this, function() {
    			this._setIPRangeSelect("IPv6", this._ipv6rangedefault);
    			
    			if (this._ipv6selectbox.get("value") == "noselected") {
    			    this._ipv6rangeselectbox.set("disabled", true);
    				dojo.replaceClass(this.ipv6editicon, "spEditInactiveIcon_v2", "spEditIcon_v2");
    			} else { 
    			    this._ipv6rangeselectbox.set("disabled", false);
    				dojo.replaceClass(this.ipv6editicon, "spEditIcon_v2", "spEditInactiveIcon_v2");
    			}    			
    		});
    		
    		this._ipv6rangeselectbox = new support.widgets.Select({
    			name : this.get("id") + "_ipv6RangeSelect",
    			store : this._ipv6rangestore,
    			emptyLabel : "&mdash; " + this.locResources.NOPOOLSELECTED + " &mdash;", //this.locResources.ANYRANGE,
    			maxHeight : -1,
    			disabled: true
    		}, this.get("id") + "_ipv6RangeSelect");    		
    		this._ipv6rangeselectbox.startup();   
    		
        },
        
        _setIPRangeSelect: function(type, rangedefault) {
        	var ipv4selectvalue = this._ipv4selectbox.get("value");
        	var ipv4rangedata = null;
        	var ipv6selectvalue = this._ipv6selectbox.get("value");
        	var ipv6rangedata = null;
        	
        	if (rangedefault == null) {
        	    rangedefault = "any";
        	}
        	
        	var response = this._ippoolListData;
        	var count;
        	var ipv4data = {
        	        "identifier": "id",
        	        "label": "name",
        	        "items": [] 
        	};
        	var ipv6data = {
        	        "identifier": "id",
        	        "label": "name",
        	        "items": []
        	};
        	for(count = 0; count < response.items.length; ++count) {
        	    if (response.items[count].protocol == "IPv4") {
        	        ipv4data.items.push(response.items[count]);
        	    }
        	    if (response.items[count].protocol == "IPv6") {
        	        ipv6data.items.push(response.items[count]);
        	    }
        	}
        	var ippoolcount = 0;
        	var rangeheader = {
        	        "identifier": "id",
        	        "label": "name",
        	        "items": []
        	};
        	for(ippoolcount = 0; ippoolcount < ipv4data.items.length; ++ippoolcount) {
        	    var rangecount = 0;
        	    if (ipv4data.items[ippoolcount].id == ipv4selectvalue){
        	        for(rangecount = 0; rangecount < ipv4data.items[ippoolcount].ranges.length; ++rangecount) {
        	            rangeheader.items.push(ipv4data.items[ippoolcount].ranges[rangecount]);
        	            rangeheader.items[rangecount].name = ipv4data.items[ippoolcount].ranges[rangecount].range;
        	        }
        	    }
        	}
        	ipv4rangedata = rangeheader;
        	
        	var rangeheaderipv6 = {
        	        "identifier": "id",
        	        "label": "name",
        	        "items": []
        	};
        	
        	for(ippoolcount = 0; ippoolcount < ipv6data.items.length; ++ippoolcount) {
        	    var rangecount = 0;
        	    if (ipv6data.items[ippoolcount].id == ipv6selectvalue){
        	        for(rangecount = 0; rangecount < ipv6data.items[ippoolcount].ranges.length; ++rangecount) {
        	            rangeheaderipv6.items.push(ipv6data.items[ippoolcount].ranges[rangecount]);
        	            rangeheaderipv6.items[rangecount].name = ipv6data.items[ippoolcount].ranges[rangecount].range;
        	        }
        	    }
        	}
        	ipv6rangedata = rangeheaderipv6;

        	if (type == "IPv4") {
    	    	this._ipv4rangestore = new dojo.data.ItemFileReadStore({
    	    		data : ipv4rangedata
    	    	});
    	    
    	    	this._ipv4rangeselectbox.setStore(this._ipv4rangestore);
       		
    	    	/*this._ipv4rangeselectbox.addOption({
    	    		value: "any",
    	    		label: this.locResources.ANYRANGE,
    	    		selected: true
    	    	});*/
    	    	
    	    	/*this._ipv4rangeselectbox.addOption({
    	    		value: "chassis",
    	    		label: this.resources.BY_CHASSIS,
    	    		selected: true
    	    	});*/    	    	
    	    	this._ipv4rangeselectbox.set("value", rangedefault);
    	    }
    		
    	    if (type == "IPv6") {
    	    	this._ipv6rangestore = new dojo.data.ItemFileReadStore({
    	    		data : ipv6rangedata
    	    	});
    	    
    	    	this._ipv6rangeselectbox.setStore(this._ipv6rangestore);
       		
    	    	/*this._ipv6rangeselectbox.addOption({
    	    		value: "any",
    	    		label: this.locResources.ANYRANGE,
    	    		selected: true
    	    	});*/
    	    	
    	    	/*this._ipv6rangeselectbox.addOption({
    	    		value: "chassis",
    	    		label: this.resources.BY_CHASSIS,
    	    		selected: true
    	    	});*/
    	    	this._ipv6rangeselectbox.set("value", rangedefault);
    	    }
        },
        
        _readSettingsFromService: function() {
        	var settings = null;
            var mode = this.templateMode;

           	var xhrGet = dojo.xhrGet({
           		url: this.REST_PATH + "template/" + this.templateIDNum,
           		handleAs: "json",
           		sync: true,
           		load: function(response) {
           			settings = response;
           		},
           		error: function(error) {
           			alert(this.locResources.ERRORTEMPLATE);
           		}
           	});

        	// Set dialog title to reflect Editing and display the warning message
        	//this.ethwarningMessage.style.display = "block";

           	this.initialData = settings.items;
           	
            this.templateInUse = settings.items[0].inUse;

           	
            if(mode == "copy"){
                this.dialogNode.set("title", this.locResources.COPYTITLE + " - " + settings.items[0].name + " - " + this.resources.COPY);
                this.templateName.set("value", settings.items[0].name + " - " + this.resources.COPY);
            }else{
                this.dialogNode.set("title", this.locResources.EDITTITLE + " - " + settings.items[0].name);
                this.templateName.set("value", settings.items[0].name);
            }        
            var descriptionvalue = settings.items[0].description;
            var description = this.decodeSpecialCharacters(descriptionvalue);
            this.ethadapDesc.set("value", description);

            // Hostname settings
            this.autogenchecklabelbutton.set("checkBox", "on");        	
            this.autogenchecklabelbutton.set("buttonState", settings.items[0].autogenhostnamebuttonvalue);
            var patternData = settings.items[0].IMM__NetworkSettings_autogen_hostname.pattern;
            this._customnametable = new support.panels.CustomNamingTable({
                templateType: "mgmt",
                namepattern: patternData    
            }, this.get("id") + "_customname");
            this._hyphenCheckBox.set("checked", settings.items[0].IMM__NetworkSettings_autogen_hostname.hyphenChecked);      
           	
           	if (settings.items[0].ipv4settingscheckvalue == true) {
           		this.ipv4checklabelbutton.set("checkBox", "on");
           		if (settings.items[0].ipv4settings == "No Change") {
           		    this.ipv4checklabelbutton.set("buttonState", 2);  // IPv4 buttonState 2 is No Change
           		} else {
           		    //this.ipv4checklabelbutton.set("buttonState", settings.items[0].ipv4settingsbuttonvalue);         
                    var ipv4settingsbuttonvaluefromservice = (settings.items[0].IMM__NetworkSettings_interface__ifconfig__eth__state == "enabled") ? true : false;
                    if (!ipv4settingsbuttonvaluefromservice) {
                        this.ipv4checklabelbutton.set("buttonState", 1);  // IPv4 buttonState 1 is Disabled
                    } else {
                        this.ipv4checklabelbutton.set("buttonState", 0);  // IPv4 buttonState 0 is Enabled
                    
                        if (settings.items[0].IMM__NetworkSettings_interface__ifconfig__eth__c == "dhcp") {
                            this.ipv4dynamicradiobutton.set("checked", true);
                            this._ipv4selectbox.set("disabled", true);
                            this._ipv4rangeselectbox.set("disabled", true);
                            this.ipv4addresspoolselections.style.display = "none";
                        } else if (settings.items[0].IMM__NetworkSettings_interface__ifconfig__eth__c == "static") {
                            this.ipv4staticradiobutton.set("checked", true);
                            this._ipv4selectbox.set("disabled", false);
                            this._ipv4rangeselectbox.set("disabled", false);
                            this.ipv4addresspoolselections.style.display = "block";
                        } else if (settings.items[0].IMM__NetworkSettings_interface__ifconfig__eth__c == "dthens") {
                            this.ipv4firstdhcpradiobutton.set("checked", true);
                            this._ipv4selectbox.set("disabled", false);
                            this._ipv4rangeselectbox.set("disabled", false);                        
                            this.ipv4addresspoolselections.style.display = "block";
                        }
                        this._ipv4selectbox.set("value", settings.items[0].ipv4settingsaddresspoolvalue);
                        this._ipv4rangedefault = settings.items[0].ipv4settingsrangevalue;
                        this._setIPRangeSelect("IPv4", settings.items[0].ipv4settingsrangevalue);                       
                    }
           		}
           	}
           	
        	if (settings.items[0].ipv6settingscheckvalue == true) {
           		this.ipv6checklabelbutton.set("checkBox", "on");
           		// this.ipv6checklabelbutton.set("buttonState", settings.items[0].ipv6settingsbuttonvalue);
           		//var ipv6settingsbuttonvaluefromservice = true; //(settings.items[0].IMM__NetworkSettings_interface__ifconfig__eth__ipv6 == "enabled") ? true : false;
           		//this.ipv6checklabelbutton.set("buttonState", ipv6settingsbuttonvaluefromservice);
           		if (settings.items[0].ipv6settings == "No Change") {
                    this.ipv6checklabelbutton.set("buttonState", 1);  // IPv6 buttonState 1 is No Change
                } else {
                    this.ipv6checklabelbutton.set("buttonState", 0);  // IPv6 buttonState 0 is Enabled
           		//if (ipv6settingsbuttonvaluefromservice == true){
           			// if (settings.items[0].ipv6settingsradiovalue == "dynamicip") {
           		    if (settings.items[0].IMM__NetworkSettings_interface__ifconfig__eth__dhcp6 == "enabled") {
           				this.ipv6dynamicradiobutton.set("checked", true);
           				this._ipv6selectbox.set("disabled", true);
           				this.ipv6addresspoolselections.style.display = "none";
           			} else{
           			 this.ipv6dynamicradiobutton.set("checked", false);
           			}
           			if (settings.items[0].IMM__NetworkSettings_interface__ifconfig__eth__sa6 == "enabled") {
           				this.ipv6statelessradiobutton.set("checked", true);
           				this._ipv6selectbox.set("disabled", true);
           				this.ipv6addresspoolselections.style.display = "none";
           			} else{
           			 this.ipv6statelessradiobutton.set("checked", false);
           			}
           			if (settings.items[0].IMM__NetworkSettings_interface__ifconfig__eth__ipv6static == "enabled") {
         				this.ipv6staticradiobutton.set("checked", true);
           				this._ipv6selectbox.set("disabled", false);
           				this.ipv6addresspoolselections.style.display = "block";
           			} else{
           			 this.ipv6staticradiobutton.set("checked", false);
           			}
           			this._ipv6selectbox.set("value", settings.items[0].ipv6settingsaddresspoolvalue);
           			this._ipv6rangedefault = settings.items[0].ipv6settingsrangevalue;
           			this._setIPRangeSelect("IPv6", settings.items[0].ipv6settingsrangevalue);           			
           		}
           	}
          	
           	if (settings.items[0].DDNSsettingscheckvalue == true) {
           		this.ddnschecklabelbutton.set("checkBox", "on");
           		var DDNSsettingsbuttonvaluefromservice = (settings.items[0].IMM__NetworkSettings_interface__dns__ddns == "enabled") ? true : false;
           		this.ddnschecklabelbutton.set("buttonState", DDNSsettingsbuttonvaluefromservice);
           		if (DDNSsettingsbuttonvaluefromservice == true){
           			if (settings.items[0].IMM__NetworkSettings_interface__dns__dnsrc == "dhcp") {
           				this.ddnsradiodynamic.set("checked", true);
           				this.ddnsradiostatictextbox.style.display = "none";          				
           			} else if (settings.items[0].IMM__NetworkSettings_interface__dns__dnsrc == "manual") {
           				this.ddnsradiostatic.set("checked", true);
           				this.ddnstextbox.set("value", settings.items[0].IMM__NetworkSettings_interface__dns__ddn);
           				this.ddnsradiostatictextbox.style.display = "inline";
           			}
           		}
           	}
           	
           	if (settings.items[0].interfacespeedsettingscheckvalue == true) {
           		this.ifspeedchecklabelbutton.set("checkBox", "on");
           		var interfacespeedsettingsbuttonvaluefromservice = (settings.items[0].IMM__NetworkSettings_interface__ifconfig__eth__auto == "true") ? 0 : 1;
           		this.ifspeedchecklabelbutton.set("buttonState", interfacespeedsettingsbuttonvaluefromservice);
           		if (interfacespeedsettingsbuttonvaluefromservice == 1) { 
           			if (settings.items[0].IMM__NetworkSettings_interface__ifconfig__eth__d == "half") {
           				this.duplexButtonBar.set("selIndex", 0);
           			} else {
           				this.duplexButtonBar.set("selIndex", 1);
           			}
           		}
           	}
           	
           	if (settings.items[0].MTUsettingscheckvalue == true) {
           		this.mtuchecklabelbutton.set("checkBox", "on");
           		this.mtuchecklabelbutton.set("buttonState", settings.items[0].IMM__NetworkSettings_interface__ifconfig__eth__m);
           	}
           	
            this.httpchecklabelbutton.set("checkBox", "on");
            this.httpschecklabelbutton.set("checkBox", "on");
            this.telnetclichecklabelbutton.set("checkBox", "on");
            this.sshclichecklabelbutton.set("checkBox", "on");
            this.snmpagentchecklabelbutton.set("checkBox", "on");
            this.snmptrapschecklabelbutton.set("checkBox", "on");
            this.remotecontrolchecklabelbutton.set("checkBox", "on");
            this.cimhttpchecklabelbutton.set("checkBox", "on");
            this.cimhttpschecklabelbutton.set("checkBox", "on");
            
            this.httpchecklabelbutton.set("buttonState", settings.items[0].httpPort);
            this.httpschecklabelbutton.set("buttonState", settings.items[0].httpsPort);
            this.telnetclichecklabelbutton.set("buttonState", settings.items[0].telnetcliPort);
            this.sshclichecklabelbutton.set("buttonState", settings.items[0].sshcliPort);
            this.snmpagentchecklabelbutton.set("buttonState", settings.items[0].snmpagentPort);
            this.snmptrapschecklabelbutton.set("buttonState", settings.items[0].snmptrapsPort);
            this.remotecontrolchecklabelbutton.set("buttonState", settings.items[0].remotecontrolPort);
            this.cimhttpchecklabelbutton.set("buttonState", settings.items[0].cimhttpPort);
            this.cimhttpschecklabelbutton.set("buttonState", settings.items[0].cimhttpsPort);           	
           	
           //	this.hideuncheckedToggleButtonId._onClick();
            
            this._expandall();
        },
        
    	_saveandhideDialog: function(evt) {
    		if (!this._validateFields()) {
    			return;
    		}

    		var ethernetTemplateObj = new Object();
    		
    		ethernetTemplateObj.name = this.templateName.get("value").trim();
    	
    		ethernetTemplateObj.type = "Management";
    		
    		var description = this.ethadapDesc.get("value").trim();
    		ethernetTemplateObj.description = this.encodeSpecialCharacters(description);

    		// Needed for profile command generation
    		ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth = 0;
    		
    		// Hostname
 
    		ethernetTemplateObj.autogenhostnamecheckvalue = 
    			(this.autogenchecklabelbutton.get("checkBox") == false) ? false : true;
    		ethernetTemplateObj.autogenhostnamebuttonvalue = this.autogenchecklabelbutton.get("buttonState");
    		var autogenObject = new Object();
    		if(this.autogenchecklabelbutton.get("buttonState") == 1){
                 autogenObject.IMM__NetworkSettings__info__autogen = "Disable";
            }
            else{
                autogenObject.IMM__NetworkSettings__info__autogen = "Custom";
                if (this._customnametable){
                    autogenObject.pattern = this._customnametable.get("pattern");
                }
            }
            autogenObject.checked = true;
            autogenObject.hyphenChecked = this._hyphenCheckBox.checked;
            ethernetTemplateObj.IMM__NetworkSettings_autogen_hostname = autogenObject;

    		var ipv4settingscheck = this.ipv4checklabelbutton.get("checkBox");
    		ethernetTemplateObj.ipv4settingscheckvalue = 
    			(ipv4settingscheck == false) ? false : true;
    		// ethernetTemplateObj.ipv4settingsbuttonvalue = this.ipv4checklabelbutton.get("buttonState");
    		if (this.ipv4checklabelbutton.get("buttonState") == 2) {   // IPv4 button is set to "No Change"
    		    ethernetTemplateObj.ipv4settings = "No Change";
    		} else {
    		    ethernetTemplateObj.ipv4settings = "Enabled";
    		    ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__state = 
                    (this.ipv4checklabelbutton.get("buttonState") == 0) ? "enabled" : "disabled";  // IPv4 buttonState 0 is Enabled
                
                if (ipv4settingscheck == "on") {
                    if (this.ipv4checklabelbutton.get("buttonState") == 0) {  //IPv4 buttonState 0 is Enabled (no longer a toggle button)                        
                        // dynamic static
                        var ipv4radiobutton = this.ipv4form.get("value").ipv4;
                        // ethernetTemplateObj.ipv4settingsradiovalue = ipv4radiobutton;
                        
                        if (ipv4radiobutton == "staticip") {
                            ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__c = "static";
                            ethernetTemplateObj.ipv4settingsaddresspoolvalue = this._ipv4selectbox.get("value");
                            var ipv4rangevalue = this._ipv4rangeselectbox.get("value");
                            if (ipv4rangevalue == "any") {
                                ethernetTemplateObj.ipv4settingsrangevalue = null;
                            } else {
                                ethernetTemplateObj.ipv4settingsrangevalue = ipv4rangevalue;
                            }
                        } else if (ipv4radiobutton == "firstdynamicip"){
                            ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__c = "dthens";
                            ethernetTemplateObj.ipv4settingsaddresspoolvalue = this._ipv4selectbox.get("value");
                            var ipv4rangevalue = this._ipv4rangeselectbox.get("value");
                            if (ipv4rangevalue == "any") {
                                ethernetTemplateObj.ipv4settingsrangevalue = null;
                            } else {
                                ethernetTemplateObj.ipv4settingsrangevalue = ipv4rangevalue;
                            }                       
                        } else {
                            ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__c = "dhcp";
                        }
                    }
                }
    		}
    		var ipv6settingscheck = this.ipv6checklabelbutton.get("checkBox");
    		ethernetTemplateObj.ipv6settingscheckvalue = (ipv6settingscheck == false) ? false : true;
             // ethernetTemplateObj.ipv6settingsbuttonvalue = this.ipv6checklabelbutton.get("buttonState");
//             ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__ipv6 = 
//                 (this.ipv6checklabelbutton.get("buttonState") == true) ? "enabled" : "disabled";    
    		if (ipv6settingscheck == "on") {
                if (this.ipv6checklabelbutton.get("buttonState") == 0) {  // IPv6 is Enabled
                    ethernetTemplateObj.ipv6settings = "Enabled";
                    if (this.ipv6staticradiobutton.get("checked") == true) {
                        // stateless dynamic static
                        ethernetTemplateObj.ipv6settingsaddresspoolvalue = this._ipv6selectbox.get("value");
                        ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__ipv6static = "enabled";
                        var ipv6rangevalue = this._ipv6rangeselectbox.get("value");
                        if (ipv6rangevalue == "any") {
                            ethernetTemplateObj.ipv6settingsrangevalue = null;
                        } else {
                            ethernetTemplateObj.ipv6settingsrangevalue = ipv6rangevalue;
                        }
                    } else {
                        ethernetTemplateObj.ipv6settingsaddresspoolvalue = this._ipv6selectbox.get("value");
                        ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__ipv6static = "disabled";
                        var ipv6rangevalue = this._ipv6rangeselectbox.get("value");
                        if (ipv6rangevalue == "any") {
                            ethernetTemplateObj.ipv6settingsrangevalue = null;
                        } else {
                            ethernetTemplateObj.ipv6settingsrangevalue = ipv6rangevalue;
                        }
                        
                    }
                    
                    if (this.ipv6statelessradiobutton.get("checked") == true) {
                        ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__sa6 = "enabled";
                    } else{
                        ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__sa6 = "disabled";
                    }
                    if (this.ipv6dynamicradiobutton.get("checked") == true) {
                        ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__dhcp6 = "enabled";
                    } else{
                        ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__dhcp6 = "disabled";
                    }
                } else {
                    ethernetTemplateObj.ipv6settings = "No Change";
                }
            }

    		// DDNS settings

    		ethernetTemplateObj.DDNSsettingscheckvalue = 
    			(this.ddnschecklabelbutton.get("checkBox") == false) ? false : true;
    		// ethernetTemplateObj.DDNSsettingsbuttonvalue = this.ddnschecklabelbutton.get("buttonState");
    		ethernetTemplateObj.IMM__NetworkSettings_interface__dns__ddns = 
    		    (this.ddnschecklabelbutton.get("buttonState") == true) ? "enabled" : "disabled";
    		// dhcp or domain name
    		//var ddnsradiobutton = this.ddnsform.attr("value").ddns;
    		//alert(ddnsradiobutton);
    		if (this.ddnschecklabelbutton.get("checkBox") == "on") {
    			if (this.ddnschecklabelbutton.get("buttonState") == true) {
    				var ddnsradiobutton = this.ddnsradiodynamic.get("value");
    				if (ddnsradiobutton != false) {
    					// ethernetTemplateObj.DDNSsettingsradiovalue = "dhcp";
    				    ethernetTemplateObj.IMM__NetworkSettings_interface__dns__dnsrc = "dhcp";    				    
    				} else {
    				    ethernetTemplateObj.IMM__NetworkSettings_interface__dns__dnsrc = "manual";
    					// ethernetTemplateObj.DDNSsettingsradiovalue = this.ddnstextbox.get("value");
    				    ethernetTemplateObj.IMM__NetworkSettings_interface__dns__ddn = this.ddnstextbox.get("value");
    				}
    			}
    		}

    		// Interface speed
    		
    		ethernetTemplateObj.interfacespeedsettingscheckvalue = 
    			(this.ifspeedchecklabelbutton.get("checkBox") == false) ? false : true;
    		// ethernetTemplateObj.interfacespeedsettingsbuttonvalue = this.ifspeedchecklabelbutton.get("buttonState");
    		
    		if (this.ifspeedchecklabelbutton.get("checkBox") == "on") {
    			if (this.ifspeedchecklabelbutton.get("buttonState") == 1) {
    			    ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__auto = "false";
    				if (this.duplexButtonBar.get("selIndex") == 0) {
   						// ethernetTemplateObj.interfacespeedsettingsduplexvalue = "Half";
   					    ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__d = "half";
   					} else {
   						// ethernetTemplateObj.interfacespeedsettingsduplexvalue = "Full";
   					 ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__d = "full";
   					}    				
    			} else {
    			    ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__auto = "true";
    			    ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__r = "auto";
    			    ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__d = "auto";
    			}
    		} 

    		// MTU

    		ethernetTemplateObj.MTUsettingscheckvalue = 
    			(this.mtuchecklabelbutton.get("checkBox") == false) ? false : true;
    		if (this.mtuchecklabelbutton.get("checkBox") == "on") {
    			// ethernetTemplateObj.MTUsettingsmtuvalue = this.mtuchecklabelbutton.get("buttonState");
    		    ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__m = this.mtuchecklabelbutton.get("buttonState");
    		}
    		
    		//Ports
            var portsObj = new Object();
            if(this.httpchecklabelbutton.isValid() && !isNaN(this.httpchecklabelbutton.get("buttonState"))){
                ethernetTemplateObj.httpPort = this.httpchecklabelbutton.get("buttonState");   
            }
            if(this.httpschecklabelbutton.isValid() && !isNaN(this.httpschecklabelbutton.get("buttonState"))){
                ethernetTemplateObj.httpsPort = this.httpschecklabelbutton.get("buttonState");   
            }
            if(this.telnetclichecklabelbutton.isValid() && !isNaN(this.telnetclichecklabelbutton.get("buttonState"))){
                ethernetTemplateObj.telnetcliPort = this.telnetclichecklabelbutton.get("buttonState");   
            }
            if(this.sshclichecklabelbutton.isValid() && !isNaN(this.sshclichecklabelbutton.get("buttonState"))){
                ethernetTemplateObj.sshcliPort = this.sshclichecklabelbutton.get("buttonState");   
            }
            if(this.snmpagentchecklabelbutton.isValid() && !isNaN(this.snmpagentchecklabelbutton.get("buttonState"))){
                ethernetTemplateObj.snmpagentPort = this.snmpagentchecklabelbutton.get("buttonState");   
            }
            if(this.snmptrapschecklabelbutton.isValid() && !isNaN(this.snmptrapschecklabelbutton.get("buttonState"))){
                ethernetTemplateObj.snmptrapsPort = this.snmptrapschecklabelbutton.get("buttonState");   
            }
            if(this.remotecontrolchecklabelbutton.isValid() && !isNaN(this.remotecontrolchecklabelbutton.get("buttonState"))){
                ethernetTemplateObj.remotecontrolPort = this.remotecontrolchecklabelbutton.get("buttonState");   
            }
            if(this.cimhttpchecklabelbutton.isValid() && !isNaN(this.cimhttpchecklabelbutton.get("buttonState"))){
                ethernetTemplateObj.cimhttpPort = this.cimhttpchecklabelbutton.get("buttonState");   
            }
            if(this.cimhttpschecklabelbutton.isValid() && !isNaN(this.cimhttpschecklabelbutton.get("buttonState"))){
                ethernetTemplateObj.cimhttpsPort = this.cimhttpschecklabelbutton.get("buttonState");   
            }
    		
    		// If doing an edit, need to add the id
            if(this.templateIDNum != null && this.templateMode != "copy"){                
                ethernetTemplateObj.id = this.templateIDNum;
            }else{
                this.templateIDNum = null;
            }

    		var argJSONString = dojo.toJson({ 
    				"identifier":"id",
    				  "label":"name",
    				  "items":[ ethernetTemplateObj ]
    			}, true);

    		//console.log(this.declaredClass + ": ", argJSONString);

    		this.getProgressDialog("save").show(); // Show progress dialog for save request.
            var xhrPost = dojo.xhrPost({
                url: this.REST_PATH + "template/create",
                handleAs: "json", // <<<< Required
                headers: {
                    "Content-Type": "application/json; charset=utf-8" // <<<< Required
                },
                postData: argJSONString,     //Template Data to Post
                load: dojo.hitch(this, function(response, ioArgs) {
                    // Happy path! We received a 2xx status code from the API.
                                            
                    dojo.publish("ProgressComplete", response.id);
                    dojo.publish("EthTemplateComplete", response.id);
                    this.hide();   
                }),
                error: dojo.hitch(this, function(error, ioArgs) {
                    // Failure path! We received a non-2xx status code (ie: 3xx/4xx/5xx status code) from the API.

                    dojo.publish("ProgressFailed", error);
                    console.log(this.declaredClass + ": ", error, ioArgs);
                    
                    var response = dojo.fromJson(ioArgs.xhr.responseText);
                    if ((ioArgs.xhr.status >= 400) && (response.message == "service_error_name_in_use")) {
                        // Error Template name in use
                        this.getModalDialog("Error", this.resources.ERROR_400_NAME).show();
                    }
                    else if(ioArgs.xhr.status == 404) {
                        // Edit Template ID doesn't exist
                        this.getModalDialog("Error", this.resources.ERROR_404_ID).show();
                        this.hide();
                    }
                    else if(ioArgs.xhr.status >= 500) {
                        // Internal Programming Error
                        this.getModalDialog("Error", this.resources.ERROR_500_INTERNAL).show();
                        this.hide();
                    }
                    else {
                        this.getModalDialog("Error", this.resources.ERROR_TEMPLATE_CREATE).show();
                        this.hide();
                    }
                    
                }),
                handle: dojo.hitch(this, function(data, ioArgs) {
                    // - The 1st param ("data") is either the response data (on success) or Error object (on failure).
                    // - The 2nd param ("ioArgs") contains detail about the xhr request, including a reference to the
                    // native xhr object. Check ioArgs.xhr.status to determine success or failure, and handle "data"
                    // accordingly.
                })
            });

    	},    	
        saveClicked: function() {      

            if (!this._validateFields()) {
                return;
            }

            var ethernetTemplateObj = new Object();
            
            ethernetTemplateObj.name = this.templateName.get("value").trim();
            ethernetTemplateObj.type = "Management";
            
            var description = this.ethadapDesc.get("value").trim();
            ethernetTemplateObj.description = this.encodeSpecialCharacters(description);

            // Needed for profile command generation
            ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth = 0;
            
            // Hostname
 
            ethernetTemplateObj.autogenhostnamecheckvalue = 
                (this.autogenchecklabelbutton.get("checkBox") == false) ? false : true;
            ethernetTemplateObj.autogenhostnamebuttonvalue = this.autogenchecklabelbutton.get("buttonState");
            
            var autogenObject = new Object();
            if(this.autogenchecklabelbutton.get("buttonState") == 1){
                autogenObject.IMM__NetworkSettings__info__autogen = "Disable";
            }
            else{
                autogenObject.IMM__NetworkSettings__info__autogen = "Custom";
                if (this._customnametable){
                   autogenObject.pattern = this._customnametable.get("pattern");
                }
            }
            autogenObject.checked = true;
            autogenObject.hyphenChecked = this._hyphenCheckBox.checked;
            ethernetTemplateObj.IMM__NetworkSettings_autogen_hostname = autogenObject;

            var ipv4settingscheck = this.ipv4checklabelbutton.get("checkBox");
            ethernetTemplateObj.ipv4settingscheckvalue = 
                (ipv4settingscheck == false) ? false : true;
            // ethernetTemplateObj.ipv4settingsbuttonvalue = this.ipv4checklabelbutton.get("buttonState");
            if (this.ipv4checklabelbutton.get("buttonState") == 2) {  // IPv4 buttonState 2 is No Change
                ethernetTemplateObj.ipv4settings = "No Change";
            } else {
                ethernetTemplateObj.ipv4settings = "Enabled";
                ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__state = 
                    (this.ipv4checklabelbutton.get("buttonState") == 0) ? "enabled" : "disabled";  // IPv4 buttonState 0 is Enabled 1 is Disabled
                
                if (ipv4settingscheck == "on") {
                    if (this.ipv4checklabelbutton.get("buttonState") == 0) {  // IPv4 buttonState 0 is Enabled         
                        // dynamic static
                        var ipv4radiobutton = this.ipv4form.get("value").ipv4;
                        // ethernetTemplateObj.ipv4settingsradiovalue = ipv4radiobutton;
                        
                        if (ipv4radiobutton == "staticip") {
                            ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__c = "static";
                            ethernetTemplateObj.ipv4settingsaddresspoolvalue = this._ipv4selectbox.get("value");
                            var ipv4rangevalue = this._ipv4rangeselectbox.get("value");
                            if (ipv4rangevalue == "any") {
                                ethernetTemplateObj.ipv4settingsrangevalue = null;
                            } else {
                                ethernetTemplateObj.ipv4settingsrangevalue = ipv4rangevalue;
                            }
                        } else if (ipv4radiobutton == "firstdynamicip"){
                            ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__c = "dthens";
                            ethernetTemplateObj.ipv4settingsaddresspoolvalue = this._ipv4selectbox.get("value");
                            var ipv4rangevalue = this._ipv4rangeselectbox.get("value");
                            if (ipv4rangevalue == "any") {
                                ethernetTemplateObj.ipv4settingsrangevalue = null;
                            } else {
                                ethernetTemplateObj.ipv4settingsrangevalue = ipv4rangevalue;
                            }                       
                        } else {
                            ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__c = "dhcp";
                        }
                    }            
                }
            }

            var ipv6settingscheck = this.ipv6checklabelbutton.get("checkBox");
            ethernetTemplateObj.ipv6settingscheckvalue = (ipv6settingscheck == false) ? false : true;
            // ethernetTemplateObj.ipv6settingsbuttonvalue = this.ipv6checklabelbutton.get("buttonState");
           // ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__ipv6 = 
           //     (this.ipv6checklabelbutton.get("buttonState") == true) ? "enabled" : "disabled";            
            if (this.ipv6checklabelbutton.get("buttonState") == 1) {  // IPv6 buttonState 1 is No Change
                ethernetTemplateObj.ipv6settings = "No Change";
            } else {
                ethernetTemplateObj.ipv6settings = "Enabled";
                if (ipv6settingscheck == "on") {
                    if (this.ipv6checklabelbutton.get("buttonState") == 0) {  // IPv6 buttonState 0 is Enabled
                        if (this.ipv6staticradiobutton.get("checked") == true) {
                            // stateless dynamic static
                            ethernetTemplateObj.ipv6settingsaddresspoolvalue = this._ipv6selectbox.get("value");
                            ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__ipv6static = "enabled";
                            var ipv6rangevalue = this._ipv6rangeselectbox.get("value");
                            if (ipv6rangevalue == "any") {
                                ethernetTemplateObj.ipv6settingsrangevalue = null;
                            } else {
                                ethernetTemplateObj.ipv6settingsrangevalue = ipv6rangevalue;
                            }
                        } else {
                            ethernetTemplateObj.ipv6settingsaddresspoolvalue = this._ipv6selectbox.get("value");
                            ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__ipv6static = "disabled";
                            var ipv6rangevalue = this._ipv6rangeselectbox.get("value");
                            if (ipv6rangevalue == "any") {
                                ethernetTemplateObj.ipv6settingsrangevalue = null;
                            } else {
                                ethernetTemplateObj.ipv6settingsrangevalue = ipv6rangevalue;
                            }
                            
                        }
                        
                        if (this.ipv6statelessradiobutton.get("checked") == true) {
                            ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__sa6 = "enabled";
                        } else{
                            ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__sa6 = "disabled";
                        }
                        if (this.ipv6dynamicradiobutton.get("checked") == true) {
                            ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__dhcp6 = "enabled";
                        } else{
                            ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__dhcp6 = "disabled";
                        }
                    }
                }
            }

            // DDNS settings

            ethernetTemplateObj.DDNSsettingscheckvalue = 
                (this.ddnschecklabelbutton.get("checkBox") == false) ? false : true;
            // ethernetTemplateObj.DDNSsettingsbuttonvalue = this.ddnschecklabelbutton.get("buttonState");
            ethernetTemplateObj.IMM__NetworkSettings_interface__dns__ddns = 
                (this.ddnschecklabelbutton.get("buttonState") == true) ? "enabled" : "disabled";
            // dhcp or domain name
            //var ddnsradiobutton = this.ddnsform.attr("value").ddns;
            //alert(ddnsradiobutton);
            if (this.ddnschecklabelbutton.get("checkBox") == "on") {
                if (this.ddnschecklabelbutton.get("buttonState") == true) {
                    var ddnsradiobutton = this.ddnsradiodynamic.get("value");
                    if (ddnsradiobutton != false) {
                        // ethernetTemplateObj.DDNSsettingsradiovalue = "dhcp";
                        ethernetTemplateObj.IMM__NetworkSettings_interface__dns__dnsrc = "dhcp";                        
                    } else {
                        ethernetTemplateObj.IMM__NetworkSettings_interface__dns__dnsrc = "manual";
                        // ethernetTemplateObj.DDNSsettingsradiovalue = this.ddnstextbox.get("value");
                        ethernetTemplateObj.IMM__NetworkSettings_interface__dns__ddn = this.ddnstextbox.get("value");
                    }
                }
            }

            // Interface speed
            
            ethernetTemplateObj.interfacespeedsettingscheckvalue = 
                (this.ifspeedchecklabelbutton.get("checkBox") == false) ? false : true;
            // ethernetTemplateObj.interfacespeedsettingsbuttonvalue = this.ifspeedchecklabelbutton.get("buttonState");
            
            if (this.ifspeedchecklabelbutton.get("checkBox") == "on") {
                if (this.ifspeedchecklabelbutton.get("buttonState") == 1) {
                    ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__auto = "false";
                    if (this.duplexButtonBar.get("selIndex") == 0) {
                        // ethernetTemplateObj.interfacespeedsettingsduplexvalue = "Half";
                        ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__d = "half";
                    } else {
                        // ethernetTemplateObj.interfacespeedsettingsduplexvalue = "Full";
                     ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__d = "full";
                    }                   
                } else {
                    ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__auto = "true";
                    ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__r = "auto";
                    ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__d = "auto";
                }
            } 

            // MTU

            ethernetTemplateObj.MTUsettingscheckvalue = 
                (this.mtuchecklabelbutton.get("checkBox") == false) ? false : true;
            if (this.mtuchecklabelbutton.get("checkBox") == "on") {
                // ethernetTemplateObj.MTUsettingsmtuvalue = this.mtuchecklabelbutton.get("buttonState");
                ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__m = this.mtuchecklabelbutton.get("buttonState");
            }
            
            // Port assignmnets
            
            ethernetTemplateObj.httpPort = this.httpchecklabelbutton.get("buttonState");
            ethernetTemplateObj.httpsPort = this.httpschecklabelbutton.get("buttonState");
            ethernetTemplateObj.telnetcliPort = this.telnetclichecklabelbutton.get("buttonState");
            ethernetTemplateObj.sshcliPort = this.sshclichecklabelbutton.get("buttonState");
            ethernetTemplateObj.snmpagentPort = this.snmpagentchecklabelbutton.get("buttonState");
            ethernetTemplateObj.snmptrapsPort = this.snmptrapschecklabelbutton.get("buttonState");
            ethernetTemplateObj.remotecontrolPort = this.remotecontrolchecklabelbutton.get("buttonState");
            ethernetTemplateObj.cimhttpPort = this.cimhttpchecklabelbutton.get("buttonState");
            ethernetTemplateObj.cimhttpsPort = this.cimhttpschecklabelbutton.get("buttonState");
            
            ethernetTemplateObj.id = this.templateIDNum;
            
            var argJSONString = dojo.toJson({ 
                    "identifier":"id",
                      "label":"name",
                      "items":[ ethernetTemplateObj ]
                }, true);

            var saveTemplate = true;
            
            if(this.templateInUse.toString() == "true"){
                //  Need to remove extra properties that aren't included in the dialog
                delete this.initialData[0].inUse;
                delete this.initialData[0].uri;
                delete this.initialData[0].referencedBy;
                delete this.initialData[0].useCount;
                delete this.initialData[0].userDefined;
                
                // Remove description since it shouldn't force a redeploy
                delete this.initialData[0].description;
                delete ethernetTemplateObj.description;
                
                var preData = this.sortAndFlatten(this.initialData[0]);
                var postData = this.sortAndFlatten(ethernetTemplateObj);
                
                if(preData != postData){
                    this.rdstDialog.set("templateID",this.templateIDNum);
                    this.rdstDialog.set("templateType","Category");
                    this.rdstDialog.set("templateData",argJSONString);

                    this.rdstDialog.show();
                    
                    saveTemplate = false;
                }            
            }
            if (saveTemplate) {

                this.getProgressDialog("save").show(); // Show progress dialog for save request.
                    var xhrPost = dojo.xhrPost({
                        url: this.REST_PATH + "template/create",
                        handleAs: "json", // <<<< Required
                        headers: {
                            "Content-Type": "application/json; charset=utf-8" // <<<< Required
                        },
                        postData: argJSONString,     //Template Data to Post
                        load: dojo.hitch(this, function(response, ioArgs) {
                            // Happy path! We received a 2xx status code from the API.
                                                    
                            dojo.publish("ProgressComplete", response.id);
                            dojo.publish("EthTemplateComplete", response.id);
                            this.hide();   
                        }),
                        error: dojo.hitch(this, function(error, ioArgs) {
                            // Failure path! We received a non-2xx status code (ie: 3xx/4xx/5xx status code) from the API.

                            dojo.publish("ProgressFailed", error);
                            console.log(this.declaredClass + ": ", error, ioArgs);
                            
                            var response = dojo.fromJson(ioArgs.xhr.responseText);
                            if ((ioArgs.xhr.status >= 400) && (response.message == "service_error_name_in_use")) {
                                // Error Template name in use
                                this.getModalDialog("Error", this.resources.ERROR_400_NAME).show();
                            }
                            else if(ioArgs.xhr.status == 404) {
                                // Edit Template ID doesn't exist
                                this.getModalDialog("Error", this.resources.ERROR_404_ID).show();
                                this.hide();
                            }
                            else if(ioArgs.xhr.status >= 500) {
                                // Internal Programming Error
                                this.getModalDialog("Error", this.resources.ERROR_500_INTERNAL).show();
                                this.hide();
                            }
                            else {
                                this.getModalDialog("Error", this.resources.ERROR_TEMPLATE_CREATE).show();
                                this.hide();
                            }
                            
                        }),
                        handle: dojo.hitch(this, function(data, ioArgs) {
                            // - The 1st param ("data") is either the response data (on success) or Error object (on failure).
                            // - The 2nd param ("ioArgs") contains detail about the xhr request, including a reference to the
                            // native xhr object. Check ioArgs.xhr.status to determine success or failure, and handle "data"
                            // accordingly.
                        })
                    });

            }
        },
        saveasClicked: function() {      

            if (!this._validateFields()) {
                return;
            }

            var ethernetTemplateObj = new Object();
            
            ethernetTemplateObj.name = this.templateName.get("value").trim();
            ethernetTemplateObj.type = "Management";
            
            var description = this.ethadapDesc.get("value").trim();
            ethernetTemplateObj.description = this.encodeSpecialCharacters(description);

            // Needed for profile command generation
            ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth = 0;
            
            // Hostname
 
            ethernetTemplateObj.autogenhostnamecheckvalue = 
                (this.autogenchecklabelbutton.get("checkBox") == false) ? false : true;
            ethernetTemplateObj.autogenhostnamebuttonvalue = this.autogenchecklabelbutton.get("buttonState");
            
            var autogenObject = new Object();
            if(this.autogenchecklabelbutton.get("buttonState") == 1){
                autogenObject.IMM__NetworkSettings__info__autogen = "Disable";
            }
            else{
                autogenObject.IMM__NetworkSettings__info__autogen = "Custom";
                if (this._customnametable){
                   autogenObject.pattern = this._customnametable.get("pattern");
                }
            }
            autogenObject.checked = true;
            autogenObject.hyphenChecked = this._hyphenCheckBox.checked;
            ethernetTemplateObj.IMM__NetworkSettings_autogen_hostname = autogenObject;

            var ipv4settingscheck = this.ipv4checklabelbutton.get("checkBox");
            ethernetTemplateObj.ipv4settingscheckvalue = 
                (ipv4settingscheck == false) ? false : true;
            // ethernetTemplateObj.ipv4settingsbuttonvalue = this.ipv4checklabelbutton.get("buttonState");
            if (this.ipv4checklabelbutton.get("buttonState") == 2) {  // IPv4 buttonState 2 is No Change
                ethernetTemplateObj.ipv4settings = "No Change";
            } else {
                ethernetTemplateObj.ipv4settings = "Enabled";
                ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__state = 
                    (this.ipv4checklabelbutton.get("buttonState") == 0) ? "enabled" : "disabled";  // IPv4 buttonState 0 is Enabled 1 is Disabled
                
                if (ipv4settingscheck == "on") {
                    if (this.ipv4checklabelbutton.get("buttonState") == 0) {  // IPv4 buttonState 0 is Enabled         
                        // dynamic static
                        var ipv4radiobutton = this.ipv4form.get("value").ipv4;
                        // ethernetTemplateObj.ipv4settingsradiovalue = ipv4radiobutton;
                        
                        if (ipv4radiobutton == "staticip") {
                            ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__c = "static";
                            ethernetTemplateObj.ipv4settingsaddresspoolvalue = this._ipv4selectbox.get("value");
                            var ipv4rangevalue = this._ipv4rangeselectbox.get("value");
                            if (ipv4rangevalue == "any") {
                                ethernetTemplateObj.ipv4settingsrangevalue = null;
                            } else {
                                ethernetTemplateObj.ipv4settingsrangevalue = ipv4rangevalue;
                            }
                        } else if (ipv4radiobutton == "firstdynamicip"){
                            ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__c = "dthens";
                            ethernetTemplateObj.ipv4settingsaddresspoolvalue = this._ipv4selectbox.get("value");
                            var ipv4rangevalue = this._ipv4rangeselectbox.get("value");
                            if (ipv4rangevalue == "any") {
                                ethernetTemplateObj.ipv4settingsrangevalue = null;
                            } else {
                                ethernetTemplateObj.ipv4settingsrangevalue = ipv4rangevalue;
                            }                       
                        } else {
                            ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__c = "dhcp";
                        }
                    }
                }
            }

            var ipv6settingscheck = this.ipv6checklabelbutton.get("checkBox");
            ethernetTemplateObj.ipv6settingscheckvalue = (ipv6settingscheck == false) ? false : true;
            // ethernetTemplateObj.ipv6settingsbuttonvalue = this.ipv6checklabelbutton.get("buttonState");
            //ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__ipv6 = 
            //    (this.ipv6checklabelbutton.get("buttonState") == true) ? "enabled" : "disabled";   
            if (this.ipv6checklabelbutton.get("buttonState") == 1) {  // IPv6 buttonState 1 is No Change
                ethernetTemplateObj.ipv6settings = "No Change";
            } else {
                ethernetTemplateObj.ipv6gettings = "Enabled";
                if (ipv6settingscheck == "on") {
                    if (this.ipv6checklabelbutton.get("buttonState") == 0) {  // IPv6 buttonState 0 is Enabled
                        if (this.ipv6staticradiobutton.get("checked") == true) {
                            // stateless dynamic static
                            ethernetTemplateObj.ipv6settingsaddresspoolvalue = this._ipv6selectbox.get("value");
                            ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__ipv6static = "enabled";
                            var ipv6rangevalue = this._ipv6rangeselectbox.get("value");
                            if (ipv6rangevalue == "any") {
                                ethernetTemplateObj.ipv6settingsrangevalue = null;
                            } else {
                                ethernetTemplateObj.ipv6settingsrangevalue = ipv6rangevalue;
                            }
                        } else {
                            ethernetTemplateObj.ipv6settingsaddresspoolvalue = this._ipv6selectbox.get("value");
                            ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__ipv6static = "disabled";
                            var ipv6rangevalue = this._ipv6rangeselectbox.get("value");
                            if (ipv6rangevalue == "any") {
                                ethernetTemplateObj.ipv6settingsrangevalue = null;
                            } else {
                                ethernetTemplateObj.ipv6settingsrangevalue = ipv6rangevalue;
                            }
                            
                        }
                        
                        if (this.ipv6statelessradiobutton.get("checked") == true) {
                            ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__sa6 = "enabled";
                        } else{
                            ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__sa6 = "disabled";
                        }
                        if (this.ipv6dynamicradiobutton.get("checked") == true) {
                            ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__dhcp6 = "enabled";
                        } else{
                            ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__dhcp6 = "disabled";
                        }
                    }
                }            
            }

            // DDNS settings

            ethernetTemplateObj.DDNSsettingscheckvalue = 
                (this.ddnschecklabelbutton.get("checkBox") == false) ? false : true;
            // ethernetTemplateObj.DDNSsettingsbuttonvalue = this.ddnschecklabelbutton.get("buttonState");
            ethernetTemplateObj.IMM__NetworkSettings_interface__dns__ddns = 
                (this.ddnschecklabelbutton.get("buttonState") == true) ? "enabled" : "disabled";
            // dhcp or domain name
            //var ddnsradiobutton = this.ddnsform.attr("value").ddns;
            //alert(ddnsradiobutton);
            if (this.ddnschecklabelbutton.get("checkBox") == "on") {
                if (this.ddnschecklabelbutton.get("buttonState") == true) {
                    var ddnsradiobutton = this.ddnsradiodynamic.get("value");
                    if (ddnsradiobutton != false) {
                        // ethernetTemplateObj.DDNSsettingsradiovalue = "dhcp";
                        ethernetTemplateObj.IMM__NetworkSettings_interface__dns__dnsrc = "dhcp";                        
                    } else {
                        ethernetTemplateObj.IMM__NetworkSettings_interface__dns__dnsrc = "manual";
                        // ethernetTemplateObj.DDNSsettingsradiovalue = this.ddnstextbox.get("value");
                        ethernetTemplateObj.IMM__NetworkSettings_interface__dns__ddn = this.ddnstextbox.get("value");
                    }
                }
            }

            // Interface speed
            
            ethernetTemplateObj.interfacespeedsettingscheckvalue = 
                (this.ifspeedchecklabelbutton.get("checkBox") == false) ? false : true;
            // ethernetTemplateObj.interfacespeedsettingsbuttonvalue = this.ifspeedchecklabelbutton.get("buttonState");
            
            if (this.ifspeedchecklabelbutton.get("checkBox") == "on") {
                if (this.ifspeedchecklabelbutton.get("buttonState") == 1) {
                    ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__auto = "false";
                    if (this.duplexButtonBar.get("selIndex") == 0) {
                        // ethernetTemplateObj.interfacespeedsettingsduplexvalue = "Half";
                        ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__d = "half";
                    } else {
                        // ethernetTemplateObj.interfacespeedsettingsduplexvalue = "Full";
                     ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__d = "full";
                    }                   
                } else {
                    ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__auto = "true";
                    ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__r = "auto";
                    ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__d = "auto";
                }
            } 

            // MTU

            ethernetTemplateObj.MTUsettingscheckvalue = 
                (this.mtuchecklabelbutton.get("checkBox") == false) ? false : true;
            if (this.mtuchecklabelbutton.get("checkBox") == "on") {
                // ethernetTemplateObj.MTUsettingsmtuvalue = this.mtuchecklabelbutton.get("buttonState");
                ethernetTemplateObj.IMM__NetworkSettings_interface__ifconfig__eth__m = this.mtuchecklabelbutton.get("buttonState");
            }
            
            // Port assignmnets
            
            ethernetTemplateObj.httpPort = this.httpchecklabelbutton.get("buttonState");
            ethernetTemplateObj.httpsPort = this.httpschecklabelbutton.get("buttonState");
            ethernetTemplateObj.telnetcliPort = this.telnetclichecklabelbutton.get("buttonState");
            ethernetTemplateObj.sshcliPort = this.sshclichecklabelbutton.get("buttonState");
            ethernetTemplateObj.snmpagentPort = this.snmpagentchecklabelbutton.get("buttonState");
            ethernetTemplateObj.snmptrapsPort = this.snmptrapschecklabelbutton.get("buttonState");
            ethernetTemplateObj.remotecontrolPort = this.remotecontrolchecklabelbutton.get("buttonState");
            ethernetTemplateObj.cimhttpPort = this.cimhttpchecklabelbutton.get("buttonState");
            ethernetTemplateObj.cimhttpsPort = this.cimhttpschecklabelbutton.get("buttonState");
            
            this.saveasDialog.set("templateObject",ethernetTemplateObj);
            this.saveasDialog.show();
                        
        },
       	_getIPPooldata: function() {
    		var ipv4data = null;
    		var ipv6data = null;
    		var ipv4store = null;
    		var ipv6store = null;
    		var ippoollistdata = null;
    		    		
    	    var xhrGet = dojo.xhrGet({
    	    	url: this.REST_PATH + "ippool/list",
    	    	handleAs: "json",
    	    	preventCache: true,
    	    	sync: true,
    	    	load: function(response) {
    	    	    ippoollistdata = response;
    	    		var count;
    	    		ipv4data = {
    	    				"identifier": "id",
    	    				"label": "name",
    	    				"items": [] 
    	    		};
    	    		ipv6data = {
    	    				"identifier": "id",
    	    				"label": "name",
    	    				"items": []
    	    		};
    	    		for(count = 0; count < response.items.length; ++count) {
    	    			if (response.items[count].protocol == "IPv4") {
    	    				ipv4data.items.push(response.items[count]);
    	    			}
    	    			if (response.items[count].protocol == "IPv6") {
    	    				ipv6data.items.push(response.items[count]);
    	    			}
    	    		}

    	    		ipv4store = new dojo.data.ItemFileReadStore({
    	    			data : ipv4data
    	    		});
    	    		
    	    		ipv6store = new dojo.data.ItemFileReadStore({
    	    			data : ipv6data
    	    		});
 
    	    	},
    	    	error: function(error){
    	    		alert("error getting data from service");
    	    		// Probably need to mock up some dummy data here
    	      }
    	    	
    	    });
    	    this._ipv4store = ipv4store;
    	    this._ipv6store = ipv6store;
    	    this._ippoolListData = ippoollistdata;
    	},    	
        
        _validateFields: function(evt) {
            var validationpopup = new support.temp.ModalDialog({
                type: "Error",
                text: this.locResources.ERRORSELECTADDRESSPOOL
            });
            
        	if (this.ipv4checklabelbutton.get("checkBox") == "on" && this.ipv4checklabelbutton.get("buttonState") == 0) {  // IPv4 buttonState 0 is Enabled
        		if (this.ipv4staticradiobutton.get("checked") == true) {
        			if (this._ipv4selectbox.get("value") == "noselected" ||
        			        this._ipv4selectbox.get("disabled") == true ) {
        			    validationpopup.show();
        				return false;
        			}        		
        		}
        	}
        	
        	if (this.ipv6checklabelbutton.get("checkBox") == "on" && this.ipv6checklabelbutton.get("buttonState") == 0) {  // IPv6 buttonState 0 is Enabled
        		if (this.ipv6staticradiobutton.get("checked") == true) {
        			if (this._ipv6selectbox.get("value") == "noselected" ||
        			        this._ipv6selectbox.get("disabled") == true ) {
        			    validationpopup.show();
        				return false;
        			}        		
        		}
        	} 
        	
        	if (this.ddnschecklabelbutton.get("checkBox") == "on") {
        		if (this.ddnsradiostatic.get("checked") == true) {
        			if (this.ddnstextbox.get("value") == "" ) {
        	            var validationpopup2 = new support.temp.ModalDialog({
        	                type: "Error",
        	                text: this.locResources.ERRORDOMAINNAME
        	            });        			    
        			    validationpopup2.show();
        				return false;
        			}        		
        		}
        	}
        	
        	return true;
        },
        
    	_cancelDialog: function() {
    		this.hide();
    		//this.dialogNode.destroy();
    	},

    	_selectall: function() {    		
    		this.autogenchecklabelbutton.set("checkBox", "on");
    		this._toggleAutoGenHostname();
    		this.ipv4checklabelbutton.set("checkBox", "on");
    		this.ipv6checklabelbutton.set("checkBox", "on");
    		this._toggleMgmtIPAddrSettings();
    		this.ddnschecklabelbutton.set("checkBox", "on");
    		this._toggleDNSSettings();
    		// Not going to support the manual if speed options
    		this.ifspeedchecklabelbutton.set("checkBox", false);
    		this.interfacespeedchecktr.style.display = "none";
    		this.mtuchecklabelbutton.set("checkBox", "on");    	
    		this._toggleInterfaceSpeedSettings();
            this.httpchecklabelbutton.set("checkBox", "on");
            this.httpschecklabelbutton.set("checkBox", "on");
            this.telnetclichecklabelbutton.set("checkBox", "on");
            this.sshclichecklabelbutton.set("checkBox", "on");
            this.snmpagentchecklabelbutton.set("checkBox", "on");
            this.snmptrapschecklabelbutton.set("checkBox", "on");
            this.remotecontrolchecklabelbutton.set("checkBox", "on");
            this.cimhttpchecklabelbutton.set("checkBox", "on");
            this.cimhttpschecklabelbutton.set("checkBox", "on");
            this._togglePortAssignmentSettings();
    		this._expandall();
    		this.layout();
    		//this.dialogNode.resize();
    	},

    	_deselectall: function() {
    		this.autogenchecklabelbutton.set("checkBox", false);
    		this._toggleAutoGenHostname();
    		this.ipv4checklabelbutton.set("checkBox", false);
    		this.ipv6checklabelbutton.set("checkBox", false);
    		this.ddnschecklabelbutton.set("checkBox", false);
    		this._toggleDNSSettings();
    		this.ifspeedchecklabelbutton.set("checkBox", false);
    		this.mtuchecklabelbutton.set("checkBox", false);
    		this._toggleInterfaceSpeedSettings();    		
            this.httpchecklabelbutton.set("checkBox", false);
            this.httpschecklabelbutton.set("checkBox", false);
            this.telnetclichecklabelbutton.set("checkBox", false);
            this.sshclichecklabelbutton.set("checkBox", false);
            this.snmpagentchecklabelbutton.set("checkBox", false);
            this.snmptrapschecklabelbutton.set("checkBox", false);
            this.remotecontrolchecklabelbutton.set("checkBox", false);
            this.cimhttpchecklabelbutton.set("checkBox", false);
            this.cimhttpschecklabelbutton.set("checkBox", false);
            this._togglePortAssignmentSettings();
    		this.layout();
    	},

    	_expandall: function(evt) {
    		this.hostnameCheckBoxId.set("checked", "on");
    		this.mgmtipaddrCheckBoxId.set("checked", "on");
    		this.dnsCheckBoxId.set("checked", "on");
    		this.interfacespeedCheckBoxId.set("checked", "on");
    		this.portassignmentCheckBoxId.set("checked", "on");
    		this.expandall.style.display = "none";
    		this.collapseall.style.display = "inline";
    		this.mixedexpandcollapse.style.display = "none";
    		this._toggleAutoGenHostname();
    		this._toggleMgmtIPAddrSettings();
    		this._toggleDNSSettings();
    		this._toggleInterfaceSpeedSettings();
    		this._togglePortAssignmentSettings();
    		this.layout();
    		//this.dialogNode.resize();
    	},
        
    	_collapseall: function() {
    		this.hostnameCheckBoxId.set("checked", false);
    		this.mgmtipaddrCheckBoxId.set("checked", false);
    		this.dnsCheckBoxId.set("checked", false);
    		this.interfacespeedCheckBoxId.set("checked", false);
    		this.portassignmentCheckBoxId.set("checked", false);
    		this.expandall.style.display = "inline";
    		this.collapseall.style.display = "none";
    		this.mixedexpandcollapse.style.display = "none";
    		this._toggleAutoGenHostname();
    		this._toggleMgmtIPAddrSettings();
    		this._toggleDNSSettings();
    		this._toggleInterfaceSpeedSettings();
    		this._togglePortAssignmentSettings();
    		this.layout();
    	},

    	_checkExpandCollapseState: function() {
    		var hostnameCheckBoxState = this.hostnameCheckBoxId.get("value");
    		var mgmtipaddrCheckBoxState = this.mgmtipaddrCheckBoxId.get("value");
    		var dnsCheckBoxState = this.dnsCheckBoxId.get("value");
    		var interfacespeedCheckBoxState = this.interfacespeedCheckBoxId.get("value");
    		var portassignmentCheckBoxState = this.portassignmentCheckBoxId.get("value");
    		/* value on = checked, false = unchecked */

    		if (hostnameCheckBoxState == "on" && mgmtipaddrCheckBoxState == "on"
    				&& dnsCheckBoxState == "on"
    				&& interfacespeedCheckBoxState == "on"
    				&& portassignmentCheckBoxState == "on") {
    			return "allon";
    		}
    		if (hostnameCheckBoxState == false && mgmtipaddrCheckBoxState == false
    				&& dnsCheckBoxState == false
    				&& interfacespeedCheckBoxState == false
    				&& portassignmentCheckBoxState == false) {
    			return "alloff";
    		}

    		return "mixed";
    	},

    	_setExpandCollapseIcon: function() {
    		if (this._checkExpandCollapseState() == "mixed") {
    			this.expandall.style.display = "none";
    			this.collapseall.style.display = "none";
    			this.mixedexpandcollapse.style.display = "inline";
    		}
    		if (this._checkExpandCollapseState() == "allon") {
    			this.expandall.style.display = "none";
    			this.collapseall.style.display = "inline";
    			this.mixedexpandcollapse.style.display = "none";
    		}
    		if (this._checkExpandCollapseState() == "alloff") {
    			this.expandall.style.display = "inline";
    			this.collapseall.style.display = "none";
    			this.mixedexpandcollapse.style.display = "none";
    		}
    	},
    	
    	_displayHostnameSettings: function(evt) {    	    
    		this._setExpandCollapseIcon();
    		this._toggleAutoGenHostname();
    		this.layout();
    	},

    	_toggleAutoGenHostname: function() {
    	    // iHot Changes:
    	    // Check value of button bar.  If "Disable", then hide the section
    	    // If anything else, then section should be displayed
    		if (this.hideuncheckedToggleButtonId.get("checked") == true) {
    			if (this.autogenchecklabelbutton.get("checkbox") == false) {
    				this.autogenhostnametr.style.display = "none";
    				this.hostnametr.style.display = "none";
    				return;
    			}
    			if (this.autogenchecklabelbutton.get("buttonState") == 1) {
    				this.autogenhostnametr.style.display = "none";
    			} else {
    			    if(this._customnametable == null){
    			        this._customnametable = new support.panels.CustomNamingTable({
    			            templateType: "mgmt"
    		            }, this.get("id") + "_customname"); 
    			    }
    				this.autogenhostnametr.style.display = "block";
    			}
    			this.hostnametr.style.display = "block";
    			return;
    		} else {
    			this.hostnametr.style.display = "block";
    			if (this.hostnameCheckBoxId.get("value") == false) {
    				this.autogenhostnametr.style.display = "none";
    			} else {
    			    if(this._customnametable == null){
    			        this._customnametable = new support.panels.CustomNamingTable({
                            templateType: "mgmt"
                        }, this.get("id") + "_customname"); 
    			    }
    				this.autogenhostnametr.style.display = "block";
    				this._hostnameButtonBarClicked();    				
    			}
    			return;
    		}
    	},

    	_displayMgmtIPAddrSettings: function() {
    		this._setExpandCollapseIcon();
    		this._toggleMgmtIPAddrSettings();
    		this.layout();
    	},
    	
    	_ipv4radioClicked:function() {
    		if (this.ipv4form.get("value").ipv4 == "dynamicip") {
    			this._ipv4selectbox.set("disabled", true);
    			this._ipv4rangeselectbox.set("disabled", true);
    			this.ipv4addresspoolselections.style.display = "none";
    		}
    		if (this.ipv4form.get("value").ipv4 == "staticip" || this.ipv4form.get("value").ipv4 == "firstdynamicip") {
    			if (this._ipv4selectbox.get("value") != "") {
    				this._ipv4selectbox.set("disabled", false);
    				this._ipv4rangeselectbox.set("disabled", false);
    				if (this._ipv4selectbox.get("value") == "noselected") {
    				    this._ipv4rangeselectbox.set("disabled", true);
    					dojo.replaceClass(this.ipv4editicon, "spEditInactiveIcon_v2", "spEditIcon_v2");
    				} else {    				    
    					dojo.replaceClass(this.ipv4editicon, "spEditIcon_v2", "spEditInactiveIcon_v2");
    				}
    			}else {
    				this._ipv4selectbox.set("disabled", true);
    				this._ipv4rangeselectbox.set("disabled", true);    				
    				dojo.replaceClass(this.ipv4editicon, "spEditInactiveIcon_v2", "spEditIcon_v2");
    			}
    			this.ipv4addresspoolselections.style.display = "block";
    		}
    		this.layout();
    	},
    	
    	_ipv6radioClicked:function() {
    		if (this.ipv6staticradiobutton.get("checked") == true) {
    			if (this._ipv6selectbox.get("value") != "") {
    				this._ipv6selectbox.set("disabled", false);
    				//this._ipv6rangeselectbox.set("disabled", false);
    				
    				if (this._ipv6selectbox.get("value") == "noselected") {
    				    this._ipv6rangeselectbox.set("disabled", true);
    					dojo.replaceClass(this.ipv6editicon, "spEditInactiveIcon_v2", "spEditIcon_v2");
    				} else {
    					dojo.replaceClass(this.ipv6editicon, "spEditIcon_v2", "spEditInactiveIcon_v2");
    				}    				
    			} else {
        			this._ipv6selectbox.set("disabled", true);
        			this._ipv6rangeselectbox.set("disabled", true);
        			dojo.replaceClass(this.ipv6editicon, "spEditInactiveIcon_v2", "spEditIcon_v2");
    			}
    			this.ipv6addresspoolselections.style.display = "block";

    		} else {
    		    this.ipv6addresspoolselections.style.display = "none";
    		}
    		this._enableOk();
    		this.layout();
    	},	

    	_toggleMgmtIPAddrSettings: function() {
    		if (this.hideuncheckedToggleButtonId.get("checked") == true) {
    			// Both checkboxes are unchecked, hide the whole section
    			if (this.ipv4checklabelbutton.get("checkBox") == false
    					&& this.ipv6checklabelbutton.get("checkBox") == false) {
    				this.mgmtipaddripv4tr.style.display = "none";
    				this.mgmtipaddripv6tr.style.display = "none";
    				this.ipv4outlinepane.style.display = "none";
    				this.ipv6outlinepane.style.display = "none";
    				this.mgmtipaddrtr.style.display = "none";
    				return;
    			}

    			this.mgmtipaddrtr.style.display = "block";
    			if (this.mgmtipaddrCheckBoxId.get("value") == false) {
    				this.mgmtipaddripv4tr.style.display = "none";
    				this.mgmtipaddripv6tr.style.display = "none";
    				return;
    			} else {
    				this.mgmtipaddripv4tr.style.display = "block";
    				this.mgmtipaddripv6tr.style.display = "block";
    			}

    			if (this.ipv4checklabelbutton.get("buttonState") == 0){
    				this.mgmtipaddripv4tr.style.display = "block";
    				this.ipv4outlinepane.style.display = "block";
    				
    			} else if(this.ipv4checklabelbutton.get("buttonState") == 1){
    			    this.mgmtipaddripv4tr.style.display = "block";
    			    this.ipv4outlinepane.style.display = "none";
    			}else {
    				this.mgmtipaddripv4tr.style.display = "none";
    			}

    			//var defaultOps = (this.ipv6statelessradiobutton.get("checked") == true && this.ipv6dynamicradiobutton.get("checked") == true);
    			if (this.ipv6checklabelbutton.get("buttonState") == 0) {  // IPv6 buttonState 1 is Disabled
    				this.mgmtipaddripv6tr.style.display = "block";
    				this.ipv6outlinepane.style.display = "block";
    			} else {
    				this.mgmtipaddripv6tr.style.display = "none";
    			}
    			return;
    		} else {
    			this.mgmtipaddrtr.style.display = "block";
    			if (this.mgmtipaddrCheckBoxId.get("value") == false) {
    				this.mgmtipaddripv4tr.style.display = "none";
    				this.mgmtipaddripv6tr.style.display = "none";
    			} else {
    				this.mgmtipaddripv4tr.style.display = "block";
    				if (this.ipv4checklabelbutton.get("checkBox") == "on") {
    					if (this.ipv4checklabelbutton.get("buttonState") == 0) {
    						this.ipv4outlinepane.style.display = "block";
    					} else {
    						this.ipv4outlinepane.style.display = "none";
    					}
    				} else {
    					this.ipv4outlinepane.style.display = "none";
    				}
    				this.mgmtipaddripv6tr.style.display = "block";
    				if (this.ipv6checklabelbutton.get("checkBox") == "on") {
    					if (this.ipv6checklabelbutton.get("buttonState") == 0) {
    						this.ipv6outlinepane.style.display = "block";
    					} else {
    						this.ipv6outlinepane.style.display = "none";
    					}
    				} else {
    					this.ipv6outlinepane.style.display = "none";
    				}
    			}
    			return;
    		}
    		
    	},

    	_displayDNSSettings: function(evt) {
    		// Unhide DNS settings
    		this._setExpandCollapseIcon();
    		this._toggleDNSSettings();
    		this.layout();
    	},

    	_toggleDNSSettings: function() {
    		if (this.hideuncheckedToggleButtonId.get("checked") == true) {
    			// Both checkboxes are unchecked, hide the whole section
    			if (this.ddnschecklabelbutton.get("checkBox") == false) {
    				this.ddnstr.style.display = "none";
    				this.dnstr.style.display = "none";
    				return;
    			}

    			this.dnstr.style.display = "block";
    			if (this.dnsCheckBoxId.get("value") == false) {
    				this.ddnstr.style.display = "none";
    				return;
    			} else {
    				this.ddnstr.style.display = "block";
    			}
    		
    			if (this.ddnschecklabelbutton.get("checkBox") == "on" && ((this.ddnschecklabelbutton.get("buttonState") == 0) ||
    			       (this.ddnschecklabelbutton.get("buttonState") == 1 && this.ddnsradiodynamic.get("checked") == false))) {
    				this.ddnstr.style.display = "block";
    			} else {
    				this.ddnstr.style.display = "none";
    			}
    			return;
    		} else {
    			this.dnstr.style.display = "block";
    			if (this.dnsCheckBoxId.get("value") == false) {
    				this.ddnstr.style.display = "none";
    			} else {
    				this.ddnstr.style.display = "block";
    				if (this.ddnschecklabelbutton.get("checkBox") == "on") {
    					if (this.ddnschecklabelbutton.get("buttonState") == true) {
    						this.ddnsoutlinepane.style.display = "block";
    					} else {
    						this.ddnsoutlinepane.style.display = "none";
    					}
    				} else {
    					this.ddnsoutlinepane.style.display = "none";
    				}
    			}
    			this._enableOk();
    			return;
    		}
    	},

        _displayPortAssignmentSettings: function(evt) {
            // Unhide DNS settings
            this._setExpandCollapseIcon();
            this._togglePortAssignmentSettings();
            this.layout();
        },

        _togglePortAssignmentSettings: function() {
            if (this.hideuncheckedToggleButtonId.get("checked") == true && this.portassignmentCheckBoxId.get("value") == "on") {
                    if(this.httpchecklabelbutton.get("buttonState") == 80){
                        this.httptr.style.display = "none";
                    }
                    if(this.httpschecklabelbutton.get("buttonState") == 443){
                        this.httpstr.style.display = "none";
                    }
                    if(this.telnetclichecklabelbutton.get("buttonState") == 23){
                        this.telnetclitr.style.display = "none";
                    }
                    if(this.sshclichecklabelbutton.get("buttonState") == 22){
                        this.sshclitr.style.display = "none";
                    }
                    if(this.snmpagentchecklabelbutton.get("buttonState") == 161){
                        this.snmpagenttr.style.display = "none";
                    }
                    if(this.snmptrapschecklabelbutton.get("buttonState") == 162){
                        this.snmptrapstr.style.display = "none";
                    }
                    if(this.remotecontrolchecklabelbutton.get("buttonState") == 3900){
                        this.remotecontroltr.style.display = "none";
                    }
                    if(this.cimhttpchecklabelbutton.get("buttonState") == 5988){
                        this.cimhttptr.style.display = "none";
                    }
                    if(this.cimhttpschecklabelbutton.get("buttonState") == 5989){
                        this.cimhttpstr.style.display = "none";
                    }
            } 
            else if(this.portassignmentCheckBoxId.get("value") == "on"){
                this.httptr.style.display = "block";
                this.httpstr.style.display = "block";
                this.telnetclitr.style.display = "block";
                this.sshclitr.style.display = "block";
                this.snmpagenttr.style.display = "block";
                this.snmptrapstr.style.display = "block";
                this.remotecontroltr.style.display = "block";
                this.cimhttptr.style.display = "block";
                this.cimhttpstr.style.display = "block";
             }
            else if(this.portassignmentCheckBoxId.get("value") == false){
                this.httptr.style.display = "none";
                this.httpstr.style.display = "none";
                this.telnetclitr.style.display = "none";
                this.sshclitr.style.display = "none";
                this.snmpagenttr.style.display = "none";
                this.snmptrapstr.style.display = "none";
                this.remotecontroltr.style.display = "none";
                this.cimhttptr.style.display = "none";
                this.cimhttpstr.style.display = "none";
            }
   
        },    	
    	
    	_displayInterfaceSpeedSettings: function() {
    		// Unhide Interface Speed settings
    		this._setExpandCollapseIcon();
    		this._toggleInterfaceSpeedSettings();
    		this.layout();
    	},

    	_hideUncheckedClicked: function(evt) {
    		this._toggleAutoGenHostname();
    		this._toggleMgmtIPAddrSettings();
    		this._toggleDNSSettings();
    		this._toggleInterfaceSpeedSettings();
    		this._togglePortAssignmentSettings();
    		this.layout();
    		return;
    	},
    	
    	_dhcpDDNSTextBox: function() {
    		this.ddnsradiostatictextbox.style.display = "none";
    		this.ddnsradiodynamic.set("checked", true);
    		this._enableOk();
    	},
    	
    	_specifyDDNSTextBox: function() {
    		this.ddnsradiostatictextbox.style.display = "inline";
    		this.ddnsradiodynamic.set("checked", false);
    		this._enableOk();
    	},
    	
        _toggleInterfaceSpeedSettings: function() {
            if (this.hideuncheckedToggleButtonId.get("checked") == true) {
                // Both checkboxes are unchecked, hide the whole section
                if (this.ifspeedchecklabelbutton.get("checkBox") == false && this.mtuchecklabelbutton.get("checkBox") == false) {
                    this.interfacespeedchecktr.style.display = "none";
                    this.mtutr.style.display = "none";
                    this.interfacespeedtr.style.display = "none";
                    return;
                }

                this.interfacespeedtr.style.display = "block";
                if (this.interfacespeedCheckBoxId.get("value") == false) {
                    this.interfacespeedchecktr.style.display = "none";
                    this.mtutr.style.display = "none";
                    return;
                }
                else {
                    // Hide for this release
                    this.interfacespeedchecktr.style.display = "none";
                    //this.interfacespeedchecktr.style.display = "block";
                    this.mtutr.style.display = "block";
                }

                if (this.ifspeedchecklabelbutton.get("checkBox") == "on") {
                    if (this.ifspeedchecklabelbutton.get("buttonState") == 1) {
                        // Hide for this release
                        this.interfacespeedchecktr.style.display = "none";
                        //this.interfacespeedchecktr.style.display = "block";
                    }
                    else {
                        this.interfacespeedchecktr.style.display = "none";
                    }
                }
                else {
                    this.interfacespeedchecktr.style.display = "none";
                }
                
                if (this.mtuchecklabelbutton.get("checkBox") == "on" && this.mtuchecklabelbutton.get("buttonState") != 1500) {
                    this.mtutr.style.display = "block";
                }
                else {
                    this.mtutr.style.display = "none";
                }

                return;
            }
            else {
                this.interfacespeedtr.style.display = "block";
                if (this.interfacespeedCheckBoxId.get("value") == false) {
                    this.interfacespeedchecktr.style.display = "none";
                    this.mtutr.style.display = "none";
                }
                else {
                    // Hide for this release
                    this.interfacespeedchecktr.style.display = "none";
                    //this.interfacespeedchecktr.style.display = "block";
                    if (this.ifspeedchecklabelbutton.get("checkBox") == "on") {
                        if (this.ifspeedchecklabelbutton.get("buttonState") == 1) {
                            this.ifspeedoutlinepane.style.display = "block";
                        }
                        else {
                            this.ifspeedoutlinepane.style.display = "none";
                        }
                    }
                    else {
                        this.ifspeedoutlinepane.style.display = "none";
                    }
                    this.mtutr.style.display = "block";
                }
                return;
            }
        },
        
        _showIPPoolDialog: function(evt) {
        	var ippooldialog = new support.dialogs.NewIPPool({
        	        id: "cp_managementinterfacetemplate_newippooldialog"
        	});
        	ippooldialog.show();
        },
        
        _showIPv6PoolDialog: function(evt) {
            var ipv6pooldialog = new support.dialogs.NewIPPool({
                id: "cp_managementinterfacetemplate_newipv6pooldialog"
            });
            ipv6pooldialog.set("version", "IPv6");
            ipv6pooldialog.show();
        },
        
        _editIPPoolDialog: function(evt) {
            var poolID = this._ipv4selectbox.get("value");
            console.log(this.declaredClass + ": ipv4pool:" + poolID);
            if (poolID == "noselected" || poolID == "") {
                return;
            }                        
            var ippooldialog = new support.dialogs.NewIPPool({
                id: "cp_managementinterfacetemplate_neweditippooldialog",                
                poolIDNum: poolID
            });
            ippooldialog.show();
        },
        
        _editIPv6PoolDialog: function(evt) {
            var poolID = this._ipv6selectbox.get("value");
            console.log(this.declaredClass + ": ipv6pool:" + poolID);
            if (poolID == "noselected" || poolID == "") {
                return;
            }            
            var ipv6pooldialog = new support.dialogs.NewIPPool({
                id: "cp_managementinterfacetemplate_neweditipv6pooldialog",                
                poolIDNum: poolID
            });
            ipv6pooldialog.set("version", "IPv6");
            ipv6pooldialog.show();
        },        
        
        _displayDnsHoverHelp: function() {
            if(this._checkDNSEntryAdded() == true){
                this.dnstooltip.close();
            }
        },
        
        _checkName: function() {
            if ((this.templateName.get("value").trim() != "") && this.mtuchecklabelbutton.isValid() && (this.mtuchecklabelbutton.get("buttonState") != null)) {
                return true;
            }
            return false;
        },
              
        _checkIPv6MgmtAddress: function(){
            if (this.ipv6staticradiobutton.get("checked") == true || this.ipv6dynamicradiobutton.get("checked") == true || 
                    this.ipv6statelessradiobutton.get("checked") == true) {
                return true;
            } else {
                return false;
            }
        },
        
        _checkDDNS: function(){
            if((this.ddnsradiostatic.get("checked") == true && this.ddnstextbox.isValid() == true) ||
                    this.ddnsradiostatic.get("checked") == false){
                return true;
            } else {
                return false;
            }
        },
        
        _checkPortAssignments: function() {
            var passed = this.httpchecklabelbutton.isValid() &&
                this.httpschecklabelbutton.isValid() &&
                this.telnetclichecklabelbutton.isValid() &&
                this.sshclichecklabelbutton.isValid() &&
                this.snmpagentchecklabelbutton.isValid() &&
                this.snmptrapschecklabelbutton.isValid() &&
                this.remotecontrolchecklabelbutton.isValid() &&
                this.cimhttpchecklabelbutton.isValid() &&
                this.cimhttpschecklabelbutton.isValid();
            return passed;
          },

        _enableOk: function() {
            if (!this._isCustomNamePatternValid && (this.autogenchecklabelbutton.get("buttonState") == 0)) {
                this.okButton.set("disabled", true);
                this.saveBtn.set("disabled", true);
                this.saveasBtn.set("disabled", true);
                return;
            }
            
            if(this._checkName() && this._checkIPv6MgmtAddress() && this._checkDDNS() && this._checkPortAssignments()){
                this.okButton.set("disabled", false);
                this.saveBtn.set("disabled", false);
                this.saveasBtn.set("disabled", false);
            } else {
                this.okButton.set("disabled", true);
                this.saveBtn.set("disabled", true);
                this.saveasBtn.set("disabled", true);
            }
        },
        
        exitParent: function() {
            var data ="management";
            
            dojo.publish("EthTemplateComplete", data);
            
            if(this.rdstDialog != null){
                var deployClicked = this.rdstDialog.get("closeParent");
                if(deployClicked) {
                    this.hide();
                }
            }
        },
        
        _setDefaults: function() {
            this.autogenchecklabelbutton.set("buttonState", 1);
            this.ipv4checklabelbutton.set("buttonState", 2);  // Default is No Change
			this.ipv6checklabelbutton.set("buttonState", 1);  // Default is No Change
            this.ifspeedchecklabelbutton.set("buttonState", 0);
            this.disableautogentext.style.display = "block";
            this.predefinedautogentext.style.display = "none";
        },
        
        _hostnameButtonBarClicked: function() {
            switch(this.autogenchecklabelbutton.get("buttonState")) {
                /*case 0:
                    this.disableautogentext.style.display = "none";
                    this.predefinedautogentext.style.display = "block";
                    this.customautogentext.style.display = "none";
                    break;*/
                case 0:
                    this.disableautogentext.style.display = "none";
                    this.predefinedautogentext.style.display = "none";
                    this.customautogentext.style.display = "block";                    
                    this._enableOk();
                    break;                   
                case 1:
                    this.disableautogentext.style.display = "block";
                    this.predefinedautogentext.style.display = "none";
                    this.customautogentext.style.display = "none";                    
                    this._enableOk();
                    break;
            }
        },
                    
        _setup: function(){

            //Set Template Field to catch intermediate changes
            this.templateName.intermediateChanges = true;

            // Set Description Label
            this._descLimit.innerHTML = this.resources.LIMIT.replace("%500","500");

            //Set Information Messages and Load Previous Settings                      
            if(this.templateIDNum != null && this.templateMode == "edit"){     //if dialog in edit mode    
                
        //        this.loadprevSettings();
                
                //alert(this.templateInUse);
                
                if(this.templateInUse.toString() == "true"){
                
                    if(this.templateLaunchPoint == "table"){
                        
                        this.warningMessage.style.display = "block";
                        this.warningMessageText.innerHTML = this.resources.INUSE;
                        this.saveBtnContainer.style.display = "inline";
                        this.saveasBtnContainer.style.display = "inline";
                        
                    }else if(this.templateLaunchPoint == "wizard"){
                        
                        this.informationMessage.style.display = "block";
                        this.informationMessageText.innerHTML = this.resources.INUSEWIZARD;
                        this.saveasBtnContainer.style.display = "inline";
                        
                    }else{
                        this.informationMessage.style.display = "block";
                        this.informationMessageText.innerHTML = this.resources.INUSEWIZARD;
                        this.saveasBtnContainer.style.display = "inline";
                    }
                    
                }else{
                    
                    this.saveBtnContainer.style.display = "inline";
                    this.saveasBtnContainer.style.display = "inline";
                                        
                }    

                this.templateName.set("disabled",true);
                
             }else if(this.templateIDNum != null && this.templateMode == "copy"){    //if dialog in copy mode     
                 
          //       this.loadprevSettings();
                 this.templateIDNum = null;  //set template ID to null in order to create new template
                 this.okBtnContainer.style.display = "inline";

             }else{     //if dialog in create new mode
                 
                 this.okBtnContainer.style.display = "inline";
             } 

        }
   
    });
});