define(["dojo",
        "dijit",
        "support/dialogs/Dialog",
        "dojo/i18n!./nls/NewLearnedSettingsTemplate",
        "dojo/text!./templates/NewLearnedSettingsTemplate.html",
        "dijit/form/SimpleTextarea",
        "dijit/form/ValidationTextBox",
        "dijit/Dialog",
        "dojo/parser",
        "dijit/form/SimpleTextarea",
        "dijit/layout/ContentPane",
        "support/panels/LearnedSettings",
        "support/dialogs/SaveAs",
        "support/dialogs/ReDeployServerTemplate",
        "support/temp/ModalDialog",
        "support/dialogs/ProgressDialog"
        ], function(dojo, dijit, dialog, mri, template) {

    return dojo.declare("support.dialogs.NewLearnedSettingsTemplate", [ support.dialogs.Dialog ], {

        // templateString: [protected] String
        // This widget's HTML template, provided.
        templateString: template,

        // locResources: [protected] Object
        // This widget's National Language Source (NLS) object.
        locResources: mri,

        baseClass: "NewLearnedSettingsTemplate",
        widgetsInTemplate: true,

        templateIDNum: null,
        templateMode: "create", // "create" or "edit" or "copy"
        type: null, // "uefi" or "imm" or "port"

        name: null,
        description: null,
       
        //Options needed for the Port Extended
        portbdf: "",
        vendor: "",
        chipset: "",
        protocol: "",
        portFunctions: new Array(),
        bdfList: new Array(),
        
        configSettings: null,

        configDef: null,
        configDefconstant: null,

        //Performance Recovery Template Related
         //Currently only has a value when during Server Pattern Firmware page
         //when a performance recovery template is selected on that page
        performanceRelated: null,
        
        // the name of the CSS stylesheet of this page
        spCssPathAndName: "support/dialogs/themes/NewLearnedSettingsTemplate.css",

        // When this method is called, all variables inherited from superclasses are "mixed in".
        // Common operations for postMixInProperties
        // 1) Modify or assign values for widget property variables defined in the template HTML
        // file
        postMixInProperties: function() {
            this.inherited(arguments);
        },

        // postCreate() is called after buildRendering(). This is useful to override when
        // you need to access and/or manipulate DOM nodes included with your widget.
        // DOM nodes and widgets with the dojoAttachPoint attribute specified can now be directly
        // accessed as fields on "this".
        // Common operations for postCreate
        // 1) Access and manipulate DOM nodes created in buildRendering()
        // 2) Add new DOM nodes or widgets
        postCreate: function() {
            this.inherited(arguments);

            this.dialogNode.show();

            this._setup();

            this.dialogNode._position();

            dojo.connect(this.dialogNode, "hide", this, function() {
                this.destroy();
            });

            dojo.connect(this._learnedSettingsTree, "reposition", this, function() {
                this.dialogNode._position();
            });

            dojo.connect(this._learnedSettingsTree, "setDialogWidth", this, function(level) {
                var percent = 40 + (level * 5);
                this.dialogNode.set("style", "min-width:" + percent + "%;");
            });

            if (this.type == "port") {
             //   this.adapterInfo.style.display = "block";
            }

            if (this.templateIDNum != null) {
                this.xhrGetLearnedSettings(this.templateIDNum);

                this._learnedSettingsTree = new support.panels.LearnedSettings({
                    type: this.type,
                    maxPercent: ".50",
                    configDef: this.configDef,
                    configSettings: this.configSettings,
                    performanceRelated: this.performanceRelated
                }).placeAt(this.settingsContainer);
                
            }

            // Resizes dialog
            this.layout();


        },

        _setNameAttr: function(n) {
            this.name = n;
            if (n != "")
                this._okBtn.set("disabled", false);
            else
                this._okBtn.set("disabled", true);
        },

        _setDescriptionAttr: function(d) {
            this.description = d;
        },

        cancelClicked: function() {
            this.hide();
        },
        showChangeSetting: function(){
            this.changeSettingsBtnContainer.style.display = "none";
            this.saveBtnContainer.style.display = "none";
            this.saveasBtnContainer.style.display = "none";
            this.cancelBtnContainer.style.display = "none";
            
            this.doneSettingsBtnContainer.style.display = "inline";
            this.cancelSettingsBtnContainer.style.display = "inline";

            this.Node_1.style.display = "none";
            this.Node_2.style.display = "block";
            
            this._learnedSettingsTree.changeSettings();
  
        },
        doneChangingSetting: function(){
            this.doneSettingsBtnContainer.style.display = "none";
            this.cancelSettingsBtnContainer.style.display = "none";
            
            this.Node_2.style.display = "none";
            this.Node_1.style.display = "block";

            this.changeSettingsBtnContainer.style.display = "inline";
            this.saveBtnContainer.style.display = "inline";
            this.saveasBtnContainer.style.display = "inline";
            this.cancelBtnContainer.style.display = "inline";
            
            this._learnedSettingsTree.saveChangeSettings();
        },        
        cancelSettingsClicked: function(){
            this.doneSettingsBtnContainer.style.display = "none";
            this.cancelSettingsBtnContainer.style.display = "none";
            
            this.Node_2.style.display = "none";
            this.Node_1.style.display = "block";

            this.changeSettingsBtnContainer.style.display = "inline";
            this.saveBtnContainer.style.display = "inline";
            this.saveasBtnContainer.style.display = "inline";
            this.cancelBtnContainer.style.display = "inline";
            
            this._learnedSettingsTree.cancelChangeSettings();
        },
        okClicked: function() {

            if(this._learnedSettingsTree.checkValidation()){
            
                if (this.templateInUse.toString() == "true") {
                    var finalData = this.getLSObject();
                    this.rdstDialog.set("templateID", this.templateIDNum);
                    this.rdstDialog.set("templateType", this.resources.CATEGORY);
                    this.rdstDialog.set("templateData", finalData);
                    this.rdstDialog.show();
                }
                else {
                    this.getProgressDialog("save").show();
                    this.xhrPostLearnedSettings();
                }
                
            }else{
                
                var validationpopup = new support.temp.ModalDialog({
                    type: "Error",
                    text: this.resources.VALIDCHECK
                });
                validationpopup.show();
            }

        },

        getLSObject: function() {
            var lstemplate = this._learnedSettingsTree.getLearnedSettings();
            lstemplate["name"] = this.name;
            lstemplate["description"] = this._description.get("value").trim();
            lstemplate["id"] = this.templateIDNum;
            if (this.type == "uefi") {
                lstemplate["type"] = "ExtendedUEFI";
            }
            else if (this.type == "imm") {
                lstemplate["type"] = "ExtendedIMM";
            }
            else if (this.type == "port") {
                lstemplate["type"] = "ExtendedPort";
                lstemplate["portbdf"] = this.portbdf;                     
                lstemplate["vendor"] = this.vendor;                    
                lstemplate["chipset"] = this.chipset;                    
                lstemplate["protocol"] = this.protocol;
                lstemplate["portFunctions"] = this.portFunctions;
                lstemplate["bdfList"] = this.bdfList;
            }
            else {
                lstemplate["type"] = "Extended";
            }

            
            lstemplate["ConfigDefinitions"] = dojo.fromJson(this.configDefconstant);
                                    
            return dojo.toJson({
                "identifier": "id",
                "label": "name",
                "items": [ lstemplate ]
            });
        },

        xhrGetLearnedSettings: function(ID) {
            var items = "";

            var xhrGet = dojo.xhrGet({
               url: this.REST_PATH + "template/" + ID,
               //url: "data/IMM.json",
                handleAs: "json",
                sync: true,
                preventCache: true,
                headers: {
                    "Content-Type": "application/json; charset=utf-8"
                },
                load: dojo.hitch(this, function(response) {
                    items = response.items[0];
            
                    var patternTitle = this.locResources.TITLE2;
                    var editpatternTitle = this.locResources.EDIT_DIALOG;
                    
                    if (this.type == "uefi") {
                        patternTitle = this.locResources.UEFI_TITLE;
                        editpatternTitle = this.locResources.EDIT_UEFI_TITLE;
                    }
                    else if (this.type == "imm") {
                        patternTitle = this.locResources.IMM_TITLE;
                        editpatternTitle = this.locResources.EDIT_IMM_TITLE;
                    }
                    else if (this.type == "port") {
                        patternTitle = this.locResources.PORT_TITLE;
                        editpatternTitle = this.locResources.EDIT_PORT_TITLE;
                    }
                    
                    if(this.templateMode == "copy"){
                        this.dialogNode.set("title", patternTitle + " - " + items.name + " - " +  this.resources.COPY);
                        this._name.set("value", items.name + " - " +  this.resources.COPY);
                        this.templateIDNum = null;
                        this._okBtn.set("label", this.resources.CREATE);
                    }else{
                        this.dialogNode.set("title", editpatternTitle + " - " + items.name);
                        this._name.set("value", items.name);
                        this.templateIDNum = items.id;
                        this._okBtn.set("label", this.resources.SAVE);
                    }
                    
                    this._description.set("value", items.description);

                    if(items.type == "ExtendedPort"){
                        
                        if(items.portbdf)
                        this.portbdf = items.portbdf;
                        
                        if(items.vendor)
                        this.vendor = items.vendor;
                        
                        if(items.chipset)
                        this.chipset = items.chipset;
                        
                        if(items.protocol)
                        this.protocol = items.protocol;
                        
                        if(items.portFunctions)
                        this.portFunctions = items.portFunctions;

                        if(items.bdfList)
                        this.bdfList = items.bdfList;

                    }
                    
                    for ( var attr in items.ConfigDefinitions) {
                        var widget = dijit.byId(attr);
                        if (widget != null) {
                            this.setValueFromDisplay(items.ConfigDefinitions[attr]);
                        }
                    }
                })
            });

            this.configSettings = items;


            this.configDef = items.ConfigDefinitions;

//            console.log(this.declaredClass + ": ConfigDefinitions Length: "+items.ConfigDefinitions.items.length);
                                                
            this.configDefconstant = dojo.toJson(items.ConfigDefinitions);

        },

        xhrPostLearnedSettings: function() {
            var finalData = this.getLSObject();

            dojo.xhrPost({
                url: this.REST_PATH + "template/create",
                handleAs: "json",
                postData: finalData,
                headers: {
                    "Content-Type": "application/json; charset=utf-8"
                },
                load: dojo.hitch(this, function(data) {
                    dojo.publish("ProgressComplete", data);
                    dojo.publish("RefreshTable", "");
                    this.hide();
                }),
                error: dojo.hitch(this, function(error, ioArgs) {
                    dojo.publish("ProgressFailed", error);
                    console.log(this.declaredClass + ": ", error, ioArgs);
                    
                    var response = dojo.fromJson(ioArgs.xhr.responseText);
                    if ((ioArgs.xhr.status >= 400) && (response.message == "service_error_name_in_use")) {
                        // Error Template name in use
                        this.getModalDialog("Error", this.resources.ERROR_400_NAME).show();
                    }
                    else if(ioArgs.xhr.status == 404) {
                        // Edit Template ID doesn't exist
                        this.getModalDialog("Error", this.resources.ERROR_404_ID).show();
                        this.hide();
                    }
                    else if(ioArgs.xhr.status >= 500) {
                        // Internal Programming Error
                        this.getModalDialog("Error", this.resources.ERROR_500_INTERNAL).show();
                        this.hide();
                    }
                    else {
                        this.getModalDialog("Error", this.resources.ERROR_TEMPLATE_CREATE).show();
                        this.hide();
                    }
                })
            });
        },
        xhrPutLearnedSettings: function(ID) {
            var finalData = this.getLSObject();
            var success = false;
            dojo.xhrPut({
                url: this.REST_PATH + "template/" + ID,
                handleAs: "json",
                sync: true,
                putData: finalData,
                headers: {
                    "Content-Type": "application/json; charset=utf-8"
                },
                load: dojo.hitch(this, function(data) {
                    success = true;
                }),
                error: dojo.hitch(this, function(error, ioArgs) {
                    console.log(this.declaredClass + ": ", error, ioArgs);
                    
                    var response = dojo.fromJson(ioArgs.xhr.responseText);
                    if ((ioArgs.xhr.status >= 400) && (response.message == "service_error_name_in_use")) {
                        // Error Template name in use
                        this.getModalDialog("Error", this.resources.ERROR_400_NAME).show();
                    }
                    else if(ioArgs.xhr.status == 404) {
                        // Edit Template ID doesn't exist
                        this.getModalDialog("Error", this.resources.ERROR_404_ID).show();
                    }
                    else if(ioArgs.xhr.status >= 500) {
                        // Internal Programming Error
                        this.getModalDialog("Error", this.resources.ERROR_500_INTERNAL).show();
                    }
                    else {
                        this.getModalDialog("Error", this.resources.ERROR_TEMPLATE_CREATE).show();
                    }
                    success = false;
                })
            });
            return success;
        },

        saveasClicked: function() {

            var finalData = dojo.fromJson(this.getLSObject());

            // console.debug(this.declaredClass + ": ", finalData.items[0]);

            this.saveasDialog.set("templateObject", finalData.items[0]);
            this.saveasDialog.show();
        },

        _setup: function() {

            // Set Template Field to catch intermediate changes
            this._name.intermediateChanges = true;

            // Set Description Label
            this._descLimit.innerHTML = this.resources.LIMIT.replace("%500", "500");

            // Set Information Messages and Load Previous Settings
            if (this.templateIDNum != null && this.templateMode == "edit") { // if dialog in edit
                // mode

                if (this.templateInUse.toString() == "true") {

                    if (this.templateLaunchPoint == "table") {

                        this.warningMessage.style.display = "block";
                        this.warningMessageText.innerHTML = this.resources.INUSE;
                        // this.saveBtnContainer.style.display = "inline";
                        // this.saveasBtnContainer.style.display = "inline";

                    }
                    else if (this.templateLaunchPoint == "wizard") {

                        this.informationMessage.style.display = "block";
                        this.informationMessageText.innerHTML = this.resources.INUSEWIZARD;
                        // this.saveasBtnContainer.style.display = "inline";

                    }
                    else {
                        this.informationMessage.style.display = "block";
                        this.informationMessageText.innerHTML = this.resources.INUSEWIZARD;
                        // this.saveasBtnContainer.style.display = "inline";
                    }

                }
                else {

                    // this.saveBtnContainer.style.display = "inline";
                    // this.saveasBtnContainer.style.display = "inline";

                }

                this._name.set("disabled", true);

            }
            else if (this.templateIDNum != null && this.templateMode == "copy") { // if dialog in
                // copy mode
                 this.saveasBtnContainer.style.display = "none";
//                this.templateIDNum = null; // set template ID to null in order to create new

            }
            else { // if dialog in create new mode

                // this.okBtnContainer.style.display = "inline";

            }

        },

        exitParent: function() {

            if (this.rdstDialog != null) {
                var deployClicked = this.rdstDialog.get("closeParent");
                if (deployClicked) {
                    this.hide();
                }
            }
        }
    });
});