define([ 
         "dojo", 
         "dijit", 
         "support/dialogs/Dialog", 
         "dojo/i18n!./nls/NewPortPhysicalFunctionTemplate",
         "dojo/text!./templates/NewPortPhysicalFunctionTemplate.html",
        "dojo/parser", 
        "dijit/form/Select", 
        "dijit/form/ValidationTextBox", 
        "dijit/Tooltip", 
        "dijit/form/Button",
        "dijit/form/SimpleTextarea",
        "support/widgets/OutlinePane", 
        "dojox/data/AndOrReadStore",
        "dijit/form/NumberSpinner", 
        "support/dialogs/FibreChannelAddressPool", 
        "support/dialogs/ReDeployServerTemplate", 
        "dijit/layout/ContentPane",
        "support/dialogs/EditEthernetAddressPool", 
        "support/panels/CheckLabelButton",
        "support/dialogs/SaveAs" 
        ], function(dojo, dijit, dialog, mri, template) {
   
    
    return dojo.declare("support.dialogs.NewPortPhysicalFunctionTemplate", [ support.dialogs.Dialog], {
        
        // templateString: [protected] String
        // This widget's HTML template, provided.
        templateString: template,
            
        // locResources: [protected] Object
        // This widget's National Language Source (NLS) object.
        locResources: mri,
        
        baseClass: "NewPortPhysicalFunctionTemplate",
  
        _targetAdapterTypeSelector: null,
        _targetPortPhysicalFunctionTypeSelector: null,
        _targetPortPhysicalFunctionTypeStore: null,
        _portExtendedSettingsSelector: null,
        _addressingModeSelector: null,
        _ethernetAddressPoolSelector: null,
        _ethernetAddressPoolRangeSelector: null,
        _fibreChannelAddressPoolSelector: null,
        _fibreChannelAddressPoolRangeSelector: null,
        
        _supportedAdaptersStore: null,
        _ethernetAddressPoolStore: null,
        _ethernetAddressPoolRangeStore: null,
        _fibreChannelAddressPoolStore: null,
        _fibreChannelAddressPoolRangeStore: null,
        _adapterData: null,
        _currentAdapterType: null,
        _ioAddressingMode: null,
        _poolDefault: null,
        _vendor: null,
        _ibmFCrangesize: null,
        _emulexFCrangesize: null,
        _qlogicFCrangesize: null,
        _brocadeFCrangesize: null,
        _ibmEthernetrangesize: null,
        
        templateIDNum: null, // Used for "edit" mode
        addType: "*", // Used for "create" mode
        physicalFunction: null, // Used for "create" mode
        nodeType: "*",
        cfgPortGroup: 1,
        
        _templateSettings: null,
        
        _vlanmsg: null,
              
        //adapterId: null,
        
        // the name of the CSS stylesheet of this page
        spCssPathAndName: "support/dialogs/themes/NewPortPhysicalFunctionTemplate.css",

        // When this method is called, all variables inherited from superclasses are "mixed in".
        // Common operations for postMixInProperties
        // 1) Modify or assign values for widget property variables defined in the template HTML
        // file
        postMixInProperties: function() {
            this.inherited(arguments);
            
            this._vlanmsg = this.locResources.VLAN_MSG1.replace("%1", 2).replace("%2", 4094);
        },

        // postCreate() is called after buildRendering(). This is useful to override when
        // you need to access and/or manipulate DOM nodes included with your widget.
        // DOM nodes and widgets with the dojoAttachPoint attribute specified can now be directly
        // accessed as fields on "this".
        // Common operations for postCreate
        // 1) Access and manipulate DOM nodes created in buildRendering()
        // 2) Add new DOM nodes or widgets
        postCreate: function() {
            this.inherited(arguments);
            
            //Resizes dialog
            this.layout(); 
            
            this._descLimit.innerHTML = this.resources.LIMIT.replace("%500","500");

            this.templateName.intermediateChanges = true; //Allow code to catch auto updates of field
            
            dojo.replaceClass(this._portextendedicon, "spEditInactiveLgIcon", "spEditLgIcon");
            
            if (this.templateIDNum != null) {
                this._readSettingsFromService();                
            }
            
            //alert(this.adapterId + " " + this.nodeType);
            this._connectDataModels();           
            this._createSelectBoxes();
                        
            this.vlanchecklabelbutton.set("checkBox", "on");
            dojo.connect(this.vlanchecklabelbutton, "onChange", this, function() {
                this._nameChanged();
            });
            
            if (this.templateIDNum != null) {
                this._setSelectorsFromSettings();                
            }            
            
            this._setup();
           
        },

        _connectDataModels: function() {
            var adapData = null;
            var xhrArgs = {
                url: this.REST_PATH + "supportedDevices/ioAdapter/list",
                handleAs: "json",
                sync: true,
                headers: {
                    "Content-Type": "application/json; charset=utf-8"
                },
                load: function(data) {
                    adapData = data;
                },
                error: function(error) {
                    alert(error);
                }
            };

            // Call the asynchronous xhrGet
            var deferred = dojo.xhrGet(xhrArgs);
            
            this._adapterData = adapData;
            
            this._supportedAdaptersStore = new dojox.data.AndOrReadStore({
                data: this._adapterData
            });
            
            /**************************/
            /* Ethernet address pools */
            /**************************/
            var ethpooldata = null;
            var xhrEthPoolArgs = {
                    url: this.REST_PATH + "addresspool/vendordefaults/Ethernet/IBM",
                    handleAs: "json",
                    sync: true,
                    headers: {
                        "Content-Type": "application/json; charset=utf-8"
                    },
                    load: function(data) {
                        ethpooldata = data;
                    },
                    error: function(error) {
                        alert(error);
                    }
                };

            // Call the asynchronous xhrGet
            var deferred = dojo.xhrGet(xhrEthPoolArgs);
            
            //alert(dojo.toJson(ethpooldata));
            
            this._macPoolLabel.innerHTML = ethpooldata.name;
            this._ibmEthernetrangesize = ethpooldata.vendorRangeSize;
            
            this._ethernetAddressPoolStore = new dojox.data.AndOrReadStore({
               data: ethpooldata
            });
            /*************************************/
            /* End Ethernet address pool section */
            /*************************************/
            
            /********************************/
            /* Ethernet address pool ranges */
            /********************************/
            var ethrangedata = null;
            var xhrEthRangeArgs = {
                    url: this.REST_PATH + "addresspool/getpoolranges/Ethernet/IBM",
                    handleAs: "json",
                    sync: true,
                    headers: {
                        "Content-Type": "application/json; charset=utf-8"
                    },
                    load: function(data) {                        
                        ethrangedata = data;
                    },
                    error: function(error) {
                        alert(error);
                    }
                };

            // Call the asynchronous xhrGet
            var deferred = dojo.xhrGet(xhrEthRangeArgs);

            var ethdata = {
                    "identifier": "id",
                    "label": "name",
                    "items": []
            };
            if (dojo.toJson(ethrangedata) == "{}") { 
                ethrangedata = ethdata;
            } else {
                for (var rangecounter=0;rangecounter < ethrangedata.items.length;++rangecounter) {
                    var rangeObj = new Object();
                    rangeObj.id = ethrangedata.items[rangecounter].id;
                    var remaining = this.locResources.REMAININGADDRESSES.replace("%1", ethrangedata.items[rangecounter].size);
                    rangeObj.name = ethrangedata.items[rangecounter].range + " (" + remaining + ")";
                    ethdata.items.push(rangeObj);
                }
                ethrangedata = ethdata;
            }                        
                        
            this._ethernetAddressPoolRangeStore = new dojox.data.AndOrReadStore({
                data: ethrangedata 
            });
            /**************************************************/
            /* End of Ethernet address pool range data section*/
            /**************************************************/

            /*******************************/
            /* Fibre Channel address pools */
            /*******************************/            
            var fibrePoolSelectorList = {
                    "identifier": "id",
                    "label": "name",
                    "items": []
            };
            
            var fibrepooldata = null;
            var xhrFibrePoolArgs = {
                    url: this.REST_PATH + "addresspool/vendordefaults/Fibre/IBM",
                    handleAs: "json",
                    sync: true,
                    headers: {
                        "Content-Type": "application/json; charset=utf-8"
                    },
                    load: function(data) {
                        fibrepooldata = data;
                    },
                    error: function(error) {
                        alert(error);
                    }
                };

            // Call the asynchronous xhrGet
            var deferred = dojo.xhrGet(xhrFibrePoolArgs);
            
            var fibrepooldataObj = new Object();
            fibrepooldataObj.id = fibrepooldata.id;
            fibrepooldataObj.name = fibrepooldata.name;
            fibrePoolSelectorList.items.push(fibrepooldataObj);
            
            this._ibmFCrangesize = fibrepooldata.vendorRangeSize;
            
            var emulexfibrepooldata = null;
            var xhrEmulexFibrePoolArgs = {
                    url: this.REST_PATH + "addresspool/vendordefaults/Fibre/Emulex",
                    handleAs: "json",
                    sync: true,
                    headers: {
                        "Content-Type": "application/json; charset=utf-8"
                    },
                    load: function(data) {
                        emulexfibrepooldata = data;
                    },
                    error: function(error) {
                        alert(error);
                    }
                };

            // Call the asynchronous xhrGet
            var deferred = dojo.xhrGet(xhrEmulexFibrePoolArgs);
            
            var emulexfibrepooldataObj = new Object();
            emulexfibrepooldataObj.id = emulexfibrepooldata.id;
            emulexfibrepooldataObj.name = emulexfibrepooldata.name;
            fibrePoolSelectorList.items.push(emulexfibrepooldataObj);
            
            this._emulexFCrangesize = emulexfibrepooldata.vendorRangeSize;
            
            var brocadefibrepooldata = null;
            var xhrBrocadeFibrePoolArgs = {
                    url: this.REST_PATH + "addresspool/vendordefaults/Fibre/Brocade",
                    handleAs: "json",
                    sync: true,
                    headers: {
                        "Content-Type": "application/json; charset=utf-8"
                    },
                    load: function(data) {
                        brocadefibrepooldata = data;
                    },
                    error: function(error) {
                        alert(error);
                    }
                };

            // Call the asynchronous xhrGet
            var deferred = dojo.xhrGet(xhrBrocadeFibrePoolArgs);
            
            var brocadefibrepooldataObj = new Object();
            brocadefibrepooldataObj.id = brocadefibrepooldata.id;
            brocadefibrepooldataObj.name = brocadefibrepooldata.name;
            fibrePoolSelectorList.items.push(brocadefibrepooldataObj);
            
            this._brocadeFCrangesize = brocadefibrepooldata.vendorRangeSize;
            
            var qlogicfibrepooldata = null;
            var xhrQLogicFibrePoolArgs = {
                    url: this.REST_PATH + "addresspool/vendordefaults/Fibre/QLogic",
                    handleAs: "json",
                    sync: true,
                    headers: {
                        "Content-Type": "application/json; charset=utf-8"
                    },
                    load: function(data) {
                        qlogicfibrepooldata = data;
                    },
                    error: function(error) {
                        alert(error);
                    }
                };

            // Call the asynchronous xhrGet
            var deferred = dojo.xhrGet(xhrQLogicFibrePoolArgs);
            
            var qlogicfibrepooldataObj = new Object();
            qlogicfibrepooldataObj.id = qlogicfibrepooldata.id;
            qlogicfibrepooldataObj.name = qlogicfibrepooldata.name;
            fibrePoolSelectorList.items.push(qlogicfibrepooldataObj);
            
            this._qlogicFCrangesize = qlogicfibrepooldata.vendorRangeSize;
                                    
            //alert(dojo.toJson(ethpooldata));
            
            this._fibreChannelAddressPoolStore = new dojox.data.AndOrReadStore({
               //data: fibrepooldata
                data: fibrePoolSelectorList
            });
            /******************************************/
            /* End Fibre Channel address pool section */
            /******************************************/
            
            /*****************************************/
            /* Fibre Channel address pool range data */
            /*****************************************/
            var fibrerangedata = null;
            var xhrFibRangeArgs = {
                    url: this.REST_PATH + "addresspool/getpoolranges/Fibre/IBM",
                    handleAs: "json",
                    sync: true,
                    headers: {
                        "Content-Type": "application/json; charset=utf-8"
                    },
                    load: function(data) {
                        fibrerangedata = data;
                    },
                    error: function(error) {
                        alert(error);
                    }
                };

            // Call the asynchronous xhrGet
            var deferred = dojo.xhrGet(xhrFibRangeArgs);

            var fibredata = {
                    "identifier": "id",
                    "label": "name",
                    "items": []
            };
            if (dojo.toJson(fibrerangedata) == "{}") {         
                fibrerangedata = fibredata;
            } else {
                for (var rangecounter=0;rangecounter < fibrerangedata.items.length;++rangecounter) {
                    var rangeObj = new Object();
                    rangeObj.id = fibrerangedata.items[rangecounter].id;
                    rangeObj.name = fibrerangedata.items[rangecounter].range + fibrerangedata.items[rangecounter].size;
                    fibredata.items.push(rangeObj);
                }
                fibrerangedata = fibredata;
            }
            
            this._fibreChannelAddressPoolRangeStore = new dojox.data.AndOrReadStore({
                data: fibrerangedata 
            });
            /********************************************************/
            /* End of Fibre Channel Address pool range data section */
            /********************************************************/
            
            var preferences = null;
            var xhrPref = {
                url: this.REST_PATH + "config/default",
                handleAs: "json",
                sync: true,
                load: function(data) {
                    preferences = data;
                },
                error: function(error) {
                    alert("error");
                }
            };

            // Call the asynchronous xhrGet
            deferred = dojo.xhrGet(xhrPref);
            
            //alert(dojo.toJson(preferences));
            
            if ( preferences.ioAddressingMode != undefined) {
                this._ioAddressingMode = preferences.ioAddressingMode;
            }            
            
            if (preferences.pools != undefined) {
                this._poolDefault = preferences.pools;
            }
        },
        
        _readSettingsFromService: function() {
            var settings = null;
            var mode = this.templateMode;

            var xhrGet = dojo.xhrGet({
                url: this.REST_PATH + "template/" + this.templateIDNum,
                handleAs: "json",
                sync: true,
                load: function(response) {
                    settings = response;
                },
                error: function(error) {
                    alert(this.locResources.ERRORTEMPLATE);
                }
            });
            
            //alert(dojo.toJson(settings));
            
            if (settings.items[0].adapterType.toString() != "*ANY") { 
                this.addType = settings.items[0].adapterType;
            }
            
            this.physicalFunction = settings.items[0].physicalFunction;
            this.portFuncDesc.set("value", settings.items[0].description);
            
            var vlan = settings.items[0].vlanId;
            if (vlan == "*NONE") {
                vlan = 0;
            }
            this.vlanchecklabelbutton.set("buttonState", vlan);
         
            this._templateSettings = settings;
            
           //this.templateInUse = settings.items[0].inUse;
            
            this.templateInUse = false;
            if (settings.items[0].userDefined) {
                this.templateMode = "edit";
            } else {
                this.templateMode = "copy";
            }            
            
            this.saveBtn.set("disabled", false);
            this.saveasBtn.set("disabled", false);
            
            if(this.templateMode == "copy"){
                this.dialogNode.set("title", this.locResources.TITLE + " - " + settings.items[0].name + " - " + this.resources.COPY);
                this.templateName.set("value", settings.items[0].name + " - " + this.resources.COPY);
            }else{
                this.dialogNode.set("title", this.locResources.EDITTITLE + " - " + settings.items[0].name);
                this.templateName.set("value", settings.items[0].name);
            }
            
            return;            
        },
        
        _setSelectorsFromSettings: function() {
            this._targetAdapterTypeSelector.set("value", this._templateSettings.items[0].adapterType);
            var addressingMode = this._templateSettings.items[0].ioAddressingMode;
            if (addressingMode == "burned") {
                this._addressingModeSelector.set("value", "ba");
            } else if (addressingMode == "virtual") {
                this._addressingModeSelector.set("value", "va");
            }            
            if (this._templateSettings.items[0].ioAddressingMode == "virtual" && this.physicalFunction != "fc") {
                this._ethernetAddressPoolRangeSelector.set("value", this._templateSettings.items[0].macAddressRange);
            }
            if (this._templateSettings.items[0].ioAddressingMode == "virtual" && 
                (this.physicalFunction == "fc" || this.physicalFunction == "fcoe")) {
                this._fibreChannelAddressPoolRangeSelector.set("value", this._templateSettings.items[0].fcAddressRange);                
            }
            if (this._templateSettings.items[0].fcAddressPool != undefined) {
                this._fibreChannelAddressPoolSelector.set("value", this._templateSettings.items[0].fcAddressPool);
            }
        },
        
        _createSelectBoxes: function() {
            this._targetAdapterTypeSelector = new dijit.form.Select({
                id: this.get("id") + "_targetTypeSelector",
                name: "targetAdapterType",
                store: this._supportedAdaptersStore,
                maxHeight: -1,
                emptyLabel: this.resources.GENERICVFATITLE,
                query: {
                    id: this.addType,
                    supportedNodeTypes: this.nodeType
                },
                style: {
                    width: "250px"    //this._defaultselectorwidth
                },
                disabled: false
            }).placeAt(this._targetadaptertype);
            this._targetAdapterTypeSelector.startup();
            
            this._targetAdapterTypeSelector.addOption({
                value: "*ANY",
                label: this.locResources.ANYADAPTER,
                selected: false
            });
            
            if ( this.addType == "*" || this.addType == "*ANY") {
                this._targetAdapterTypeSelector.addOption({
                    value: "vfa",
                    label: this.resources.VIRTUAL_FABRIC,
                    selected: false
                });
                this._targetAdapterTypeSelector.set("value", "*ANY");
            }
                        
            dojo.connect(this._targetAdapterTypeSelector, "onChange", this, function() {  
                for(var counter=0;counter < this._adapterData.items.length;++counter) {
                    if (this._adapterData.items[counter].id == this._targetAdapterTypeSelector.get("value")) {
                        //console.log(this.declaredClass + ": ", this._adapterData.items[counter].adapterType);
                        this._vendor = this._adapterData.items[counter].controllers[0].vendor;                        
                        this._targetPortPhysicalFunctionTypeSelector.removeOption(this._targetPortPhysicalFunctionTypeSelector.getOptions());
                        this._currentAdapterType = String(this._adapterData.items[counter].adapterType);
                        switch(String(this._adapterData.items[counter].adapterType)) {
                            case "ethernet":                                
                                this._targetPortPhysicalFunctionTypeSelector.addOption({
                                    value: "nic",
                                    label: this.resources.NIC,
                                    selected: true
                                });
                                break;
                            case "fc":
                                this._targetPortPhysicalFunctionTypeSelector.addOption({
                                    value: "fc",
                                    label: this.resources.FC,
                                    selected: true
                                });
                                break;
                            case "fcoe":
                                this._targetPortPhysicalFunctionTypeSelector.addOption({
                                    value: "nic",
                                    label: this.resources.NIC,
                                    selected: true
                                });                                
                                this._targetPortPhysicalFunctionTypeSelector.addOption({
                                    value: "fcoe",
                                    label: this.resources.FCOE,
                                    selected: false
                                });
                                break;
                            case "vfa":
                                this._targetPortPhysicalFunctionTypeSelector.addOption({
                                    value: "nic",
                                    label: this.resources.NIC,
                                    selected: true
                                });                                
                                this._targetPortPhysicalFunctionTypeSelector.addOption({
                                    value: "fcoe",
                                    label: this.resources.FCOE,
                                    selected: false
                                });
                                this._targetPortPhysicalFunctionTypeSelector.addOption({
                                    value: "iscsi",
                                    label: this.resources.ISCSI,
                                    selected: false
                                });                                
                                break;                                                                                        
                        }
                    } else {                        
                        if (this._targetAdapterTypeSelector.get("value") == "*ANY") {
                            this._targetPortPhysicalFunctionTypeSelector.removeOption(this._targetPortPhysicalFunctionTypeSelector.getOptions());
                            this._targetPortPhysicalFunctionTypeSelector.addOption({
                                value: "nic",
                                label: this.resources.NIC,
                                selected: true
                            });                                
                            this._targetPortPhysicalFunctionTypeSelector.addOption({
                                value: "fcoe",
                                label: this.resources.FCOE,
                                selected: false
                            });
                            this._targetPortPhysicalFunctionTypeSelector.addOption({
                                value: "iscsi",
                                label: this.resources.ISCSI,
                                selected: false
                            });                            
                            this._targetPortPhysicalFunctionTypeSelector.addOption({
                                value: "fc",
                                label: this.resources.FC,
                                selected: false
                            });
                            this._currentAdapterType = "*ANY";
                            break;
                        }
                        if (this._targetAdapterTypeSelector.get("value") == "vfa") {
                            this._targetPortPhysicalFunctionTypeSelector.removeOption(this._targetPortPhysicalFunctionTypeSelector.getOptions());
                            this._targetPortPhysicalFunctionTypeSelector.addOption({
                                value: "nic",
                                label: this.resources.NIC,
                                selected: true
                            });                                
                            this._targetPortPhysicalFunctionTypeSelector.addOption({
                                value: "fcoe",
                                label: this.resources.FCOE,
                                selected: false
                            });
                            this._targetPortPhysicalFunctionTypeSelector.addOption({
                                value: "iscsi",
                                label: this.resources.ISCSI,
                                selected: false
                            });
                            this._currentAdapterType = "vfa";
                            break;
                        }                        
                    }
                }
                
                if (this._targetAdapterTypeSelector.get("value") == "*ANY") {
                    this._extendedphysicalfunctionsection.style.display = "none";
                } else {
                    this._extendedphysicalfunctionsection.style.display = "block";
                }
                               
                if (this._targetPortPhysicalFunctionTypeSelector.get("value") == "nic") {
                    this._commonphysicalfunctionsection.style.display = "block";                    
                } else {
                    this._commonphysicalfunctionsection.style.display = "none";
                }
                this.layout(); 
            });            
            
            this._targetPortPhysicalFunctionTypeSelector = new dijit.form.Select({
                id: this.get("id") + "_targetPortPhysicalFunctionTypeSelector",
                name: "targetPortPhysicalFunctionTypeMode",
                store: this._targetPortPhysicalFunctionTypeStore,
                maxHeight: -1,
                style: {
                    width: "80px"    //this._defaultselectorwidth
                },
                disabled: false
            }).placeAt(this._targetportphysicalfunctiontype);
            this._targetPortPhysicalFunctionTypeSelector.startup();
            
            this._targetPortPhysicalFunctionTypeSelector.addOption({
                value: "nic",
                label: this.resources.NIC,
                selected: false
            });
            
            this._targetPortPhysicalFunctionTypeSelector.addOption({
                value: "fcoe",
                label: this.resources.FCOE,
                selected: false
            });
            
            this._targetPortPhysicalFunctionTypeSelector.addOption({
                value: "iscsi",
                label: this.resources.ISCSI,
                selected: false
            });
            
            this._targetPortPhysicalFunctionTypeSelector.addOption({
                value: "fc",
                label: this.resources.FC,
                selected: false
            });
            
            dojo.connect(this._targetPortPhysicalFunctionTypeSelector, "onChange", this, function() {  
                var portPhysicalFunctionType = this._targetPortPhysicalFunctionTypeSelector.get("value");
                if (this._addressingModeSelector.get("value") == "va") {
                    if (portPhysicalFunctionType == "nic" || portPhysicalFunctionType == "fcoe" ||
                            portPhysicalFunctionType == "iscsi") {                        
                        this._ethernetaddresspoolrow.style.display = "table-row";
                    } else {
                        this._ethernetaddresspoolrow.style.display = "none";
                    }
                    if (portPhysicalFunctionType == "fcoe" || portPhysicalFunctionType == "fc") {
                        this._fibrechanneladdresspoolrow.style.display = "table-row";
                    } else {
                        this._fibrechanneladdresspoolrow.style.display = "none";
                    }
                } else { 
                    this._ethernetaddresspoolrow.style.display = "none";
                    this._fibrechanneladdresspoolrow.style.display = "none";
                }
                
                if (this._targetPortPhysicalFunctionTypeSelector.get("value") == "nic") {
                    this._commonphysicalfunctionsection.style.display = "block";                    
                } else {
                    this._commonphysicalfunctionsection.style.display = "none";
                }
                if (this.addType != "*" && this.physicalFunction != null) {                    
                    this._targetPortPhysicalFunctionTypeSelector.set("value", this.physicalFunction);
                    this._targetPortPhysicalFunctionTypeSelector.set("disabled", true);
                }
            });            

            this._portExtendedSettingsSelector = new dijit.form.Select({
                id: this.get("id") + "_portExtendedSettingsSelector",
                name: "portExtendedSettings",
                store: this._portExtendedSettingsStore,
                maxHeight: -1,
                emptyLabel: "&mdash; " + this.resources.NO_TEMP_DEFINED + " &mdash;",
                style: {
                    //width: "250px"    //this._defaultselectorwidth
                },
                disabled: true
            }).placeAt(this._portextendedsettings);
            this._portExtendedSettingsSelector.startup();
            
            this._addressingModeSelector = new dijit.form.Select({
                id: this.get("id") + "_addressingModeSelector",
                name: "addressingMode",
                store: this._addressingModeStore,
                maxHeight: -1,
                style: {
                    width: "150px"    //this._defaultselectorwidth
                },
                disabled: false
            }).placeAt(this._addressingmode);
            this._addressingModeSelector.startup();
            
            this._addressingModeSelector.addOption({
                value: "va",
                label: this.locResources.VIRTUAL,
                selected: true
            });
            
            this._addressingModeSelector.addOption({
                value: "ba",
                label: this.locResources.BURNEDIN,
                selected: false
            });
            
            if (this._ioAddressingMode == "virtual") {
                this._addressingModeSelector.set("value", "va");
            }
            
            if (this._ioAddressingMode == "burned") {
                this._addressingModeSelector.set("value", "ba");
            }
            
            dojo.connect(this._addressingModeSelector, "onChange", this, function() {  
                var portPhysicalFunctionType = this._targetPortPhysicalFunctionTypeSelector.get("value");
                if (this._addressingModeSelector.get("value") == "va") {
                    if (portPhysicalFunctionType == "nic" || portPhysicalFunctionType == "fcoe" ||
                            portPhysicalFunctionType == "iscsi") {                        
                        this._ethernetaddresspoolrow.style.display = "table-row";
                    } else {
                        this._ethernetaddresspoolrow.style.display = "none";
                    }
                    if (portPhysicalFunctionType == "fcoe" || portPhysicalFunctionType == "fc") {
                        this._fibrechanneladdresspoolrow.style.display = "table-row";
                    } else {
                        this._fibrechanneladdresspoolrow.style.display = "none";
                    }
                } else { 
                    this._ethernetaddresspoolrow.style.display = "none";
                    this._fibrechanneladdresspoolrow.style.display = "none";
                }
                this.layout(); 
            });            

            // Get the value of the adapter selector
            for(var adapCounter=0;adapCounter<this._adapterData.items.length;++adapCounter) {                
                if (this._adapterData.items[adapCounter].id == this._targetAdapterTypeSelector.get("value")) {
                    this._vendor = this._adapterData.items[adapCounter].controllers[0].vendor;                    
                }
            }
            
            this._ethernetAddressPoolRangeSelector = new dijit.form.Select({
                id: this.get("id") + "_ethernetAddressPoolRangeSelector",
                name: "ethernetAddressPoolRange",
                store: this._ethernetAddressPoolRangeStore,
                maxHeight: -1,
                style: {
                    width: "200px"    //this._defaultselectorwidth
                },
                disabled: false
            }).placeAt(this._ethernetaddresspoolrange);
               
            dojo.connect(this._ethernetAddressPoolRangeSelector, "onClick", this, function() {                
                var ethrangedata = null;
                var xhrEthRangeArgs = {
                        url: this.REST_PATH + "addresspool/getpoolranges/Ethernet/IBM",
                        handleAs: "json",
                        sync: true,
                        headers: {
                            "Content-Type": "application/json; charset=utf-8"
                        },
                        load: function(data) {                        
                            ethrangedata = data;
                        },
                        error: function(error) {
                            alert(error);
                        }
                    };

                // Call the asynchronous xhrGet
                var deferred = dojo.xhrGet(xhrEthRangeArgs);
                
                var ethdata = {
                        "identifier": "id",
                        "label": "name",
                        "items": []
                };
                if (dojo.toJson(ethrangedata) == "{}") { 
                    ethrangedata = ethdata;
                } else {
                    for (var rangecounter=0;rangecounter < ethrangedata.items.length;++rangecounter) {
                        var rangeObj = new Object();
                        rangeObj.id = ethrangedata.items[rangecounter].id;
                        var remaining = this.locResources.REMAININGADDRESSES.replace("%1", ethrangedata.items[rangecounter].size);
                        rangeObj.name = ethrangedata.items[rangecounter].range + " (" + remaining + ")";
                        ethdata.items.push(rangeObj);
                    }
                    ethrangedata = ethdata;
                }                            
                this._ethernetAddressPoolRangeStore = new dojox.data.AndOrReadStore({
                    data: ethrangedata 
                });
                
                this._ethernetAddressPoolRangeSelector.setStore(this._ethernetAddressPoolRangeStore);
                
                var overallremaining = this.locResources.REMAININGADDRESSES.replace("%1", this._ibmEthernetrangesize);
                this._ethernetAddressPoolRangeSelector.addOption({
                    value: "*OVERALL",
                    label: this.locResources.OVERALL + " (" + overallremaining + ")"                
                });
                               
            });            
            this._ethernetAddressPoolRangeSelector.startup();
            
            var overallremaining = this.locResources.REMAININGADDRESSES.replace("%1", this._ibmEthernetrangesize);
            this._ethernetAddressPoolRangeSelector.addOption({
                value: "*OVERALL",
                label: this.locResources.OVERALL + " (" + overallremaining + ")"                
            });
            
            this._ethernetAddressPoolRangeSelector.set("value", "*OVERALL");
                        
            this._fibreChannelAddressPoolSelector = new dijit.form.Select({
                id: this.get("id") + "_fibreChannelAddressPoolSelector",
                name: "fibreChannelAddressPool",
                store: this._fibreChannelAddressPoolStore,
                maxHeight: -1,
                style: {
                    width: "200px"    //this._defaultselectorwidth
                },
                query: {
                    complexQuery: "(id: 'IBM' OR id: '" + this._vendor + "')"
                },
                disabled: false
            }).placeAt(this._fibrechanneladdresspool);
            dojo.connect(this._fibreChannelAddressPoolSelector, "onChange", this, function() {
                var fibrerangedata = null;
                var fcvendor = this._fibreChannelAddressPoolSelector.get("value");
                if (fcvendor == "QLogic") {
                    fcvendor = "Qlogic";
                }
                var xhrFibRangeArgs = {
                        url: this.REST_PATH + "addresspool/getpoolranges/Fibre/" + fcvendor,
                        handleAs: "json",
                        sync: true,
                        headers: {
                            "Content-Type": "application/json; charset=utf-8"
                        },
                        load: function(data) {
                            fibrerangedata = data;
                        },
                        error: function(error) {
                            alert(error);
                        }
                    };

                // Call the asynchronous xhrGet
                var deferred = dojo.xhrGet(xhrFibRangeArgs);
                            
                var fibredata = {
                        "identifier": "id",
                        "label": "name",
                        "items": []
                };
                if (dojo.toJson(fibrerangedata) == "{}") {         
                    fibrerangedata = fibredata;
                } else {
                    for (var rangecounter=0;rangecounter < fibrerangedata.items.length;++rangecounter) {
                        var rangeObj = new Object();
                        rangeObj.id = fibrerangedata.items[rangecounter].id;
                        var remaining = this.locResources.REMAININGADDRESSES.replace("%1", fibrerangedata.items[rangecounter].size);
                        rangeObj.name = fibrerangedata.items[rangecounter].range + " (" + remaining + ")";
                        fibredata.items.push(rangeObj);
                    }
                    fibrerangedata = fibredata;
                }                                    
                this._fibreChannelAddressPoolRangeStore = new dojox.data.AndOrReadStore({
                    data: fibrerangedata 
                });                
                
                this._fibreChannelAddressPoolRangeSelector.setStore(this._fibreChannelAddressPoolRangeStore);

                var rangesize = "";                
                switch(fcvendor) {
                    case "IBM":                                             
                        rangesize = this.locResources.REMAININGADDRESSES.replace("%1", this._ibmFCrangesize);
                        break;
                    case "Emulex":                        
                        rangesize = this.locResources.REMAININGADDRESSES.replace("%1", this._emulexFCrangesize);
                        break;
                    case "Brocade":                        
                        rangesize = this.locResources.REMAININGADDRESSES.replace("%1", this._brocadeFCrangesize);
                        break;
                    case "Qlogic":                        
                        rangesize = this.locResources.REMAININGADDRESSES.replace("%1", this._qlogicFCrangesize);
                        break;
                }               
                this._fibreChannelAddressPoolRangeSelector.addOption({
                    value: "*OVERALL",
                    label: this.locResources.OVERALL + " (" + rangesize + ")"       
                });            
                
                this._fibreChannelAddressPoolRangeSelector.set("value", "*OVERALL");
            });
            
            this._fibreChannelAddressPoolSelector.startup();
            
            if (this._poolDefault == "vendor") {
                this._fibreChannelAddressPoolSelector.set("value", this._vendor);
            } else {
                this._fibreChannelAddressPoolSelector.set("value", "IBM");
            }
            
            this._fibreChannelAddressPoolRangeSelector = new dijit.form.Select({
                id: this.get("id") + "_fibreChannelAddressPoolRangeSelector",
                name: "fibreChannelAddressPoolRange",
                store: this._fibreChannelAddressPoolRangeStore,
                maxHeight: -1,
                style: {
                    width: "200px"    //this._defaultselectorwidth
                },
                disabled: false
            }).placeAt(this._fibrechanneladdresspoolrange);
            this._fibreChannelAddressPoolRangeSelector.startup();
            
            this._fibreChannelAddressPoolRangeSelector.addOption({
                value: "*OVERALL",
                label: this.locResources.OVERALL               
            });
            
            this._fibreChannelAddressPoolRangeSelector.set("value", "*OVERALL");
            
            dojo.connect(this._fibreChannelAddressPoolRangeSelector, "onClick", this, function() {
                var fibrerangedata = null;
                var fcvendor = this._fibreChannelAddressPoolSelector.get("value");
                if (fcvendor == "QLogic") {
                    fcvendor = "Qlogic";
                }
                var xhrFibRangeArgs = {
                        url: this.REST_PATH + "addresspool/getpoolranges/Fibre/" + fcvendor,
                        handleAs: "json",
                        sync: true,
                        headers: {
                            "Content-Type": "application/json; charset=utf-8"
                        },
                        load: function(data) {
                            fibrerangedata = data;
                        },
                        error: function(error) {
                            alert(error);
                        }
                    };

                // Call the asynchronous xhrGet
                var deferred = dojo.xhrGet(xhrFibRangeArgs);
                            
                var fibredata = {
                        "identifier": "id",
                        "label": "name",
                        "items": []
                };
                if (dojo.toJson(fibrerangedata) == "{}") {         
                    fibrerangedata = fibredata;
                } else {
                    for (var rangecounter=0;rangecounter < fibrerangedata.items.length;++rangecounter) {
                        var rangeObj = new Object();
                        rangeObj.id = fibrerangedata.items[rangecounter].id;
                        var remaining = this.locResources.REMAININGADDRESSES.replace("%1", fibrerangedata.items[rangecounter].size);
                        rangeObj.name = fibrerangedata.items[rangecounter].range + " (" + remaining+ ")";
                        fibredata.items.push(rangeObj);
                    }
                    fibrerangedata = fibredata;
                }
                                    
                this._fibreChannelAddressPoolRangeStore = new dojox.data.AndOrReadStore({
                    data: fibrerangedata 
                });                
                
                this._fibreChannelAddressPoolRangeSelector.setStore(this._fibreChannelAddressPoolRangeStore);
                
                var rangesize = "";                
                switch(fcvendor) {
                    case "IBM":                        
                        rangesize = this.locResources.REMAININGADDRESSES.replace("%1", this._ibmFCrangesize);
                        break;
                    case "Emulex":                        
                        rangesize = this.locResources.REMAININGADDRESSES.replace("%1", this._emulexFCrangesize);
                        break;
                    case "Brocade":                        
                        rangesize = this.locResources.REMAININGADDRESSES.replace("%1", this._brocadeFCrangesize);
                        break;
                    case "Qlogic":                        
                        rangesize = this.locResources.REMAININGADDRESSES.replace("%1", this._qlogicFCrangesize);
                        break;
                }               
                this._fibreChannelAddressPoolRangeSelector.addOption({
                    value: "*OVERALL",
                    label: this.locResources.OVERALL + " (" + rangesize + ")"       
                });
            });

        },
        
        _editFCPool: function() {       
            var fcvendor = this._fibreChannelAddressPoolSelector.get("value");
            if (fcvendor == "QLogic") {
                fcvendor = "Qlogic";
            }
            var fcapdialog = new support.dialogs.FibreChannelAddressPool({
                vendor: fcvendor
            });
            fcapdialog.show();
        },
        
        _editEthernetPool: function() {
            var ethpooldialog = new support.dialogs.EditEthernetAddressPool();
            ethpooldialog.show();            
        },
  
        _nameChanged: function() {
            if (this.templateName.get("value").trim() != "" && this.vlanchecklabelbutton.isValid()) {                
                this.okButton.set("disabled", false);                
            }
            else {
                this.okButton.set("disabled", true);
            }
        },
        
        _saveandhideDialog: function() {
            var portPhysicalFunctionTemplateObj = new Object();
            
            portPhysicalFunctionTemplateObj.id = "";
            portPhysicalFunctionTemplateObj.name = this.templateName.get("value").trim();
            portPhysicalFunctionTemplateObj.type = "PortPhysicalFunction";
            portPhysicalFunctionTemplateObj.adapterType = this._targetAdapterTypeSelector.get("value");
            var description = this.portFuncDesc.get("value").trim();
            portPhysicalFunctionTemplateObj.description = this.encodeSpecialCharacters(description);
            portPhysicalFunctionTemplateObj.userDefined = true;
            portPhysicalFunctionTemplateObj.physicalFunction = this._targetPortPhysicalFunctionTypeSelector.get("value");
            if (this._targetPortPhysicalFunctionTypeSelector.get("value") == "nic") {
                portPhysicalFunctionTemplateObj.vlanId = this.vlanchecklabelbutton.get("buttonState").toString();
            }
            var addressingMode = this._addressingModeSelector.get("value");
            if (addressingMode == "ba") {
                portPhysicalFunctionTemplateObj.ioAddressingMode = "burned";
            } else if (addressingMode == "va"){
                portPhysicalFunctionTemplateObj.ioAddressingMode = "virtual";
            }
            
            if (this._ethernetaddresspoolrow.style.display != "none") {
                portPhysicalFunctionTemplateObj.macAddressPool = "IBM";
                portPhysicalFunctionTemplateObj.macAddressRange = this._ethernetAddressPoolRangeSelector.get("value");                
            }
            if (this._fibrechanneladdresspoolrow.style.display != "none") {
                portPhysicalFunctionTemplateObj.fcAddressPool = this._fibreChannelAddressPoolSelector.get("value");
                portPhysicalFunctionTemplateObj.fcAddressRange = this._fibreChannelAddressPoolRangeSelector.get("value");                
            }
            
            //console.log(this.declaredClass + ": ", dojo.toJson(portPhysicalFunctionTemplateObj));
            
            var xhrArgs = {
                    url:  this.REST_PATH + "template/create?type=ppfunction",
                    handleAs: "json",
                    headers: {
                        "Content-Type": "application/json; charset=utf-8"
                    },
                    sync: true,
                    postData: dojo.toJson(portPhysicalFunctionTemplateObj),
                    load : function(data) {
                        dojo.publish("CreatePortPhysicalFunctionTemplateComplete", data);                        
                    },
                    error : function(error, ioArgs) {
                        console.log(this.declaredClass + ": ", error, ioArgs);
                        
                        var response = dojo.fromJson(ioArgs.xhr.responseText);
                        if ((ioArgs.xhr.status >= 400) && (response.message == "service_error_name_in_use")) {
                            // Error Template name in use
                            this.getModalDialog("Error", this.resources.ERROR_400_NAME).show();
                        } else if(ioArgs.xhr.status == 404) {
                            // Edit Template ID doesn't exist
                            this.getModalDialog("Error", this.resources.ERROR_404_ID).show();
                        } else if(ioArgs.xhr.status >= 500) {
                            // Internal Programming Error
                            this.getModalDialog("Error", this.resources.ERROR_500_INTERNAL).show();
                        } else {
                            this.getModalDialog("Error", this.resources.ERROR_TEMPLATE_CREATE).show();
                        }

                    }
            };
            
            dojo.xhrPost(xhrArgs);
            
            this.hide();
            this.dialogNode.destroy();            
        },
        
        saveClicked: function() {
            //Validate the vlanId first
            var invalidTemplateArray = this._validateVlanId();
            
            if (invalidTemplateArray.length > 0) {
                //A match was found.  Display the dialog
                
                if(this.CP_RUN_ENVIRONMENT == "fsm"){

                    require([ "support/temp/ConfirmationDialog" ], dojo.hitch(this, function() {

                        var confirmDialog = new support.temp.ConfirmationDialog({
                            buttonLabel: this.resources.OK,
                            type: "Warning",
                            text: this.locResources.VLAN_ERROR1,
                            info: this.locResources.VLAN_ERROR2                    
                        });

                        confirmDialog.startup();
                        confirmDialog.show();
                    
                    }));
     
                    
                }else if(this.CP_RUN_ENVIRONMENT == "augusta"){

                    require([ "idx/widget/ConfirmationDialog" ], dojo.hitch(this, function() {

                        var confirmDialog = new idx.widget.ConfirmationDialog({
                            buttonLabel: this.resources.OK,
                            type: "Warning",
                            text: this.locResources.VLAN_ERROR1,
                            info: this.locResources.VLAN_ERROR2                    
                        });

                        confirmDialog.startup();
                        confirmDialog.show();
                    
                    }));
                    
                }

                
                return;
            }
            
            var portPhysicalFunctionTemplateObj = new Object();
                        
            portPhysicalFunctionTemplateObj.name = this.templateName.get("value").trim();
            portPhysicalFunctionTemplateObj.type = "PortPhysicalFunction";
            portPhysicalFunctionTemplateObj.adapterType = this._targetAdapterTypeSelector.get("value");
            var description = this.portFuncDesc.get("value").trim();
            portPhysicalFunctionTemplateObj.description = this.encodeSpecialCharacters(description);
            portPhysicalFunctionTemplateObj.userDefined = true;
            portPhysicalFunctionTemplateObj.physicalFunction = this._targetPortPhysicalFunctionTypeSelector.get("value");
            if (this._targetPortPhysicalFunctionTypeSelector.get("value") == "nic") {
                portPhysicalFunctionTemplateObj.vlanId = this.vlanchecklabelbutton.get("buttonState").toString();
            }
            var addressingMode = this._addressingModeSelector.get("value");
            if (addressingMode == "ba") {
                portPhysicalFunctionTemplateObj.ioAddressingMode = "burned";
            } else if (addressingMode == "va"){
                portPhysicalFunctionTemplateObj.ioAddressingMode = "virtual";
            }            
            if (this._ethernetaddresspoolrow.style.display != "none") {
                portPhysicalFunctionTemplateObj.macAddressPool = "IBM";
                portPhysicalFunctionTemplateObj.macAddressRange = this._ethernetAddressPoolRangeSelector.get("value");                
            }
            if (this._fibrechanneladdresspoolrow.style.display != "none") {
                portPhysicalFunctionTemplateObj.fcAddressPool = this._fibreChannelAddressPoolSelector.get("value");
                portPhysicalFunctionTemplateObj.fcAddressRange = this._fibreChannelAddressPoolRangeSelector.get("value");                
            }
            
            portPhysicalFunctionTemplateObj.id = this.templateIDNum;
            
            //console.log(this.declaredClass + ": ", dojo.toJson(portPhysicalFunctionTemplateObj));
            
            if (this.templateInUse) {

                this.rdstDialog.set("templateID", this.templateIDNum);
                this.rdstDialog.set("templateType", "Category");
                this.rdstDialog.set("templateData", dojo.toJson(portPhysicalFunctionTemplateObj));
                this.rdstDialog.show();
            
            } else {

                var templateidvalue = this.templateIDNum;
                var xhrArgs = {
                        url:  this.REST_PATH + "template/" + this.templateIDNum, //create?type=ppfunction",
                        handleAs: "json",
                        sync: true,
                        headers: {
                            "Content-Type": "application/json; charset=utf-8"
                        },
                        postData: dojo.toJson(portPhysicalFunctionTemplateObj),
                        load : function(data) {
                            //alert("post data: " + data);
                            dojo.publish("EditPortPhysicalFunctionTemplateComplete", {
                                id: templateidvalue
                            });     
                        },
                        error : function(error) {
                            alert(error);
                        }
                };
                
                dojo.xhrPut(xhrArgs);
            }            
            this.hide();
            this.dialogNode.destroy();
        },
        
        saveasClicked: function() {
            var portPhysicalFunctionTemplateObj = new Object();
            
            portPhysicalFunctionTemplateObj.id = "";
            portPhysicalFunctionTemplateObj.name = this.templateName.get("value").trim();
            portPhysicalFunctionTemplateObj.type = "PortPhysicalFunction";
            portPhysicalFunctionTemplateObj.adapterType = this._targetAdapterTypeSelector.get("value");
            var description = this.portFuncDesc.get("value").trim();
            portPhysicalFunctionTemplateObj.description = this.encodeSpecialCharacters(description);
            portPhysicalFunctionTemplateObj.userDefined = true;
            portPhysicalFunctionTemplateObj.physicalFunction = this._targetPortPhysicalFunctionTypeSelector.get("value");
            if (this._targetPortPhysicalFunctionTypeSelector.get("value") == "nic") {
                portPhysicalFunctionTemplateObj.vlanId = this.vlanchecklabelbutton.get("buttonState").toString();
            }
            var addressingMode = this._addressingModeSelector.get("value");
            if (addressingMode == "ba") {
                portPhysicalFunctionTemplateObj.ioAddressingMode = "burned";
            } else if (addressingMode == "va"){
                portPhysicalFunctionTemplateObj.ioAddressingMode = "virtual";
            }           
            if (this._ethernetaddresspoolrow.style.display != "none") {
                portPhysicalFunctionTemplateObj.macAddressPool = "IBM";
                portPhysicalFunctionTemplateObj.macAddressRange = this._ethernetAddressPoolRangeSelector.get("value");                
            }
            if (this._fibrechanneladdresspoolrow.style.display != "none") {
                portPhysicalFunctionTemplateObj.fcAddressPool = this._fibreChannelAddressPoolSelector.get("value");
                portPhysicalFunctionTemplateObj.fcAddressRange = this._fibreChannelAddressPoolRangeSelector.get("value");                
            }
            
            //console.log(this.declaredClass + ": ", dojo.toJson(portPhysicalFunctionTemplateObj));
            
            this.saveasDialog.set("templateObject", portPhysicalFunctionTemplateObj);
            this.saveasDialog.show();            
        },
        
        _setup: function(){
            //Set Information Messages and Load Previous Settings          
            if(this.templateIDNum != null && this.templateMode == "edit"){     //if dialog in edit mode    
                                
                if(this.templateInUse.toString() == "true"){
                
                    if(this.templateLaunchPoint == "table"){
                        
                        this.warningMessage.style.display = "block";
                        this.warningMessageText.innerHTML = this.resources.INUSE;
                        this.saveBtnContainer.style.display = "inline";
                        this.saveasBtnContainer.style.display = "inline";
                        
                    }else if(this.templateLaunchPoint == "wizard"){
                        
                        this.informationMessage.style.display = "block";
                        this.informationMessageText.innerHTML = this.resources.INUSEWIZARD;
                        this.saveasBtnContainer.style.display = "inline";
                        
                    }else{
                        this.informationMessage.style.display = "block";
                        this.informationMessageText.innerHTML = this.resources.INUSEWIZARD;
                        this.saveasBtnContainer.style.display = "inline";
                    }
                    
                }else{
                    
                    this.saveBtnContainer.style.display = "inline";
                    this.saveasBtnContainer.style.display = "inline";
                                        
                }    

                this.templateName.set("disabled",true);
                
             }else if(this.templateIDNum != null && this.templateMode == "copy"){    //if dialog in copy mode     
                 
          //       this.loadprevSettings();
                 this.templateIDNum = null;  //set template ID to null in order to create new template
                 this.okBtnContainer.style.display = "inline";

             }else{     //if dialog in create new mode
                 
                 this.okBtnContainer.style.display = "inline";
             } 
        },         
        
        exitParent: function() {
            dojo.publish("EditPortPhysicalFunctionTemplateComplete", {
                id: this.templateIDNum
            });
            if (this.rdstDialog.get("closeParent")) {
                this.hide();
            }
        },       
        
        _validateVlanId: function() {
            //1.  Read the port virtualization templates from the services
            
            var portVirtualizationTemplateData = null;
            var xhrPortVirtTemp = {
                url: this.REST_PATH + "template/list/portvirtual",
                handleAs: "json",
                sync: true,
                headers: {
                    "Content-Type": "application/json; charset=utf-8"
                },
                load: function(data) {
                    portVirtualizationTemplateData = data;
                },
                error: function(error) {
                    alert(error);
                }
            };

            // Call the asynchronous xhrGet
            dojo.xhrGet(xhrPortVirtTemp);            
                        
            this._defaultPortVirtualizationTemplateStore = new dojox.data.AndOrReadStore({
                data: portVirtualizationTemplateData
            });
            
            //2.  Loop through the templates to find a vport associated with this template
            var currentvlan = this.vlanchecklabelbutton.get("buttonState").toString();
            var vlanmatchArray = new Array();
            //Loop through all the port virtualization templates
            for (var portvirtcount=0;portvirtcount < portVirtualizationTemplateData.items.length;++portvirtcount) {                
                //Loop through the vports within this template
                for (var vportcount=0;vportcount < portVirtualizationTemplateData.items[portvirtcount].vports.length;++vportcount) {                    
                    //Find a match for this current template
                    if (portVirtualizationTemplateData.items[portvirtcount].vports[vportcount].templateId == this.templateIDNum) {                        
                        //This port virtualization template references the current port physical function template
                        var matchingoffset = vportcount;
                        //Loop back through and read in the port physical function templates
                        for (var vportcount2=0;vportcount2 < portVirtualizationTemplateData.items[portvirtcount].vports.length;++vportcount2) {
                            if (vportcount2 == matchingoffset) {
                                continue;
                            }
                            var portPhysicalFunctionTemplateData = null;
                            var xhrPortPhyFuncTemp = {
                                url: this.REST_PATH + "template/" + portVirtualizationTemplateData.items[portvirtcount].vports[vportcount2].templateId, //list/ppfunction",
                                handleAs: "json",
                                sync: true,
                                headers: {
                                    "Content-Type": "application/json; charset=utf-8"
                                },
                                load: function(data) {
                                    portPhysicalFunctionTemplateData = data;
                                },
                                error: function(error) {
                                    alert(error);
                                }
                            };

                            // Call the asynchronous xhrGet
                            dojo.xhrGet(xhrPortPhyFuncTemp);
                                                        
                            if (portPhysicalFunctionTemplateData.items[0].vlanId == currentvlan && currentvlan != 0) {
                                //Found a matching vlan within this port virtualization template
                                //Add it to the array                            
                                vlanmatchArray.push(portVirtualizationTemplateData.items[portvirtcount].name);
                                break;
                            }
                        }
                        break;
                    }
                }
            }
            
            return vlanmatchArray;
        },
        
        _cancelDialog: function() {
            this.hide();
            this.dialogNode.destroy();            
        }        
    });
});
