define([
        "dojo",
        "dijit",
        "support/dialogs/Dialog",
        "dojo/i18n!./nls/PXENetworkBootTargetTemplate",
        "dojo/text!./templates/PXENetworkBootTargetTemplate.html",
        "dijit/form/SimpleTextarea",
        "dijit/form/CheckBox",
        "dijit/form/Button",
        "dijit/form/ComboBox",
        "dijit/form/TimeTextBox",
        "dijit/Dialog",
        "dojo/parser",
        "dijit/form/ValidationTextBox",
        "support/dialogs/ReDeployServerTemplate",
        "dijit/Tooltip",
        "dijit/layout/BorderContainer",
        "dijit/layout/ContentPane",
        "support/dialogs/SaveAs",
        "support/dialogs/ProgressDialog"
    ], function(dojo, dijit, dialog,mri, template) {

    return dojo.declare("support.dialogs.PXENetworkBootTargetTemplate", [ support.dialogs.Dialog], {

        // templateString: [protected] String
        // This widget's HTML template, provided.
        templateString: template,
            
        // locResources: [protected] Object
        // This widget's National Language Source (NLS) object.
        locResources: mri, 
        
        templateIDNum: null,      
        pvlanVar: null,
        svlanVar: null,
        okButton: null,
        store: "",
        
        // the name of the CSS stylesheet of this page
        spCssPathAndName: "support/dialogs/themes/PXENetworkBootTargetTemplate.css",

        postMixInProperties: function() {
            this.inherited(arguments);
        },
        postCreate: function() {

            this.inherited(arguments);

            dojo.connect(this.dialogNode, "hide", this, function() {        
                this.dialogNode.destroy();
            });

            //Setup for template new, edit, or copy mode 
            this._setup();
                      
            //Resizes dialog
            this.layout();                                                

        },
        loadprevSettings: function() {
            var widget = this;
            var mode = this.templateMode;
            var locResources = this.locResources;
            var resources = this.resources;
            var inUse = false;
            var templatename = this.templateName;
            var templatedescription = this.description;
            var templatepvlan = this.pxepvlan;
            var templatesvlan = this.pxesvlan;
            var dialogNode = this.dialogNode;
            //var warningMessage = this.warningMessage;

            var xhrGet = dojo.xhrGet({
                url: this.REST_PATH + "template/"+this.templateIDNum,
                handleAs: "json",
                sync: true,
                preventCache: true,
                load: function(response) {
                    this.store = response; 
                    //alert(this.store.items[0].name);
                },
                handle: function(){
                 // Set dialog title to reflect Editing and display the warning message
                    //warningMessage.style.display = "block";

                    inUse = this.store.items[0].inUse;

                    if(mode == "copy"){
                        dialogNode.set("title", locResources.Title + " - " + this.store.items[0].name + " - " + resources.COPY);
                        templatename.set("value", this.store.items[0].name + " - " + resources.COPY);
                    }else{
                        dialogNode.set("title", locResources.EditTitle + " - " + this.store.items[0].name);
                        templatename.set("value", this.store.items[0].name);
                    }
                    
                 
                    //templatename.set("value", this.store.items[0].name);

                    var descriptionvalue = widget.decodeSpecialCharacters(this.store.items[0].description);
                    templatedescription.set("value", descriptionvalue);
                    
                    templatepvlan.set("value", this.store.items[0].pxepvlan);

                    templatesvlan.set("value", this.store.items[0].pxesvlan);

                }
                
            });

            this.templateInUse = inUse;

            return this.templateName.get("value").trim();  // returns templates current name
            
        },
        exitParent: function() {
            var data = "pxe";
            
            dojo.publish("PXEBootTemplateComplete", data);

            if(this.rdstDialog != null){
                var deployClicked = this.rdstDialog.get("closeParent");
                if(deployClicked) {
                    this.hide();
                }
            }
        },
        cancelClicked: function() {
            this.hide();
        },
        createClicked: function() {

            var templateObject = new Object();

            var templatename = this.templateName;
            var namevalue = templatename.get("value").trim();
            templateObject.name = namevalue;
      
            templateObject.type = "PXE";
                        
            var templatedescription = this.description;
            var descriptionvalue = templatedescription.get("value").trim();
            templateObject.description = this.encodeSpecialCharacters(descriptionvalue);

            var templatepvlan = this.pxepvlan;
            var pvlanvalue = templatepvlan.get("value").trim();
            templateObject.pxepvlan = pvlanvalue;

            var templatesvlan = this.pxesvlan;
            var svlanvalue = templatesvlan.get("value").trim();
            templateObject.pxesvlan = svlanvalue;

            var argJSONString = dojo.toJson({ 
                "identifier":"id",
                  "label":"name",
                  "items":[ templateObject ]
            }, true);

            //alert(argJSONString);
            this.getProgressDialog("save").show(); // Show progress dialog for save request.
                    var xhrPost = dojo.xhrPost({
                        url: this.REST_PATH + "template/create",
                        handleAs: "json", // <<<< Required
                        headers: {
                            "Content-Type": "application/json; charset=utf-8" // <<<< Required
                        },
                        postData: argJSONString,     //Template Data to Post
                        load: dojo.hitch(this, function(response, ioArgs) {
                            // Happy path! We received a 2xx status code from the API.
                                                    
                            dojo.publish("ProgressComplete", response.id);
                            dojo.publish("PXEBootTemplateComplete", response.id);
                            this.hide();
                        }),
                        error: dojo.hitch(this, function(error, ioArgs) {
                            // Failure path! We received a non-2xx status code (ie: 3xx/4xx/5xx status code) from the API.

                            dojo.publish("ProgressFailed", error);
                            console.log(this.declaredClass + ": ", error, ioArgs);
                            
                            var response = dojo.fromJson(ioArgs.xhr.responseText);
                            if ((ioArgs.xhr.status >= 400) && (response.message == "service_error_name_in_use")) {
                                // Error Template name in use
                                this.getModalDialog("Error", this.resources.ERROR_400_NAME).show();
                            }
                            else if(ioArgs.xhr.status == 404) {
                                // Edit Template ID doesn't exist
                                this.getModalDialog("Error", this.resources.ERROR_404_ID).show();
                                this.hide();
                            }
                            else if(ioArgs.xhr.status >= 500) {
                                // Internal Programming Error
                                this.getModalDialog("Error", this.resources.ERROR_500_INTERNAL).show();
                                this.hide();
                            }
                            else {
                                this.getModalDialog("Error", this.resources.ERROR_TEMPLATE_CREATE).show();
                                this.hide();
                            }
                            
                        }),
                        handle: dojo.hitch(this, function(data, ioArgs) {
                            // - The 1st param ("data") is either the response data (on success) or Error object (on failure).
                            // - The 2nd param ("ioArgs") contains detail about the xhr request, including a reference to the
                            // native xhr object. Check ioArgs.xhr.status to determine success or failure, and handle "data"
                            // accordingly.
                        })
                    });

                   // this.clearprevSettings();                                  
        },
        saveClicked: function() {

            var templateObject = new Object();

            var templatename = this.templateName;
            var namevalue = templatename.get("value").trim();
            templateObject.name = namevalue;
            
            templateObject.id = this.templateIDNum;
            
            templateObject.type = "PXE";
                        
            var templatedescription = this.description;
            var descriptionvalue = templatedescription.get("value").trim();
            templateObject.description = this.encodeSpecialCharacters(descriptionvalue);

            var templatepvlan = this.pxepvlan;
            var pvlanvalue = templatepvlan.get("value").trim();
            templateObject.pxepvlan = pvlanvalue;

            var templatesvlan = this.pxesvlan;
            var svlanvalue = templatesvlan.get("value").trim();
            templateObject.pxesvlan = svlanvalue;

            var argJSONString = dojo.toJson({ 
                "identifier":"id",
                  "label":"name",
                  "items":[ templateObject ]
            }, true);

            //alert(argJSONString);
            
            if(this.templateInUse.toString() == "true"){

                this.rdstDialog.set("templateID",this.templateIDNum);
                this.rdstDialog.set("templateType","Category");
                this.rdstDialog.set("templateData",argJSONString);

                this.rdstDialog.show();

            }else{
                this.getProgressDialog("save").show(); // Show progress dialog for save request.
                    var xhrPost = dojo.xhrPost({
                        url: this.REST_PATH + "template/create",
                        handleAs: "json", // <<<< Required
                        headers: {
                            "Content-Type": "application/json; charset=utf-8" // <<<< Required
                        },
                        postData: argJSONString,     //Template Data to Post
                        load: dojo.hitch(this, function(response, ioArgs) {
                            // Happy path! We received a 2xx status code from the API.
                                                    
                            dojo.publish("ProgressComplete", response.id);
                            dojo.publish("PXEBootTemplateComplete", response.id);
                            this.hide();
                        }),
                        error: dojo.hitch(this, function(error, ioArgs) {
                            // Failure path! We received a non-2xx status code (ie: 3xx/4xx/5xx status code) from the API.

                            dojo.publish("ProgressFailed", error);
                            console.log(this.declaredClass + ": ", error, ioArgs);
                            
                            var response = dojo.fromJson(ioArgs.xhr.responseText);
                            if ((ioArgs.xhr.status >= 400) && (response.message == "service_error_name_in_use")) {
                                // Error Template name in use
                                this.getModalDialog("Error", this.resources.ERROR_400_NAME).show();
                            }
                            else if(ioArgs.xhr.status == 404) {
                                // Edit Template ID doesn't exist
                                this.getModalDialog("Error", this.resources.ERROR_404_ID).show();
                                this.hide();
                            }
                            else if(ioArgs.xhr.status >= 500) {
                                // Internal Programming Error
                                this.getModalDialog("Error", this.resources.ERROR_500_INTERNAL).show();
                                this.hide();
                            }
                            else {
                                this.getModalDialog("Error", this.resources.ERROR_TEMPLATE_CREATE).show();
                                this.hide();
                            }
                            
                        }),
                        handle: dojo.hitch(this, function(data, ioArgs) {
                            // - The 1st param ("data") is either the response data (on success) or Error object (on failure).
                            // - The 2nd param ("ioArgs") contains detail about the xhr request, including a reference to the
                            // native xhr object. Check ioArgs.xhr.status to determine success or failure, and handle "data"
                            // accordingly.
                        })
                    });

            }

        },
        saveasClicked: function() {      

            var templateObject = new Object();

            var templatename = this.templateName;
            var namevalue = templatename.get("value").trim();
            templateObject.name = namevalue;
            
            templateObject.type = "PXE";
                        
            var templatedescription = this.description;
            var descriptionvalue = templatedescription.get("value").trim();
            templateObject.description = this.encodeSpecialCharacters(descriptionvalue);

            var templatepvlan = this.pxepvlan;
            var pvlanvalue = templatepvlan.get("value").trim();
            templateObject.pxepvlan = pvlanvalue;

            var templatesvlan = this.pxesvlan;
            var svlanvalue = templatesvlan.get("value").trim();
            templateObject.pxesvlan = svlanvalue;

            this.saveasDialog.set("templateObject",templateObject);
            this.saveasDialog.show();
            
        },        
        _nameChanged: function() {                        

            if (this.templateName.validate() && this.pxepvlan.validate() && this.pxesvlan.validate()) {
                this.okBtn.set("disabled",false);
            }else {
                this.okBtn.set("disabled", true);                           
            }
            
        },
        _setup: function(){

            //Set Template Field to catch intermediate changes
            this.templateName.intermediateChanges = true;

            this.pxepvlan.intermediateChanges = true;

            this.pxesvlan.intermediateChanges = true;
   
            //Sets Range labels
            this.range1.innerHTML = this.locResources.Range.replace("%1", "1").replace("%2","4094");
            this.range2.innerHTML = this.locResources.Range.replace("%1", "1").replace("%2","4094");

            // Set Description Label
            this._descLimit.innerHTML = this.resources.LIMIT.replace("%500","500");

            //Set Information Messages and Load Previous Settings                      
            if(this.templateIDNum != null && this.templateMode == "edit"){     //if dialog in edit mode    

                this.loadprevSettings();

                if(this.templateInUse.toString() == "true"){
                
                    if(this.templateLaunchPoint == "table"){
                        
                        this.warningMessage.style.display = "block";
                        this.warningMessageText.innerHTML = this.resources.INUSE;
                        this.saveBtnContainer.style.display = "inline";
                        this.saveasBtnContainer.style.display = "inline";
                        
                    }else if(this.templateLaunchPoint == "wizard"){
                        
                        this.informationMessage.style.display = "block";
                        this.informationMessageText.innerHTML = this.resources.INUSEWIZARD;
                        this.saveasBtnContainer.style.display = "inline";
                        
                    }else{
                        this.informationMessage.style.display = "block";
                        this.informationMessageText.innerHTML = this.resources.INUSEWIZARD;
                        this.saveasBtnContainer.style.display = "inline";
                    }
                    
                }else{
                    
                    this.saveBtnContainer.style.display = "inline";
                    this.saveasBtnContainer.style.display = "inline";
                                        
                }    

                this.templateName.set("disabled",true);
                


             }else if(this.templateIDNum != null && this.templateMode == "copy"){    //if dialog in copy mode     
                 
                 this.loadprevSettings();
                 this.templateIDNum = null;  //set template ID to null in order to create new template
                 this.okBtnContainer.style.display = "inline";

             }else{     //if dialog in create new mode
                 
                 this.okBtnContainer.style.display = "inline";
                 
             } 

        }


    });
});