define([ "dojo", 
         "dijit", 
         "support/dialogs/Dialog",
         "dojo/i18n!./nls/PerformanceAndRecoveryTemplate",
         "dojo/text!./templates/PerformanceAndRecoveryTemplate.html",
         "dijit/form/SimpleTextarea",
         "dijit/form/RadioButton", 
         "dijit/form/Select", 
         "dijit/form/TimeTextBox", 
         "dijit/Dialog", 
         "dojo/parser",
         "support/widgets/ToggleButton",
         "support/widgets/ButtonBar", 
         "dijit/layout/BorderContainer", 
         "dijit/layout/ContentPane", 
         "dijit/Tooltip",
         "support/panels/CheckButton",
         "support/dialogs/ReDeployServerTemplate",
         "support/dialogs/SaveAs",
         "support/dialogs/ProgressDialog"], function(dojo, dijit, dialog, mri, template) {

    return dojo.declare("support.dialogs.PerformanceAndRecoveryTemplate", [ support.dialogs.Dialog], {

        // templateString: [protected] String
        // This widget's HTML template, provided.
        templateString: template,
            
        // locResources: [protected] Object
        // This widget's National Language Source (NLS) object.
        locResources: mri, 
        
        // baseClass: [protected] String
        // The root CSS className to be placed on this widget's domNode.
        baseClass: "PerformanceAndRecoveryTemplate",
        
        repeatVar: null,
        maxPercent: .40,
        mycheckVar: null,
        hidecheckVar: null,
        store: "",
        templateIDNum: null,
        initialData: null,
        
        buttonBar1_1: null,

        // the name of the CSS stylesheet of this page
        spCssPathAndName: "support/dialogs/themes/PerformanceAndRecoveryTemplate.css",

        // When this method is called, all variables inherited from superclasses are "mixed in".
        // Common operations for postMixInProperties
        // 1) Modify or assign values for widget property variables defined in the template HTML
        // file
        postMixInProperties: function() {
            this.inherited(arguments);
        },

        // postCreate() is called after buildRendering(). This is useful to override when
        // you need to access and/or manipulate DOM nodes included with your widget.
        // DOM nodes and widgets with the dojoAttachPoint attribute specified can now be directly
        // accessed as fields on "this".
        // Common operations for postCreate
        // 1) Access and manipulate DOM nodes created in buildRendering()
        // 2) Add new DOM nodes or widgets
        postCreate: function() {
            
            this.inherited(arguments);
            
            // Create the button bar
            this.buttonBar1_1 = new support.widgets.ButtonBar({
                values: "Custom|Predefined",
                labels: this.locResources.Buttonbar                    
            }).placeAt(this.buttonBar1_1div);

            dojo.connect(this.dialogNode, "hide", this, function() {        
                this.destroy();
            });


            //Setup for template new, edit, or copy mode 
            this._setup();
                    
            //Controls dialog dynamic resizing max height 
//            var availHeight = window.screen.availHeight;
  //          var maxHeight = availHeight * this.maxPercent;
    //        this.settingsContainer.setAttribute("style", "max-height:" + maxHeight + "px");

            dojo.connect(this.buttonBar1_1, "onClick", this,
                    function() {
                        this.togglesettingsBorder1_1();
                    });
            dojo.connect(this.buttonBar1_1, "onButtonClick", this,
                    function() {
                        this.togglesettingsBorder1_1();
                });

            dojo.connect(this.maxperformance, "onClick", this,
                    function() {

                        if(this.buttonBar1_1.get("selected") == "Predefined"){
                            this.qpiCombobox.set("value","Max Performance");
                            this.speedplanCombobox.set("value","Max Performance");
                            this.qpiCombobox.set("disabled",true);
                            this.speedplanCombobox.set("disabled",true);
                        }else{
                            this.qpiCombobox.set("disabled",false);
                            this.speedplanCombobox.set("disabled",false);
                        }
                
                });
            dojo.connect(this.effperformance, "onClick", this,
                    function() {
                        if(this.buttonBar1_1.get("selected") == "Predefined"){
                            this.qpiCombobox.set("value","Max Performance");
                            this.speedplanCombobox.set("value","Max Performance");
                            this.qpiCombobox.set("disabled",true);
                            this.speedplanCombobox.set("disabled",true);
                        }else{
                            this.qpiCombobox.set("disabled",false);
                            this.speedplanCombobox.set("disabled",false);
                        }
                });
            dojo.connect(this.effpowersavings, "onClick", this,
                    function() {
                        if(this.buttonBar1_1.get("selected") == "Predefined"){
                            this.qpiCombobox.set("value","Minimal Power");
                            this.speedplanCombobox.set("value","Balanced");
                            this.qpiCombobox.set("disabled",true);
                            this.speedplanCombobox.set("disabled",true);
                        }else{
                            this.qpiCombobox.set("disabled",false);
                            this.speedplanCombobox.set("disabled",false);
                        }
            });
            dojo.connect(this.minpower, "onClick", this,
                    function() {
                        if(this.buttonBar1_1.get("selected") == "Predefined"){
                            this.qpiCombobox.set("value","Minimal Power");
                            this.speedplanCombobox.set("value","Minimal Power");
                            this.qpiCombobox.set("disabled",true);
                            this.speedplanCombobox.set("disabled",true);
                        }else{
                            this.qpiCombobox.set("disabled",false);
                            this.speedplanCombobox.set("disabled",false);
                        }
            });
            
            this.layout();

        },
        toggle1: function(){
            
            if(this.mycheck1.get("checked") == true){
                this.settingsSelectionArea1.style.display = "block";
                this.settingsButton1_1.style.display = "inline";
                this.togglesettingsBorder1_1();
            }else{
                this.settingsSelectionArea1.style.display = "none";
                this.settingsButton1_1.style.display = "none";
                this.settingsBorder1_1.style.display = "none";
            }
            
            this._setExpandCollapseIcon();   
            this.layout();

        },
        togglesettingsBorder1_1: function(){
            
            if(this.buttonBar1_1.get("selected") == "Predefined" ){
                this.settingsBorder1_1.style.display = "inline-block";
                this.settingsBorder1_2.style.display = "none";              
                this.togglePredefinedSettings();    
            }else{
                this.settingsBorder1_1.style.display = "none";
                this.settingsBorder1_2.style.display = "inline-block";
                this.qpiCombobox.set("disabled",false);
                this.speedplanCombobox.set("disabled",false);
            }
            this.layout();

        },
        togglePredefinedSettings: function(){
            
            if(this.maxperformance.get("checked") == true){
                this.qpiCombobox.set("value","Max Performance");
                this.speedplanCombobox.set("value","Max Performance");              
            }else if(this.effperformance.get("checked") == true){
                this.qpiCombobox.set("value","Max Performance");
                this.speedplanCombobox.set("value","Max Performance");                              
            }else if(this.effpowersavings.get("checked") == true){
                this.qpiCombobox.set("value","Minimal Power");
                this.speedplanCombobox.set("value","Balanced");             
            }else if(this.minpower.get("checked") == true){
                this.qpiCombobox.set("value","Minimal Power");
                this.speedplanCombobox.set("value","Minimal Power");                
            }
 
            this.toggle2();
            this.toggle3();
            
            this.qpiCombobox.set("disabled",true);
            this.speedplanCombobox.set("disabled",true);
            this.layout();

        },
        toggle2: function(){

            if(this.mycheck2.get("checked") == true){
                this.settingsSelectionArea2.style.display = "block";
                this.settingsButton2_1.style.display = "inline";
                this.settingsButton2_2.style.display = "inline";
            }else{
                this.settingsSelectionArea2.style.display = "none";
                this.settingsButton2_1.style.display = "none";
                this.settingsButton2_2.style.display = "none";                
            }
            
            this._setExpandCollapseIcon();
            this.layout();

        },
        toggle3: function(){

            if(this.mycheck3.get("checked") == true){
                this.settingsSelectionArea3.style.display = "block";
                this.settingsButton3_1.style.display = "inline";
                this.settingsButton3_2.style.display = "inline";                
                this.settingsButton3_3.style.display = "inline";                
                this.settingsButton3_4.style.display = "inline";                
            }else{
                this.settingsSelectionArea3.style.display = "none";
                this.settingsButton3_1.style.display = "none";
                this.settingsButton3_2.style.display = "none";
                this.settingsButton3_3.style.display = "none";
                this.settingsButton3_4.style.display = "none";
            }
            
            this._setExpandCollapseIcon();
            this.layout();

        },
        toggle6: function(){

            if(this.mycheck6.get("checked") == true){
                this.settingsSelectionArea6.style.display = "block";
                this.settingsButton6_1.style.display = "inline";
                this.settingsButton6_2.style.display = "inline";
                this.settingsButton6_3.style.display = "inline";
                this.settingsButton6_4.style.display = "inline";
                this.settingsButton6_5.style.display = "inline";
                this.settingsButton6_6.style.display = "inline";
                this.settingsButton6_7.style.display = "inline";                
            }else{
                this.settingsSelectionArea6.style.display = "none";
                this.settingsButton6_1.style.display = "none";
                this.settingsButton6_2.style.display = "none";               
                this.settingsButton6_3.style.display = "none";               
                this.settingsButton6_4.style.display = "none";               
                this.settingsButton6_5.style.display = "none";               
                this.settingsButton6_6.style.display = "none";               
                this.settingsButton6_7.style.display = "none";               
            }
            
            this._setExpandCollapseIcon();
            this.layout();

        },  
        togglesettingsBorder6_1: function(){

            var buttonvalue = this.togglebutton6_1.get("enabled");

            if (buttonvalue == true) {
                this.settingsBorder6_1.style.display = "inline-block";                          
            }else {
                this.settingsBorder6_1.style.display = "none";                              
            }
            this.layout();

        },
        togglesettingsBorder6_2: function(){

            var buttonvalue = this.togglebutton6_2.get("enabled");

            if (buttonvalue == true) {
                this.settingsBorder6_2.style.display = "inline-block";                          
            }else {
                this.settingsBorder6_2.style.display = "none";                              
            }
            
            this.layout();

        },  
        togglesettingsBorder6_3: function(){

            var buttonvalue = this.togglebutton6_3.get("enabled");

            if (buttonvalue == true) {
                this.settingsBorder6_3.style.display = "inline-block";                          
            }else {
                this.settingsBorder6_3.style.display = "none";                              
            }
            
            this.layout();

        },  
        togglesettingsBorder6_6: function(){

            var buttonvalue = this.togglebutton6_6.get("enabled");

            if (buttonvalue == true) {
                this.settingsBorder6_6.style.display = "inline-block";                          
            }else {
                this.settingsBorder6_6.style.display = "none";                              
            }
            
            this.layout();

        },
        _checkExpandCollapseState: function() {
            var mycheck1BoxState = this.mycheck1.get("value");
            var mycheck2BoxState = this.mycheck2.get("value");
            var mycheck3BoxState = this.mycheck3.get("value");
            var mycheck6BoxState = this.mycheck6.get("value");
         
            /* value on = checked, false = unchecked */

            if (mycheck1BoxState == "on" && mycheck2BoxState == "on" && mycheck3BoxState == "on" && mycheck6BoxState == "on") {
                return "allon";
            }
            if (mycheck1BoxState == false && mycheck2BoxState == false && mycheck3BoxState == false && mycheck6BoxState == false) {
                return "alloff";
            }

            this.layout();

            return "mixed";
        },

        _setExpandCollapseIcon: function() {
            if (this._checkExpandCollapseState() == "mixed") {
                this.expandall.style.display = "none";
                this.collapseall.style.display = "none";
                this.mixedexpandcollapse.style.display = "inline";
            }
            if (this._checkExpandCollapseState() == "allon") {
                this.expandall.style.display = "none";
                this.collapseall.style.display = "inline";
                this.mixedexpandcollapse.style.display = "none";
            }
            if (this._checkExpandCollapseState() == "alloff") {
                this.expandall.style.display = "inline";
                this.collapseall.style.display = "none";
                this.mixedexpandcollapse.style.display = "none";
            }
            this.layout();

        },

        hideunchecked2: function() {

          var checkvalue = this.hideunchecked.get("checked");
          var buttonvalue2_1 = this.togglebutton2_1.get("enabled"); //Hyper Threading
          var combobox2_2 = this.qpiCombobox.get("value");  
          var combobox3_1 = this.speedplanCombobox.get("value");
          var combobox3_2 = this.channelmodeCombobox.get("value");
          var combobox3_3 = this.socketinterCombobox.get("value");
          var buttonvalue3_4 = this.togglebutton3_4.get("enabled");   //Patrol Scrub
          var buttonvalue6_5 = this.togglebutton6_5.get("enabled");   //Reboot system on NMI
          var buttonvalue6_4 = this.togglebutton6_4.get("enabled");   //LAN over USB

          var buttonvalue6_1 = this.togglebutton6_1.get("enabled");   //
          var buttonvalue6_2 = this.togglebutton6_2.get("enabled");   //
          var buttonvalue6_3 = this.togglebutton6_3.get("enabled");   //
          var buttonvalue6_6 = this.togglebutton6_6.get("enabled");   //
          var buttonvalue6_7 = this.togglebutton6_7.get("enabled");   //


          if(checkvalue == true) {

              if(this.buttonBar1_1.get("selected") == "Predefined" && this.maxperformance.get("checked") == true){                                   
                  this.mygroup1_1.style.display = "none";                 
              }    
          
              if(buttonvalue2_1 == true){
                  this.mygroup2_1.style.display = "none";                 
              }
              
              if(combobox2_2 == "Maximum Performance"){
                  this.mygroup2_2.style.display = "none";                 
              }

              if(combobox3_1 == "Maximum Performance"){
                  this.mygroup3_1.style.display = "none";                 
              }

              if(combobox3_2 == "Independent"){
                  this.mygroup3_2.style.display = "none";                 
              }

              if(combobox3_3 == "NUMA"){
                  this.mygroup3_3.style.display = "none";                 
              }
              
              if(buttonvalue3_4 == true){
                  this.mygroup3_4.style.display = "none";                 
              }
              
              
              
              if(buttonvalue6_5 == true){
                  this.mygroup6_5.style.display = "none";                 
              }
              
              if(buttonvalue6_4 == true){
                  this.mygroup6_4.style.display = "none";                 
              }

              if(buttonvalue6_1 == false){
                  this.mygroup6_1.style.display = "none";                 
              }

              if(buttonvalue6_2 == false){
                  this.mygroup6_2.style.display = "none";                 
              }

              if(buttonvalue6_3 == false){
                  this.mygroup6_3.style.display = "none";                 
              }

              if(buttonvalue6_6 == false){
                  this.mygroup6_6.style.display = "none";                 
              }

              if(buttonvalue6_7 == false){
                  this.mygroup6_7.style.display = "none";                 
              }

          }else {
              this.mygroup1_1.style.display = "table";                 
              this.mygroup2_1.style.display = "table";                 
              this.mygroup2_2.style.display = "table";                 
              this.mygroup3_1.style.display = "table";                 
              this.mygroup3_2.style.display = "table";                 
              this.mygroup3_3.style.display = "table";                 
              this.mygroup3_4.style.display = "table";                 
              this.mygroup6_4.style.display = "table";                 
              this.mygroup6_1.style.display = "table";                 
              this.mygroup6_2.style.display = "table";                 
              this.mygroup6_3.style.display = "table";                 
              this.mygroup6_6.style.display = "table";                 
              this.mygroup6_7.style.display = "table";                 
              this.mygroup6_5.style.display = "table";                 

          }
          this.layout();

        },
        cancelClicked: function() {
            this.hide();
        },
        createClicked: function() {

            var templateObject = new Object();
            
            var namevalue = this.templateName.get("value").trim();
            templateObject.name = namevalue;
                             
            templateObject.type = "PerformanceRecovery";
            
            var descriptionvalue = this.description.get("value").trim();
            templateObject.description = this.encodeSpecialCharacters(descriptionvalue);

         // Operating Mode
            var settings1Object = new Object();

            settings1Object.setoperatingmodes = true;

            var checkvalue1 = this.mycheck1.get("value");
            settings1Object.checkvalue1 = checkvalue1;

            var buttonBar1_1 = this.buttonBar1_1.get("selected");
            settings1Object.buttonBar1_1 = buttonBar1_1;
            
            if(this.buttonBar1_1.get("selected") == "Predefined"){
          
                if(this.maxperformance.get("checked") == true){
                    settings1Object.opModeSelection = "Maximum Performance";                    
                }else if(this.effperformance.get("checked") == true){
                    settings1Object.opModeSelection = "Efficiency - Favor Performance";                            
                }else if(this.effpowersavings.get("checked") == true){
                    settings1Object.opModeSelection = "Efficiency - Favor Power";                                        
                }else if(this.minpower.get("checked") == true){
                    settings1Object.opModeSelection = "Minimal Power";                                        
                }

            }

            if(this.buttonBar1_1.get("selected") == "Custom"){

                settings1Object.opModeSelection = "Custom Mode";                    
            }
            
            templateObject.operating_mode = settings1Object;

         // Processors
            var settings2Object = new Object();

            settings2Object.setprocessors = true;

            var checkvalue2 = this.mycheck2.get("value");
            settings2Object.checkvalue2 = checkvalue2;

                //Hyper Threading
            var buttonvalue2_1 = this.togglebutton2_1.get("enabled");
            
            if(buttonvalue2_1 == true){                            
                settings2Object.buttonvalue2_1 = "Enable";
            }else{
                settings2Object.buttonvalue2_1 = "Disable";                
            }
                //QPI link frequency plan
            var combobox2_2 = this.qpiCombobox.get("value");
            settings2Object.combobox2_2 = combobox2_2;

            templateObject.processors = settings2Object;
            
         // Memory
            var settings3Object = new Object();
            settings3Object.setmemory = true;
            
            var checkvalue3 = this.mycheck3.get("value");
            settings3Object.checkvalue3 = checkvalue3;
            
                //Speed plan
            var combobox3_1 = this.speedplanCombobox.get("value");
            settings3Object.combobox3_1 = combobox3_1;
            
                //Channel mode
            var combobox3_2 = this.channelmodeCombobox.get("value");
            settings3Object.combobox3_2 = combobox3_2;

                //Socket interleave
            var combobox3_3 = this.socketinterCombobox.get("value");
            settings3Object.combobox3_3 = combobox3_3;

                //Patrol scrub
            var buttonvalue3_4 = this.togglebutton3_4.get("enabled");
            
            if(buttonvalue3_4 == true){                            
                settings3Object.buttonvalue3_4 = "Enable";
            }else{
                settings3Object.buttonvalue3_4 = "Disable";
            }

            

            templateObject.memory = settings3Object;


         // Timer and related options
            var settings6Object = new Object();
            settings6Object.setrecovery = true;
            
            var checkvalue6 = this.mycheck6.get("value");
            settings6Object.checkvalue6 = checkvalue6;

                //POST watchdog timer
            var buttonvalue6_1 = this.togglebutton6_1.get("enabled");
            
            if(buttonvalue6_1 == true){                            
                settings6Object.buttonvalue6_1 = "Enable";
                
                var combobox6_1 = this.timeComboBox1.get("value");
                settings6Object.combobox6_1 = combobox6_1;

            }else{
                settings6Object.buttonvalue6_1 = "Disable";
               // settings6Object.combobox6_1 = "disabled";
                                
            }


                //LOADER watchdog timer
            var buttonvalue6_2 = this.togglebutton6_2.get("enabled");
            settings6Object.buttonvalue6_2 = buttonvalue6_2;

            if(buttonvalue6_2 == true){                            

                var combobox6_2 = this.timeComboBox2.get("value");
                settings6Object.combobox6_2 = combobox6_2;

            }else{

                settings6Object.combobox6_2 = "disabled";

            }
            

                //OS watchdog timer
            var buttonvalue6_3 = this.togglebutton6_3.get("enabled");
            settings6Object.buttonvalue6_3 = buttonvalue6_3;
            
            if(buttonvalue6_3 == true){                            

                var combobox6_3 = this.timeComboBox3.get("value");
                settings6Object.combobox6_3 = combobox6_3;

            }else{

                settings6Object.combobox6_3 = "disabled";

            }

                //LAN over USB
            var buttonvalue6_4 = this.togglebutton6_4.get("enabled");

            if(buttonvalue6_4 == true){                            

                settings6Object.buttonvalue6_4 = "enabled";

            }else{

                settings6Object.buttonvalue6_4 = "disabled";

            }

                //Reboot system on NMI
            var buttonvalue6_5 = this.togglebutton6_5.get("enabled");
            if(buttonvalue6_5 == true){                            
                settings6Object.buttonvalue6_5 = "Enable";
            }else{
                settings6Object.buttonvalue6_5 = "Disable";
            }

                //Power off Delay
            var buttonvalue6_6 = this.togglebutton6_6.get("enabled");
            settings6Object.buttonvalue6_6 = buttonvalue6_6;

            if(buttonvalue6_6 == true){                            

                var combobox6_6 = this.timeComboBox6.get("value");
                settings6Object.combobox6_6 = combobox6_6;

            }else{

                settings6Object.combobox6_6 = "disabled";

            }
            
                //Halt on server error
            var buttonvalue6_7 = this.togglebutton6_7.get("enabled");

            if(buttonvalue6_7 == true){                            
                settings6Object.buttonvalue6_7 = "Enable";
            }else{
                settings6Object.buttonvalue6_7 = "Disable";
            }

            templateObject.timer = settings6Object;

            
            var argJSONString = dojo.toJson({ 
                "identifier":"id",
                  "label":"name",
                  "items":[ templateObject ]
            }, true);


            //alert(argJSONString);

            this.getProgressDialog("save").show(); // Show progress dialog for save request.
                    var xhrPost = dojo.xhrPost({
                        url: this.REST_PATH + "template/create",
                        handleAs: "json", // <<<< Required
                        headers: {
                            "Content-Type": "application/json; charset=utf-8" // <<<< Required
                        },
                        postData: argJSONString,     //Template Data to Post
                        load: dojo.hitch(this, function(response, ioArgs) {
                            // Happy path! We received a 2xx status code from the API.
                                                    
                            dojo.publish("ProgressComplete", response.id);
                            dojo.publish("PerformanceAndRecoveryComplete", response.id);
                            this.hide();
                        }),
                        error: dojo.hitch(this, function(error, ioArgs) {
                            // Failure path! We received a non-2xx status code (ie: 3xx/4xx/5xx status code) from the API.

                            dojo.publish("ProgressFailed", error);
                            console.log(this.declaredClass + ": ", error, ioArgs);
                            
                            var response = dojo.fromJson(ioArgs.xhr.responseText);
                            if ((ioArgs.xhr.status >= 400) && (response.message == "service_error_name_in_use")) {
                                // Error Template name in use
                                this.getModalDialog("Error", this.resources.ERROR_400_NAME).show();
                            }
                            else if(ioArgs.xhr.status == 404) {
                                // Edit Template ID doesn't exist
                                this.getModalDialog("Error", this.resources.ERROR_404_ID).show();
                                this.hide();
                            }
                            else if(ioArgs.xhr.status >= 500) {
                                // Internal Programming Error
                                this.getModalDialog("Error", this.resources.ERROR_500_INTERNAL).show();
                                this.hide();
                            }
                            else {
                                this.getModalDialog("Error", this.resources.ERROR_TEMPLATE_CREATE).show();
                                this.hide();
                            }
                            
                        }),
                        handle: dojo.hitch(this, function(data, ioArgs) {
                            // - The 1st param ("data") is either the response data (on success) or Error object (on failure).
                            // - The 2nd param ("ioArgs") contains detail about the xhr request, including a reference to the
                            // native xhr object. Check ioArgs.xhr.status to determine success or failure, and handle "data"
                            // accordingly.
                        })
                    });

          },          
          saveClicked: function() {

              var templateObject = new Object();
              
              var namevalue = this.templateName.get("value").trim();
              templateObject.name = namevalue;

              templateObject.id = this.templateIDNum;
              
              templateObject.type = "PerformanceRecovery";
              
              var descriptionvalue = this.description.get("value").trim();
              templateObject.description = this.encodeSpecialCharacters(descriptionvalue);

           // Operating Mode
              var settings1Object = new Object();
    
              settings1Object.setoperatingmodes = true;

              var checkvalue1 = this.mycheck1.get("value");
              settings1Object.checkvalue1 = checkvalue1;

    //          var checkvalue1_1 = this.mycheck1_1.get("value");
      //        settings1Object.checkvalue1_1 = checkvalue1_1;

              var buttonBar1_1 = this.buttonBar1_1.get("selected");
              settings1Object.buttonBar1_1 = buttonBar1_1;
              
              if(this.buttonBar1_1.get("selected") == "Predefined"){
            
                  if(this.maxperformance.get("checked") == true){
                      settings1Object.opModeSelection = "Maximum Performance";                    
                  }else if(this.effperformance.get("checked") == true){
                      settings1Object.opModeSelection = "Efficiency - Favor Performance";                            
                  }else if(this.effpowersavings.get("checked") == true){
                      settings1Object.opModeSelection = "Efficiency - Favor Power";                                        
                  }else if(this.minpower.get("checked") == true){
                      settings1Object.opModeSelection = "Minimal Power";                                        
                  }

              }

              if(this.buttonBar1_1.get("selected") == "Custom"){

                  settings1Object.opModeSelection = "Custom Mode";                    
              }

              templateObject.operating_mode = settings1Object;

           // Processors
              var settings2Object = new Object();
              settings2Object.setprocessors = true;
              
              var checkvalue2 = this.mycheck2.get("value");
              settings2Object.checkvalue2 = checkvalue2;

                  //Hyper Threading
              var buttonvalue2_1 = this.togglebutton2_1.get("enabled");

              if(buttonvalue2_1 == true){                            
                  settings2Object.buttonvalue2_1 = "Enable";
              }else{
                  settings2Object.buttonvalue2_1 = "Disable";                
              }

                  //QPI link frequency plan
              var combobox2_2 = this.qpiCombobox.get("value");
              settings2Object.combobox2_2 = combobox2_2;

              templateObject.processors = settings2Object;
              
           // Memory
              var settings3Object = new Object();
              settings3Object.setmemory = true;
              
              var checkvalue3 = this.mycheck3.get("value");
              settings3Object.checkvalue3 = checkvalue3;
              
                  //Speed plan
              var combobox3_1 = this.speedplanCombobox.get("value");
              settings3Object.combobox3_1 = combobox3_1;
              
                  //Channel mode
              var combobox3_2 = this.channelmodeCombobox.get("value");
              settings3Object.combobox3_2 = combobox3_2;

                  //Socket interleave
              var combobox3_3 = this.socketinterCombobox.get("value");
              settings3Object.combobox3_3 = combobox3_3;

                  //Patrol scrub
              var buttonvalue3_4 = this.togglebutton3_4.get("enabled");
              if(buttonvalue3_4 == true){                            
                  settings3Object.buttonvalue3_4 = "Enable";
              }else{
                  settings3Object.buttonvalue3_4 = "Disable";
              }

             

              templateObject.memory = settings3Object;


           // Timer and related options
              var settings6Object = new Object();
              settings6Object.setrecovery = true;
              
              var checkvalue6 = this.mycheck6.get("value");
              settings6Object.checkvalue6 = checkvalue6;

                  //POST watchdog timer
              var buttonvalue6_1 = this.togglebutton6_1.get("enabled");
              if(buttonvalue6_1 == true){                            
                  settings6Object.buttonvalue6_1 = "Enable";
                  
                  var combobox6_1 = this.timeComboBox1.get("value");
                  settings6Object.combobox6_1 = combobox6_1;

              }else{
                  settings6Object.buttonvalue6_1 = "Disable";
                 // settings6Object.combobox6_1 = "disabled";
                                  
              }

                  //LOADER watchdog timer
              var buttonvalue6_2 = this.togglebutton6_2.get("enabled");
              settings6Object.buttonvalue6_2 = buttonvalue6_2;
              
              if(buttonvalue6_2 == true){                            

                  var combobox6_2 = this.timeComboBox2.get("value");
                  settings6Object.combobox6_2 = combobox6_2;

              }else{

                  settings6Object.combobox6_2 = "disabled";

              }
                  //OS watchdog timer
              var buttonvalue6_3 = this.togglebutton6_3.get("enabled");
              settings6Object.buttonvalue6_3 = buttonvalue6_3;

              if(buttonvalue6_3 == true){                            

                  var combobox6_3 = this.timeComboBox3.get("value");
                  settings6Object.combobox6_3 = combobox6_3;

              }else{

                  settings6Object.combobox6_3 = "disabled";

              }


                  //LAN over USB
              var buttonvalue6_4 = this.togglebutton6_4.get("enabled");
              if(buttonvalue6_4 == true){                            

                  settings6Object.buttonvalue6_4 = "enabled";

              }else{

                  settings6Object.buttonvalue6_4 = "disabled";

              }

                  //Reboot system on NMI
              var buttonvalue6_5 = this.togglebutton6_5.get("enabled");
              if(buttonvalue6_5 == true){                            
                  settings6Object.buttonvalue6_5 = "Enable";
              }else{
                  settings6Object.buttonvalue6_5 = "Disable";
              }

                  //Power off Delay
              var buttonvalue6_6 = this.togglebutton6_6.get("enabled");
              settings6Object.buttonvalue6_6 = buttonvalue6_6;

              if(buttonvalue6_6 == true){                            

                  var combobox6_6 = this.timeComboBox6.get("value");
                  settings6Object.combobox6_6 = combobox6_6;

              }else{

                  settings6Object.combobox6_6 = "disabled";

              }


                  //Halt on server error
              var buttonvalue6_7 = this.togglebutton6_7.get("enabled");

              if(buttonvalue6_7 == true){                            
                  settings6Object.buttonvalue6_7 = "Enable";
              }else{
                  settings6Object.buttonvalue6_7 = "Disable";
              }
              
              templateObject.timer = settings6Object;


              
              var argJSONString = dojo.toJson({ 
                  "identifier":"id",
                    "label":"name",
                    "items":[ templateObject ]
              }, true);


//              alert(argJSONString);

              var saveTemplate = true;
              
              if(this.templateInUse.toString() == "true"){
                  //  Need to remove extra properties that aren't included in the dialog
                  delete this.initialData[0].inUse;
                  delete this.initialData[0].uri;
                  delete this.initialData[0].referencedBy;
                  delete this.initialData[0].useCount;
                  delete this.initialData[0].userDefined;
                  
                  // Remove description since it shouldn't force a redeploy
                  delete this.initialData[0].description;
                  delete templateObject.description;
                  
                  var preData = this.sortAndFlatten(this.initialData[0]);
                  var postData = this.sortAndFlatten(templateObject);
                  
                  if(preData != postData){
                      this.rdstDialog.set("templateID",this.templateIDNum);
                      this.rdstDialog.set("templateType","Category");
                      this.rdstDialog.set("templateData",argJSONString);

                      this.rdstDialog.show();
                      
                      saveTemplate = false;
                  }
              }
              if (saveTemplate) {
                  this.getProgressDialog("save").show(); // Show progress dialog for save request.
                      var xhrPost = dojo.xhrPost({
                          url: this.REST_PATH + "template/create",
                          handleAs: "json", // <<<< Required
                          headers: {
                              "Content-Type": "application/json; charset=utf-8" // <<<< Required
                          },
                          postData: argJSONString,     //Template Data to Post
                          load: dojo.hitch(this, function(response, ioArgs) {
                              // Happy path! We received a 2xx status code from the API.
                                                      
                              dojo.publish("ProgressComplete", response.id);
                              dojo.publish("PerformanceAndRecoveryComplete", response.id);
                              this.hide();
                          }),
                          error: dojo.hitch(this, function(error, ioArgs) {
                              // Failure path! We received a non-2xx status code (ie: 3xx/4xx/5xx status code) from the API.

                              dojo.publish("ProgressFailed", error);
                              console.log(this.declaredClass + ": ", error, ioArgs);
                              
                              var response = dojo.fromJson(ioArgs.xhr.responseText);
                              if ((ioArgs.xhr.status >= 400) && (response.message == "service_error_name_in_use")) {
                                  // Error Template name in use
                                  this.getModalDialog("Error", this.resources.ERROR_400_NAME).show();
                              }
                              else if(ioArgs.xhr.status == 404) {
                                  // Edit Template ID doesn't exist
                                  this.getModalDialog("Error", this.resources.ERROR_404_ID).show();
                                  this.hide();
                              }
                              else if(ioArgs.xhr.status >= 500) {
                                  // Internal Programming Error
                                  this.getModalDialog("Error", this.resources.ERROR_500_INTERNAL).show();
                                  this.hide();
                              }
                              else {
                                  this.getModalDialog("Error", this.resources.ERROR_TEMPLATE_CREATE).show();
                                  this.hide();
                              }
                              
                          }),
                          handle: dojo.hitch(this, function(data, ioArgs) {
                              // - The 1st param ("data") is either the response data (on success) or Error object (on failure).
                              // - The 2nd param ("ioArgs") contains detail about the xhr request, including a reference to the
                              // native xhr object. Check ioArgs.xhr.status to determine success or failure, and handle "data"
                              // accordingly.
                          })
                      });

              }
            },
            saveasClicked: function() {      

                var templateObject = new Object();
                
                var namevalue = this.templateName.get("value").trim();
                templateObject.name = namevalue;
                
                templateObject.type = "PerformanceRecovery";
                
                var descriptionvalue = this.description.get("value").trim();
                templateObject.description = this.encodeSpecialCharacters(descriptionvalue);

             // Operating Mode
                var settings1Object = new Object();
      
                settings1Object.setoperatingmodes = true;

                var checkvalue1 = this.mycheck1.get("value");
                settings1Object.checkvalue1 = checkvalue1;

                var buttonBar1_1 = this.buttonBar1_1.get("selected");
                settings1Object.buttonBar1_1 = buttonBar1_1;
                
                if(this.buttonBar1_1.get("selected") == "Predefined"){
              
                    if(this.maxperformance.get("checked") == true){
                        settings1Object.opModeSelection = "Maximum Performance";                    
                    }else if(this.effperformance.get("checked") == true){
                        settings1Object.opModeSelection = "Efficiency - Favor Performance";                            
                    }else if(this.effpowersavings.get("checked") == true){
                        settings1Object.opModeSelection = "Efficiency - Favor Power";                                        
                    }else if(this.minpower.get("checked") == true){
                        settings1Object.opModeSelection = "Minimal Power";                                        
                    }

                }

                if(this.buttonBar1_1.get("selected") == "Custom"){

                    settings1Object.opModeSelection = "Custom Mode";                    
                }

                templateObject.operating_mode = settings1Object;

             // Processors
                var settings2Object = new Object();
                settings2Object.setprocessors = true;
                
                var checkvalue2 = this.mycheck2.get("value");
                settings2Object.checkvalue2 = checkvalue2;

                    //Hyper Threading
                var buttonvalue2_1 = this.togglebutton2_1.get("enabled");

                if(buttonvalue2_1 == true){                            
                    settings2Object.buttonvalue2_1 = "Enable";
                }else{
                    settings2Object.buttonvalue2_1 = "Disable";                
                }
                
                    //QPI link frequency plan
                var combobox2_2 = this.qpiCombobox.get("value");
                settings2Object.combobox2_2 = combobox2_2;

                templateObject.processors = settings2Object;
                
             // Memory
                var settings3Object = new Object();
                settings3Object.setmemory = true;
                
                var checkvalue3 = this.mycheck3.get("value");
                settings3Object.checkvalue3 = checkvalue3;
                
                    //Speed plan
                var combobox3_1 = this.speedplanCombobox.get("value");
                settings3Object.combobox3_1 = combobox3_1;
                
                    //Channel mode
                var combobox3_2 = this.channelmodeCombobox.get("value");
                settings3Object.combobox3_2 = combobox3_2;

                    //Socket interleave
                var combobox3_3 = this.socketinterCombobox.get("value");
                settings3Object.combobox3_3 = combobox3_3;

                    //Patrol scrub
                var buttonvalue3_4 = this.togglebutton3_4.get("enabled");
                if(buttonvalue3_4 == true){                            
                    settings3Object.buttonvalue3_4 = "Enable";
                }else{
                    settings3Object.buttonvalue3_4 = "Disable";
                }

               

                templateObject.memory = settings3Object;


             // Timer and related options
                var settings6Object = new Object();
                settings6Object.setrecovery = true;
                
                var checkvalue6 = this.mycheck6.get("value");
                settings6Object.checkvalue6 = checkvalue6;

                    //POST watchdog timer
                var buttonvalue6_1 = this.togglebutton6_1.get("enabled");
                if(buttonvalue6_1 == true){                            
                    settings6Object.buttonvalue6_1 = "Enable";
                    
                    var combobox6_1 = this.timeComboBox1.get("value");
                    settings6Object.combobox6_1 = combobox6_1;

                }else{
                    settings6Object.buttonvalue6_1 = "Disable";
           //         settings6Object.combobox6_1 = "disabled";
                                    
                }


                    //LOADER watchdog timer
                var buttonvalue6_2 = this.togglebutton6_2.get("enabled");
                settings6Object.buttonvalue6_2 = buttonvalue6_2;
               
                if(buttonvalue6_2 == true){                            

                    var combobox6_2 = this.timeComboBox2.get("value");
                    settings6Object.combobox6_2 = combobox6_2;

                }else{

                    settings6Object.combobox6_2 = "disabled";

                }

                    //OS watchdog timer
                var buttonvalue6_3 = this.togglebutton6_3.get("enabled");
                settings6Object.buttonvalue6_3 = buttonvalue6_3;

                if(buttonvalue6_3 == true){                            

                    var combobox6_3 = this.timeComboBox3.get("value");
                    settings6Object.combobox6_3 = combobox6_3;

                }else{

                    settings6Object.combobox6_3 = "disabled";

                }


                    //LAN over USB
                var buttonvalue6_4 = this.togglebutton6_4.get("enabled");
                if(buttonvalue6_4 == true){                            

                    settings6Object.buttonvalue6_4 = "enabled";

                }else{

                    settings6Object.buttonvalue6_4 = "disabled";

                }

                    //Reboot system on NMI
                var buttonvalue6_5 = this.togglebutton6_5.get("enabled");
                if(buttonvalue6_5 == true){                            
                    settings6Object.buttonvalue6_5 = "Enable";
                }else{
                    settings6Object.buttonvalue6_5 = "Disable";
                }

                    //Power off Delay
                var buttonvalue6_6 = this.togglebutton6_6.get("enabled");
                settings6Object.buttonvalue6_6 = buttonvalue6_6;

                if(buttonvalue6_6 == true){                            

                    var combobox6_6 = this.timeComboBox6.get("value");
                    settings6Object.combobox6_6 = combobox6_6;

                }else{

                    settings6Object.combobox6_6 = "disabled";

                }
                
                    //Halt on server error
                var buttonvalue6_7 = this.togglebutton6_7.get("enabled");

                if(buttonvalue6_7 == true){                            
                    settings6Object.buttonvalue6_7 = "Enable";
                }else{
                    settings6Object.buttonvalue6_7 = "Disable";
                }
                
                templateObject.timer = settings6Object;

                this.saveasDialog.set("templateObject",templateObject);
                this.saveasDialog.show();

            },          
            loadprevSettings: function() {
            var widget = this;
            var locResources = this.locResources;
            var resources = this.resources;

            var mode = this.templateMode;
            
            var inUse = false;

            var name = this.templateName;
            var description = this.description;
            var mycheck1 = this.mycheck1;
            var buttonBar1_1 = this.buttonBar1_1;
            var maxperformance = this.maxperformance;
            var effperformance = this.effperformance;
            var effpowersavings = this.effpowersavings;
            var minpower = this.minpower;
            
            var mycheck2 = this.mycheck2;
            var buttonvalue2_1 = this.togglebutton2_1;
            var combobox2_2 = this.qpiCombobox;

            var mycheck3 = this.mycheck3;
            var combobox3_1 = this.speedplanCombobox;
            var combobox3_2 = this.channelmodeCombobox;
            var combobox3_3 = this.socketinterCombobox;
            var buttonvalue3_4 = this.togglebutton3_4;

            var mycheck6 = this.mycheck6;
            var buttonvalue6_1 = this.togglebutton6_1;
            var combobox6_1 = this.timeComboBox1;
            var buttonvalue6_2 = this.togglebutton6_2;
            var combobox6_2 = this.timeComboBox2;
            var buttonvalue6_3 = this.togglebutton6_3;
            var combobox6_3 = this.timeComboBox3;
            var buttonvalue6_4 = this.togglebutton6_4;
            var buttonvalue6_5 = this.togglebutton6_5;
            var buttonvalue6_6 = this.togglebutton6_6;
            var combobox6_6 = this.timeComboBox6;
            var buttonvalue6_7 = this.togglebutton6_7;

            var dialogNode = this.dialogNode;
            
            var xhrGet = dojo.xhrGet({
                url: this.REST_PATH + "template/"+this.templateIDNum,
                handleAs: "json",
                sync: true,
                preventCache: true,
                load: dojo.hitch(this, function(response) {
                    this.store = response; 
                    //alert(this.store.items[0].IMM_GeneralSettings_power_off.IMM_GeneralSettings_power_off);
                }),
                handle: dojo.hitch(this, function(){

                    inUse = this.store.items[0].inUse;

                    if(mode == "copy"){
                        dialogNode.set("title", locResources.Title + " - " + this.store.items[0].name + " - " + resources.COPY);
                        name.set("value", this.store.items[0].name + " - " + resources.COPY);
                    }else{
                        dialogNode.set("title", locResources.EditTitle + " - " + this.store.items[0].name);
                        name.set("value", this.store.items[0].name);
                    }
            
                    var descriptionvalue = widget.decodeSpecialCharacters(this.store.items[0].description);
                    description.set("value", descriptionvalue);
                                                        
                    // Operating Mode
                    mycheck1.set("value",this.store.items[0].operating_mode.checkvalue1);
                    buttonBar1_1.set("selected" ,this.store.items[0].operating_mode.buttonBar1_1);
                    
                    if(this.store.items[0].operating_mode.buttonBar1_1 == "Predefined"){
                        
                        if(this.store.items[0].operating_mode.opModeSelection == "Maximum Performance"){
                            maxperformance.set("checked",true);           
                        }else if(this.store.items[0].operating_mode.opModeSelection == "Efficiency - Favor Performance"){
                            effperformance.set("checked",true);                                        
                        }else if(this.store.items[0].operating_mode.opModeSelection == "Efficiency - Favor Power"){
                            effpowersavings.set("checked",true);                    
                        }else if(this.store.items[0].operating_mode.opModeSelection == "Minimal Power"){
                            minpower.set("checked",true);           
                        }

                        
                    }
                    
                    // Processors
                    mycheck2.set("value",this.store.items[0].processors.checkvalue2);
                    
                    if(this.store.items[0].processors.buttonvalue2_1 == "Enable"){                            
                        buttonvalue2_1.set("enabled",true);
                    }else{
                        buttonvalue2_1.set("enabled",false);
                    }

                    combobox2_2.set("value",this.store.items[0].processors.combobox2_2);
                    
                    // Memory
                    mycheck3.set("value",this.store.items[0].memory.checkvalue3);
                    combobox3_1.set("value",this.store.items[0].memory.combobox3_1);
                    combobox3_2.set("value",this.store.items[0].memory.combobox3_2);
                    combobox3_3.set("value",this.store.items[0].memory.combobox3_3);
                   
                    if(this.store.items[0].memory.buttonvalue3_4 == "Enable"){                            
                        buttonvalue3_4.set("enabled",true);
                    }else{
                        buttonvalue3_4.set("enabled",false);
                    }

                    
                    // Timer and related options
                    mycheck6.set("value",this.store.items[0].timer.checkvalue6);
                    
                    if(this.store.items[0].timer.buttonvalue6_1 == "Enable"){                            
                        buttonvalue6_1.set("enabled",true);
                    }else{
                        buttonvalue6_1.set("enabled",false);
                    }
                    
                    combobox6_1.set("value",this.store.items[0].timer.combobox6_1);
                    buttonvalue6_2.set("enabled",this.store.items[0].timer.buttonvalue6_2);
                    combobox6_2.set("value",this.store.items[0].timer.combobox6_2);
                    buttonvalue6_3.set("enabled",this.store.items[0].timer.buttonvalue6_3);
                    combobox6_3.set("value",this.store.items[0].timer.combobox6_3);

                    if(this.store.items[0].timer.buttonvalue6_4 == "enabled"){                            
                        buttonvalue6_4.set("enabled",true);
                    }else{
                        buttonvalue6_4.set("enabled",false);
                    }
                    
                    if(this.store.items[0].timer.buttonvalue6_5 == "Enable"){                            
                        buttonvalue6_5.set("enabled",true);
                    }else{
                        buttonvalue6_5.set("enabled",false);
                    }

                    buttonvalue6_6.set("enabled",this.store.items[0].timer.buttonvalue6_6);
                    combobox6_6.set("value",this.store.items[0].timer.combobox6_6);

                    if(this.store.items[0].timer.buttonvalue6_7 == "Enable"){                            
                        buttonvalue6_7.set("enabled",true);
                    }else{
                        buttonvalue6_7.set("enabled",false);
                    }
                })
            });

            this.initialData = this.store.items;
            
            this.templateInUse = inUse;

            this.togglesettingsBorder6_1();
            this.togglesettingsBorder6_2();
            this.togglesettingsBorder6_3();
            this.togglesettingsBorder6_6();
            
            this.layout();

            return this.templateName.get("value").trim();

        },
        exitParent: function() {
            var data = "performance";
            
            dojo.publish("PerformanceAndRecoveryComplete", data);

            if(this.rdstDialog != null){
                var deployClicked = this.rdstDialog.get("closeParent");
                if(deployClicked) {
                    this.hide();
                }
            }
        },
        _expandall: function() {
            this.mycheck1.set("checked", true);
            this.mycheck2.set("checked", true);
            this.mycheck3.set("checked", true);
            this.mycheck6.set("checked", true);
 
            this.expandall.style.display = "none";
            this.collapseall.style.display = "inline";
            this.mixedexpandcollapse.style.display = "none";
                  
            this.toggle1();
            this.toggle2();
            this.toggle3();
            this.toggle6();
            this.layout();

        },
        
        _collapseall: function() {
            this.mycheck1.set("checked", false);
            this.mycheck2.set("checked", false);
            this.mycheck3.set("checked", false);
            this.mycheck6.set("checked", false);
 
            this.expandall.style.display = "inline";
            this.collapseall.style.display = "none";
            this.mixedexpandcollapse.style.display = "none";
           
            this.toggle1();
            this.toggle2();
            this.toggle3();
            this.toggle6();
            this.layout();

        },        
        _nameChanged: function() {                        

            if (this.templateName.get("value").trim() != "") {
                this.okBtn.set("disabled", false);
            }
            else {
                this.okBtn.set("disabled", true);
            }
           
        },
        _setup: function(){

            //Set Template Field to catch intermediate changes
            this.templateName.intermediateChanges = true;

            // Set Description Label
            this._descLimit.innerHTML = this.resources.LIMIT.replace("%500","500");

            //Set Information Messages and Load Previous Settings                      
            if(this.templateIDNum != null && this.templateMode == "edit"){     //if dialog in edit mode    

                this.loadprevSettings();

                if(this.templateInUse.toString() == "true"){
                   
                    if(this.templateLaunchPoint == "table"){
                        
                        this.warningMessage.style.display = "block";
                        this.warningMessageText.innerHTML = this.resources.INUSE;
                        this.saveBtnContainer.style.display = "inline";
                        this.saveasBtnContainer.style.display = "inline";
                        
                    }else if(this.templateLaunchPoint == "wizard"){
                        
                        this.informationMessage.style.display = "block";
                        this.informationMessageText.innerHTML = this.resources.INUSEWIZARD;
                        this.saveasBtnContainer.style.display = "inline";
                        
                    }else{
                        this.informationMessage.style.display = "block";
                        this.informationMessageText.innerHTML = this.resources.INUSEWIZARD;
                        this.saveasBtnContainer.style.display = "inline";
                    }
                    
                }else{
                    
                    this.saveBtnContainer.style.display = "inline";
                    this.saveasBtnContainer.style.display = "inline";
                                        
                }    

                this.templateName.set("disabled",true);
                


             }else if(this.templateIDNum != null && this.templateMode == "copy"){    //if dialog in copy mode     
                 
                 this.loadprevSettings();
                 this.templateIDNum = null;  //set template ID to null in order to create new template
                 this.okBtnContainer.style.display = "inline";

             }else{     //if dialog in create new mode
                 
                 this.okBtnContainer.style.display = "inline";
                 
                 this.buttonBar1_1.set("selected" ,"Predefined");
                 this._expandall();

             } 

            this.layout();

        }
   
    });
});