define([
        "dojo",
        "dijit",
        "support/panels/Panel",
        "dojo/i18n!./nls/ServerDetailsDialog",
        "dojo/text!./templates/ServerDetailsDialog.html",
        "support/panels/ServerDetails",
        "support/panels/ServerTemplateDetails",
        "dojo/parser",
        "dijit/Toolbar",
        "dijit/form/Button",
        "dijit/ToolbarSeparator",
        "dijit/Menu",
        "support/dialogs/ServerTemplateWizard",
        "support/panels/CategoryTemplateDetails",
        "support/panels/PolicyDetails",
        "support/panels/PoolDetails",
        "support/panels/StandbyDetails",
        "support/panels/ChassisTemplateDetails",
        "support/panels/EthPoolDetails",
        "support/panels/FibrePoolDetails",
        "support/panels/ChassisCategoryTemplateDetails"
    ], function(dojo, dijit, panel, mri, template) {

    return dojo.declare("support.dialogs.ServerDetailsDialog", [ support.dialogs.Dialog], {

        // summary:
        // A panel widget extending support.panels.Panel, for use in displaying information
        // associated with a server.

        // templateString: [protected] String
        // This widget's HTML template, provided.
        templateString: template,
            
        // locResources: [protected] Object
        // This widget's National Language Source (NLS) object.
        locResources: mri, 

        // baseClass: [protected] String
        // The root CSS className to be placed on this widget's domNode.
        baseClass: "ServerDetailsDialog",
        
        // the name of the CSS stylesheet of this page
        spCssPathAndName: "support/panels/themes/ServerDetailsDialog.css",
        
        detailsMode: "",
        templateIDNum: "",
        templateName:"",
        templateDesc:"",
        templateType:"",
        templateInUse:false,
        policyType:"",
        // When this method is called, all variables inherited from superclasses are "mixed in".
        // Common operations for postMixInProperties
        // 1) Modify or assign values for widget property variables defined in the template HTML
        // file
        postMixInProperties: function() {
            this.inherited(arguments);
        },

        // postCreate() is called after buildRendering(). This is useful to override when you need
        // to access and/or manipulate DOM nodes included with your widget. DOM nodes and widgets
        // with the dojoAttachPoint attribute specified can now be directly accessed as fields on
        // "this".
        // Common operations for postCreate
        // 1) Access and manipulate DOM nodes created in buildRendering()
        // 2) Add new DOM nodes or widgets
        postCreate: function() {
            this.inherited(arguments);

//            var dialogNode = this.dialogNode;
            var DetailsTemplateName = this.DetailsTemplateName;
            var resources = this.resources;
            
            this.subscribe("RefreshNameDiv", function(data) {
                data = data+" - "+resources.DETAILS;
                DetailsTemplateName.innerHTML = data;
            });

         //   alert(this.templateIDNum);
            dojo.connect(this.dialogNode, "hide", this, function() {        
                this.dialogNode.destroy();
                
                if(dijit.byId("expanded_status",this))
                dijit.byId("expanded_status",this).destroy();
            });

            this.moreMenu = new dijit.Menu({          // Add to More/Actions Menu
                style: "display: none;"
            });

                if(this.detailsMode == "Chassis"){

                    this.stdpanel = new support.panels.ChassisDetails({
                        detailsMode:"Chassis",
                        templateIDNum: this.templateIDNum
                    }).placeAt(this.ServerTemplatePoint); 

                }else if(this.detailsMode == "ChassisTemplate"){

                    this.stdpanel = new support.panels.ChassisTemplateDetails({
                        detailsMode:"Chassis",
                        templateIDNum: this.templateIDNum
                    }).placeAt(this.ServerTemplatePoint); 

                }else if(this.detailsMode == "ServerProfile"){

            /*        this.createButton = new dijit.form.Button({     //Add Create Button to toolbar
                        showLabel: false,
                        iconClass: "spCreateLgIcon",
                        disabled: false,
                        title: this.resources.CREATE_SERVER_PATTERN_TITLE,
                        onClick: dojo.hitch(this, this.createServerTemplate),
                        onKeypress: dojo.hitch(this, this.createServerTemplate)
                    });
                    this.detailsToolBar.addChild(this.createButton);

                    this.editButton = new dijit.form.Button({     //Add Edit Button to toolbar
                        showLabel: false,
                        iconClass: "spEditLgIcon",
                        disabled: false,
                        title: this.resources.EDIT_SERVER_PATTERN_TITLE,
                        onClick: dojo.hitch(this, this.editTemplate),
                        onKeypress: dojo.hitch(this, this.editTemplate)
                    });
                    this.detailsToolBar.addChild(this.editButton);

                    this.deployButton = new dijit.form.Button({     //Add Deploy Button to toolbar
                        showLabel: false,
                        iconClass: "spDeployLgIcon",
                        disabled: false,
                        title: this.resources.DEPLOY_SERVER_PATTERN_TITLE,
                        onClick: dojo.hitch(this, this.deployTemplate),
                        onKeypress: dojo.hitch(this, this.deployTemplate)
                    });
                    this.detailsToolBar.addChild(this.deployButton);

                    this.restartButton = new dijit.form.Button({     //Add Restart Button to toolbar
                        showLabel: false,
                        iconClass: "spRestartLgIcon",
                        disabled: false,
                        title: this.locResources.RESTARTSERVER,
                        onClick: dojo.hitch(this, this.restartServer),
                        onKeypress: dojo.hitch(this, this.restartServer)
                    });
                    this.detailsToolBar.addChild(this.restartButton);

          
                    // Add to More/Actions Menu                    
                    this.detailsSeparator = new dijit.ToolbarSeparator();
                    this.detailsToolBar.addChild(this.detailsSeparator);
                    
                    this.assignItem = new dijit.MenuItem({
                        label: this.resources.ASSIGN_SERVER_PROFILE,
                        title: this.resources.ASSIGN_SERVER_PROFILE,
                        onClick: dojo.hitch(this, this.assignProfile),
                        onKeypress: dojo.hitch(this, this.assignProfile)
                    });
                    this.moreMenu.addChild(this.assignItem);

                    this.resetItem = new dijit.MenuItem({
                        label: this.locResources.RESETTITLE,
                        title: this.locResources.RESETTITLE,
                        onClick: dojo.hitch(this, this.resetStorage),
                        onKeypress: dojo.hitch(this, this.resetStorage)
                    });
                    this.moreMenu.addChild(this.resetItem);
                    
                    this.moreButton = new dijit.form.DropDownButton({
                        showLabel: true,
                        label: this.resources.MORE,
//                        title: this.resources.CREATE_SERVER_PATTERN_TITLE,
                        dropDown: this.moreMenu
                    });

                    this.detailsToolBar.addChild(this.moreButton);

                    
                                        
                    var nameValue = this.templateName.toString();

                    nameValue = nameValue.slice(4);
                    
//                    this.dialogNode.set("title", "Server Details - "+nameValue);
                    this.dialogNode.set("title", this.locResources.SERVER_DETAILS);

                    nameValue = nameValue+" - "+this.resources.DETAILS;
                    
                    this.DetailsTemplateName.innerHTML = nameValue;

                    //this.DetailsTemplateDescription.innerHTML = this.templateDesc;
*/
                    this.stdpanel = new support.panels.ServerDetails({
                        detailsMode:"ServerProfile",
                        templateIDNum: this.templateIDNum
                    }).placeAt(this.ServerTemplatePoint); 

                }else if(this.detailsMode == "ServerTemplate"){

/*                    this.editButton = new dijit.form.Button({     //Add Edit Button to toolbar
                        showLabel: false,
                        iconClass: "spEditLgIcon",
                        disabled: false,
                        title: this.resources.EDIT_SERVER_PATTERN_TITLE,
                        onClick: dojo.hitch(this, this.editTemplate),
                        onKeypress: dojo.hitch(this, this.editTemplate)
                    });
                    this.detailsToolBar.addChild(this.editButton);

                    this.deployButton = new dijit.form.Button({     //Add Deploy Button to toolbar
                        showLabel: false,
                        iconClass: "spDeployLgIcon",
                        disabled: false,
                        title: this.resources.DEPLOY_SERVER_PATTERN_TITLE,
                        onClick: dojo.hitch(this, this.deployTemplate),
                        onKeypress: dojo.hitch(this, this.deployTemplate)
                    });
                    this.detailsToolBar.addChild(this.deployButton);

                    // Add to More/Actions Menu                    
                    this.detailsSeparator = new dijit.ToolbarSeparator();
                    this.detailsToolBar.addChild(this.detailsSeparator);
                    
                    this.copyItem = new dijit.MenuItem({
                        label: this.resources.COPY,
                        title: this.resources.COPY_PATTERN_TITLE,
                        onClick: dojo.hitch(this, this.copyTemplate),
                        onKeypress: dojo.hitch(this, this.copyTemplate)
                    });
                    this.moreMenu.addChild(this.copyItem);

                    this.renameItem = new dijit.MenuItem({
                        label: this.resources.RENAME,
                        title: this.resources.RENAME_PATTERN_TITLE,
                        onClick: dojo.hitch(this, this.renameTemplate),
                        onKeypress: dojo.hitch(this, this.renameTemplate)
                    });
                    this.moreMenu.addChild(this.renameItem);
                    
                    this.moreButton = new dijit.form.DropDownButton({
                        showLabel: true,
                        label: this.resources.MORE,
//                        title: this.resources.CREATE_SERVER_PATTERN_TITLE,
                        dropDown: this.moreMenu
                    });

                    this.detailsToolBar.addChild(this.moreButton);
                    
                                        
                    var nameValue = this.templateName.toString();

                    nameValue = nameValue.slice(4);

                    var nameToPass = nameValue;

//                    this.dialogNode.set("title", "Server Template Details - "+nameValue);
                    this.dialogNode.set("title", this.locResources.SERVERTD);

                    nameValue = nameValue+" - "+this.resources.DETAILS;
                    
                    this.DetailsTemplateName.innerHTML = nameValue;

                    this.DetailsTemplateDescription.innerHTML = this.templateDesc;
*/
                    this.stdpanel = new support.panels.ServerTemplateDetails({
                        detailsMode:"ServerTemplate",
                        templateIDNum: this.templateIDNum
                       // templateName: nameToPass
                    }).placeAt(this.ServerTemplatePoint); 
                                      
                }else if(this.detailsMode == "CategoryTemplate"){
/*
                    this.editButton = new dijit.form.Button({     //Add Edit Button to toolbar
                        showLabel: false,
                        iconClass: "spEditLgIcon",
                        disabled: false,
                        title: this.resources.EDIT_SERVER_PATTERN_TITLE,
                        onClick: dojo.hitch(this, this.editTemplate),
                        onKeypress: dojo.hitch(this, this.editTemplate)
                    });
                    this.detailsToolBar.addChild(this.editButton);
                    
                    // Add to More/Actions Menu                    
                    this.detailsSeparator = new dijit.ToolbarSeparator();
                    this.detailsToolBar.addChild(this.detailsSeparator);
                    
                    this.copyItem = new dijit.MenuItem({
                        label: this.resources.COPY,
                        title: this.resources.COPY_PATTERN_TITLE,
                        onClick: dojo.hitch(this, this.copyTemplate),
                        onKeypress: dojo.hitch(this, this.copyTemplate)
                    });
                    this.moreMenu.addChild(this.copyItem);

                    this.renameItem = new dijit.MenuItem({
                        label: this.resources.RENAME,
                        title: this.resources.RENAME_PATTERN_TITLE,
                        onClick: dojo.hitch(this, this.renameTemplate),
                        onKeypress: dojo.hitch(this, this.renameTemplate)
                    });
                    this.moreMenu.addChild(this.renameItem);
                    
                    this.moreButton = new dijit.form.DropDownButton({
                        showLabel: true,
                        label: this.resources.MORE,
//                        title: this.resources.CREATE_SERVER_PATTERN_TITLE,
                        dropDown: this.moreMenu
                    });

                    this.detailsToolBar.addChild(this.moreButton);

                    var dialogTitle ="";
                    
                    var nameValue = this.templateName.toString();
                    
                    if (nameValue.indexOf("st::") == 0) {
                        nameValue = nameValue.slice(4);
                        dialogTitle = this.locResources.Server;
                    }
                    else if (nameValue.indexOf("sit::") == 0) {
                        nameValue = nameValue.slice(5);
                        dialogTitle = this.locResources.SystemInfo;
                    }
                    else if (nameValue.indexOf("mit::") == 0) {
                        nameValue = nameValue.slice(5);
                        dialogTitle = this.locResources.Management;
                    }
                    else if (nameValue.indexOf("psct::") == 0) {
                        nameValue = nameValue.slice(6); 
                        dialogTitle = this.locResources.Power;
                    }
                    else if (nameValue.indexOf("part::") == 0) {
                        nameValue = nameValue.slice(6);          
                        dialogTitle = this.locResources.Performance;
                    }
                    else if (nameValue.indexOf("daipt::") == 0) {
                        nameValue = nameValue.slice(7);          
                        dialogTitle = this.locResources.Devices;
                    }
                    else if (nameValue.indexOf("pbtt::") == 0) {
                        nameValue = nameValue.slice(6);       
                        dialogTitle = this.locResources.PXE;
                    }
                    else if (nameValue.indexOf("fcbtt::") == 0) {
                        nameValue = nameValue.slice(7);         
                        dialogTitle = this.locResources.FibreChannel;
                    }
                    else if (nameValue.indexOf("sbtt::") == 0) {
                        nameValue = nameValue.slice(6);           
                        dialogTitle = this.locResources.SAS;
                    }
                    else if (nameValue.indexOf("at::") == 0) {
                        nameValue = nameValue.slice(4);
                        dialogTitle = this.locResources.Adapter;
                    }
                    else if (nameValue.indexOf("pvt::") == 0) {
                        nameValue = nameValue.slice(5);
                        dialogTitle = this.locResources.PortV;
                    }
                    else if (nameValue.indexOf("ppt::") == 0) {
                        nameValue = nameValue.slice(5);
                        dialogTitle = this.locResources.PortP;
                    }

                    //this.dialogNode.set("title", dialogTitle+" Template Details - "+nameValue);
                    this.dialogNode.set("title", dialogTitle + " " + this.locResources.TemplateDetails);

                    nameValue = nameValue+" - "+this.resources.DETAILS;
                    
                    this.DetailsTemplateName.innerHTML = nameValue;

                    this.DetailsTemplateDescription.innerHTML = this.templateDesc;
*/
                    this.stdpanel = new support.panels.CategoryTemplateDetails({
                        detailsMode:"CategoryTemplate",
                        templateIDNum: this.templateIDNum
                    }).placeAt(this.ServerTemplatePoint); 
                    
                }else if(this.detailsMode == "ChassisCategoryTemplate"){

                    this.stdpanel = new support.panels.ChassisCategoryTemplateDetails({
                        detailsMode:"ChassisCategoryTemplate",
                        templateIDNum: this.templateIDNum
                    }).placeAt(this.ServerTemplatePoint); 
                    
                }else if(this.detailsMode == "Policy"){
                

/*                    this.editButton = new dijit.form.Button({     //Add Edit Button to toolbar
                        showLabel: false,
                        iconClass: "spEditLgIcon",
                        disabled: false,
                        title: this.resources.EDIT_SERVER_PATTERN_TITLE,
                        onClick: dojo.hitch(this, this.editTemplate),
                        onKeypress: dojo.hitch(this, this.editTemplate)
                    });
                    this.detailsToolBar.addChild(this.editButton);

                    // Add to More/Actions Menu                    
                    this.detailsSeparator = new dijit.ToolbarSeparator();
                    this.detailsToolBar.addChild(this.detailsSeparator);
                    
                    this.copyItem = new dijit.MenuItem({
                        label: this.resources.COPY,
                        title: this.resources.COPY_PATTERN_TITLE,
                        onClick: dojo.hitch(this, this.copyTemplate),
                        onKeypress: dojo.hitch(this, this.copyTemplate)
                    });
                    this.moreMenu.addChild(this.copyItem);

                    this.renameItem = new dijit.MenuItem({
                        label: this.resources.RENAME,
                        title: this.resources.RENAME_PATTERN_TITLE,
                        onClick: dojo.hitch(this, this.renameTemplate),
                        onKeypress: dojo.hitch(this, this.renameTemplate)
                    });
                    this.moreMenu.addChild(this.renameItem);
                    
                    this.moreButton = new dijit.form.DropDownButton({
                        showLabel: true,
                        label: this.resources.MORE,
//                        title: this.resources.CREATE_SERVER_PATTERN_TITLE,
                        dropDown: this.moreMenu
                    });

                    this.detailsToolBar.addChild(this.moreButton);
                                        
                    var nameValue = this.templateName.toString();

                    //nameValue = nameValue.slice(4);

//                    this.dialogNode.set("title", "Policy Details - "+nameValue);
                    this.dialogNode.set("title", this.locResources.PolicyDetails);

                    nameValue = nameValue+" - "+this.resources.DETAILS;
                    
                    this.DetailsTemplateName.innerHTML = nameValue;

                    this.DetailsTemplateDescription.innerHTML = this.templateDesc;
*/
                    this.stdpanel = new support.panels.PolicyDetails({
                        detailsMode:"Policy",
                        templateIDNum: this.templateIDNum
                    }).placeAt(this.ServerTemplatePoint); 

                }else if(this.detailsMode == "Pool"){
/*
                    this.editButton = new dijit.form.Button({     //Add Edit Button to toolbar
                        showLabel: false,
                        iconClass: "spEditLgIcon",
                        disabled: false,
                        title: this.resources.EDIT_SERVER_PATTERN_TITLE,
                        onClick: dojo.hitch(this, this.editTemplate),
                        onKeypress: dojo.hitch(this, this.editTemplate)
                    });
                    this.detailsToolBar.addChild(this.editButton);

                    // Add to More/Actions Menu                    
                    this.detailsSeparator = new dijit.ToolbarSeparator();
                    this.detailsToolBar.addChild(this.detailsSeparator);
                    
                    this.renameItem = new dijit.MenuItem({
                        label: this.resources.RENAME,
                        title: this.resources.RENAME_PATTERN_TITLE,
                        onClick: dojo.hitch(this, this.renameTemplate),
                        onKeypress: dojo.hitch(this, this.renameTemplate)
                    });
                    this.moreMenu.addChild(this.renameItem);
                    
                    this.moreButton = new dijit.form.DropDownButton({
                        showLabel: true,
                        label: this.resources.MORE,
                        dropDown: this.moreMenu
                    });

                    this.detailsToolBar.addChild(this.moreButton);

                    var nameValue = this.templateName.toString();

                    nameValue = nameValue.slice(4);

                    this.dialogNode.set("title", "Pool Details");

                    nameValue = nameValue+" - "+this.resources.DETAILS;
                    
                    this.DetailsTemplateName.innerHTML = nameValue;

                    this.DetailsTemplateDescription.innerHTML = this.templateDesc;
                    */
                    this.stdpanel = new support.panels.PoolDetails({
                        detailsMode:"Pool",
                        templateIDNum: this.templateIDNum
                    }).placeAt(this.ServerTemplatePoint); 

                }else if(this.detailsMode == "EthPool"){

                    this.stdpanel = new support.panels.EthPoolDetails({
                        detailsMode:"Pool",
                        templateIDNum: this.templateIDNum
                    }).placeAt(this.ServerTemplatePoint); 

                }
                else if(this.detailsMode == "FibrePool"){

                    this.stdpanel = new support.panels.FibrePoolDetails({
                        detailsMode:"Pool",
                        templateIDNum: this.templateIDNum
                    }).placeAt(this.ServerTemplatePoint); 

                }else if(this.detailsMode == "StandByServerPool"){

/*                    this.editButton = new dijit.form.Button({     //Add Edit Button to toolbar
                        showLabel: false,
                        iconClass: "spEditLgIcon",
                        disabled: false,
                        title: this.resources.EDIT_SERVER_PATTERN_TITLE,
                        onClick: dojo.hitch(this, this.editTemplate),
                        onKeypress: dojo.hitch(this, this.editTemplate)
                    });
                    this.detailsToolBar.addChild(this.editButton);

                    var nameValue = this.templateName.toString();

                    //nameValue = nameValue.slice(4);

//                    this.dialogNode.set("title", "Stand By Server Pool Details - "+nameValue);
                    this.dialogNode.set("title", this.locResources.StandByServer);

                    nameValue = nameValue+" - "+this.resources.DETAILS;
                    
                    this.DetailsTemplateName.innerHTML = nameValue;

                    this.DetailsTemplateDescription.innerHTML = this.templateDesc;
*/
                    this.stdpanel = new support.panels.StandbyDetails({
                        detailsMode:"StandByServerPool",
                        templateIDNum: this.templateIDNum
                    }).placeAt(this.ServerTemplatePoint); 

                }

                
                this.layout(); 

        },
        // Edit Template
        editTemplate: function() {

            if (this.templateType == "Server") {

                var stweditdialog = new support.dialogs.ServerTemplateWizard({
                    templateIDNum: this.templateIDNum,
                    templateInUse: this.templateInUse,
                    editMode: true
                });
                stweditdialog.show();

            }
            else if (this.templateType == "Power") {

                var psceditdialog = new support.dialogs.PowerStateAndCappingTemplate({
                    templateIDNum: this.templateIDNum,
                    templateMode: "edit",
                    templateInUse: this.templateInUse,
                    templateLaunchPoint : "table"
                });
                psceditdialog.show();

            }
            else if (this.templateType == "PXE") {

                var pxedialog = new support.dialogs.PXENetworkBootTargetTemplate({
                    templateIDNum: this.templateIDNum,
                    templateMode: "edit",
                    templateInUse: this.templateInUse,
                    templateLaunchPoint : "table"
                });
                pxedialog.show();

            }
            else if (this.templateType == "FibreChannel") {

                var fibreChanneldialog = new support.dialogs.FibreChannelBootTargetTemplate({
                    templateIDNum: this.templateIDNum,
                    templateMode: "edit",
                    templateInUse: this.templateInUse,
                    templateLaunchPoint : "table"
                });
                fibreChanneldialog.show();

            }
            else if (this.templateType == "SAS") {

                var sasdialog = new support.dialogs.SASBootTargetTemplate({
                    templateIDNum: this.templateIDNum,
                    templateMode: "edit",
                    templateInUse: this.templateInUse,
                    templateLaunchPoint : "table"
                });
                sasdialog.show();

            }
            else if (this.templateType == "SystemInfo") {

                var sitdialog = new support.dialogs.SystemInfoTemplate({
                    templateIDNum: this.templateIDNum,
                    templateMode: "edit",
                    templateInUse: this.templateInUse,
                    templateLaunchPoint : "table"
                });
                sitdialog.show();

            }
            else if (this.templateType == "PerformanceRecovery") {

                var partdialog = new support.dialogs.PerformanceAndRecoveryTemplate({
                    templateIDNum: this.templateIDNum,
                    templateMode: "edit",
                    templateInUse: this.templateInUse,
                    templateLaunchPoint : "table"
                });
                partdialog.show();

            }
            else if (this.templateType == "DevicesAndIOPorts") {

                var daiptdialog = new support.dialogs.DevicesAndIOPortsTemplate({
                    templateIDNum: this.templateIDNum,
                    templateMode: "edit",
                    templateInUse: this.templateInUse,
                    templateLaunchPoint : "table"
                });
                daiptdialog.show();

            }
            else if (this.templateType == "Management") {

                var miteditdialog = new support.dialogs.ManagementInterfaceTemplate({
                    templateIDNum: this.templateIDNum,
                    templateMode: "edit",
                    templateInUse: this.templateInUse,
                    templateLaunchPoint : "table"
                });
                miteditdialog.show();

            }
            else if (this.templateType == "Adapter") {

                var atDialog = new support.dialogs.NewAdapterTemplate({
                    templateIDNum: this.templateIDNum,
                    templateMode: "edit",
                    templateInUse: this.templateInUse,
                    templateLaunchPoint : "table"
                });
                atDialog.show();

            }
            else if (this.templateType == "PortVirtualization") {

                var pvtDialog = new support.dialogs.NewPortVirtualizationTemplate({
                    templateIDNum: this.templateIDNum,
                    templateMode: "edit",
                    templateInUse: this.templateInUse,
                    templateLaunchPoint : "table"
                });
                pvtDialog.show();

            }
            else if (this.templateType == "PortPhysicalFunction") {

                var pptDialog = new support.dialogs.NewPortPhysicalFunctionTemplate({
                    templateIDNum: this.templateIDNum,
                    templateMode: "edit",
                    templateInUse: this.templateInUse,
                    templateLaunchPoint : "table"
                });
                pptDialog.show();

            }else if(this.templateType == "Policy"){
                                
                var fptDialog = new support.dialogs.FailoverPolicyTemplate({
                    templateIDNum: this.templateIDNum.toString(),
                    templateMode: "edit",
                    templateInUse: this.templateInUse,
                    templateLaunchPoint : "table"
                });
                fptDialog.show();
            }else if(this.templateType == "Pool"){

                var ipeditdialog = new support.dialogs.NewIPPool({
                    poolIDNum: this.templateIDNum.toString(),
                    editMode: true,
                    templateInUse: this.templateInUse,
                    templateLaunchPoint : "table"
                });
                ipeditdialog.show();
                
           }

            return false;
        },       
        // Deploy Template
        deployTemplate: function() {

            if (this.templateIDNum != null && this.templateIDNum != "") {
                var dst = new support.dialogs.DeployServerTemplate({
                    templateId: this.templateIDNum
                });
                dst.show();
            }

        },
     // Copy Template
        copyTemplate: function() {

            if (this.templateType == "Server") {

                var stweditdialog = new support.dialogs.ServerTemplateWizard({
                    templateIDNum: this.templateIDNum,
                    copyMode: true
                });
                stweditdialog.show();

            }
            else if (this.templateType == "Power") {

                var psceditdialog = new support.dialogs.PowerStateAndCappingTemplate({
                    templateIDNum: this.templateIDNum,
                    templateMode: "copy"
                });
                psceditdialog.show();

            }
            else if (this.templateType == "PXE") {

                var pxedialog = new support.dialogs.PXENetworkBootTargetTemplate({
                    templateIDNum: this.templateIDNum,
                    templateMode: "copy"
                });
                pxedialog.show();

            }
            else if (this.templateType == "FibreChannel") {

                var fibreChanneldialog = new support.dialogs.FibreChannelBootTargetTemplate({
                    templateIDNum: this.templateIDNum,
                    templateMode: "copy"
                });
                fibreChanneldialog.show();

            }
            else if (this.templateType == "SAS") {

                var sasdialog = new support.dialogs.SASBootTargetTemplate({
                    templateIDNum: this.templateIDNum,
                    templateMode: "copy"
                });
                sasdialog.show();

            }
            else if (this.templateType == "SystemInfo") {

                var sitdialog = new support.dialogs.SystemInfoTemplate({
                    templateIDNum: this.templateIDNum,
                    templateMode: "copy"
                });
                sitdialog.show();

            }
            else if (this.templateType == "PerformanceRecovery") {

                var partdialog = new support.dialogs.PerformanceAndRecoveryTemplate({
                    templateIDNum: this.templateIDNum,
                    templateMode: "copy"
                });
                partdialog.show();

            }
            else if (this.templateType == "DevicesAndIOPorts") {

                var daiptdialog = new support.dialogs.DevicesAndIOPortsTemplate({
                    templateIDNum: this.templateIDNum,
                    templateMode: "copy"
                });
                daiptdialog.show();

                // this.partDialog.set("templateIDNum",this.templateEditID.toString());
                // this.partDialog.show();

            }
            else if (this.templateType == "Management") {

                var miteditdialog = new support.dialogs.ManagementInterfaceTemplate({
                    templateIDNum: this.templateIDNum,
                    templateMode: "copy"
                });
                miteditdialog.show();

            }
            else if (this.templateType == "Adapter") {

                var atDialog = new support.dialogs.NewAdapterTemplate({
                    templateIDNum: this.templateIDNum,
                    templateMode: "copy"
                });
                atDialog.show();

            }
            else if (this.templateType == "PortVirtualization") {

                var pvtDialog = new support.dialogs.NewPortVirtualizationTemplate({
                    templateIDNum: this.templateIDNum,
                    templateMode: "copy"
                });
                pvtDialog.show();

            }
            else if (this.templateType == "PortPhysicalFunction") {

                var pptDialog = new support.dialogs.NewPortPhysicalFunctionTemplate({
                    templateIDNum: this.templateIDNum,
                    templateMode: "copy"
                });
                pptDialog.show();

            }else if(this.templateType == "Policy"){
               var fptDialog = new support.dialogs.FailoverPolicyTemplate({
                    templateIDNum: this.templateIDNum,
                    templateMode: "copy"
                });
                fptDialog.show();
            }

            return false;
        },
        // Rename Template
        renameTemplate: function() {

            if(this.templateType == "Policy"){
                var renamedialog = new support.dialogs.Rename({
                    templateIDNum: this.templateIDNum,
                    saveTemplateType: this.policyType
                });
                renamedialog.show();
            }else if(this.templateType == "Pool"){
                var renamedialog = new support.dialogs.Rename({
                    templateIDNum: this.templateIDNum,
                    ippoolMode: true
                });
                renamedialog.show();
            }else{
                var renamedialog = new support.dialogs.Rename({
                    templateIDNum: this.templateIDNum
                });
                renamedialog.show();
            }
        },
        cancelClicked: function() {      
            this.hide();
        },
        createServerTemplate: function() {

            var stwdialog = new support.dialogs.ServerTemplateWizard({
                templateIDNum: null,
                editMode: false
            });
            
            stwdialog.show();
        },
        restartServer: function(){
            
            alert("Restart Server");
            
        },
        resetStorage: function(){
            
            alert("Reset Storgage");
            
        },
        assignProfile: function(){
            alert("Assign Profile");
        }



        
    });

});