/*
 * Licensed Materials - Property of IBM
 * 
 * OCO Source Materials
 * 
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 * 
 * The source code for this program is not published or other- wise divested of its trade secrets,
 * irrespective of what has been deposited with the U.S. Copyright Office.
 */
define({
  root: {
    NEWTITILE: "New Security Pattern",
    TITLE: "Security Pattern",
    EDITTITLE: "Edit Security Pattern",
    SECURITY: "Security",
    OVR_SECURIT: "Overall security policy",
    CENTRALIZED: "Centralized",
    CENT_MSG1: "This setting is overridden by the user authentication method setting in this pattern.",
    CENT_MSG2: "When the user authentication method is set to &quot;Centralized user management via %1&quot;, the overall security policy will be set the same as the %2 security policy when this pattern is deployed.",
    CENT_MSG3: "The user authentication method can be changed via Global Login Settings in this pattern.",
    CENT_MSG4: "When the user authentication method is set to &quot;Centralized user management via %1&quot; or &quot;External authentication server only&quot;, account level security does not apply and is not changed on target systems when this pattern is deployed.",
    GLOB_LOGIN: "Global Login Settings",
    SECURE: "Secure",
    LEGACY: "Legacy",
    SECURE_MSG: "This is the default security setting that establishes a secure chassis infrastructure with a moderate level of user control over the chassis configuration. "
            + "The Secure level of security policy provides the following settings",
    SECURE_PT1: "Password policies are automatically checked and required to be strong",
    SECURE_PT2: "Well-known passwords for network login are automatically required to be changed after initial setup",
    SECURE_PT3: "Only secure communication protocols may be enabled",
    SECURE_PT4: "Certificates for establishing secure and trusted connections to applications running on management processors are automatically generated and managed by the system",
    SECURE_FIXED: "This setting is fixed at High security when the Overall Security Policy setting in this pattern is set to Secure.",
    LEGACY_MSG: "The Legacy level of security policy provides the user with the greatest level of flexibility and responsibility for managing platform security, but this policy is least secure overall. "
            + "Some of the attributes of Legacy security policy level are listed below",
    LEGACY_PT1: "Weak password policies are permitted",
    LEGACY_PT2: "Well-known passwords for network login are not required to be changed",
    LEGACY_PT3: "Unencrypted communication protocols may be enabled",
    USER_AUTH: "User authentication method",
    USER_AUTH_OPT1: "Centralized user management via %1",
    USER_AUTH_OPT2: "Local authentication only",
    USER_AUTH_OPT3: "External authentication server only",
    USER_AUTH_OPT4: "Local first, then external authentication server",
    USER_AUTH_OPT5: "External first, then local authentication",
    TIMEOUT: "Web inactivity session timeout",
    TIMEOUT_OPT1: "User selects timeout period",
    TIMEOUT_OPT2: "No timeout",
    CLI_TIMEOUT: "CLI inactivity session timeout (seconds)",
    CLI_TIMEOUT_MSG: "The valid range is from %1 to %2 seconds inclusive.",
    USER_EVT: "User login event logging",
    LOG_ALL: "Log All",
    LOG_NONE: "Log None",
    LOG_DELAY: "Limit Duplicates",
    LOG_DELAY_MSG: "Suspend logging of duplicate login events from same user account",
    LOG_DELAY_CHECK: "Ignore client's IP address when comparing user accounts",
    ACC_SEC: "Account level security",
    PW_EXP: "Password expiration period (days)",
    FORCE_USER: "Force user to change password on first access",
    MIN_PW: "Minimum password reuse cycle",
    MIN_PW2: "Minimum password change interval (hours)",
    LOCK: "Account is locked for %1 minutes after %2 login failures",
    COMPLEX_PW: "Complex password rules with %1 degrees of difference from previous password",
    ALERT: "Alert on account inactivity after %1 days",
    ACCT_DISABLE: "Accounts disabled after %1 days of inactivity",
    FACT_DEF: "Factory default &quot;USERID&quot; account password must be changed",
    SIMPLE_PW: "Simple password rules",
    ACCT_INACT: "Account inactivity monitoring",
    OVERRIDE_MSG: "Overridden by the Overall Security Policy setting in this pattern. "
            + "The &quot;Overall Security Policy&quot; under &quot;Security&quot; must be set to Legacy to allow this account level security option.",
    TT1_1: "Some user authentication method choices can override other settings in this pattern. "
            + "Selecting &quot;Centralized user management via %1&quot; or &quot;External authentication server only&quot; will override the following settings",
    TT1_2: "Security: Overall security policy",
    TT1_3: "Global Login Settings: Account level security",
    EXTERNAL: "External"
  },
  "en": true,
  "zh": true
});