/*
 * Licensed Materials - Property of IBM
 * 
 * OCO Source Materials
 * 
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 * 
 * The source code for this program is not published or other- wise divested of its trade secrets,
 * irrespective of what has been deposited with the U.S. Copyright Office.
 */
define({
  root: {
    EDIT_DIALOG: "Edit IP Address Pool",
    ADD_DIALOG: "New IP Address Pool",
    IP_DESCRIPTION: "IP address pools provide a means of assigning static "
            + "IP addresses to endpoints by referencing a specific IP "
            + "address pool when defining a configuration pattern. The "
            + "IP address pool defines the range of IP addresses that can be assigned.",
    SAME_NETWORK_WARNING: "In order to prevent disruption of communications between %1 "
            + "and the managed systems, you should ensure the addresses being defined in the IP address pools "
            + "are reachable by %2.",
    DESC: "Description (limit of %1 characters):",
    SELECT_IP_VERSION: "Select internet protocol version",
    SPECIFY_NETWORK_INFO: "Specify network information",
    GATEWAY: "Gateway address",
    SUBNET: "Subnet mask",
    ROUTING: "Routing prefix length",
    SUBRANGE_TABLE_TITLE: "Define IP pool address subranges",
    SUBRANGE_TABLE_TOOLTIP: "All subranges must be part of the same sub network and are bounded by "
            + "the limits shown in the Overall Network Information table. Subranges have "
            + "%1 domain scope. In a multiple %2 environment, you can create unique "
            + "subranges for each system manager to avoid address conflicts, and to avoid address "
            + "conflicts with existing IP management tools. Subranges can also be used to "
            + "separate hosts by operating system type, workload types, business "
            + "function, etc. and tie to organizational network rules.",
    ADD_SUBRANGE: "Add Range",
    ADD_SUBRANGE_TITLE: "Click to add IP address range",
    NETWORK_INFO: "Overall Network Information",
    NETWORK_TABLE_TOOLTIP_IPV4: "The overall address pool range is derived from the specified "
            + "subnet mask, and gateway or initial subrange. You can create "
            + "pools of different sizes based on the specific subnet mask, "
            + "but overall pool ranges must be unique within the management domain. "
            + "Subranges are then created from the overall pool range. Pool "
            + "and subranges have %1 domain scope. In a multiple %2 "
            + "environment, you can create unique pools and subranges for each system manager to avoid address conflicts",
    NETWORK_TABLE_TOOLTIP_IPV6: "The overall address pool range is derived from the specified "
            + "routing prefix length, and gateway or initial subrange. You "
            + "can create pools of different sizes based on the specific routing "
            + "prefix length, but overall pool ranges must be unique within the management domain."
            + "Subranges are then created from the overall pool range. "
            + "Pool and subranges have %1 domain scope. In a multiple %2 "
            + "environment, you can create unique pools and subranges for each system manager to avoid address conflicts.",
    SUBRANGE_NO_DATA_MESSAGE: "None. At least one range is required",
    NETWORK_NO_DATA_MESSAGE: "Overall network information not available.",
    RANGE_NAME: "Range Name",
    FIRST_ADDRESS: "First Address",
    RANGE_SIZE: "Range Size",
    LAST_ADDRESS: "Last Address",
    LOWEST_ADDRESS: "Lowest Address",
    HIGHEST_ADDRESS: "Highest Address",
    NETWORK_ID: "Network ID",
    BROADCAST: "Broadcast Address",
    HOST_ADDRESSES: "Host Addresses",
    POOL_NAME: "Pool Name",
    EDIT_TITLE: "Edit subrange",
    REMOVE_TITLE: "Remove subrange",
    NONE_SELECTED: "None Selected",
    DELETE_CONFIRMATION: "Are you sure you want to delete range name %1?",
    SWITCH_CONFIRMATION: "Switching internet protocol version will clear "
            + "information already entered. Do you wish to continue?",
    ERROR_MESSAGE: "Sorry, we had a slight problem",
    INVALID_MESSAGE: "This value is invalid",
    INVALID_MESSAGE_IPV4: "Address must have 4 groups of decimal values separated by periods, "
            + "each value in the range of 0-255. e.g. 192.168.0.1",
    INVALID_MESSAGE_IPV6: "Address must have 8 groups of hexadecimal values separated by colons, "
            + "each value in the range of 0-FFFF. Addresses can be abbreviated by omitting "
            + "leading zeros within each group, and one group of consecutive zeroes may be "
            + "replaced by a double colon. e.g. 2001:db8:0:0:1:0:0:1, 2001:0DB8:0:0:1::1",
    INVALID_MESSAGE_GATEWAY_MATCH: "Gateway address must match network ID",
    INVALID_MESSAGE_GATEWAY_BROAD: "Gateway address cannot be the same as broadcast address",
    INVALID_MESSAGE_GATEWAY_NET: "Gateway address cannot be the same as network address",
    OVERLAPPING_NETWORK: "Overall pool ranges must be unique for each IP address pool within the same management domain.<br>"
	        + "The specified subnet mask and gateway address combination result in an overall network range "
            + "that overlaps with existing IP address pools.<br>"
            + "The subnet mask or gateway address must be modified to avoid overlap with the following IP address pools:",
    TEMPLATE_NAME_USED: "An IP address pool with this name already exists."    
  },
  "en": true,
  "zh": true
});