define(["dojo",
        "dijit", 
        "support/panels/Panel",
        "dojo/i18n!./nls/CategoryTemplateDetails",
        "dojo/text!./templates/CategoryTemplateDetails.html",
        "support/base/NextGenUIMixin", 
        "support/widgets/OutlinePane", 
        "dijit/layout/TabContainer",
        "support/panels/CategoryDetailsDependent",
        "dijit/Toolbar",
        "dijit/ToolbarSeparator",
        "dijit/Menu",
        "dojo/dom"
        ], function(dojo, dijit, panel, mri, template) {

    
    return dojo.declare("support.panels.CategoryTemplateDetails", [ support.panels.Panel, support.base.NextGenUIMixin ], {

        // summary:
        // A panel widget extending support.panels.Panel, for use in displaying information
        // associated with a server.

        // templateString: [protected] String
        // This widget's HTML template, provided.
        templateString: template,
            
        // locResources: [protected] Object
        // This widget's National Language Source (NLS) object.
        locResources: mri, 

        // baseClass: [protected] String
        // The root CSS className to be placed on this widget's domNode.
        baseClass: "ServerDetails",
        
        // the properties used to construct the title of this page in the
        //   NextGen UI
        cpPageContext: null,
        cpPageName: null,
        
        // the name of the CSS stylesheet of this page
        spCssPathAndName: "support/panels/themes/CategoryTemplateDetails.css",

        configurationTabdata: "",
        ioAddressesTabdata: "",
        eventsTabdata: "",
        dependenciesTabdata: "",
        
        templateInformation: "",
        
        templateIDNum: "",
        templateName: "",
        templateDesc: "",
        templateInUse: false,
        templateType: "",
        templateUserDefined:"",
        
        postMixInProperties: function() {
            this.inherited(arguments);
            this.cpPageContext = "";
            this.cpPageName = this.resources.DETAILS;
        },

        postCreate: function() {
            this.inherited(arguments);

            if(this.CP_RUN_ENVIRONMENT == "augusta"){

                //Add page base in order to use the setTitle() function
                require([ "augusta/augustaUICore/core/augustaPageBase" ], dojo.hitch(this, function(PageBase) {                
                    var CP_AUGUSTA_PAGE_BASE = new augusta.augustaUICore.core.augustaPageBase();
                    dojo.safeMixin(this, CP_AUGUSTA_PAGE_BASE);            
                }));
                
                this.bwIsCacheable = false;
            }    

            this.subscribe("RefreshNameDiv", function(data) {
                // Invoke the NextGenUIMixin to change the title of the NextGen UI work area
                this.cpPageContext = data;
                
                if(this.CP_RUN_ENVIRONMENT == "fsm"){
                    //Set title in FSM
                    this.changeNextGenUITitle();
                }
                
                if(this.CP_RUN_ENVIRONMENT == "augusta"){
                    //Set Title in xHMC, only can be used if augustaPageBase mixed in
                    this.setTitle(this.cpPageContext + " - " + this.cpPageName);
                }
            });

            this.subscribe("PowerTemplateComplete", function(data) {
                // Update details page with Server Pattern new information
                this.getServerTemplateID();
                dojo.publish("RefreshNameDiv",this.templateName);
            });
            
            this.subscribe("EthTemplateComplete", function(data) {
                // Update details page with Server Pattern new information
                this.getServerTemplateID();
                dojo.publish("RefreshNameDiv",this.templateName);
            });
            
            this.subscribe("PerformanceAndRecoveryComplete", function(data) {
                // Update details page with Server Pattern new information
                this.getServerTemplateID();
                dojo.publish("RefreshNameDiv",this.templateName);
            });
            
            this.subscribe("DevicesAndIOPortsComplete", function(data) {
                // Update details page with Server Pattern new information
                this.getServerTemplateID();
                dojo.publish("RefreshNameDiv",this.templateName);
            });
            
            this.subscribe("SystemTemplateComplete", function(data) {
                // Update details page with Server Pattern new information
                this.getServerTemplateID();
                dojo.publish("RefreshNameDiv",this.templateName);
            });
            
            this.subscribe("SASBootTemplateComplete", function(data) {
                // Update details page with Server Pattern new information
                this.getServerTemplateID();
                dojo.publish("RefreshNameDiv",this.templateName);
            });
            
            this.subscribe("FibreBootTemplateComplete", function(data) {
                // Update details page with Server Pattern new information
                this.getServerTemplateID();
                dojo.publish("RefreshNameDiv",this.templateName);
            });
            
            this.subscribe("PXEBootTemplateComplete", function(data) {
                // Update details page with Server Pattern new information
                this.getServerTemplateID();
                dojo.publish("RefreshNameDiv",this.templateName);
            });
            
            this.subscribe("CreateAdapterTemplateComplete", function(data) {
                // Update details page with Server Pattern new information
                this.getServerTemplateID();
                dojo.publish("RefreshNameDiv",this.templateName);
            });
            
            this.subscribe("EditAdapterTemplateComplete", function(data) {
                // Update details page with Server Pattern new information
                this.getServerTemplateID();
                dojo.publish("RefreshNameDiv",this.templateName);
            });
            
            this.subscribe("CreatePortVirtualizationTemplateComplete", function(data) {
                // Update details page with Server Pattern new information
                this.getServerTemplateID();
                dojo.publish("RefreshNameDiv",this.templateName);
            });
            
            this.subscribe("EditPortVirtualizationTemplateComplete", function(data) {
                // Update details page with Server Pattern new information
                this.getServerTemplateID();
                dojo.publish("RefreshNameDiv",this.templateName);
            });
            
            this.subscribe("CreatePortPhysicalFunctionTemplateComplete", function(data) {
                // Update details page with Server Pattern new information
                this.getServerTemplateID();
                dojo.publish("RefreshNameDiv",this.templateName);
            });
            
            this.subscribe("EditPortPhysicalFunctionTemplateComplete", function(data) {
                // Update details page with Server Pattern new information
                this.getServerTemplateID();
                dojo.publish("RefreshNameDiv",this.templateName);
            });
                        
            this.getServerTemplateID();
                        
            // Invoke the NextGenUIMixin to change the title of the NextGen UI work area
            this.cpPageContext = this.templateName;
            
            if(this.CP_RUN_ENVIRONMENT == "fsm"){
                //Set Title in FSM
                this.changeNextGenUITitle();
            }

            if(this.CP_RUN_ENVIRONMENT == "augusta"){
                //Set Title in xHMC
                this.setTitle(this.cpPageContext + " - " + this.cpPageName);
            }
            
            this.toolbarSetup();
            
            // Dependencies Tab
//            this.dependenciesTabdata = new support.panels.DetailsDependentTable({
            this.dependenciesTabdata = new support.panels.CategoryDetailsDependent({
                id: this.id + "cp_categorytemplatedetails_categorydetailsdependent",
                mode: "categoryTemplateDetails",
                templateType: this.templateType,
                templateIDNum:this.templateIDNum,
                tableWidth: "99%",
                title:this.locResources.SVRTMPL_DEPENDENTS_TAB_TITLE
            }).placeAt(this._dependenciesTab);  
                                   
            // Events Tab
            /*this.eventsTabdata = new support.panels.DetailsDependentTable({
                mode: "detailsTab", 
                tableWidth: "99%",
                title:this.locResources.EVENTS_TAB_TITLE
            }).placeAt(this._eventsTab);*/
                                                                                                                                                                                             
        },
        //Get Server Template ID
        getServerTemplateID: function(){
            var store ="";
          
            if(this.templateIDNum == ""){  //If this templateID not provided then parse url for it
                var url = window.location.href;
                var splitUrl = url.split("cpTarget=");
                var IDarray = new Array();
                var ID = "";
                
                if(splitUrl[1]){
                    IDarray = splitUrl[1].split("&");
                }else{
                    ID = "";
                }
                
                if(IDarray[0]){
                    ID=IDarray[0];
                    
                    var xhrGet = dojo.xhrGet({
                        url: this.REST_PATH + "template/" + ID,
                        handleAs: "json",
                        sync: true,
                        preventCache: true,
                        load: function(response) {
                            console.log(response);
                            store = response;
                        }
                    });
                                 
                    this.templateInformation = store;
                    
                    this.templateIDNum = ID;
                    
                }else{  //If no ID found then ...
                                                
                    
                }
    
                                                                 
            }else{ //IF ID passed then use passed ID

                var xhrGet = dojo.xhrGet({
                    url: this.REST_PATH + "template/" + this.templateIDNum,
                    handleAs: "json",
                    sync: true,
                    preventCache: true,
                    load: function(response) {
          //              console.log(response);
                        store = response;
                    }
                });
                
                this.templateInformation = store;
            }            
            
            
         //Set Template Name and Description and InUse ... etc ....            
            //Check to see if server template info was gained
            if(this.templateInformation != "" && this.templateInformation.items != ""){  
             
                //if(this.templateInformation.items[0].name){
                    this.templateName = this.templateInformation.items[0].name;
                //}
                
                if(this.templateInformation.items[0].description){                    
                    this.DetailsTemplateDescription.innerHTML = this.templateInformation.items[0].description;
                }
                
                //if(this.templateInformation.items[0].inUse){
                    this.templateInUse = this.templateInformation.items[0].inUse;
                //}
                  
                //if(this.templateInformation.items[0].type){
                    this.templateType = this.templateInformation.items[0].type;
                    this.DetailsTemplateType.innerHTML = this.typeTitle(this.templateType);
                //}
                    this.templateUserDefined = this.templateInformation.items[0].userDefined;                    
            }

            
        },
        //ToolBar Setup
        toolbarSetup: function(){
          
            this.moreMenu = new dijit.Menu({          // Add to More/Actions Menu
                style: "display: none;"
            });
      
            this.editButton = new dijit.form.Button({     //Add Edit Button to toolbar
                id: this.id + "cp_categorytemplatedetails_editbutton",
                showLabel: false,
                iconClass: "spEditLgIcon",
                disabled: false,
                title: this.resources.EDIT_PATTERN_TITLE,
                onClick: dojo.hitch(this, this.editTemplate),
                onKeypress: dojo.hitch(this, this.editTemplate)
            });
            this.detailsToolBar.addChild(this.editButton);
            
            // Add to More/Actions Menu                    
            this.detailsSeparator = new dijit.ToolbarSeparator();
            this.detailsToolBar.addChild(this.detailsSeparator);
            
            this.copyItem = new dijit.MenuItem({
               // id: this.id + "cp_categorytemplatedetails_copyitem",
                label: this.resources.COPY,
                title: this.resources.COPY_PATTERN_TITLE,
                onClick: dojo.hitch(this, this.copyTemplate),
                onKeypress: dojo.hitch(this, this.copyTemplate)
            });
            this.moreMenu.addChild(this.copyItem);

            this.renameItem = new dijit.MenuItem({
               // id: this.id + "cp_categorytemplatedetails_renameitem",
                label: this.resources.RENAME,
                title: this.resources.RENAME_PATTERN_TITLE,
                onClick: dojo.hitch(this, this.renameTemplate),
                onKeypress: dojo.hitch(this, this.renameTemplate)
            });
            
            this.editItem = new dijit.MenuItem({
               // id: this.id + "cp_categorytemplatedetails_edititem",
                label: this.resources.EDIT,
                title: this.resources.EDIT_PATTERN_TITLE,
                iconClass: "spEditLgIcon",
                onClick: dojo.hitch(this, this.editTemplate),
                onKeypress: dojo.hitch(this, this.editTemplate)
            });
            this.moreMenu.addChild(this.editItem,0);
            
            if (this.templateUserDefined != false) {     //Add rename item if pattern not predefined
                this.moreMenu.addChild(this.renameItem);
            }
            
            this.moreButton = new dijit.form.DropDownButton({
                id: this.id + "cp_categorytemplatedetails_morebutton",
                showLabel: true,
                label: this.resources.ALL_ACTIONS,
                title: this.resources.ALL_ACTIONS_TITLE,
                dropDown: this.moreMenu
            });

            this.detailsToolBar.addChild(this.moreButton);

//            if(dojo.byId("toolbarDiv")){
  //              var toolbarContainer = dojo.byId("toolbarDiv");
    //            this.detailsToolBar.placeAt(toolbarContainer);  
      //      }
            
        },
        //Return type title
        typeTitle: function(templateType){
          
            if (templateType == "Power") {
                templateType = this.resources.SERVER_POWER;
            }
            else if (templateType == "PXE") {
                templateType = this.resources.SERVER_PXE;
            }
            else if (templateType == "FibreChannel") {
                templateType = this.resources.SERVER_FIBRE;
            }
            else if (templateType == "SAS") {
                templateType = this.resources.SERVER_SAS;
            }
            else if (templateType == "SystemInfo") {
                templateType = this.resources.SERVER_INFO;
            }
            else if (templateType == "PerformanceRecovery") {
                templateType = this.resources.SERVER_PERFORM;
            }
            else if (templateType == "DevicesAndIOPorts") {
                templateType = this.resources.SERVER_DEVICE;
            }
            else if (templateType == "Management") {
                templateType = this.resources.SERVER_MGMT;
            }
            else if (templateType == "Adapter") {
                templateType = this.resources.SERVER_ADAPTER;
            }
            else if (templateType == "PortVirtualization") {
                templateType = this.resources.SERVER_PORT;
            }
            else if (templateType == "PortPhysicalFunction") {
                templateType = this.resources.SERVER_PORTPF;
            }            
            else if (templateType == "ExtendedIMM") {
                templateType = this.resources.SERVER_EXIMM;
            }
            else if (templateType == "ExtendedUEFI") {
                templateType = this.resources.SERVER_EXUEFI;                
            }
            else if (templateType == "ExtendedPort") {
                templateType = this.resources.SERVER_EXPORT;
            }else{
                templateType = "";
            }

            return templateType;
            
        },
        // Edit Template
        editTemplate: function() {
        
            if (this.templateType == "Power") {

                require([ "support/dialogs/PowerStateAndCappingTemplate" ], dojo.hitch(this, function() {
                    var psceditdialog = new support.dialogs.PowerStateAndCappingTemplate({
                        id: this.id + "cp_categorytemplatedetails_powerstateandcapping",
                        templateIDNum: this.templateIDNum,
                        templateMode: "edit",
                        templateInUse: this.templateInUse,
                        templateLaunchPoint : "table"
                    });
                    psceditdialog.show();
                }));

            }
            else if (this.templateType == "PXE") {
                require([ "support/dialogs/PXENetworkBootTargetTemplate" ], dojo.hitch(this, function() {
                    var pxedialog = new support.dialogs.PXENetworkBootTargetTemplate({
                        id: this.id + "cp_categorytemplatedetails_pxenetworkboottarget",
                        templateIDNum: this.templateIDNum,
                        templateMode: "edit",
                        templateInUse: this.templateInUse,
                        templateLaunchPoint : "table"
                    });
                    pxedialog.show();
                }));
            }
            else if (this.templateType == "FibreChannel") {
                require([ "support/dialogs/FibreChannelBootTargetTemplate" ], dojo.hitch(this, function() {
                    var fibreChanneldialog = new support.dialogs.FibreChannelBootTargetTemplate({
                        id: this.id + "cp_categorytemplatedetails_fibrechannelboottarget",
                        templateIDNum: this.templateIDNum,
                        templateMode: "edit",
                        templateInUse: this.templateInUse,
                        templateLaunchPoint : "table"
                    });
                    fibreChanneldialog.show();
                }));
            }
            else if (this.templateType == "SAS") {
                require([ "support/dialogs/SASBootTargetTemplate" ], dojo.hitch(this, function() {
                    var sasdialog = new support.dialogs.SASBootTargetTemplate({
                        id: this.id + "cp_categorytemplatedetails_sasboottarget",
                        templateIDNum: this.templateIDNum,
                        templateMode: "edit",
                        templateInUse: this.templateInUse,
                        templateLaunchPoint : "table"
                    });
                    sasdialog.show();
                }));
            }
            else if (this.templateType == "SystemInfo") {
                require([ "support/dialogs/SystemInfoTemplate" ], dojo.hitch(this, function() {
                    var sitdialog = new support.dialogs.SystemInfoTemplate({
                        id: this.id + "cp_categorytemplatedetails_systeminfo",
                        templateIDNum: this.templateIDNum,
                        templateMode: "edit",
                        templateInUse: this.templateInUse,
                        templateLaunchPoint : "table"
                    });
                    sitdialog.show();
                }));
            }
            else if (this.templateType == "PerformanceRecovery") {
                require([ "support/dialogs/PerformanceAndRecoveryTemplate" ], dojo.hitch(this, function() {
                    var partdialog = new support.dialogs.PerformanceAndRecoveryTemplate({
                        id: this.id + "cp_categorytemplatedetails_performanceandrecovery",
                        templateIDNum: this.templateIDNum,
                        templateMode: "edit",
                        templateInUse: this.templateInUse,
                        templateLaunchPoint : "table"
                    });
                    partdialog.show();
                }));
            }
            else if (this.templateType == "DevicesAndIOPorts") {
                require([ "support/dialogs/DevicesAndIOPortsTemplate" ], dojo.hitch(this, function() {
                    var daiptdialog = new support.dialogs.DevicesAndIOPortsTemplate({
                        id: this.id + "cp_categorytemplatedetails_devicesandioports",
                        templateIDNum: this.templateIDNum,
                        templateMode: "edit",
                        templateInUse: this.templateInUse,
                        templateLaunchPoint : "table"
                    });
                    daiptdialog.show();
                }));

            }
            else if (this.templateType == "Management") {
                require([ "support/dialogs/ManagementInterfaceTemplate" ], dojo.hitch(this, function() {
                    var miteditdialog = new support.dialogs.ManagementInterfaceTemplate({
                        id: this.id + "cp_categorytemplatedetails_managementinterface",
                        templateIDNum: this.templateIDNum,
                        templateMode: "edit",
                        templateInUse: this.templateInUse,
                        templateLaunchPoint : "table"
                    });
                    miteditdialog.show();
                }));

            }
            else if (this.templateType == "Adapter") {
                require([ "support/dialogs/NewAdapterTemplate" ], dojo.hitch(this, function() {
                    var atDialog = new support.dialogs.NewAdapterTemplate({
                        id: this.id + "cp_categorytemplatedetails_newadapter",
                        templateIDNum: this.templateIDNum,
                        templateMode: "edit",
                        templateInUse: this.templateInUse,
                        templateLaunchPoint : "table"
                    });
                    atDialog.show();
                }));

            }
            else if (this.templateType == "PortVirtualization") {
                require([ "support/dialogs/NewPortVirtualizationTemplate" ], dojo.hitch(this, function() {
                    var pvtDialog = new support.dialogs.NewPortVirtualizationTemplate({
                        id: this.id + "cp_categorytemplatedetails_newportvirtualization",
                        templateIDNum: this.templateIDNum,
                        templateMode: "edit",
                        templateInUse: this.templateInUse,
                        templateLaunchPoint : "table"
                    });
                    pvtDialog.show();
                }));
            }
            else if (this.templateType == "PortPhysicalFunction") {
                require([ "support/dialogs/NewPortPhysicalFunctionTemplate" ], dojo.hitch(this, function() {
                    var pptDialog = new support.dialogs.NewPortPhysicalFunctionTemplate({
                        id: this.id + "cp_categorytemplatedetails_newportphysicalfunction",
                        templateIDNum: this.templateIDNum,
                        templateMode: "edit",
                        templateInUse: this.templateInUse,
                        templateLaunchPoint : "table"
                    });
                    pptDialog.show();
                }));

            }            
            else if (this.templateType == "ExtendedIMM") {
                require([ "support/dialogs/NewLearnedSettingsTemplate" ], dojo.hitch(this, function() {
                    var eitDialog = new support.dialogs.NewLearnedSettingsTemplate({
                        id: this.id + "cp_categorytemplatedetails_newlearnedsettings",
                        type: "imm",
                        templateMode: "edit",
                        templateIDNum: this.templateIDNum,
                        templateInUse: this.templateInUse,
                        templateLaunchPoint: "table"
                    });

                    eitDialog.show();
                }));
            }
            else if (this.templateType == "ExtendedUEFI") {
                require([ "support/dialogs/NewLearnedSettingsTemplate" ], dojo.hitch(this, function() {
                    var eutDialog = new support.dialogs.NewLearnedSettingsTemplate({
                        id: this.id + "cp_categorytemplatedetails_newlearnedsettings",
                        type: "uefi",
                        templateMode: "edit",
                        templateIDNum: this.templateIDNum,
                        templateInUse: this.templateInUse,
                        templateLaunchPoint: "table"
                    });

                    eutDialog.show();
                }));
            }
            else if (this.templateType == "ExtendedPort") {
                require([ "support/dialogs/NewLearnedSettingsTemplate" ], dojo.hitch(this, function() {
                    var eutDialog = new support.dialogs.NewLearnedSettingsTemplate({
                        id: this.id + "cp_categorytemplatedetails_newlearnedsettings",
                        type: "port",
                        templateMode: "edit",
                        templateIDNum: this.templateIDNum,
                        templateInUse: this.templateInUse,
                        templateLaunchPoint: "table"
                    });

                    eutDialog.show();
                }));
            }

        },
        // Copy Template
        copyTemplate: function() {

            if (this.templateType == "Power") {
                require([ "support/dialogs/PowerStateAndCappingTemplate" ], dojo.hitch(this, function() {
                    var psceditdialog = new support.dialogs.PowerStateAndCappingTemplate({
                        id: this.id + "cp_categorytemplatedetails_powerstateandcapping",
                        templateIDNum: this.templateIDNum,
                        templateMode: "copy"
                    });
                    psceditdialog.show();
                }));

            }
            else if (this.templateType == "PXE") {
                require([ "support/dialogs/PXENetworkBootTargetTemplate" ], dojo.hitch(this, function() {
                    var pxedialog = new support.dialogs.PXENetworkBootTargetTemplate({
                        id: this.id + "cp_categorytemplatedetails_pxenetworkboottarget",
                        templateIDNum: this.templateIDNum,
                        templateMode: "copy"
                    });
                    pxedialog.show();
                }));

            }
            else if (this.templateType == "FibreChannel") {
                require([ "support/dialogs/FibreChannelBootTargetTemplate" ], dojo.hitch(this, function() {
                    var fibreChanneldialog = new support.dialogs.FibreChannelBootTargetTemplate({
                        id: this.id + "cp_categorytemplatedetails_fibrechannelboottarget",
                        templateIDNum: this.templateIDNum,
                        templateMode: "copy"
                    });
                    fibreChanneldialog.show();
                }));
            }
            else if (this.templateType == "SAS") {
                require([ "support/dialogs/SASBootTargetTemplate" ], dojo.hitch(this, function() {
                    var sasdialog = new support.dialogs.SASBootTargetTemplate({
                        id: this.id + "cp_categorytemplatedetails_sasboottarget",
                        templateIDNum: this.templateIDNum,
                        templateMode: "copy"
                    });
                    sasdialog.show();
                }));

            }
            else if (this.templateType == "SystemInfo") {
                require([ "support/dialogs/SystemInfoTemplate" ], dojo.hitch(this, function() {
                    var sitdialog = new support.dialogs.SystemInfoTemplate({
                        id: this.id + "cp_categorytemplatedetails_systeminfo",
                        templateIDNum: this.templateIDNum,
                        templateMode: "copy"
                    });
                    sitdialog.show();
                }));
            }
            else if (this.templateType == "PerformanceRecovery") {
                require([ "support/dialogs/PerformanceAndRecoveryTemplate" ], dojo.hitch(this, function() {
                    var partdialog = new support.dialogs.PerformanceAndRecoveryTemplate({
                        id: this.id + "cp_categorytemplatedetails_performanceandrecovery",
                        templateIDNum: this.templateIDNum,
                        templateMode: "copy"
                    });
                    partdialog.show();
                }));

            }
            else if (this.templateType == "DevicesAndIOPorts") {
                require([ "support/dialogs/DevicesAndIOPortsTemplate" ], dojo.hitch(this, function() {
                    var daiptdialog = new support.dialogs.DevicesAndIOPortsTemplate({
                        id: this.id + "cp_categorytemplatedetails_devicesandioports",
                        templateIDNum: this.templateIDNum,
                        templateMode: "copy"
                    });
                    daiptdialog.show();
                }));
            }
            else if (this.templateType == "Management") {
                require([ "support/dialogs/ManagementInterfaceTemplate" ], dojo.hitch(this, function() {
                    var miteditdialog = new support.dialogs.ManagementInterfaceTemplate({
                        id: this.id + "cp_categorytemplatedetails_managementinterface",
                        templateIDNum: this.templateIDNum,
                        templateMode: "copy"
                    });
                    miteditdialog.show();
                }));


            }
            else if (this.templateType == "Adapter") {
                require([ "support/dialogs/NewAdapterTemplate" ], dojo.hitch(this, function() {
                    var atDialog = new support.dialogs.NewAdapterTemplate({
                        id: this.id + "cp_categorytemplatedetails_newadapter",
                        templateIDNum: this.templateIDNum,
                        templateMode: "copy"
                    });
                    atDialog.show();
                }));

            }
            else if (this.templateType == "PortVirtualization") {
                require([ "support/dialogs/NewPortVirtualizationTemplate" ], dojo.hitch(this, function() {
                    var pvtDialog = new support.dialogs.NewPortVirtualizationTemplate({
                        id: this.id + "cp_categorytemplatedetails_newportvirtualization",
                        templateIDNum: this.templateIDNum,
                        templateMode: "copy"
                    });
                    pvtDialog.show();
                }));

            }
            else if (this.templateType == "PortPhysicalFunction") {
                require([ "support/dialogs/NewPortPhysicalFunctionTemplate" ], dojo.hitch(this, function() {
                    var pptDialog = new support.dialogs.NewPortPhysicalFunctionTemplate({
                        id: this.id + "cp_categorytemplatedetails_newportphysicalfunction",
                        templateIDNum: this.templateIDNum,
                        templateMode: "copy"
                    });
                    pptDialog.show();
                }));
            }
            else if (this.templateType == "ExtendedIMM") {
                require([ "support/dialogs/NewLearnedSettingsTemplate" ], dojo.hitch(this, function() {
                    var eitDialog = new support.dialogs.NewLearnedSettingsTemplate({
                        id: this.id + "cp_categorytemplatedetails_newlearnedsettings",
                        type: "imm",
                        templateMode: "copy",
                        templateIDNum: this.templateIDNum
                    });

                    eitDialog.show();
                }));
            }
            else if (this.templateType == "ExtendedUEFI") {
                require([ "support/dialogs/NewLearnedSettingsTemplate" ], dojo.hitch(this, function() {
                    var eutDialog = new support.dialogs.NewLearnedSettingsTemplate({
                        id: this.id + "cp_categorytemplatedetails_newlearnedsettings",
                        type: "uefi",
                        templateMode: "copy",
                        templateIDNum: this.templateIDNum
                    });

                    eutDialog.show();
                }));
            }
            else if (this.templateType == "ExtendedPort") {
                require([ "support/dialogs/NewLearnedSettingsTemplate" ], dojo.hitch(this, function() {
                    var eutDialog = new support.dialogs.NewLearnedSettingsTemplate({
                        id: this.id + "cp_categorytemplatedetails_newlearnedsettings",
                        type: "port",
                        templateMode: "copy",
                        templateIDNum: this.templateIDNum
                    });

                    eutDialog.show();
                }));
            }


        },
        // Rename Template
        renameTemplate: function() {
            
            require([ "support/dialogs/Rename" ], dojo.hitch(this, function() {
                var renamedialog = new support.dialogs.Rename({
                    id: this.id + "cp_categorytemplatedetails_rename",
                    templateIDNum: this.templateIDNum,
                    launchPoint: "details"
                });
                renamedialog.show();
            }));
            
        }
    });

});