define([
        "dojo",
        "dijit",
        "support/panels/Panel",
        "dojo/i18n!./nls/CheckButton",
        "dojo/text!./templates/CheckButton.html",
        "dijit/form/ToggleButton",
        "dijit/form/Button"
    ], function (dojo, dijit, panel, mri, template) {

	return dojo.declare("support.panels.CheckButton", [ support.panels.Panel ], {
	    
	    // templateString: [protected] String
	    // This widget's HTML template, provided.
	    templateString: template,
	        
	    // locResources: [protected] Object
	    // This widget's National Language Source (NLS) object.
	    locResources: mri, 
	    
		widgetsInTemplate : true,
		baseClass : "CheckButton", // This widget's base CSS classname.
		checked : false,
		label: "",
		
        // the name of the CSS stylesheet of this page
        spCssPathAndName: "support/panels/themes/CheckButton.css",

		// postCreate() is called after buildRendering(). This is useful to override when
		// you need to access and/or manipulate DOM nodes included with your widget.
		// DOM nodes and widgets with the dojoAttachPoint attribute specified can now be
		// directly
		// accessed as fields on "this".
		// Common operations for postCreate
		// 1) Access and manipulate DOM nodes created in buildRendering()
		// 2) Add new DOM nodes or widgets
		postCreate : function () {
			this.inherited(arguments);
			this._checkButton.set("checked", this.checked);
			if(this.checked)
				this._checkButton.set("iconClass", "spCheckedBoxIcon");
			else
				this._checkButton.set("iconClass", "spUncheckedBoxIcon");
		},

		onClick : function (evt) {
			// Does nothing.
			// Override to specify custom handler.        
		},

		_onClick : function (evt) {
			//toggle iconClass
			var iconClass = this._checkButton.get("iconClass");
			if(iconClass == "spCheckedBoxIcon"){
				this._checkButton.set("iconClass", "spUncheckedBoxIcon");
				this.checked = false;
			}
			else{
				this._checkButton.set("iconClass", "spCheckedBoxIcon");
				this.checked = true;
			}
			this.onClick(evt);

		},
		setAttrChecked : function (c){
		    this.checked= c;
	           
	        if(this.checked)
	            this._checkButton.set("iconClass", "spCheckedBoxIcon");
	        else
	            this._checkButton.set("iconClass", "spUncheckedBoxIcon");
	        
		}
	});
});
