define([ "dojo", 
         "dijit", 
         "support/panels/Panel", 
         "dojo/i18n!./nls/CustomNamingTable", 
         "dojo/text!./templates/CustomNamingTable.html", 
         "dojo/_base/lang", 
         "dijit/form/MultiSelect",
         "dijit/form/Button", 
         "support/widgets/OutlinePane",
         "dijit/Tooltip" ], 
		function (dojo, dijit, panel, mri, template, lang) {

	dojo.declare("support.panels.CustomNamingTable", [ support.panels.Panel ], {
	    // the name of the CSS stylesheet of this page
        spCssPathAndName: "support/panels/themes/CustomNamingTable.css",
        
        // templateString: [protected] String
        // This widget's HTML template, provided.
        templateString: template,
            
        // locResources: [protected] Object
        // This widget's National Language Source (NLS) object.
        locResources: mri, 
        
        _selectionList: null,
        _editDisabled: true,
        _deleteDisabled: true,
        _selectedNode: null,
        _selectedNodeCustomText: null,
        _exampleSystemLocation: null,
        _exampleRoom: null,
        _exampleRack: null,
        _exampleLowestRackUnit: "7",
        _exampleChassisBay: "5",
        _customTextCounter: 0,
        _namelimit: null,
        _hostnamelimit: null,
        _exampleelements: null,
        _actualelements: null,
        _namingtooltip: "",
        _moveRightButtonEnabled: false,
        _moveLeftButtonEnabled: false,
        
        templateType: "sys",
        defaultpatternlength: 15,
        namepattern: null,
        
		widgetsInTemplate : true,
		baseClass: "CustomNamingTable",		
			
		postMixInProperties : function() {
		    this.inherited(arguments);
		    
		    this._exampleSystemLocation = this.locResources.SYSTEMLOCATIONEXAMPLE;
		    this._exampleRoom = this.locResources.ROOMEXAMPLE;
		    this._exampleRack = this.locResources.RACKEXAMPLE;
		    
		    if (this.templateType == "sys") {
		        this._namelimit = this.locResources.SYSTEMNAMELIMIT.replace("%1", 15).replace("%2", 15);
	            this._exampleelements = this.locResources.NOPREDEF_EXAMPLE;
	            //this._namingTip.style.display = "none";
		    }
		    
		    if (this.templateType == "chassis") {
		        this._namelimit = this.locResources.CHASSISNAMELIMIT.replace("%1", 15).replace("%2", 15);
	            this._exampleelements = this.locResources.CHASSISINFO_EXAMPLE;
	            //this._namingTip.style.display = "none";
		    }
		    
		    if (this.templateType == "mgmt" || this.templateType == "chassismgmt") {
		        this.defaultpatternlength = 63;
		        //this._namelimit = this.locResources.HOSTNAMELIMIT.replace("%1", 63).replace("%2", 63);
		        if (this.templateType == "mgmt") {
		            this._namelimit = this.locResources.HOSTNAMELIMIT.replace("%1", 63).replace(
	                        "%2", this.locResources.IMM).replace("%3", 63);
		            this._exampleelements = this.locResources.SYSTEM_EXAMPLE_ELEMENTS + " " + this.locResources.NOPREDEF_EXAMPLE;
		            this._namingtooltip = this.locResources.NAMING_SCHEME_TIP.replace(
		                "%1", this.locResources.SYSTEMLOCATION).replace("%2", this.locResources.SYSTEM_INFO).replace(
		                "%3", this.resources.SERVER_TEMP).replace("%4", this.locResources.SYSTEM_INFO).replace("%5", this.locResources.FIRMWARE_SETTINGS); 
		        } else if (this.templateType == "chassismgmt") {
		            this._namelimit = this.locResources.HOSTNAMELIMIT.replace("%1", 63).replace(
		                "%2", this.locResources.CMM).replace("%3", 63);
		            this._exampleelements = this.locResources.CHASSIS_EXAMPLE_ELEMENTS + " " + this.locResources.CHASSISINFO_EXAMPLE;
		            this._namingtooltip = this.locResources.NAMING_SCHEME_TIP.replace(
	                        "%1", this.locResources.LOCATION_ROOM).replace("%2", this.locResources.CHASSIS_INFO).replace(
	                        "%3", this.resources.CHASSIS_TEMP).replace("%4", this.locResources.CHASSIS_INFO).replace("%5", this.locResources.MGMT_MODULE);
		        }
		    }
		    
		    /* Several options have been removed for this release  
            this._exampleelements = this.locResources.EXAMPLEELEMENTS.replace(
                    "%1", this._exampleSystemLocation).replace("%2", "<i>" + this.locResources.SYSTEMLOCATION + "</i>").replace(
                    "%3", this._exampleRoom).replace("%4", "<i>" + this.locResources.ROOM + "</i>").replace(
                    "%5", this._exampleRack).replace("%6", "<i>" + this.locResources.RACK + "</i>").replace(
                    "%7", this._exampleLowestRackUnit).replace("%8", "<i>" + this.locResources.LOWESTRACKUNIT + "</i>").replace(
                    "%9", this._exampleChassisBay).replace("%10", "<i>" + this.locResources.CHASSISBAY + "</i>");*/
            

            
		},

		postCreate : function(){	
			this.inherited(arguments);
			
			this._errorToolTip.set("connectId", this.id + "_patternErrorTip");
			this._warningToolTip.set("connectId", this.id + "_patternWarningTip");
			this._exampleToolTip.set("connectId", this.id + "_exampleToolTip");
			
			if (this.templateType == "sys" || this.templateType == "chassis") {
                this._namingTip.style.display = "none";			    
			}
			
            if (this.templateType == "sys" || this.templateType == "mgmt") {
                var customValue = dojo.doc.createElement("option");
                customValue.innerHTML = this.locResources.CUSTOMTEXT;
                customValue.value = "CT";                                               

                var locationValue = dojo.doc.createElement("option");
                locationValue.innerHTML = this.locResources.SYSTEMLOCATION;
                locationValue.value = "SL";                                               

                // Not supported for this release
                //var roomValue = dojo.doc.createElement("option");
                //var rackValue = dojo.doc.createElement("option");
                //var lruValue = dojo.doc.createElement("option");
                //var chassisbayValue = dojo.doc.createElement("option");
                //chassisbayValue.innerHTML = this.locResources.CHASSISBAY;
                //chassisbayValue.value = "CB";                               
                
                var incrementingValue = dojo.doc.createElement("option");
                incrementingValue.innerHTML = this.locResources.INCREMENTINGNUMERIC;
                incrementingValue.value = "IN";
                
                this._selectionListNode.containerNode.appendChild(customValue);                
                this._selectionListNode.containerNode.appendChild(locationValue);
                //this._selectionListNode.containerNode.appendChild(chassisbayValue);
                this._selectionListNode.containerNode.appendChild(incrementingValue);
            }
            
            if (this.templateType == "chassis" || this.templateType == "chassismgmt") {
                var customValue = dojo.doc.createElement("option");
                customValue.innerHTML = this.locResources.CUSTOMTEXT;
                customValue.value = "CT";                                               

                var locationValue = dojo.doc.createElement("option");
                locationValue.innerHTML = this.locResources.CHASSISLOCATION;
                locationValue.value = "SL";                                               

                var roomValue = dojo.doc.createElement("option");
                roomValue.innerHTML = this.locResources.ROOM;
                roomValue.value = "RM";                                      
                
                // Not supported for this release
                
                //var rackValue = dojo.doc.createElement("option");
                //var lruValue = dojo.doc.createElement("option");
                //var chassisbayValue = dojo.doc.createElement("option");
                //chassisbayValue.innerHTML = this.locResources.CHASSISBAY;
                //chassisValue.value = "CB";                               
                
                var incrementingValue = dojo.doc.createElement("option");
                incrementingValue.innerHTML = this.locResources.INCREMENTINGNUMERIC;
                incrementingValue.value = "IN";                                               

                
                this._selectionListNode.containerNode.appendChild(customValue);                
                this._selectionListNode.containerNode.appendChild(locationValue);
                this._selectionListNode.containerNode.appendChild(roomValue);
                this._selectionListNode.containerNode.appendChild(incrementingValue);                
            }			
			
			this.customNameTextBox.intermediateChanges = true; //Allow code to catch auto updates of field
			
			this.patternText.innerHTML = this.locResources.VALUE_NONE;
			dojo.publish("customNamePattern", "none");
			this._patternErrorIcon.style.display = "block";
			this.exampleText.innerHTML = this.locResources.VALUE_NONE;
			
			this._setMoveLeftButtonStatus();
			this._setMoveRightButtonStatus();
			
			if (this.namepattern != null) {
			    for(var len=0;len<this.namepattern.length;++len) {
                    if (this.namepattern[len].value[0] == "C" && this.namepattern[len].value[1] == "T") {
                        var customValue = dojo.doc.createElement("option");
                        customValue.innerHTML = "\"" + this.namepattern[len].name + "\"";
                        customValue.value = "CT" + this._customTextCounter;
                        customValue.selected = true;
                        this._selectedNodeCustomText = customValue.innerHTML;                
                        this._customListNode.containerNode.appendChild(customValue);                
                        this._selectedNode = customValue.value;
                        this._selectedNodeCustomText = customValue.innerHTML;
                        this._editDisabled = false;
                        this._deleteDisabled = false;
                        dojo.replaceClass(this._editCustomEntry, "spEditIcon", "spEditInactiveIcon");
                        dojo.replaceClass(this._deleteCustomEntry, "spDeleteIcon_v2", "spDeleteInactiveIcon_v2");
                        this._customTextCounter++;
                        this._refresh();
                        continue;
                    }			        
		            var nodeList = this._selectionListNode.containerNode.childNodes;            
		            for(var counter=0;counter < nodeList.length;++counter) {
		                if (this.namepattern[len].value == nodeList.item(counter).value) {                        
		                    nodeList.item(counter).selected = true;
		                    this._moveRight("initialLoad");		                    
		                }
		            }			        
			    }
			}
			
			this.subscribe("customTextComplete", function(data) {
                var newValue = dojo.doc.createElement("option");
                newValue.innerHTML = "\"" + data + "\"";
                newValue.value = "CT" + this._customTextCounter;
                newValue.selected = true;
                this._selectedNodeCustomText = newValue.innerHTML;                
                this._customListNode.containerNode.appendChild(newValue);                
                this._selectedNode = newValue.value;
                this._selectedNodeCustomText = newValue.innerHTML;
                this._editDisabled = false;
                this._deleteDisabled = false;
                dojo.replaceClass(this._editCustomEntry, "spEditIcon", "spEditInactiveIcon");
                dojo.replaceClass(this._deleteCustomEntry, "spDeleteIcon_v2", "spDeleteInactiveIcon_v2");
                this._customTextCounter++;
                this._refresh();
            });
            
			this.subscribe("customTextSaveComplete", function(data) {
                this._customListNode.getSelected().forEach(function(n){                    
                    if (n.value[0] != "C" && n.value[1] != "T") {
                        return;
                    }
                    n.innerHTML = "\"" + data + "\"";
                    this._selectedNodeCustomText = n.innerHTML;
                }, this);
                this._refresh();
            });          
			
			dojo.removeAttr(this.id + "_selectionListNode", "multiple");
			dojo.removeAttr(this.id + "_customListNode", "multiple");
		},
		
		startup: function(){
            this.inherited(arguments);
        },
        
        _moveLeft: function() {
            this._customListNode.getSelected().forEach(function(n){                
                if (n.value[0] == "C" && n.value[1] == "T") {                    
                    
                } else {
                    this._selectionListNode.containerNode.appendChild(n);
                    this._refresh();
                }                
            },this);               
        },
        
        _moveLeftClicked: function() {
            if (this._moveLeftButtonEnabled == true) {
                dojo.replaceClass(this._moveLeftBtn, "spMoveLeftClickedIcon_v2", "spMoveLeftIcon_v2");
            }
        },        

        
        _moveLeftReleased: function() {
            if (this._moveLeftButtonEnabled == true) {
                dojo.replaceClass(this._moveLeftBtn, "spMoveLeftHoverIcon_v2", "spMoveLeftClickedIcon_v2");
            }
        },
        
        _moveLeftHover: function() { 
            if (this._moveLeftButtonEnabled == true) {
                dojo.replaceClass(this._moveLeftBtn, "spMoveLeftHoverIcon_v2", "spMoveLeftIcon_v2");
            }
        },
        
        _moveLeftMouseOut: function() {                                    
            dojo.replaceClass(this._moveLeftBtn, "spMoveLeftIcon_v2", "spMoveLeftHoverIcon_v2");
        },        
        
        _moveRight: function(init) {                     
            var roomOrLocation = false;
            var initialLoad = false;
            if (init == "initialLoad") {
                initialLoad = true;
            }
            this._selectionListNode.getSelected().forEach(function(n){                                
                if (n.value[0] == "C" && n.value[1] == "T") {
                    this.customTextDialog.set("title", this.locResources.ADD_TITLE);
                    this.customNameTextBox.set("value", "");
                    this.addButton.domNode.style.display = "inline-block";
                    this.saveButton.domNode.style.display = "none";
                    this.customTextDialog.show();
                } else {                    
                    this._customListNode.containerNode.appendChild(n);
                    this._selectedNode = n.value;
                    if (this._selectedNode == "RM" || this._selectedNode == "SL"){
                       roomOrLocation = true;
                    }
                    this._selectedNodeCustomText = "";
                    this._editDisabled = true;
                    this._deleteDisabled = true;                    
                    dojo.replaceClass(this._editCustomEntry, "spEditInactiveIcon", "spEditIcon");
                    dojo.replaceClass(this._deleteCustomEntry, "spDeleteInactiveIcon_v2", "spDeleteIcon_v2");
                    this._refresh();
                }                
            },this);
            if (roomOrLocation && (this.templateType == "mgmt" || this.templateType == "chassismgmt")) {
                var element = "";
                var pattern = "";
                var step = "";
                if (this._selectedNode == "RM") {
                    element = this.locResources.ROOM;
                    pattern = this.locResources.CHASSIS_INFO;
                    step = this.locResources.MGMT_MODULE;
                } 
                else if (this._selectedNode == "SL" && this.templateType == "chassismgmt") {
                    element = this.locResources.CHASSISLOCATION;
                    pattern = this.locResources.CHASSIS_INFO;
                    step = this.locResources.MGMT_MODULE;
                }
                else if (this._selectedNode == "SL" && this.templateType == "mgmt") {
                    element = this.locResources.SYSTEMLOCATION;
                    pattern = this.locResources.SYSTEM_INFO;
                    step = this.locResources.FIRMWARE_SETTINGS;
                }
                
                if (!initialLoad) {
                    var infoMessage = this.locResources.INFO_MESSAGE.replace("%1", element).replace("%2", pattern).replace("%3", step);
                    infoMessage = infoMessage.replace("%4", pattern).replace("%5", step).replace("%6", element);
                    this.getModalDialog("Information", infoMessage).show();
                }
            }
        },
        
        _moveRightClicked: function() {                
            if (this._moveRightButtonEnabled == true) {
                dojo.replaceClass(this._moveRightBtn, "spMoveRightClickedIcon_v2", "spMoveRightHoverIcon_v2");
            }
        },        

        _moveRightReleased: function() {                     
            if (this._moveRightButtonEnabled == true) {             
                dojo.replaceClass(this._moveRightBtn, "spMoveRightHoverIcon_v2", "spMoveRightClickedIcon_v2");
            }
        },
        
        _moveRightHover: function() {            
            if (this._moveRightButtonEnabled == true) {
                dojo.replaceClass(this._moveRightBtn, "spMoveRightHoverIcon_v2", "spMoveRightIcon_v2");
            }
        },
        
        _moveRightMouseOut: function() {            
            dojo.replaceClass(this._moveRightBtn, "spMoveRightIcon_v2", "spMoveRightHoverIcon_v2");           
        },        
        
        _generatePatternText: function() {
            var pattern = "";
            var patternLength = 0;
            var nodeList = this._customListNode.containerNode.childNodes;
            for(var counter=0;counter < nodeList.length;++counter) {
                var nodevalue = null;
                if (nodeList.item(counter).value == undefined) {
                    continue;
                }
                if (nodeList.item(counter).value[0] == "C" && nodeList.item(counter).value[1] == "T") {
                    nodevalue = "CT";
                } else {
                    nodevalue = nodeList.item(counter).value;
                }               
                // Used to use textContent in place of innerHTML in the code below.  IE8 does not like
                // textContent but seemed okay.  IE9 and Firefox seemed to be okay with either.
                switch(nodevalue) {
                    case "CT":
                        if (nodeList.item(counter).innerHTML == this._selectedNodeCustomText) {                                                       
                            pattern = pattern + "<b>" + nodeList.item(counter).innerHTML.replace(/\"/g, "") + "</b>";
                        } else {
                            pattern = pattern + nodeList.item(counter).innerHTML.replace(/\"/g, "");
                        }
                        patternLength = patternLength + nodeList.item(counter).innerHTML.length - 2;                       
                        break;
                    default:             
                        if (nodeList.item(counter).value == this._selectedNode){                        
                            pattern = pattern + "<i><b>" + nodeList.item(counter).innerHTML + "</b></i>";
                        } else {                            
                            pattern = pattern + "<i>" + nodeList.item(counter).innerHTML + "</i>";
                        }
                        // Calculate the length to determine when the warning tooltip appears
                        switch(nodeList.item(counter).value) {
                            case "SL":
                                patternLength = patternLength + this._exampleSystemLocation.length;
                                break;
                            case "RM":
                                patternLength = patternLength + this._exampleRoom.length;
                                break;
                            case "RA":
                                patternLength = patternLength + this._exampleRack.length;
                                break;
                            case "LR":
                                patternLength = patternLength + this._exampleLowestRackUnit.length;
                                break;
                            case "CB":
                                patternLength = patternLength + this._exampleChassisBay.length;
                                break;
                            case "IN":
                                patternLength++;
                                break;
                            default:                                
                                break;
                        }                        
                        break;
                }                
            }
            if (pattern == "") {
	            this._errorToolTip.set("connectId", this.id + "_patternErrorTip");
                this._patternErrorIcon.style.display = "block";
                this._patternWarningIcon.style.display = "none";
                this.patternText.innerHTML = this.locResources.VALUE_NONE;
                dojo.publish("customNamePattern", "none");
                
            } else {
           		this.patternText.innerHTML = pattern.replace(/ /g, "");
           		
           		// IMM hostname cannot be all numeric.  Need to validate and display error/warning if needed.
            	var mgmtTemplate = (this.templateType == "mgmt");
            	if (mgmtTemplate) {
   	            	var allNumeric = this._isNumeric(pattern);
                	if (allNumeric == true) {
               			this._hostnameNumErrorToolTip.set("connectId", this.id + "_patternErrorTip");
                   		this._patternErrorIcon.style.display = "block";
                   		this._patternWarningIcon.style.display = "none";
                	} else if (allNumeric == "loc") {
                		// System Location could be all numeric.  Issue a warning in that case.
                    	this._patternErrorIcon.style.display = "none";
	           			this._hostnameNumWarningToolTip.set("connectId", this.id + "_patternWarningTip");
               			this._patternWarningIcon.style.display = "block";
               		} else {
		            	this._patternErrorIcon.style.display = "none";
						if (patternLength > this.defaultpatternlength) {
                			this._warningToolTip.set("connectId", this.id + "_patternWarningTip");
                    		this._patternWarningIcon.style.display = "block";
                		} else {
                  	  		this._patternWarningIcon.style.display = "none";
                		}
                	}
				} else {
						this._patternErrorIcon.style.display = "none";
						if (patternLength > this.defaultpatternlength) {
                			this._warningToolTip.set("connectId", this.id + "_patternWarningTip");
                    		this._patternWarningIcon.style.display = "block";
                		} else {
                  	  		this._patternWarningIcon.style.display = "none";
                		}
				}
                if (this._patternErrorIcon.style.display == "none") {
                    dojo.publish("customNamePattern", this.patternText.innerHTML);
                } else {
                    dojo.publish("customNamePattern", "none");
                }
            }
        },
        
        _isNumeric: function(pattern) {
        	var containsLocation = pattern.match(/System Location/g);
            var patternString = pattern.replace(/<b>/g, "");
            patternString = patternString.replace(/<\/b>/g, "");
            patternString = patternString.replace(/Incrementing Numeric/g, "");
            patternString = patternString.replace(/System Location/g, "");
            patternString = patternString.replace(/<i>/g, "");
            patternString = patternString.replace(/<\/i>/g, "");
            if (!isNaN(patternString)) {
            	if (containsLocation == "System Location") {
            		return "loc";
            	} else {
            		return true;
            	}
            }
            return false;
        },
        
        _generateExampleText: function() {
            var example = "";
            var example2 = "";
            var example3 = "";
            var incrementused = false;            
            var nodeList = this._customListNode.containerNode.childNodes;      
            for(var counter=0;counter < nodeList.length;++counter) {
                var nodevalue = null;
                if (nodeList.item(counter).value == undefined) {
                    continue;
                }
                if (nodeList.item(counter).value[0] == "C" && nodeList.item(counter).value[1] == "T") {
                    nodevalue = "CT";
                } else {
                    nodevalue = nodeList.item(counter).value;
                }
                // Used to use textContent in place of innerHTML in the code below.  IE8 does not like
                // textContent but seemed okay.  IE9 and Firefox seemed to be okay with either.                
                switch(nodevalue) {
                    case "CT":
                        if (nodeList.item(counter).innerHTML == this._selectedNodeCustomText) {
                            example = example + "<b>" + nodeList.item(counter).innerHTML.replace(/\"/g, "") + "</b>";                            
                            example2 = example2 + "<b>" + nodeList.item(counter).innerHTML.replace(/\"/g, "") + "</b>";
                            example3 = example3 + "<b>" + nodeList.item(counter).innerHTML.replace(/\"/g, "") + "</b>";
                        } else {
                            example = example + nodeList.item(counter).innerHTML.replace(/\"/g, "");
                            example2 = example2 + nodeList.item(counter).innerHTML.replace(/\"/g, "");
                            example3 = example3 + nodeList.item(counter).innerHTML.replace(/\"/g, "");
                        }
                        break;
                    default:                        
                        switch(nodeList.item(counter).value) {
                            case "SL":
                                if (nodeList.item(counter).value == this._selectedNode){
                                    example = example + "<b>" + this._exampleSystemLocation + "</b>";
                                    example2 = example2 + "<b>" + this._exampleSystemLocation + "</b>";
                                    example3 = example3 + "<b>" + this._exampleSystemLocation + "</b>";
                                } else {
                                    example = example + this._exampleSystemLocation;
                                    example2 = example2 + this._exampleSystemLocation;
                                    example3 = example3 + this._exampleSystemLocation;
                                }
                                break;
                            case "RM":
                                if (nodeList.item(counter).value == this._selectedNode){
                                    example = example + "<b>" + this._exampleRoom + "</b>";
                                    example2 = example2 + "<b>" + this._exampleRoom + "</b>";
                                    example3 = example3 + "<b>" + this._exampleRoom + "</b>";
                                } else {
                                    example = example + this._exampleRoom;
                                    example2 = example2 + this._exampleRoom;
                                    example3 = example3 + this._exampleRoom;
                                }
                                break;
                            case "RA":
                                if (nodeList.item(counter).value == this._selectedNode){
                                    example = example + "<b>" + this._exampleRack + "</b>";
                                    example2 = example2 + "<b>" + this._exampleRack + "</b>";
                                    example3 = example3 + "<b>" + this._exampleRack + "</b>";
                                } else {
                                    example = example + this._exampleRack;
                                    example2 = example2 + this._exampleRack;
                                    example3 = example3 + this._exampleRack;
                                }                                
                                break;
                            case "LR":
                                if (nodeList.item(counter).value == this._selectedNode){
                                    example = example + "<b>" + this._exampleLowestRackUnit + "</b>";
                                    example2 = example2 + "<b>" + this._exampleLowestRackUnit + "</b>";
                                    example3 = example3 + "<b>" + this._exampleLowestRackUnit + "</b>";
                                } else {
                                    example = example + this._exampleLowestRackUnit;
                                    example2 = example2 + this._exampleLowestRackUnit;
                                    example3 = example3 + this._exampleLowestRackUnit;
                                }                                
                                break;
                            case "CB":
                                if (nodeList.item(counter).value == this._selectedNode){
                                    example = example + "<b>" + this._exampleChassisBay + "</b>";
                                    example2 = example2 + "<b>" + this._exampleChassisBay + "</b>";
                                    example3 = example3 + "<b>" + this._exampleChassisBay + "</b>";
                                } else {
                                    example = example + this._exampleChassisBay;
                                    example2 = example2 + this._exampleChassisBay;
                                    example3 = example3 + this._exampleChassisBay;
                                }                                
                                break;
                            case "IN":
                                incrementused = true;
                                if (nodeList.item(counter).value == this._selectedNode){
                                    example = example + "<b>1</b>";
                                    example2 = example2 + "<b>2</b>";
                                    example3 = example3 + "<b>3</b>";
                                } else {
                                    example = example + "1";
                                    example2 = example2 + "2";
                                    example3 = example3 + "3";
                                }                                                             
                                break;
                            default:
                                break;
                        }                        
                        break;
                }                
            }
            if (example == "") {
                this.exampleText.innerHTML = this.locResources.VALUE_NONE;
                this._exampleTooltipIcon.style.display = "none";
            } else {
                if (incrementused == false) {
                    this.exampleText.innerHTML = example;
                } else {
                    this.exampleText.innerHTML = example + "<br>" + example2 + "<br>" + example3;
                }
                this._exampleTooltipIcon.style.display = "block";
            }
        },        

        _moveUp: function() {
            var selectedtext = null;
            var selectedvalue = null;
            this._customListNode.getSelected().forEach(function(n){
                selectedtext = n.innerHTML;
                selectedvalue = n.value;
            },this);
            var nodeList = this._customListNode.containerNode.childNodes;            
            for(var counter=0;counter < nodeList.length-1;++counter) {               
                if (nodeList.item(counter+1).innerHTML == selectedtext &&
                        nodeList.item(counter+1).value == selectedvalue) {                        
                    var temptext, tempvalue;
                    if (nodeList.item(counter).innerHTML == undefined) {
                        break;
                    }
                    temptext = nodeList.item(counter+1).innerHTML;
                    tempvalue = nodeList.item(counter+1).value;
                    nodeList.item(counter+1).innerHTML = nodeList.item(counter).innerHTML;
                    nodeList.item(counter+1).value = nodeList.item(counter).value;
                    nodeList.item(counter).innerHTML = temptext;
                    nodeList.item(counter).value = tempvalue;
                    nodeList.item(counter).selected = true;
                    nodeList.item(counter+1).selected = false;
                    this._refresh();
                    break;
                }
            }
        },
        
        
        _moveDown: function() {            
            var selectedtext = null;
            var selectedvalue = null;
            this._customListNode.getSelected().forEach(function(n){
                selectedtext = n.innerHTML;
                selectedvalue = n.value;
                
            },this);
            var nodeList = this._customListNode.containerNode.childNodes;            
            for(var counter=0;counter < nodeList.length-1;++counter) {   
                if (nodeList.item(counter).innerHTML == selectedtext &&
                        nodeList.item(counter).value == selectedvalue) {                        
                    var temptext, tempvalue;
                    temptext = nodeList.item(counter).innerHTML;
                    tempvalue = nodeList.item(counter).value;
                    nodeList.item(counter).innerHTML = nodeList.item(counter+1).innerHTML;
                    nodeList.item(counter).value = nodeList.item(counter+1).value;
                    nodeList.item(counter+1).innerHTML = temptext;
                    nodeList.item(counter+1).value = tempvalue;
                    nodeList.item(counter).selected = false;
                    nodeList.item(counter+1).selected = true;
                    this._refresh();
                    break;
                }
            }            
        },

        _addClicked: function() {
            dojo.publish("customTextComplete", this.customNameTextBox.get("value"));            
            this.customTextDialog.hide();
        },

        _saveClicked: function() {
            dojo.publish("customTextSaveComplete", this.customNameTextBox.get("value"));
            this.customTextDialog.hide();
        },
        
        _cancelClicked: function() {
            this.customTextDialog.hide();
        },
        
        _editCustomNode: function() {
            if (this._editDisabled == true) {
                return;
            }
            this._customListNode.getSelected().forEach(function(n){
                this.customNameTextBox.set("value", n.innerHTML.replace(/\"/g, ""));
            }, this);           
            this.customTextDialog.set("title", this.locResources.EDIT_TITLE);
            this.addButton.domNode.style.display = "none";
            this.saveButton.domNode.style.display = "inline-block";
            this.customTextDialog.show();
        },        

        _deleteCustomNode: function() {
            if (this._deleteDisabled == true) {
                return;
            }
            this._customListNode.getSelected().forEach(function(n){                
                if (n.value[0] == "C" && n.value[1] == "T") {                    
                    this._customListNode.containerNode.removeChild(n);
                    this._customTextCounter--;
                    this._refresh();
                }                
            },this);

            if (this._customListNode.getSelected().length == 0) {
                this._editDisabled = true;
                this._deleteDisabled = true;                    
                dojo.replaceClass(this._editCustomEntry, "spEditInactiveIcon", "spEditIcon");
                dojo.replaceClass(this._deleteCustomEntry, "spDeleteInactiveIcon_v2", "spDeleteHoverIcon_v2");
            }
        },
        
        _onClickEventCustomList: function() {
            this._customListNode.getSelected().forEach(function(n){                
                if (n.value[0] == "C" && n.value[1] == "T") {
                    this._editDisabled = false;
                    this._deleteDisabled = false;
                    dojo.replaceClass(this._editCustomEntry, "spEditIcon", "spEditInactiveIcon");
                    dojo.replaceClass(this._deleteCustomEntry, "spDeleteIcon_v2", "spDeleteInactiveIcon_v2");
                    this._selectedNode = n.value;
                    this._selectedNodeCustomText = n.innerHTML;
                } else {
                    this._editDisabled = true;
                    this._deleteDisabled = true;                    
                    dojo.replaceClass(this._editCustomEntry, "spEditInactiveIcon", "spEditIcon");
                    dojo.replaceClass(this._deleteCustomEntry, "spDeleteInactiveIcon_v2", "spDeleteIcon_v2");
                    this._selectedNode = n.value;
                    this._selectedNodeCustomText = "";
                }
            },this);
            this._refresh();
        },
        
        _setMoveRightButtonStatus: function() {
            var selectedLength = this._selectionListNode.getSelected().length;
            if (selectedLength > 0) {
                dojo.replaceClass(this._moveRightBtn, "spMoveRightIcon_v2", "spMoveRightInactiveIcon_v2");
                this._moveRightButtonEnabled = true;                       
            } else {                
                dojo.replaceClass(this._moveRightBtn, "spMoveRightInactiveIcon_v2", "spMoveRightIcon_v2");
                this._moveRightButtonEnabled = false;
            }
        },

        _setMoveLeftButtonStatus: function() {
            var customLength = this._customListNode.getSelected().length;
            if (customLength > 0) {
                this._customListNode.getSelected().forEach(function(n){                    
                    if (n.value[0] == "C" && n.value[1] == "T") {
                        dojo.replaceClass(this._moveLeftBtn, "spMoveLeftInactiveIcon_v2", "spMoveLeftIcon_v2");
                        this._moveLeftButtonEnabled = false;
                    } else {
                        dojo.replaceClass(this._moveLeftBtn, "spMoveLeftIcon_v2", "spMoveLeftInactiveIcon_v2");                                                
                        this._moveLeftButtonEnabled = true;
                    }
                }, this);                
            } else {    
                dojo.replaceClass(this._moveLeftBtn, "spMoveLeftInactiveIcon_v2", "spMoveLeftIcon_v2");                
                this._moveLeftButtonEnabled = false;
            }
        },

        _refresh: function() {
            this._generatePatternText();
            this._generateExampleText();            
            this._setMoveRightButtonStatus();
            this._setMoveLeftButtonStatus();
        },
        
        _moveUpClicked: function() {                                    
            dojo.replaceClass(this._moveUpBtn, "spArrowUpClickedIcon", "spArrowUpIcon");
        },        

        _moveUpReleased: function() {                                    
            dojo.replaceClass(this._moveUpBtn, "spArrowUpHoverIcon", "spArrowUpClickedIcon");
        },
        
        _moveUpHover: function() {                                    
            dojo.replaceClass(this._moveUpBtn, "spArrowUpHoverIcon", "spArrowUpIcon");
        },
        
        _moveUpMouseOut: function() {                                    
            dojo.replaceClass(this._moveUpBtn, "spArrowUpIcon", "spArrowUpHoverIcon");
        },
        
        _moveDownClicked: function() {                                    
            dojo.replaceClass(this._moveDownBtn, "spArrowDownClickedIcon", "spArrowDownIcon");
        },        

        _moveDownReleased: function() {                                    
            dojo.replaceClass(this._moveDownBtn, "spArrowDownHoverIcon", "spArrowDownClickedIcon");
        },
        
        _moveDownHover: function() {                                    
            dojo.replaceClass(this._moveDownBtn, "spArrowDownHoverIcon", "spArrowDownIcon");
        },        

        _moveDownMouseOut: function() {                                    
            dojo.replaceClass(this._moveDownBtn, "spArrowDownIcon", "spArrowDownHoverIcon");
        },

        _editClicked: function() {
            if (this._editDisabled == false) {
                dojo.replaceClass(this._editCustomEntry, "spEditClickedIcon", "spEditIcon");
            }
        },        

        _editReleased: function() {           
            if (this._editDisabled == false) {
                dojo.replaceClass(this._editCustomEntry, "spEditHoverIcon", "spEditClickedIcon");
            }
        },
        
        _editHover: function() {
            if (this._editDisabled == false) {
                dojo.replaceClass(this._editCustomEntry, "spEditHoverIcon", "spEditIcon");
            }
        },        

        _editMouseOut: function() {
            if (this._editDisabled == false) {
                dojo.replaceClass(this._editCustomEntry, "spEditIcon", "spEditHoverIcon");
            }
        },        
        
        _deleteClicked: function() {
            if (this._deleteDisabled == false) {
                dojo.replaceClass(this._deleteCustomEntry, "spDeleteClickedIcon_v2", "spDeleteIcon_v2");
            }
        },        

        _deleteReleased: function() {
            if (this._deleteDisabled == false) {
                dojo.replaceClass(this._deleteCustomEntry, "spDeleteHoverIcon_v2", "spDeleteClickedIcon_v2");
            }
        },
        
        _deleteHover: function() {
            if (this._deleteDisabled == false) {
                dojo.replaceClass(this._deleteCustomEntry, "spDeleteHoverIcon_v2", "spDeleteIcon_v2");
            }
        },        

        _deleteMouseOut: function() {
            if (this._deleteDisabled == false) {
                dojo.replaceClass(this._deleteCustomEntry, "spDeleteIcon_v2", "spDeleteHoverIcon_v2");
            }
        },
        
        _getPatternAttr : function () {
            var patternData = [];
            
            var nodeList = this._customListNode.containerNode.childNodes;            
            for(var counter=0;counter < nodeList.length;++counter) {
                if (nodeList.item(counter).value == undefined) {
                    continue;
                }
                var nameObj = new Object();
                nameObj.name = nodeList.item(counter).innerHTML.replace(/\"/g, "");;                
                nameObj.value = nodeList.item(counter).value;
                patternData.push(nameObj);
            }                        
            return patternData;
        },
        
        changeLocation: function(newLocation) {
            if (newLocation.length == 0) {
                this._exampleSystemLocation = this.locResources.SYSTEMLOCATIONEXAMPLE;
            } else {
                this._exampleSystemLocation = newLocation;
            }
            this._refresh();
        },
        
        changeRoom: function(newRoom) {
            if (newRoom.length == 0) {
                this._exampleRoom = this.locResources.ROOMEXAMPLE;
            } else {
                this._exampleRoom = newRoom;
            }            
            this._refresh();
        },
        
        _customTextChanged: function() {                        
            if (this.customNameTextBox.get("value").trim() != ""
                    && this.customNameTextBox.isValid()){
                this.addButton.set("disabled", false);
                this.saveButton.set("disabled", false);
            }
            else {
                this.addButton.set("disabled", true);
                this.saveButton.set("disabled", true);
            }
        }
	});
});     	