define([
        "dojo",
        "dijit",
        "support/ConfigPatternsAll",
        "support/panels/Panel",
        "dojo/i18n!./nls/GettingStarted",
        "dojo/text!./templates/GettingStarted.html",
        "support/base/NextGenUIMixin",
        "dijit/layout/TabContainer",
        "support/panels/Overview",
        "support/panels/SuggestedTasks"
    ], function(dojo, dijit, layer, panel, mri, template) {

    return dojo.declare("support.panels.GettingStarted", [ support.panels.Panel, support.base.NextGenUIMixin ], {

        // summary:
        // A panel widget extending support.panels.Panel, for use in directing users to suggested
        // "first steps" and learning overview pages to get them pointed in the right direction
        // quickly and easily.

        // templateString: [protected] String
        // This widget's HTML template, provided.
        templateString: template,
            
        // locResources: [protected] Object
        // This widget's National Language Source (NLS) object.
        locResources: mri,

        // baseClass: [protected] String
        // The root CSS className to be placed on this widget's domNode.
        baseClass: "GettingStarted",

        // the properties used to construct the title of this page in the
        //   NextGen UI
        cpProductName: null,
        cpPageContext: null,
        cpPageName: null,

        // the name of the CSS stylesheet of this page
        spCssPathAndName: "support/panels/themes/GettingStarted.css",

        // When this method is called, all variables inherited from superclasses are "mixed in".
        // Common operations for postMixInProperties
        // 1) Modify or assign values for widget property variables defined in the template
        // HTML file
        postMixInProperties: function() {

            this.inherited(arguments);
            this.cpProductName = this.resources.PRODUCT_NAME;
            this.cpPageContext = null;
            this.cpPageName = this.locResources.PAGE_NAME;

        },

        // postCreate() is called after buildRendering(). This is useful to override when
        // you need to access and/or manipulate DOM nodes included with your widget.
        // DOM nodes and widgets with the dojoAttachPoint attribute specified can now be
        // directly
        // accessed as fields on "this".
        // Common operations for postCreate
        // 1) Access and manipulate DOM nodes created in buildRendering()
        // 2) Add new DOM nodes or widgets
        postCreate: function() {

            this.inherited(arguments);

            // Invoke the NextGenUIMixin to change the title of the NextGen UI work area
            this.changeNextGenUITitle();
        },

        _gotoOverview: function() {

            this._tabContainer.selectChild(this._overviewTab);

        },

        _gotoSuggestedTasks: function() {

            this._tabContainer.selectChild(this._suggestedTasksTab);

        }

    });

});