define([
        "dojo",
        "dijit",
        "support/dialogs/Dialog",
        "dojo/i18n!./nls/ImportConfirmation",
        "dojo/text!./templates/ImportConfirmation.html",
        "dojo/store/Memory",
        "dojo/parser",
        "dijit/layout/TabContainer",
        "dojo/data/ItemFileWriteStore",
        "dojo/data/ItemFileReadStore",
        "dojox/grid/LazyTreeGridStoreModel",
        "dojox/grid/DataGrid",
        "support/panels/Panel",
        "dojo/_base/window",
        "support/dialogs/ProgressDialog"
    ], function(dojo, dijit, dialog, mri, template) {
    
    return dojo.declare("support.panels.ImportConfirmation", [ support.panels.Panel ], {
        
        // templateString: [protected] String
        // This widget's HTML template, provided.
        templateString: template,
             
        // locResources: [protected] Object
        // This widget's National Language Source (NLS) object.
        locResources: mri,
        baseClass: "ImportConfirmation",
        // Default View Mode
        viewMode: 1,
        _errorM: null,
        _gridTabs: null,
        // the name of the CSS stylesheet of this page
        spCssPathAndName: "support/panels/themes/ImportConfirmation.css",

        // When this method is called, all variables inherited from superclasses are "mixed in".
        // Common operations for postMixInProperties
        // 1) Modify or assign values for widget property variables defined in the template HTML
        // file
        postMixInProperties: function() {
            this.inherited(arguments);
        },

        // postCreate() is called after buildRendering(). This is useful to override when
        // you need to access and/or manipulate DOM nodes included with your widget.
        // DOM nodes and widgets with the dojoAttachPoint attribute specified can now be directly
        // accessed as fields on "this".
        // Common operations for postCreate
        // 1) Access and manipulate DOM nodes created in buildRendering()
        // 2) Add new DOM nodes or widgets
        postCreate: function() {
            this.inherited(arguments);
            this._setUpImportGrid();
        },
        
        _setUpImportGrid: function(){
            // Call the dummy JSON files to populate the grids
            // Note: Absolute URLs are used here
            var importUnchanged = new dojo.data.ItemFileWriteStore({
                url: "js/support/temp/importTest.json"});
                //url: "https://9.37.180.102:8422/com.ibm.stg.sysx.profile.navmodel/js/support/temp/importTest.json"});
            var importWithMod = new dojo.data.ItemFileWriteStore({
                url: "js/support/temp/importTest2.json"});
                //url: "https://9.37.180.102:8422/com.ibm.stg.sysx.profile.navmodel/js/support/temp/importTest2.json"});
            var notImported = new dojo.data.ItemFileWriteStore({
                url: "js/support/temp/importTest3.json"});
                //url: "https://9.37.180.102:8422/com.ibm.stg.sysx.profile.navmodel/js/support/temp/importTest3.json"});
            // Layouts for the grids
            //console.log(notImported);
            var importUnchangedLayout = [ {
                name: this.resources.NAME,
                field: "name",
                width: "20%"
            }, {
                name: this.resources.CATEGORY,
                field: "category",
                width: "10%"
            }, {
                name: this.resources.TYPE,
                field: "type",
                width: "40%"
            }, {
                name: "<img src=\"" + this._blankGif + "\" alt=\"\" title=\"Attention\" class=\"smallWarning\"></img> &nbsp; Potential User Action Required",
                field: "userAction",
                width: "30%"
            }];
            var importWithModLayout = [ {
                name: this.resources.NAME,
                field: "name",
                width: "20%"
            }, {
                name: this.resources.CATEGORY,
                field: "category",
                width: "10%"
            }, {
                name: this.resources.TYPE,
                field: "type",
                width: "30%"
            }, {
                name: "<img src=\"" + this._blankGif + "\" alt=\"\" title=\"Attention\" class=\"smallWarning\"></img> &nbsp; Pending Modification",
                field: "pending_modifcation",
                width: "40%"
            }];
            var notImportedLayout = [ {
                name: this.resources.NAME,
                field: "name",
                width: "20%"
            }, {
                name: this.resources.CATEGORY,
                field: "category",
                width: "10%"
            }, {
                name: this.resources.TYPE,
                field: "type",
                width: "30%"
            }, {
                name: "<img src=\"" + this._blankGif + "\" alt=\"\" title=\"\" class=\"smallCritical\"></img> &nbsp; Reason",
                field: "reason",
                width: "40%"
            }];
            // Build the grids
            var importUnchangedGrid = new dojox.grid.DataGrid({
                store: importUnchanged,
                query: {id: "*"},
                structure: importUnchangedLayout,
                title: "Imported without Modifications",
                autoHeight: false,
                autoWidth: false,
                columnReordering: false,
                selectionMode: "none",
                noDataMessage: this.resources.NO_DATA
            }, "importUnchangedGrid");
            var importWithModGrid = new dojox.grid.DataGrid({
                store: importWithMod,
                query: {id: "*"},
                structure: importWithModLayout,
                title: "Imported with Modifications",
                autoHeight: false,
                autoWidth: false,
                columnReordering: false,
                selectionMode: "none",
                noDataMessage: this.resources.NO_DATA
            }, "importWithModGrid");
            var notImportedGrid = new dojox.grid.DataGrid({
                store: notImported,
                query: {id: "*"},
                structure: notImportedLayout,
                title: "<img src=\"" + this._blankGif 
                    + "\" alt=\"\" title=\"\" class=\"smallCritical\"></img> &nbsp; Resources Not Imported",
                autoHeight: false,
                autoWidth: false,
                columnReordering: false,
                selectionMode: "none",
                noDataMessage: this.resources.NO_DATA
            }, "notImportedGrid");
            this._gridTabs = new dijit.layout.TabContainer({
                useMenu: false,
                useSlider: false,
                style: "height: 400px; width:100%; margin-left: auto; margin-right: auto;"
            }, this.gridTabs);
            this._gridTabs.addChild(importUnchangedGrid);
            this._gridTabs.addChild(importWithModGrid);
            this._gridTabs.addChild(notImportedGrid);
        }
        
    });
});