define([ "dojo", 
         "dijit",  
         "support/panels/Panel", 
         "dojo/i18n!./nls/SelectBootTargetTemplate", 
         "dojo/text!./templates/SelectBootTargetTemplate.html", 
         "support/widgets/Select",
         "dojo/data/ItemFileReadStore"], 
       function (dojo, dijit, panel, mri, template) {

	return dojo.declare("support.panels.SelectBootTargetTemplate", [ support.panels.Panel ], {
	    
	    // templateString: [protected] String
	    // This widget's HTML template, provided.
	    templateString: template,
	        
	    // locResources: [protected] Object
	    // This widget's National Language Source (NLS) object.
	    locResources: mri,
	    
		widgetsInTemplate : true,
		baseClass : "SelectBootTargetTemplate", // This widget's base CSS classname.
		
		option: null,
		template: null,
		target: null,
		templateOptions: null,
		targetOptions: null,
		templateDisabled: false,
		showTargets: true,
		bootOption: null,
		
		_tmplSelector: null,
        _tmplPXESelector: null,
        _tmplFCSelector: null,
		_targetSelector: null,
		
        // the name of the CSS stylesheet of this page
        spCssPathAndName: "support/panels/themes/SelectBootTargetTemplate.css",

		// postCreate() is called after buildRendering(). This is useful to override when
		// you need to access and/or manipulate DOM nodes included with your widget.
		// DOM nodes and widgets with the dojoAttachPoint attribute specified can now be
		// directly
		// accessed as fields on "this".
		// Common operations for postCreate
		// 1) Access and manipulate DOM nodes created in buildRendering()
		// 2) Add new DOM nodes or widgets
		postCreate : function () {
			this.inherited(arguments);
			
			if(this.target == null){
			    this.set("target", this.locResources.ALL);
			}
			
			if(this.bootOption == this.locResources.PXE){

                this._setupPXETemplateSelector();
			    
			}else if(this.bootOption == this.locResources.FC){
                
                this._setupFCTemplateSelector();
                
            }else{
                
                this._setupTemplateSelector();
                
            }
			
			
			if(this.bootOption != this.locResources.PXE){
			    this._useTarget.setAttribute("style", "display:block");
			    this._setupTargetSelector();
			}
			else{
			    this._useTarget.setAttribute("style", "display:none");
			}
			
			this.subscribe("PXEBootTemplateComplete", function(data) {
                var tmplStore = new dojo.data.ItemFileReadStore({
                    url: this.REST_PATH + "template/list/PXE"
                });
                tmplStore.fetch({
                    query: {},
                    onBegin: dojo.hitch(this, this._presetTemplateCallbackPXE),
                    start: 0,
                    count: 0,
                    selector: this._tmplPXESelector
                });
                this._tmplPXESelector.setStore(tmplStore);
                
                //if(data != "saveas"){
                    this._tmplPXESelector.set("value", data);
                //}
                
                this._tmplPXESelector.set("disabled", false);
            });
/*			this.subscribe("FibreBootTemplateComplete", function(data) {
                var tmplStore = new dojo.data.ItemFileReadStore({
                    url: this.REST_PATH + "template/list/FibreChannel"
                });
/*               tmplStore.fetch({
                   query: {},
                    onBegin: dojo.hitch(this, this._presetTemplateCallback),
                    start: 0,
                    count: 0,
                    selector: this._tmplFCSelector
                });
                this._tmplFCSelector.setStore(tmplStore);
                this._tmplFCSelector.set("value", data);
                this._tmplFCSelector.set("disabled", false);               
            });*/
						
		},
		
		_setupTemplateSelector : function(){
		    var tmplStore = this._getTemplateStore();
		    this._tmplSelector = new support.widgets.Select({
		        id: this.id + "cp_selectboottargettemplate_select",
		        value: this.template,
		        required: false,
		        store: tmplStore,
		        emptyLabel: "&mdash; " + this.resources.NO_TEMP_DEFINED + " &mdash;",
		        onChange: dojo.hitch(this, this._changeTemplateCallback)
		    }).placeAt(this._templateSelect);
		    tmplStore.fetch({
		        query:{},
		        onBegin: dojo.hitch(this, this._presetTemplateCallbackPXE),
                start: 0,
                count: 0,
                selector: this._tmplSelector
		    });
		},

	      _setupPXETemplateSelector : function(){
	            var tmplStore = this._getTemplateStore();
	            this._tmplPXESelector = new support.widgets.Select({
	                id: this.id + "cp_selectboottargettemplate_select2",
	                value: this.template,
	                required: false,
	                store: tmplStore,
	                emptyLabel: "&mdash; " + this.resources.NO_TEMP_DEFINED + " &mdash;",
	                onChange: dojo.hitch(this, this._changeTemplateCallback)
	            }).placeAt(this._templateSelect);
	            tmplStore.fetch({
	                query:{},
	                onBegin: dojo.hitch(this, this._presetTemplateCallbackPXE),
	                start: 0,
	                count: 0,
	                selector: this._tmplPXESelector
	            });
	        },

	        _setupFCTemplateSelector : function(){
	            var tmplStore = this._getTemplateStore();
	            this._tmplFCSelector = new support.widgets.Select({
	                id: this.id + "cp_selectboottargettemplate_select3",
	                value: this.template,
	                required: false,
	                store: tmplStore,
	                emptyLabel: "&mdash; " + this.resources.NO_TEMP_DEFINED + " &mdash;",
	                onChange: dojo.hitch(this, this._changeTemplateCallback)
	            }).placeAt(this._templateSelect);
	            tmplStore.fetch({
	                query:{},
	                onBegin: dojo.hitch(this, this._presetTemplateCallbackPXE),
	                start: 0,
	                count: 0,
	                selector: this._tmplFCSelector
	            });
	        },

		_setupTargetSelector : function(){
		    this._targetSelector = new support.widgets.Select({
		        id: this.id + "cp_selectboottargettemplate_select4",
		        value: this.target,
                required: false,
                emptyLabel: "&mdash; " + this.locResources.NO_TARGETS_DEFINED + " &mdash;",
                options: [
                    {label: this.locResources.PRIMARY, value: this.locResources.PRIMARY},
                    {label: this.locResources.SECONDARY, value: this.locResources.SECONDARY},
                    {label: this.locResources.ALL, value: this.locResources.ALL}
                ],
                onChange: function(newValue){
                    widget._onTargetChange(newValue);
                }
            }).placeAt(this._targetSelect);
		},
		
		_changeTemplateCallback: function(newVal) {
            // tags:
            // protected
		    this._onTemplateChange(newVal);
            if (newVal > 0) {
                dojo.replaceClass(this._edit, "nstEditIcon", "nstEditIconDisabled");
                this._edit.setAttribute("title", this.resources.EDIT_SELECTED_PATTERN);
                this._edit.onclick = dojo.hitch(this, function(){
                    this._onEditClick();
                });
            }
            else {
                dojo.replaceClass(this._edit, "nstEditIconDisabled", "nstEditIcon");
                this._edit.setAttribute("title", this.locResources.EDIT_DISABLED_TITLE);
                this._edit.onclick = dojo.hitch(this, function(){
                    //do nothing
                });
            }

        },
        
        _presetTemplateCallbackPXE: function(size, request) {

            // tags:
            // protected
            if (size <= 0) {
                // Disable selection and allow "emptyLabel" to display.
                request.selector.set("disabled", true);
            }
            else {
                // Add option to prompt for selection.
                request.selector.addOption({
                    value: -1,
                    label: "&mdash; " + this.resources.NO_TEMP_SELECTED + " &mdash;",
                    selected: true
                });
            }
            this._useTarget.setAttribute("style", "display:none");

        },
        
        _presetTemplateCallback: function(size, request) {

            // tags:
            // protected
            if (size <= 0) {
                // Disable selection and allow "emptyLabel" to display.
                request.selector.set("disabled", true);
                this._useTarget.setAttribute("style", "display:none");
            }
            else {
                // Add option to prompt for selection.
                request.selector.addOption({
                    value: -1,
                    label: "&mdash; " + this.resources.NO_TEMP_SELECTED + " &mdash;",
                    selected: true
                });
                this._useTarget.setAttribute("style", "display:block");
            }

        },
		
		_getTemplateStore : function(){
		    var tmplStore = null;
		    
		    if(this.bootOption == this.locResources.PXE){
		        tmplStore = new dojo.data.ItemFileReadStore({
	                url: this.REST_PATH + "template/list/PXE"
	            });
		    }
		    else if(this.bootOption == this.locResources.FC){
		        tmplStore = new dojo.data.ItemFileReadStore({
                    url: this.REST_PATH + "template/list/FibreChannel"
                });
		    }
		    else{
		        tmplStore = new dojo.data.ItemFileReadStore({
		            data: { "items" : [] }
                    //url: this.REST_PATH + "template/list/iSCSI" /*future release*/
                });
		    }
		    return tmplStore;
		},
	
		
		_onTemplateChange : function(value){
			this.set("template", value);
			this.onTemplateChange(value);
		},
		
		onTemplateChange : function(value){
			//override if necessary 
		},

		_onTargetChange : function(value){
			this.set("target", value);
			this.onTargetChange(value);
		},
		
		onTargetChange : function(value){
			//override if necessary 
		},
		
		_onEditClick : function(e){
			this.onEditClick(e);
		},
		
		onEditClick : function(e){
			//override if necessary
		},
		
		_onCreateClick : function(e){
			this.onCreateClick(e);
		},
		
		onCreateClick : function(e){
			//override if necessary
		}
		
		

	});
});
