define([ "dojo", 
         "dijit",  
         "support/panels/Panel", 
         "dojo/i18n!./nls/SelectBootTargetTemplateFC", 
         "dojo/text!./templates/SelectBootTargetTemplateFC.html", 
         "support/widgets/Select",
         "dojo/data/ItemFileReadStore"], 
       function (dojo, dijit, panel, mri, template) {

	return dojo.declare("support.panels.SelectBootTargetTemplateFC", [ support.panels.Panel ], {
	    
	    // templateString: [protected] String
	    // This widget's HTML template, provided.
	    templateString: template,
	        
	    // locResources: [protected] Object
	    // This widget's National Language Source (NLS) object.
	    locResources: mri,
	    
		widgetsInTemplate : true,
		baseClass : "SelectBootTargetTemplate", // This widget's base CSS classname.
		
		option: null,
		template: null,
		target: null,
		templateOptions: null,
		targetOptions: null,
		templateDisabled: false,
		showTargets: true,
		bootOption: null,
		previousPattern: true, //Holds if previous template had secondary targets
		
		_tmplSelector: null,
        _tmplPXESelector: null,
        _tmplFCSelector: null,
		_targetSelector: null,
		
        // the name of the CSS stylesheet of this page
        spCssPathAndName: "support/panels/themes/SelectBootTargetTemplateFC.css",

		// postCreate() is called after buildRendering(). This is useful to override when
		// you need to access and/or manipulate DOM nodes included with your widget.
		// DOM nodes and widgets with the dojoAttachPoint attribute specified can now be
		// directly
		// accessed as fields on "this".
		// Common operations for postCreate
		// 1) Access and manipulate DOM nodes created in buildRendering()
		// 2) Add new DOM nodes or widgets
		postCreate : function () {
			this.inherited(arguments);
			
			if(this.target == null){
                this.set("target", "all");
                this._changeTarget("all");
            }
			
            this._setupFCTemplateSelector();
			
	//	    this._useTarget.setAttribute("style", "display:inline-block");
		    this._setupTargetSelector();

		    this.subscribe("FibreBootTemplateComplete", function(data) {
                var tmplStore = new dojo.data.ItemFileReadStore({
                    url: this.REST_PATH + "template/list/FibreChannel"
                });
               tmplStore.fetch({
                   query: {},
                    onBegin: dojo.hitch(this, this._presetTemplateCallback),
                    start: 0,
                    count: 0,
                    selector: this._tmplFCSelector
                });
                this._tmplFCSelector.setStore(tmplStore);
                
                //if(data != "saveas"){
                    this._tmplFCSelector.set("value", data);
                //}
                
                this._tmplFCSelector.set("disabled", false);               
            });

	         this.subscribe("FibreBootTemplateChanged", function(data) {	                
                    this._tmplFCSelector.set("value", data);	                
	                this._tmplFCSelector.set("disabled", false);
	                	               	                
	   //             var targetValue = this._targetSelector.get("value");
	     //           console.log("TARGETVALUE");
	       //         console.log(targetValue);
	    //            this.set("target", targetValue);
	     //           this._changeTarget(targetValue);	                
             });

		},
        _setupFCTemplateSelector : function(){
	            var tmplStore = this._getTemplateStore();
	            this._tmplFCSelector = new support.widgets.Select({
	                id: this.id + "cp_selectboottargettemplatefc_select",
	                value: this.template,
	                required: false,
                    style:"width:100%;",
	                intermediateChanges: true,
	                store: tmplStore,
	                emptyLabel: "&mdash; " + this.resources.NO_TEMP_DEFINED + " &mdash;",
	                onChange: dojo.hitch(this, this._changeTemplateCallback)
	            }).placeAt(this._templateSelect);
	            tmplStore.fetch({
	                query:{},
	                onBegin: dojo.hitch(this, this._presetTemplateCallback),
	                start: 0,
	                count: 0,
	                selector: this._tmplFCSelector
	            });
	        },

		_setupTargetSelector : function(){
		    this._targetSelector = new support.widgets.Select({
		        id: this.id + "cp_selectboottargettemplatefc_select2",
		        value: this.target,
                required: false,
                intermediateChanges: true,
                emptyLabel: "&mdash; " + this.locResources.NO_TARGETS_DEFINED + " &mdash;",
                options: [
                    {label: this.locResources.PRIMARY, value: "primary"},
                    {label: this.locResources.SECONDARY, value: "secondary"},
                    {label: this.locResources.ALL, value: "all"}
                ],
                onChange: dojo.hitch(this, this._changeTarget)
            }).placeAt(this._targetSelect);
		},
		_changeTarget: function(newVal){
            this._onTargetChange(newVal);		    
		},
		_changeTemplateCallback: function(newVal) {
            // tags:
            // protected
		    this._onTemplateChange(newVal);
            if (newVal > 0) {
                dojo.replaceClass(this._edit, "spEditIcon_v2", "spEditInactiveIcon_v2");
                this._edit.setAttribute("title", this.resources.EDIT_SELECTED_PATTERN);
                this._edit.onclick = dojo.hitch(this, function(){
                    this._onEditClick();
                });
            }
            else {
                dojo.replaceClass(this._edit, "spEditInactiveIcon_v2", "spEditIcon_v2");
                this._edit.setAttribute("title", this.locResources.EDIT_DISABLED_TITLE);
                this._edit.onclick = dojo.hitch(this, function(){
                    //do nothing
                });
            }

        },
        
        _presetTemplateCallback: function(size, request) {

            // tags:
            // protected
                        
            if (size <= 0) {
                // Disable selection and allow "emptyLabel" to display.
                request.selector.set("disabled", true);
                this._useTarget.setAttribute("style", "display:none");
            }
            else {
                // Add option to prompt for selection.
                request.selector.addOption({
                    value: -1,
                    label: "&mdash; " + this.resources.NO_TEMP_SELECTED + " &mdash;",
                    selected: true
                });
                this._useTarget.setAttribute("style", "display:inline-block");
                
            }

        },
		
		_getTemplateStore : function(){
		    var tmplStore = null;
		    
		    if(this.bootOption == this.locResources.PXE){
		        tmplStore = new dojo.data.ItemFileReadStore({
	                url: this.REST_PATH + "template/list/PXE"
	            });
		    }
		    else if(this.bootOption == this.locResources.FC){
		        tmplStore = new dojo.data.ItemFileReadStore({
                    url: this.REST_PATH + "template/list/FibreChannel"
                });
		    }
		    else{
		        tmplStore = new dojo.data.ItemFileReadStore({
		            data: { "items" : [] }
                    //url: this.REST_PATH + "template/list/iSCSI" /*future release*/
                });
		    }
		    return tmplStore;
		},
	
		
		_onTemplateChange : function(value){
			this.set("template", value);

			if(value == "-1"){
			    this._useTarget.setAttribute("style", "display:none");
			}else{
                this._useTarget.setAttribute("style", "display:inline-block");
                
                var templateOBJ = "";
                
                var xhrGet = dojo.xhrGet({
                    url: this.REST_PATH + "template/"+value,
                    handleAs: "json",
                    sync: true,
                    preventCache: true,
                    load: function(response) {
                        templateOBJ = response; 
                    },
                    handle: dojo.hitch(this, function() {
                            
                        if(templateOBJ.items[0].checkvalue == false && this.previousPattern != false){
                            this._targetSelector.removeOption({label: this.locResources.SECONDARY, value: "secondary"});
                            this._targetSelector.removeOption({label: this.locResources.ALL, value: "all"});
                        }else if(templateOBJ.items[0].checkvalue == true && this.previousPattern != true ){
                            this._targetSelector.addOption({label: this.locResources.SECONDARY, value: "secondary"});
                            this._targetSelector.addOption({label: this.locResources.ALL, value: "all"});                        
                        }
                        
                        this.previousPattern = templateOBJ.items[0].checkvalue;
                                                
                    })
                    
                });

			}
			
			this.onTemplateChange(value);
			
		},
		
		onTemplateChange : function(value){
			//override if necessary 
		},

		_onTargetChange : function(value){
			this.set("target", value);
			
			this.onTargetChange(value);
		},
		
		onTargetChange : function(value){
			//override if necessary 
		},
		
		_onEditClick : function(e){
			this.onEditClick(e);
		},
		
		onEditClick : function(e){
			//override if necessary
		},
		
		_onCreateClick : function(e){
			this.onCreateClick(e);
		},
		
		onCreateClick : function(e){
			//override if necessary
		}
		
		

	});
});
