/*
 * Licensed Materials - Property of IBM
 * 
 * OCO Source Materials
 * 
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 * 
 * The source code for this program is not published or other- wise divested of its trade secrets,
 * irrespective of what has been deposited with the U.S. Copyright Office.
 */
define({
  root: {
    ALL_CHASSIS_COMPONENTS: "All chassis components",
    ALL_NODES: "All Nodes",
    ALL_IOMODULES: "All I/O Modules",
    SUPERVISOR: "Supervisor",
    SECONDS: "%1 seconds",
    ADD_PERMISSION_GRP: "Add Permission Group",
    DEFAULT_PERM: "Default permission groups",
    CUSTOM_PERM: "Custom permission groups",

    // Chassis Profile Table and Server Profile Table
    CONFIRM_UNASSIGN: "Are you sure you want to unassign the profile?",
    UNASSIGN_MESSAGE: "This action will unassign the profile from this server.",

    // System Info Pattern
    TOOLTIP_2a: "Generate a system name for each system based on either a predefined naming pattern, "
            + "or a custom naming pattern. The naming pattern can reference fields stored in the CMM and "
            + "IMM. System names are then auto-generated for each system during the pattern deploy, "
            + "using actual values retrieved from the CMM or IMM, based on the naming pattern.",
    DISABLING: "Disabling auto-generation leaves the system name unchanged on each system when the pattern is deployed.",
    PREDEFINED_GEN: "Generate system name for each system based on a predefined pattern.",

    // Management Interface Pattern
    GENERATEHOSTNAME: "Generate hostname for each system based on a predefined pattern.",
    TOOLTIP_2: "Generate a host name for each system based on location fields: Location + Room + Rack + U number + "
            + "U height + Chassis Bay",
    DISABLEMESSAGE: "Disabling auto-generation leaves the system name unchanged on each system when the pattern is deployed.",

    // Chassis Info Pattern
    DISABLING_CHASSIS: "Disabling auto-generation leaves the chassis name unchanged on each chassis when the pattern is deployed.",
    PREDEFINED_CHASSIS_GEN: "Generate chassis name for each chassis based on a predefined pattern.",

    // Deploy Server
    DEPLOY_MSG: "Deploy the server pattern to one or more individual servers, or groups of servers (e.g. chassis). On deploy, "
            + "one server profile is created for each individual server.",

    // Redeploy
    SAVE_REDEPLOY: "Save and Redeploy Pattern",
    REDEPLOY: "Redeploy",
    NO_ACTIVATION: "No activation",
    NOT_ASSOCIATED: "Not associated",
    DEFAULT_MSG: "By default, the changes will activate immediately. You can defer activation for any associated "
            + "servers by selecting then desired servers and then selecting Defer Activation. Changes to any associated "
            + "chassis are always activated immediately.",
    SERVERS_RESTARTING: "Some of the servers you selected are online, to activate the profile immediately, "
            + "these servers may be restarted: %1",
    CONF_MSG: "Are you sure you want to save %1 pattern and deploy changes?",
    RESTART_SERVERS: "Restart Servers Now",
    ACTIVATE_SERVERS: "Activate on Next Server Restart",
    SAVING: "Saving %1 pattern %2 will propagate the changes to all associated systems. The following system "
            + "patterns and their associated systems are affected: %3",
    ASSOC: "Associated Target Systems",

    // Overview
    SERVERS: "Servers (IBM System x only)",
    CHASSIS: "Chassis",
    WELCOME_PART1: "Using Configuration Patterns you can quickly provision or pre-provision multiple systems from a single "
            + "pattern, and subsequent pattern changes will automatically be applied to all associated systems.",
    WELCOME_PART2: "Configuration Patterns also integrates support for IBM Fabric Manager so you can virtualize server fabric "
            + "connections, and failover or repurpose servers without disruption to the fabric. Also, you can initiate fabric "
            + "change requests through your change management process before your hardware arrives by preconfiguring host "
            + "interconnect addresses.",
    SERVER_WELCOME: "Configure local storage, I/O adapters, boot order, and other Integrated Management Module (IMM) and "
            + "Unified Extensible Firmware Interface (UEFI) settings.",
    CHASSIS_WELCOME: "Configure CMM network management interface, security, power and acoustic settings, and "
            + "basic I/O module and node IP address assignments.",
    BEGIN_CONFIG_PATTERNS: "To begin using Configuration Patterns, select a task from Suggested Tasks.",
    CREATE_SERVER_TEMP: "Create System Pattern",
    SERVER_TEMPS: "System Patterns",
    DEPLOY_TEMP: "Deploy System Pattern",
    SERVER_PROFS: "System Profiles",
    SYSTEMS: "Systems",
    SYSTEM_TEMP: "System Pattern",
    SYSTEM_PROFILE: "System Profile",
    SERVER_CATEGORY: "Server Category Patterns (IBM System x only)",
    CHASSIS_CATEGORY: "Chassis Category Patterns",
    CHASSIS_TEMP1: "A chassis pattern represents chassis management module (CMM) configuration, including network settings, "
            + "power and acoustics settings, security settings, and basic I/O module and node configuration settings.",
    CHASSIS_TEMP2: "When defining a chassis pattern, select category patterns and address pools as needed to construct "
            + "the desired configuration for a specific group of chassis. You can define multiple chassis patterns to represent "
            + "different configurations used in your data center. When a chassis pattern is deployed to multiple chassis, "
            + "multiple chassis profiles are automatically generated (1 profile for each chassis). Each profile inherits settings "
            + "from the parent chassis pattern, which allow you to control a common configuration pattern from a single place.",
    CHASSIS_CATEGORY_TEMP: "There are several type of category patterns for configuring chassis components:",
    CHASSIS_LIST1: "System Information pattern (chassis name, room, location, contact)",
    CHASSIS_LIST2: "Management Interface pattern (host name, IP addresses, DNS, interface speed)",
    CHASSIS_LIST3: "Power and Acoustics pattern (power policy, capping policy, acoustic mode)",
    CHASSIS_LIST4: "Security pattern (global login setting, security policy)",
    CHASSIS_LIST5: "I/O Module pattern (general settings, IP addresses)",
    CHASSIS_LIST6: "Node pattern (IP addresses)",
    CATEGORY_TEMP_SUMMARY1: "When defining a system pattern, you can select category patterns as needed to construct the desired "
            + "configuration for a group of systems. For example, you could have two server patterns that use same Management "
            + "Interface pattern but use different Power State and Capping patterns. This allows you to keep the Management "
            + "Interface settings the same across both groups of servers while still having different reboot schedules.",
    ADDR_POOLS_OVERVIEW1: "Address pools allow you to define address ranges to use when provisioning systems and assigning addresses to "
            + "individual systems. There are IP Address pools, Ethernet Address (MAC) pools, and Fibre Channel Address (WWN) "
            + "pools.",
    ADDR_POOLS_OVERVIEW2: "For example, you can define an IP address pool that defines the IP address range to use when assigning "
            + "management IP addresses to individual servers. Then you can create a server pattern that references the address pool. During server "
            + "pattern deployment, addresses are allocated from the pool and assigned to individual servers.",
    CREATE_SERVER_OVERVIEW1: "You can create a system pattern from an existing system and then use that pattern to provision your "
            + "remaining systems. Or, you can create a system pattern from scratch, defining your desired configuration before "
            + "your hardware arrives. There are create pattern wizards to guide you through specifying all aspects of system configuration.",
    CREATE_SERVER_OVERVIEW3: " in the diagram for more details on what goes into a system pattern.",
    OPEN_WIZARD: "Open the New Chassis Pattern wizard",
    SYSTEM_TEMP_OVERVIEW: "A system pattern aggregates category patterns and address pools to form an overall pattern used to configure multiple managed systems with the same configuration.",
    SERVER_TEMPS_OVERVIEW1: "A server pattern represents pre-OS server configuration, including local storage configuration, I/O adapter "
            + "configuration, boot settings, and other IMM and UEFI firmware settings. A server pattern is used as an overall "
            + "pattern to quickly configure multiple servers at once.",
    CHASSIS_TEMPS_OVERVIEW1: "A chassis pattern represents chassis management module (CMM) configuration, including network settings, "
            + "power and acoustic settings, security settings, and basic I/O module and node configuration settings.",
    CHASSIS_TEMPS_OVERVIEW2: "When defining a chassis pattern, select category patterns and address pools as needed to construct the desired "
            + "configuration for a specific group of chassis. You can define multiple chassis patterns to represent different configurations used in "
            + "your data center. When a chassis pattern is deployed to multiple chassis, multiple chassis profiles are automatically generated "
            + "(1 profile for each chassis). Each profile inherits settings from the parent chassis pattern, which allow you to control a common "
            + "configuration pattern from a single place.",
    EDIT_TEMP_OVERVIEW1: "Patterns allow you to control a common configuration pattern from a single place. With Configuration "
            + "Patterns, you no longer update settings on systems directly. Now you can edit a category pattern or system "
            + "pattern, and any changes are automatically deployed to all associated profiles and their systems (dashed arrows "
            + "in the diagram indicate tasks performed automatically).",
    DEPLOY_TEMP_OVERVIEW1: "You can deploy a system pattern to one or more individual systems or to groups of systems. For example, you "
            + "can deploy a server pattern to a chassis so all the servers in that chassis are configured the same. During the "
            + "deployment, one server profile is automatically generated for each individual server system, based on the "
            + "overall server pattern (dashed arrows in the diagram indicate tasks performed automatically).",
    DEPLOY_TEMP_OVERVIEW2: "You can deploy a server pattern to existing servers and to empty bays of an existing chassis. If a server profile "
            + "is associated with an empty bay, the profile is activated once the server is installed and started. You can also "
            + "pre-provision servers by defining a placeholder chassis to act as a target to deploy configurations before your "
            + "hardware arrives. In all cases, one server profile is created for each server or bay. When your hardward arrives you can deploy the "
            + "entire placeholder chassis configuration to the real hardware.",
    DEPLOY_CHASSIS: "You can deploy a chassis pattern to existing chassis or your can pre-provision chassis by defining placeholder chassis "
            + "to act as a target to deploy configurations before your hardware arrives. In all cases, one chassis profile is created for each chassis. "
            + "When your hardware arrives you can deploy the entire placeholder chassis configuration to the real hardware.",
    SERVER_PROFS_OVERVIEW1: "System profiles are automatically generated when a system pattern is deployed (dashed arrows in the diagram "
            + "indicate tasks performed automatically). One system profile is created for each target system.",
    SERVER_PROFS_OVERVIEW1A: "Each server profile represents the specific configuration of a single server and contains server unique information like "
            + "assigned IP addresses, MAC addresses, etc.",
    CHASSIS_PROFS_OVERVIEW1: "Each chassis profile represents the specific configuration of a single chassis and contains chassis unique "
            + "information like assigned IP addresses, unique name, etc.",
    CHASSIS_PROFS_OVERVIEW2: "Chassis profiles are deployed automatically when the chassis pattern is first deployed, or when the chassis pattern "
            + "or category pattern associated with the profile is subsequently edited. This allows you to control a common configuration pattern from a single place.",
    REDEPLOY_PROFILE: "If a system configuration ever gets out of sync with its profile, you can bring the system back into compliance by redeploying the profile.",
    SERVER_PROFS_SUMMARY2: " in the diagram for more details on using a single system pattern to configure multiple systems.",
    SERVERS_OVERVIEW1: "Identify groups of systems that have the same hardware options and that you will configure the same. For example, to "
            + "represent the desired configuration for multiple groups of servers, create a server pattern for each server group. If a configuration "
            + "change is needed, changing one pattern will change all the servers in the group. This allows you to control a "
            + "common configuration pattern from a single place.",
    CHASSIS_OVERVIEW: "The chassis profile is deployed automatically when the chassis pattern is first deployed, or when the chassis pattern "
            + "or category pattern associated with the profile is subsequently edited (dashed arrows in the diagram indicate tasks performed automatically).",
    SERVER_TEMP_OVERVIEW: "One system pattern can control the configuration of multiple systems, allowing you to control a common "
            + "configuration pattern from a single place. The system pattern is the overall pattern and each profile is an "
            + "instance of that configuration applied to a specific system.",
    SERVER_PROF_OVERVIEW: "Multiple system profiles can inherit from a single system pattern. Once a system pattern is deployed to one or more "
            + "systems, a profile is created for each specific system. This allows you to quickly deploy a configuration change "
            + "to multiple systems by editing the parent system pattern.",

    // Reset storage
    RESET_BTN_LABEL: "Reset storage",
    RESET_STORAGE_ERR: "The value does not match the number of servers selected."
  },
  "en": true,
  "zh": true
});