/*
 * Licensed Materials - Property of IBM
 * 
 * OCO Source Materials
 * 
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 * 
 * The source code for this program is not published or other- wise divested of its trade secrets,
 * irrespective of what has been deposited with the U.S. Copyright Office.
 */
define({
    OVERVIEW_DESC: "This diagram shows high level objects and flow for using Configuration Patterns.",
    TO_GET_STARTED: "To get started, also see",

    CATEGORY_TEMPLATES: "Category Patterns",
    CREATE_SERVER_TEMP: "Create Server Pattern",
    SERVER_TEMPS: "Server Patterns",
    DEPLOY_TEMP: "Deploy Server Pattern",
    SERVER_PROFS: "Server Profiles",
    COLLAPSE: "Collapse details",
    OVERVIEW: "Overview",
    WELCOME: "Welcome!",
    WELCOME_PART1: "Using Configuration Patterns you can quickly provision or pre-provision servers by configuring local storage, "
            + "I/O adapters, boot order, and other Integrated Management Module (IMM) and Unified Extensible Firmware Interface "
            + "(UEFI) settings.",
    WELCOME_PART2: "Configuration Patterns also integrates support for IBM Fabric Manager so you can virtualize fabric "
            + "connections, and failover or repurpose servers without disruption to the fabric. Also, you can initiate fabric "
            + "change requests through your change management process before your hardware arrives by preconfiguring host "
            + "interconnect addresses.",
    WELCOME_PART3: "To learn more, click on an icon in the diagram.",
    INFO_PART: "To begin using Configuration Patterns, either select a task from %1 or select another view from the selector on the left.",
    INFO_PART1: "To begin using Configuration Patterns, either select another view from the selector on the left or select a task from",
    INFO_PART2: "To begin using Configuration Patterns, select another view from the selector on the left.",
    CATEGORY_TEMP_OVERVIEW1: "A category pattern groups together related configuration settings that can be reused by multiple server "
            + "configuration patterns.",
    CATEGORY_TEMP_OVERVIEW2: "There are several types of category patterns for configuring IMM and UEFI firmware settings:",
    CATEGORY_TEMP_LIST1: "System Information pattern (system name, location, contact)",
    CATEGORY_TEMP_LIST2: "Management Interface pattern (host name, IP address, DNS, interface speed, port assignments)",
    CATEGORY_TEMP_LIST3: "Power State and Capping pattern (power off/on, shutdown, restart, power restore policy, power capping)",
    CATEGORY_TEMP_LIST4a: "Performance and Recovery pattern (operating mode, processor, memory, timers)",
    CATEGORY_TEMP_LIST4b: "Devices and I/O Ports pattern (console redirection, COM ports, PCIe speed)",
    CATEGORY_TEMP_LIST5: "SAN Boot Target patterns",
    CATEGORY_TEMP_LIST6: "I/O Adapter patterns (adapter and port patterns for configuring fabric interconnects)",
    CATEGORY_TEMP_SUMMARY1: "When defining a server pattern, you can select category patterns as needed to construct the desired "
            + "configuration for a group of servers. For example, you could have two server patterns that use same Management "
            + "Interface pattern but use different Power State and Capping patterns. This allows you to keep the Management "
            + "Interface settings the same across both groups of servers while still having different reboot schedules.",
    CATEGORY_TEMP_SUMMARY2: "To manage patterns, click the Patterns view from the selector on the left.",
    ADDR_POOLS_OVERVIEW1: "Address pools allow you to define address ranges to use when provisioning servers and assigning addresses to "
            + "individual servers. There are IP Address pools, Ethernet Address (MAC) pools, and Fibre Channel Address (WWN) "
            + "pools.",
    ADDR_POOLS_OVERVIEW2: "For example, you can define an IP address pool that defines the IP address range to use when assigning "
            + "management IP addresses to individual servers. The server pattern references the address pool. During "
            + "deployment, addresses are allocated from the pool and assigned to individual servers.",
    ADDR_POOLS_SUMMARY: "To manage address pools, click the Address Pools view from the selector on the left.",
    CREATE_SERVER_OVERVIEW1: "You can create a server pattern from an existing reference server then use that pattern to provision your "
            + "remaining servers. Or, you can create a server pattern from scratch, defining your desired configuration before "
            + "your hardware arrives. The Create Server Pattern wizard will guide you through specifying all aspects of pre-OS "
            + "configuration.",
    CREATE_SERVER_OVERVIEW2: "Click the expand section icon ",
    CREATE_SERVER_OVERVIEW3: " in the diagram for more details on what goes into a server pattern.",
    CREATE_SERVER_QUICK1: "Quick Start: ",
    CREATE_SERVER_QUICK2: "Create a new server pattern from an existing server",
    CREATE_CHASSIS_QUICK2: "Create a new chassis pattern from an existing chassis",
    OPEN_WIZARD: "Open the New Server Pattern wizard",
    SERVER_TEMPS_OVERVIEW1: "A server pattern represents bare metal server configuration, including local storage configuration, I/O adapter "
            + "configuration, boot settings, and other IMM and UEFI firmware settings. A server pattern is used as an overall "
            + "model to quickly configure multiple servers at once.",
    SERVER_TEMPS_OVERVIEW2: "When defining a server pattern, select category patterns and address pools as needed to construct the "
            + "desired configuration for a specific group of servers. You can define multiple server patterns to represent "
            + "different configurations used in your data center. When a server pattern is deployed to multiple servers, "
            + "multiple server profiles are automatically generated (1 profile for each server). Each profile inherits settings "
            + "from the parent server pattern, which allow you to control a common configuration pattern from a single place.",
    SERVER_TEMPS_OVERVIEW3: "To manage patterns, click the Patterns view from the selector on the left.",
    EDIT_TEMP_OVERVIEW1: "Patterns allow you to control a common configuration model from a single place. With Configuration "
            + "Patterns, you no longer update settings on endpoints directly. Now you can edit a category pattern or server "
            + "pattern, and any changes are automatically deployed to all associated profiles and their servers (dashed arrows "
            + "in the diagram indicate tasks performed automatically).",
    EDIT_TEMP_OVERVIEW2: "To manage patterns, click the Patterns view from the selector on the left.",
    DEPLOY_TEMP_OVERVIEW1: "You can deploy a server pattern to one or more individual servers or to groups of servers. For example, you "
            + "can deploy a server pattern to a chassis so all the servers in that chassis are configured the same. During the "
            + "deployment, one server profile is automatically generated for each individual server endpoint, based on the "
            + "overall server pattern (dashed arrows in the diagram indicate tasks performed automatically).",
    DEPLOY_TEMP_OVERVIEW2: "You can deploy a server pattern to existing servers and to empty bays of an existing chassis. You can also "
            + "pre-provision servers by defining a placeholder chassis to act as a target to deploy configurations before you "
            + "hardware arrives. In all cases, one server profile is created for each server or bay. If a server profile is "
            + "associated with an empty bay, the profile is activated once the server is installed and started.",
    DEPLOY_TEMP_OVERVIEW3: "To manage patterns, click the Patterns view from the selector on the left.",
    SERVERS_OVERVIEW1: "Identify groups of servers that have the same hardware options and that you will configure the same. To "
            + "represent the desired configuration for each server group, create a server pattern for each. If a configuration "
            + "change is needed, changing one pattern can change all the servers in the group. This allows you to control a "
            + "common configuration model from a single place.",
    SERVERS_OVERVIEW2: "Once a server pattern is deployed, servers obtain and activate their associated profile automatically as "
            + "part of IMM startup (dashed arrows in the diagram indicate tasks performed automatically).",
    SERVER_PROFS_OVERVIEW1: "Server profiles are automatically generated when a server pattern is deployed (dashed arrows in the diagram "
            + "indicate tasks performed automatically). One server profile is created for each target server. Each server "
            + "profile represents the specific configuration of a single server and contains server unique information like "
            + "assigned IP addresses, MAC addresses, etc.",
    SERVER_PROFS_OVERVIEW2: "The server profile is activated automatically based on an activation schedule, which can be different for "
            + "each server. The server profile is activated as part of IMM startup. Once a server profile is activated for a "
            + "server, any subsequent configuration changes are done by editing the appropriate server pattern or category "
            + "pattern associated with the profile. This allows you to control a common configuration model from a single "
            + "place.",
    SERVER_PROFS_OVERVIEW3: "If a server needs to be moved or repurposed, you can reassign a profile from one server to another server.",
    SERVER_PROFS_SUMMARY1: "Click the expand section icon ",
    SERVER_PROFS_SUMMARY2: " in the diagram for more details on using a single server pattern to configure multiple servers.",
    SERVER_PROFS_SUMMARY3: "To manage profiles, click the Profiles view from the selector on the left.",
    SERVER_TEMP_OVERVIEW: "One server pattern can control the configuration of multiple servers, allowing you to control a common "
            + "configuration model from a single place. The server pattern is the overall model and each profile is an "
            + "instance of that configuration applied to a specific server.",
    SERVER_TEMP_SUMMARY: "To manage patterns, click the Patterns view from the selector on the left.",
    SERVER_PROF_OVERVIEW: "Multiple server profiles can inherit from a single server pattern. Once a server pattern is deployed to a "
            + "server, a profile is created for that specific server. This allows you to quickly deploy a configuration change "
            + "to multiple servers by editing the parent server pattern.",
    SERVER_PROF_SUMMARY: "To manage profiles, click the Profiles view from the selector on the left.",
    EXPAND: "Expand to see more details",
    GO_TO: "Go to Suggested Tasks tab."
});