/*
 * Licensed Materials - Property of IBM
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

define([  
	"dojo/_base/declare",
	"dojo/_base/lang", // lang.mixin lang.hitch
	"dojo/_base/event", // event.stop
	"dojo/dom-style", // domStyle.set
	"dojo/cookie", // domStyle.set
	"dijit/form/Button",
	"support/temp/ModalDialog",
//	"idx/oneui/form/CheckBox",
	"dojo/text!./templates/ConfirmationDialog.html",
    "dijit/form/ValidationTextBox",
    "dojo/parser"
], function(declare, lang, event, domStyle, cookie, Button, ModalDialog, /* CheckBox, */ template, mri){
	/**
	 * @name support.temp.ConfirmationDialog
	 * @class One UI version.
	 * @augments dijit.messaging.ConfirmationDialog
	 */
	 
	 
	return declare("support.temp.ConfirmationDialog", ModalDialog, {
		/**@lends support.temp.ConfirmationDialog*/
		
		baseClass: "idxConfirmDialog",
		// templateString: [protected] String
	    // This widget's HTML template, provided.
	    templateString: template,

		/**
		 * Execute button label
		 * @type String
		 */
		buttonLabel:"",
		
		//Custom validation text area
		validationMode: false,
		validationLabel: "",
		validationRegExp: "",
		validationInvalidMsg: "",
		
		postCreate: function(){
			this.inherited(arguments);
			domStyle.set(this.confirmAction, "display", "block");
			this.confirmAction = new Button({
				label: this.buttonLabel, 
				onClick: lang.hitch(this, function(evt){
					this.onExecute();
					event.stop(evt);
				})
			}, this.confirmAction);
			this.closeAction.set("label", this._nlsResources.cancelButtonLabel);
			this.closeAction.focusNode && dojo.style(this.closeAction.focusNode, "fontWeight", "normal");
//			this.checkbox = new CheckBox({
//				label: this._nlsResources.checked,
//				onChange: lang.hitch(this, function(evt){
//					if(this.checkbox.get("value") == "on"){
//						this.check();
//					}else{
//						this.uncheck();
//					}
//				})
//			}, this.checkbox);
			this.set("type", this.type || "Confirmation");
//			(this.checkboxNode && this.dupCheck) && domStyle.set(this.checkboxNode, "display", "");

			if(this.validationMode){
			    var vBox = new dijit.form.ValidationTextBox({
			        regExp: this.validationRegExp,
			        invalidMessage: this.validationInvalidMsg,
			        intermediateChanges: true
			    });
	            vBox.placeAt(this._validationBox);
			    dojo.attr(this._validationLabel, "innerHTML", this.validationLabel);
	            domStyle.set(this._validationTextAreaWrapper, "display", "");
	            this.confirmAction.set("disabled", this.validationRegExp.length > 0);
	            //Tie Confirm Button Availability To Validation Status
	            dojo.connect(vBox, "onChange", this, function(input){
	               var btnDisabled = this.confirmAction.get("disabled");
	               if(vBox.isValid() && btnDisabled && this.validationRegExp.length > 0
	                       && input.length > 0){
	                   this.confirmAction.set("disabled", false);
	               }
	               else if(!vBox.isValid() && !btnDisabled || 
	                       this.validationRegExp.length > 0 && input.length < 1 && !btnDisabled){
	                   this.confirmAction.set("disabled", true);
	               }
	            });

			    
			}
		},
		_confirmed: function(){
			return cookie(this.id + "_confirmed") == "true";
		},
		check: function(){
			dojo.cookie(this.id + "_confirmed", "true");
		},
		uncheck: function(){
			dojo.cookie(this.id + "_confirmed", null);
//			this.checkbox.set("value", false);
		},
		confirm: function(action, context){
			if(!this._confirmed()){
				this.show();
//				this.checkbox.set("value", false);
				this.disconnect(this._actionListener)
				this._actionListener = this.connect(this, "onExecute", dojo.hitch(context, action));
			}else{
				dojo.hitch(context, action)();
			}
		}
	});
})
