define([ 
    "dojo", 
    "dijit",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/event",
    "dojo/dom-style",
    "dijit/_Widget", 
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dojo/i18n!./nls/ConfirmationDialog",
    "dojo/text!./templates/ConfirmationDialog.html",
    "idx/oneui/messaging/ConfirmationDialog",
    "dijit/form/Button",
    "dijit/form/ValidationTextBox"
], function(dojo, dijit, declare, lang, event, domStyle, _Widget, _TemplatedMixin, _WidgetsInTemplateMixin, mri, template) {
    
    
    
    return dojo.declare("support.widgets.ConfirmationDialog", [ idx.oneui.messaging.ConfirmationDialog, dijit._Widget, dijit._TemplatedMixin, dijit._WidgetsInTemplateMixin], {
        baseClass: "idxConfirmDialog",
        // templateString: [protected] String
        // This widget's HTML template, provided.
        templateString: template,
        
        locResources: mri,
        
        spCssPathAndName: "support/widgets/themes/ConfirmationDialog.css",

        /**
         * Execute button label
         * @type String
         */
        buttonLabel:"",
        
        //Custom validation text area
        validationMode: false,
        validationLabel: "",
        validationRegExp: "",
        validationInvalidMsg: "",
        
        postCreate: function(){
            this.inherited(arguments);
            /*domStyle.set(this.confirmAction, "display", "block");
            this.confirmAction = new dijit.form.Button({
                label: this.buttonLabel, 
                onClick: lang.hitch(this, function(evt){
                    this.onExecute();
                    event.stop(evt);
                })
            }, this.confirmAction);
            this.closeAction.set("label", this._nlsResources.cancelButtonLabel);
            this.closeAction.focusNode && dojo.style(this.closeAction.focusNode, "fontWeight", "normal");

            this.set("type", this.type || "Confirmation");
*/
            if(this.validationMode){
                var vBox = new dijit.form.ValidationTextBox({
                    regExp: this.validationRegExp,
                    invalidMessage: this.validationInvalidMsg,
                    intermediateChanges: true
                });
                vBox.placeAt(this._validationBox);
                dojo.attr(this._validationLabel, "innerHTML", this.validationLabel);
                domStyle.set(this._validationTextAreaWrapper, "display", "");
                this.confirmAction.set("disabled", this.validationRegExp.length > 0);
                //Tie Confirm Button Availability To Validation Status
                dojo.connect(vBox, "onChange", this, function(input){
                   var btnDisabled = this.confirmAction.get("disabled");
                   if(vBox.isValid() && btnDisabled && this.validationRegExp.length > 0
                           && input.length > 0){
                       this.confirmAction.set("disabled", false);
                   }
                   else if(!vBox.isValid() && !btnDisabled || 
                           this.validationRegExp.length > 0 && input.length < 1 && !btnDisabled){
                       this.confirmAction.set("disabled", true);
                   }
                });

                
            }
        }
    });
})