define([ "dojo",
         "dijit",
         "dojo/text!./templates/CreateAndEditSelector.html",
         "support/widgets/Select"
         ], function(dojo, dijit, template) {

    return dojo.declare("support.widgets.CreateAndEditSelector", [ support.panels.Panel ], {
        // templateString: [protected] String
        // This widget's HTML template, provided.
        templateString: template,
        // baseClass: [protected] String
        // The root CSS className to be placed on this widget's domNode.
        baseClass: "CreateAndEditSelector",

        headerText: "",
        
        store: null,  // Selector's store
        
        selectionValue: "-2", //Selector initial value
        
        index: null, // Easy identifier of widget when many are used
        
        width: null,  // width of selector (specified with "px" suffix)
        
        // tmplStore: Select
        //      The Select Dijit within this CreateAndEditSelector
        tmplSelector: null,
        
        buttonsDisabled: false,

        postCreate: function() {
                        
            this.inherited(arguments);
            this._headerText.innerHTML = this.headerText;
            if (this.store && this._tmplSelector) {
                var tmplSelector = new support.widgets.Select({
                    // id: this.get("id") + "_tmplSelector",
                    required: false,
                    store: this.store,
                    //_destroyOnRemove: true,
                    emptyLabel: "&mdash; " + this.resources.NO_TEMP_DEFINED + " &mdash;",
                    style: {
                        width: this.width
                    }
                }).placeAt(this._tmplSelector);
                // call startup(); crucial for dijit.form.Select Dijits
                tmplSelector.startup();
                // preload selector with saved values
                this._presetSelector(this.store._arrayOfAllItems.length, tmplSelector, this.selectionValue);
                tmplSelector.onChange = dojo.hitch(this, this._changeAllTmplCallback);
                dojo.connect(tmplSelector,"onChange", this, function(value){
                    this.changeValue(value, this.index);
                });            
                this.tmplSelector = tmplSelector;
            }
        },
        _editTmpl: function(){
            if(this.buttonsDisabled == true){
                return;
            }
            this.editTmpl(this.tmplSelector.get("value"), this.index);
        },
        _createTmpl: function(){
            if(this.buttonsDisabled == true){
                return;
            }
            this.createTmpl(this.index);
        },
        //Link up with this function to setup edit handling
        editTmpl: function(value,index) {

        },
       //Link up with this function to setup create handling
        createTmpl: function(index) {

        },
        _changeAllTmplCallback: function(newVal) {

            // tags:
            // protected
            if (newVal > 0 && !this.buttonsDisabled) {
                dojo.replaceClass(this._tmplEditOption, "spEditIcon_v2", "spEditInactiveIcon_v2");
                this._tmplEditOption.title = this.resources.EDIT_SELECTED_PATTERN;
            }
            else {
                dojo.replaceClass(this._tmplEditOption, "spEditInactiveIcon_v2", "spEditIcon_v2");
                this._tmplEditOption.title = this.resources.EDIT_SELECTED_PATTERN_DISABLED;
            }

        },
        
        _presetSelector: function(size, selector, selectionValue) {
            // tags:
            // protected
            // No templates for this category?
            if (size <= 0) {
                // Disable selection and allow "emptyLabel" to display.
                selector.set("disabled", true);
            }else{                                               
                selector.set("value",selectionValue);                
            }
        },

        showDisplay: function(show) {
            if (show) {
                dojo.style(this._node, "display", "");
                dojo.style(this._headerText, "display", "");
            }
            else {
                dojo.style(this._node, "display", "none");
                dojo.style(this._headerText, "display", "none");
            }
        },
        
        setName: function(name){
            if(name){
                this._headerText.innerHTML = name;
            }
        },
        
        setStore: function(store){
            if(store && this.tmplSelector){
                this.tmplSelector.setStore(store);
            }
        },
        
        setValue: function(value){
            if(value && this.tmplSelector){
                this.tmplSelector.set("value",value);
            }
        },
        
        getValue: function(){
            if(this.tmplSelector){
                return this.tmplSelector.get("value");
            }
        },
        
        changeValue: function(value, index){
            //connect to the selector's onChange event
        },
        
        attachSelector: function(){
            this.tmplSelector.placeAt(this._tmplSelector);
        },
        
        showName: function(show){
            if (show) {
                dojo.style(this._headerText, "display", "");
            }
            else {
                dojo.style(this._headerText, "display", "none");
            }
        },
        
        toggleButtons: function(disabled){
            if(disabled){
                this._tmplCreateOption.disabled = false;
                dojo.replaceClass(this._tmplCreateOption, "spCreateInactiveIcon_v2", "spCreateIcon_v2");
                this._tmplEditOption.disabled = false;
                dojo.replaceClass(this._tmplEditOption, "spEditInactiveIcon_v2", "spEditIcon_v2");
                this._tmplEditOption.title = this.resources.EDIT_SELECTED_PATTERN_DISABLED;
                this.buttonsDisabled = true;
            }
            else {
                this._tmplCreateOption.disabled = true;
                dojo.replaceClass(this._tmplCreateOption, "spCreateIcon_v2", "spCreateInactiveIcon_v2");
                this._tmplEditOption.disabled = true;
                dojo.replaceClass(this._tmplEditOption, "spEditIcon_v2", "spEditInactiveIcon_v2");
                this._tmplEditOption.title = this.resources.EDIT_SELECTED_PATTERN;
                this.buttonsDisabled = false;
            }
        }

    });
});