define([ "dojo", "dijit/form/Select" ], function(dojo, select) {

    dojo.declare("support.widgets.Select", [ select ], {
        
        /* For some reason, in dojo 1.9, the dijit/form/Select selector
         * is not refreshed after initial load or after setting the store so the this._setDisplay()
         * is required.
         * 
         */
        startup: function() {
            this._setDisplayWithLabel();
            this.inherited(arguments);
        },

        onSetStore: function() {
            this._setDisplayWithLabel();
            this.inherited(arguments);
        },

        _setDisplayWithLabel: function() {
            // Grab the label of the current selection if one is available
            var options = this.getOptions(this.get("value"));
            if(options) {
                this._setDisplay(options.label);
            } else {
                // _setDisplay with no parrms will show the empyLabel
                this._setDisplay();
            }
        }
    });
});