/*Example Set-Up:
 * | <link rel="stylesheet" href="dojo/js/widgets/themes/ToggleButton.css" type="text/css">
 * | <script type="text/javascript">
 * |    dojo.registerModulePath("support", "../../js/support");
 * |    dojo.require("support.widgets.ToggleButton");   
 * |    dojo.require("dojo.parser");
 * |
 * |    dijit.byId("toggle").set("onClick", doSomething());
 * | </script>
 * | <div data-dojo-type="support.widgets.ToggleButton"
 * |    data-dojo-props="id:'toggle', enabled:true, onclick:'doSomething()', onkeypress:'doSomething()'">
 * | </div>
 */

define([
        "dojo", 
        "dijit", 
        "dijit/_Widget", 
        "dijit/_TemplatedMixin", 
        "dijit/_WidgetsInTemplateMixin",
        "dojo/i18n!./nls/SelectWithButtons", 
        "dojo/text!../widgets/templates/SelectWithButtons.html",
        "dojo/cookie",
        "support/widgets/Select",
        "support/dialogs/NewPortPhysicalFunctionTemplate",
        "dojox/data/AndOrReadStore"
    ], function(dojo, dijit, _Widget, _TemplatedMixin, _WidgetsInTemplateMixin, mri, template) {

    dojo.declare("support.widgets.SelectWithButtons", [ dijit._Widget, dijit._TemplatedMixin, dijit._WidgetsInTemplateMixin ], {

        // templateString: [protected] String
        // This widget's HTML template, provided.
        templateString: template,

        // locResources: [protected] Object
        // This widget's National Language Source (NLS) object.
        locResources: mri,

        widgetsInTemplate: true,
        
        jsonData: null,
        nodeType: null,
        addType: null,
        physicalFunction: null,
        templateValue: null,
        filterBy: "*",
        _defaultPortPhysicalFunctionStore: null,
        _portPhysicalFunctionSelector: null,
        restpath: null,

        postMixInProperties: function() {
            this.inherited(arguments);
        },

        postCreate: function() {
            this.inherited(arguments);
            
            var portPhysicalFunctionTemplateData = null;
            var xhrPortPhyFuncTemp = {            
                url: this.restpath + "template/list/ppfunction",
                handleAs: "json",
                sync: true,
                headers: {
                    "Content-Type": "application/json; charset=utf-8"
                },
                load: function(data) {
                    portPhysicalFunctionTemplateData = data;
                },
                error: function(error) {
                    alert(error);
                }
            };
            
            this.subscribe("CreatePortPhysicalFunctionTemplateComplete", function(data) {
                var ppfunctionTemplateData = null;
                var xhrAdapTemp = {
                    url: this.restpath + "template/list/ppfunction",                    
                    handleAs: "json",
                    sync: true,
                    headers: {
                        "Content-Type": "application/json; charset=utf-8"
                    },
                    load: function(data) {
                        ppfunctionTemplateData = data;
                    },
                    error: function(error) {
                        alert(error);
                    }
                };

                // Call the asynchronous xhrGet
                dojo.xhrGet(xhrAdapTemp);

                this._defaultPortPhysicalFunctionStore = new dojox.data.AndOrReadStore({
                    data: ppfunctionTemplateData                
                }); 
                
                this._portPhysicalFunctionSelector.setStore(this._defaultPortPhysicalFunctionStore, null, {query: {
                    complexQuery: "physicalFunction: '" + this.physicalFunction + "' AND (adapterType: '*ANY' OR adapterType: '" + this.addType + "')"
                }});
                
 //               this._portPhysicalFunctionSelector.set("value", data.id);
            });

            // Call the asynchronous xhrGet
            dojo.xhrGet(xhrPortPhyFuncTemp);
                            
            this._defaultPortPhysicalFunctionStore = new dojox.data.AndOrReadStore({
                data: portPhysicalFunctionTemplateData
                //data: this._getValidJsonData(this.jsonData)
                //url: this.jsonPath
            });
            //alert(this.physicalFunction);
            this._portPhysicalFunctionSelector = new support.widgets.Select({
                //id: this.get("id") + "_adapTemplateSelector",
                name: "selector",
                store: this._defaultPortPhysicalFunctionStore,
                query: {
                    // Only templates for specified adapter.
                    complexQuery: "physicalFunction: '" + this.physicalFunction + "' AND (adapterType: '*ANY' OR adapterType: '" + this.addType + "')"
                    //adapterType: this.addType,
                    //physicalFunction: this.physicalFunction
                },                                        
                maxHeight: -1,
                emptyLabel: "&mdash; " + this.locResources.NO_PATTERN_DEFINED + " &mdash;",
                style: {
                    width: "200px"
                },
                disabled: false
            }).placeAt(this._selector);
            this._portPhysicalFunctionSelector.startup();
            dojo.connect(this._portPhysicalFunctionSelector, "onChange", this, function(value) {
                this._onChange(value);
                //dojo.publish("SelectWithButtonsChanged", value);
            });
            
            if (this.templateValue != null) {
                this._portPhysicalFunctionSelector.set("value", this.templateValue);
            }
       /*     var slider = new dijit.form.HorizontalSlider({
                name: "horizontalslider",
                value: 0,
                minimum: 0,
                maximum: 100,
                style: "width: 100px;",
                discreteValues: 101,
                intermediateChanges: true,
                //onChange: function(value){
                //    this._sliderlabel.set("value", value);
                //},
                showButtons: false
            }).placeAt(this._horizontalslider);
            dojo.connect(slider, "onChange", this, function(value) {
                //this._sliderlabel.set("value", value);
                dojo.byId(this.id + "_sliderlabel").innerHTML = value + "%";
                this._sliderValue = value;
            });
            slider.set("value", 25);*/
        },

        startup: function() {
            this.inherited(arguments);
        },

        _onChange: function(value) {
            this.onChange(value);
        },
        
        onChange: function(value) {
            
        },
        
        // onClick event
        _onClick: function() {
            this.onClick();
        },

        onClick: function() {
            // do nothing, override if necessary
        },

        // onmouseover event
        _onMouseOver: function() {
            this.onMouseOver();
        },

        onMouseOver: function() {
            // do nothing, override if necessary
        },

        _onMouseOut: function() {
            this.onMouseOut();
        },

        onMouseOut: function() {
            // do nothing, override if necessary
        },

        // onkeypress event
        _onKeyPress: function(e) {
            if (!e) {
                e = window.event;
            }
            var code = e.keyCode;
            // space
            if (code == 0) {
                this.onKeyPress();
                return true;
            }
            // arrow keys
            else if (code == 37 || code == 38 || code == 39 || code == 40) {
                this._onClick();
                this.onKeyPress();
                return true;
            }
            // enter
            else if (code == 13) {
                e.preventDefault();
                this.onKeyPress();
                return false;
            }
            // tab
            else if (code == 9) {
                this.onKeyPress();
                return true;
            }
            this.onKeyPress();
            return false;
        },

        onKeyPress: function() {
            // do nothing, override if necessary
        },

        _getValueAttr: function() {            
           // return(this._sliderValue);
        },
        
        _createIconPressed: function() {
            dojo.replaceClass(this._createIcon, "spCreateClickedIcon_v2", "spCreateHoverIcon_v2");
        },
        
        _createIconClicked: function() {                
            var portPhysicalDialog = new support.dialogs.NewPortPhysicalFunctionTemplate({
                nodeType: "sysx",
                addType: this.addType,
                physicalFunction: this.physicalFunction
             });
            portPhysicalDialog.show();           
        },        

        _createIconReleased: function() {                     
            //if (this._moveRightButtonEnabled == true) {             
                dojo.replaceClass(this._createIcon, "spCreateHoverIcon_v2", "spCreateClickedIcon_v2");
            //}
        },
        
        _createIconHover: function() {            
            //if (this._moveRightButtonEnabled == true) {
                dojo.replaceClass(this._createIcon, "spCreateHoverIcon_v2", "spCreateIcon_v2");
            //}
        },
        
        _createIconMouseOut: function() {            
            dojo.replaceClass(this._createIcon, "spCreateIcon_v2", "spCreateHoverIcon_v2");           
        },
        
        _editIconPressed: function() {
            dojo.replaceClass(this._editIcon, "spEditClickedIcon_v2", "spEditHoverIcon_v2");
        },
        
        _editIconClicked: function() {       
            var portPhysicalFunctionTemplateData = null;
            var xhrAdapTemp = {
                url: this.restpath + "template/" + this._portPhysicalFunctionSelector.get("value"),
                handleAs: "json",
                sync: true,
                headers: {
                    "Content-Type": "application/json; charset=utf-8"
                },
                load: function(data) {
                    portPhysicalFunctionTemplateData = data;
                },
                error: function(error) {
                    alert(error);
                }
            };

            // Call the asynchronous xhrGet
            dojo.xhrGet(xhrAdapTemp);
            
            var tempmode = "copy";
            if (portPhysicalFunctionTemplateData.items[0].userDefined == false) {
                tempmode = "copy";
            } else {
                tempmode = "edit";
            }
                        
            var portPhysicalFunctionDialog = new support.dialogs.NewPortPhysicalFunctionTemplate({
                templateIDNum: this._portPhysicalFunctionSelector.get("value")
                //templateMode: tempmode,
                //templateInUse: false,
                //addType: this.addType
            });
            portPhysicalFunctionDialog.show();   
        },        

        _editIconReleased: function() {                     
            //if (this._moveRightButtonEnabled == true) {             
                dojo.replaceClass(this._editIcon, "spEditHoverIcon_v2", "spEditClickedIcon_v2");
            //}
        },
        
        _editIconHover: function() {            
            //if (this._moveRightButtonEnabled == true) {
                dojo.replaceClass(this._editIcon, "spEditHoverIcon_v2", "spEditIcon_v2");
            //}
        },
        
        _editIconMouseOut: function() {            
            dojo.replaceClass(this._editIcon, "spEditIcon_v2", "spEditHoverIcon_v2");           
        },        
        
        _setEnabledAttr: function(bool) {
            this.enabled = !bool;
            this._onClick();
        },
        
        _getSelectValueAttr: function() {          
            return this._portPhysicalFunctionSelector.get("value");
        }

    });
});
