/*Example Set-Up:
 * | <link rel="stylesheet" href="dojo/js/widgets/themes/ToggleButton.css" type="text/css">
 * | <script type="text/javascript">
 * |    dojo.registerModulePath("support", "../../js/support");
 * |    dojo.require("support.widgets.ToggleButton");   
 * |    dojo.require("dojo.parser");
 * |
 * |    dijit.byId("toggle").set("onClick", doSomething());
 * | </script>
 * | <div data-dojo-type="support.widgets.ToggleButton"
 * |    data-dojo-props="id:'toggle', enabled:true, onclick:'doSomething()', onkeypress:'doSomething()'">
 * | </div>
 */

define([
		"dojo/_base/declare",
        "dijit/form/ToggleButton",
        "dojo/i18n!./nls/ToggleButton"
    ],function(modDeclare, modToggleButton, mri) {
 
    modDeclare("support.widgets.ToggleButton", [ modToggleButton ], {
    
      // locResources: [protected] Object
      // This widget's National Language Source (NLS) object.
      locResources: mri,

      // BUGBUG: AA121016-- This should really use the base widget's "checked"
      // variable, but no time to change all the clients right now.
      enabled: false,

      // BUGBUG: AA121016-- Weird client code uses this to set and get the
      // widget state by MRI string.
      toggleValue: null,

      _enabledMriString: null,
      _disabledMriString: null,

      // Used to set the MRI strings for the enabled and disabled states.
      value: null,

      postMixInProperties: function() {
         this.inherited(arguments);

         if (this.value && this.value.length == 2) {
            this._enabledMriString = this.value[0];
            this._disabledMriString = this.value[1];
         } else {
            this._enabledMriString = "enabled";
            this._disabledMriString = "disabled";
         }
      },

      buildRendering: function() {
         this.inherited(arguments);

         // div for background
         var background = document.createElement("div");
         background.setAttribute("class", "toggleSliderBackground");
         background.setAttribute("tabindex", "-1");
         this.titleNode.parentNode.parentNode.appendChild(background);
      },

      _setToggleValueAttr: function(value) {
          
         if (value != null) {
            if (value == "enabled" || value == "enable" || value == "yes"
                || value == "on" || value == true || value == "true" || value == "Enabled"
                || value == "Enable" || value == "ENABLED" || value == "ENABLE" || value == "Yes") {
               this._setEnabledAttr(true);
            } else if (value == "disabled" || value == "disable" || value == "no"
                       || value == "off" || value == false || value == "false" || value == "Disabled"
                       || value == "Disable" || value == "DISBALED" || value == "DISABLE" || value == "No") {
               this._setEnabledAttr(false);
            }
         }
      },

      _getToggleValueAttr: function() {
         return this.checked ? this._enabledMriString : this._disabledMriString;
      },

      _setLabel: function() {
         this.set("label", this.checked ? this.locResources.ENABLED : this.locResources.DISABLED);
      },

      _onClick: function() {
         this.inherited(arguments);
         this._setLabel();
      },

      _setEnabledAttr: function(bool) {
         this.set("checked", bool);
         this._setLabel();
      },

      _getEnabledAttr: function() {
         return this.get("checked");
      }
   });
});
