define([
        "dojo",
        "dijit",
        "support/panels/Panel",
        "dojo/i18n!./nls/cmmBayNodes",
        "dojo/text!./templates/cmmBayNodes.html",
        "dojo/data/ItemFileWriteStore",
        "dijit/form/Select",
        "support/widgets/Select",
        "dijit/form/CheckBox",
        "dijit/form/Button",
        "dojox/grid/LazyTreeGrid",
        "dojox/grid/LazyTreeGridStoreModel",
        "dijit/tree/ForestStoreModel",
        "support/widgets/CreateAndEditSelector"
    ], function(dojo, dijit, page, mri, template) {

    return dojo.declare("support.wizard.pages.cmmBayNodes", [ support.panels.Panel ], {

        // templateString: [protected] String
        // This widget's HTML template, provided.
        templateString: template,

        // locResources: [protected] Object
        // This widget's National Language Source (NLS) object.
        locResources: mri,

        // editMode: boolean
        // Specifies whether the wizard is to execute in edit mode. If true, the "templateIDNum"
        // attribute is required.
        editMode: false,

        // copyMode: boolean
        // Specifies whether the wizard is to execute in copy mode. If true, the "templateIDNum"
        // attribute is required.
        copyMode: false,

        // inUse: boolean
        // Specifies whether the wizard is to execute in inUse mode.
        inUse: false,

        // baseClass: [protected] String
        // The root CSS className to be placed on this widget's domNode.
        baseClass: "nstWizard",

        // Internal Selector Names
        ALLTMPL_NAME: "nodeTemplate",

        selectedIndex: -1,

        SELECTOR_WIDTH: "200px",

        preselectedTemplates: null,

        selectors: [],
        buttons: [],

        selections: {
            1: {
                selected: false,
                templateId: -1,
                type: -1,
                formFactor: -1,
                base: false,
                name: ""
            },
            2: {
                selected: false,
                templateId: -1,
                type: -1,
                formFactor: -1,
                base: false,
                name: ""
            },
            3: {
                selected: false,
                templateId: -1,
                type: -1,
                formFactor: -1,
                base: false,
                name: ""
            },
            4: {
                selected: false,
                templateId: -1,
                type: -1,
                formFactor: -1,
                base: false,
                name: ""
            },
            5: {
                selected: false,
                templateId: -1,
                type: -1,
                formFactor: -1,
                base: false,
                name: ""
            },
            6: {
                selected: false,
                templateId: -1,
                type: -1,
                formFactor: -1,
                base: false,
                name: ""
            },
            7: {
                selected: false,
                templateId: -1,
                type: -1,
                formFactor: -1,
                base: false,
                name: ""
            },
            8: {
                selected: false,
                templateId: -1,
                type: -1,
                formFactor: -1,
                base: false,
                name: ""
            },
            9: {
                selected: false,
                templateId: -1,
                type: -1,
                formFactor: -1,
                base: false,
                name: ""
            },
            10: {
                selected: false,
                templateId: -1,
                type: -1,
                formFactor: -1,
                base: false,
                name: ""
            },
            11: {
                selected: false,
                templateId: -1,
                type: -1,
                formFactor: -1,
                base: false,
                name: ""
            },
            12: {
                selected: false,
                templateId: -1,
                type: -1,
                formFactor: -1,
                base: false,
                name: ""
            },
            13: {
                selected: false,
                templateId: -1,
                type: -1,
                formFactor: -1,
                base: false,
                name: ""
            },
            14: {
                selected: false,
                templateId: -1,
                type: -1,
                formFactor: -1,
                base: false,
                name: ""
            }

        },

        POWER_NODE: 1,
        STORAGE_NODE: 2,

        allNodes: false,

        // tmplStore: ItemFileWriteStore
        // The ItemFileWriteStore used to store
        // data from CP services
        tmplStore: null,

        // Array that holds subscriptions
        _subscriptions: [],

        // Override this method to perform custom behavior during dijit
        // construction.
        // Common operations for constructor:
        // 1) Initialize non-primitive types (i.e. objects and arrays)
        // 2) Add additional properties needed by succeeding lifecycle
        // methods
        constructor: function() {
            this.resources = dojo.i18n.getLocalization("support.panels", "Panel", this.lang);
        },

        // When this method is called, all variables inherited from superclasses are "mixed in".
        // Common operations for postMixInProperties
        // 1) Modify or assign values for widget property variables defined in
        // the template HTML file
        postMixInProperties: function() {

            this.inherited(arguments);

        },

        // postCreate() is called after buildRendering(). This is useful to
        // override when
        // you need to access and/or manipulate DOM nodes included with your
        // widget.
        // DOM nodes and widgets with the dojoAttachPoint attribute
        // specified
        // can now be directly
        // accessed as fields on "this".
        // Common operations for postCreate
        // 1) Access and manipulate DOM nodes created in buildRendering()
        // 2) Add new DOM nodes or widgets
        postCreate: function() {
            this.inherited(arguments);
            if (this.editMode || this.copyMode) {
                this._presetSelections();
            }
            this._setupAllTmplSelector();
            this._setupNodeSelectors();
            this._setupBayButtons();

            // Set bay # text

            this._selectAll = new dijit.form.CheckBox({
                checked: false,
                onChange: dojo.hitch(this, function(checked) {
                    if (checked) {
                        this._setDefinedTemplates(this._allTmplSelector.get("value"));
                        this._toggleSelectorsDisabled(true);
                        this._allTmplSelector.set("disabled", false);
                        this._changeAllTmplCallback(this._allTmplSelector.get("value"));
                        // dojo.replaceClass(this._allTmplEditOption, "nstEditIcon", "nstEditIconDisabled");
                        dojo.replaceClass(this._allTmplCreateOption, "createNewIcon", "createNewIconDisabled");
                        // Disable if selector is empty
                        if (this._allTmplSelector.store._arrayOfTopLevelItems.length < 1) {
                            this._allTmplSelector.set("disabled", true);
                        }
                    }
                    else {
                        this._toggleSelectorsDisabled(false);
                        // this._allTmplSelector.set("value","-1");
                        this._allTmplSelector.set("disabled", true);
                        dojo.replaceClass(this._allTmplEditOption, "nstEditIconDisabled", "nstEditIcon");
                        this._allTmplEditOption.title = this.resources.EDIT_SELECTED_PATTERN_DISABLED;
                        dojo.replaceClass(this._allTmplCreateOption, "createNewIconDisabled", "createNewIcon");
                    }
                })
            }).placeAt(this._selectAll);

            this._allTmplSelector.set("disabled", true);
            dojo.replaceClass(this._allTmplEditOption, "nstEditIconDisabled", "nstEditIcon");
            this._allTmplEditOption.title = this.resources.EDIT_SELECTED_PATTERN_DISABLED;
            dojo.replaceClass(this._allTmplCreateOption, "createNewIconDisabled", "createNewIcon");

            this.overallStore = new dojo.data.ItemFileWriteStore({
                data: {
                    "items": [ {
                        bayL: 13,
                        bayR: 14
                    }, {
                        bayL: 11,
                        bayR: 12
                    }, {
                        bayL: 9,
                        bayR: 10
                    }, {
                        bayL: 7,
                        bayR: 8
                    }, {
                        bayL: 5,
                        bayR: 6
                    }, {
                        bayL: 3,
                        bayR: 4
                    }, {
                        bayL: 1,
                        bayR: 2
                    } ]
                }
            });
            if (this.overallLayout == null) {
                this.overallLayout = this.getLayout();
            }

            this.overallmodel = new dijit.tree.ForestStoreModel({
                store: this.overallStore
            });

            this.subHandle = this.subscribe("NodeFormatComplete", dojo.hitch(this, function(data) {
                this._handleRow(data);
                if (this._selectAll.checked == true) {
                    this._setDefinedTemplates(this._allTmplSelector.get("value"));
                }
                // Refresh the table to adjust height for taller rows.
                this.overallTable.update();
            }));

            dojo.connect(this._allTmplSelector, "onChange", this, function(value) {
                if (this._selectAll.checked == true) {
                    this._setDefinedTemplates(value);
                }
            });

            dojo.connect(this.wizard, "updateUI", this, function(value) {
                this._setPreDefinedTemplates();
            });

            this.showoverallTable();
            this._setupSubscribers();
        },

        _setStartingPointAttr: function(newval) {
            this._set("startingPoint", newval);
            if (this.startingPoint == "FROM_SCRATCH") {
                if (this.warningMessage)
                    this.warningMessage.destroyRecursive();
                if (this.infoMessage)
                    this.infoMessage.destroyRecursive();
            }
            else {
                // Commenting out just in case this message is added back in...
                /*
                 * this.warningMessage = new modSingleMessage({ title:
                 * this.resources.LEARNED_SETTINGS_WARNING, description:
                 * this.resources.LEARNED_SETTINGS_DETAILS, type: "warning", dateFormat: {
                 * formatLength: "medium", selector: "time" }, showId: false, showAction: false,
                 * showRefresh: false, showDetailsLink: false }).placeAt(this.id + "_messagearea");
                 */

                if (this.CP_RUN_ENVIRONMENT == "fsm") {

                    require([ "idx/oneui/messaging/SingleMessage" ], dojo.hitch(this, function() {
                        this.infoMessage = new idx.oneui.messaging.SingleMessage({
                            description: " ",
                            type: "information",
                            dateFormat: {
                                formatLength: "medium",
                                selector: "time"
                            },
                            showId: false,
                            showAction: false,
                            showRefresh: false,
                            showDetailsLink: false
                        }).placeAt(this.id + "_messagearea");
                        this.infoMessage.set("title", this.resources.SYSX_NODES_MSG);

                    }));

                }
                else if (this.CP_RUN_ENVIRONMENT == "augusta") {

                    require([ "idx/widget/SingleMessage" ], dojo.hitch(this, function() {
                        this.infoMessage = new idx.widget.SingleMessage({
                            description: " ",
                            type: "information",
                            dateFormat: {
                                formatLength: "medium",
                                selector: "time"
                            },
                            showId: false,
                            showAction: false,
                            showRefresh: false,
                            showDetailsLink: false
                        }).placeAt(this.id + "_messagearea");
                        this.infoMessage.set("title", this.resources.SYSX_NODES_MSG);

                    }));

                }                
            }
        },

        _presetSelector: function(size, selector) {
            // tags:
            // protected
            // No templates for this category?
            if (size <= 0) {
                // Disable selection and allow "emptyLabel" to display.
                selector.set("disabled", true);
            }
            else {
                var curTemplates = [];
                if (this.pageParams.templates) {
                    // Pick preselected id
                    switch (selector.name) {
                        case this.ALLTMPL_NAME:
                            curTemplates = dojo.filter(this.pageParams.templates, dojo.hitch(this, function(item) {
                                return item.type == this.SYS_INFO;
                            }));
                            break;
                    }
                }

                // Set drop-down value
                if (curTemplates.length) {
                    selector.set("value", curTemplates[0].id);
                }
                else {
                    selector.set("value", "-1");
                }
            }

            this.allNodes = true;

        },

        _presetSelectorValues: function() {
            if (this.pageParams.templates) {
                for (var idx = 0; idx < this.pageParams.templates.length; idx++) {
                    if (this.pageParams.templates[idx].type == "IOModule") {
                        this._allTmplSelector.set("value", this.pageParams.templates[idx].id);
                    }
                }
            }
        },

        _setupAllTmplSelector: function() {

            // summary:
            // Setup SystemInfo template selector...
            // tags:
            // protected
            var tmplStore = this._regenerateSelectorStore(true);
            this._allTmplSelector = new support.widgets.Select({
                id: this.get("id") + "_allTmplSelector",
                name: this.ALLTMPL_NAME,
                required: false,
                store: tmplStore,
                disabled: true,
                emptyLabel: "&mdash; " + this.resources.NO_TEMP_DEFINED + " &mdash;",
                style: {
                    width: this.SELECTOR_WIDTH
                }
            }).placeAt(this._allTmplSelector);
            // call startup(); crucial for support.widgets.Select Dijits
            this._allTmplSelector.startup();
            // preload selector with saved values
            this._presetSelector(tmplStore._arrayOfAllItems.length, this._allTmplSelector);
            this._allTmplSelector.onChange = dojo.hitch(this, this._changeAllTmplCallback);

        },

        _refreshAllInfoSelector: function() {
            var tmplStore = this._regenerateSelectorStore(true);
            this._allTmplSelector.setStore(tmplStore);
        },

        _changeAllTmplCallback: function(newVal) {

            // tags:
            // protected
            // dojo.style(this._allTmplContainer, "display", "none");
            // 99299: Wade Fode, 8/2/2012. Future consideration to display
            // contents of the
            // selected template in an expandable section beneath the
            // selector.
            if (newVal > 0) {
                // dojo.replaceClass(this._sysTmplSelectorExpander,
                // "expandTwistie", "noTwistie
                // collapseTwistie");

                // Only enable if checked
                if (this._selectAll.checked) {
                    dojo.replaceClass(this._allTmplEditOption, "nstEditIcon", "nstEditIconDisabled");
                    this._allTmplEditOption.title = this.resources.EDIT_SELECTED_PATTERN;
                }
            }
            else {
                // dojo.replaceClass(this._sysTmplSelectorExpander,
                // "noTwistie", "expandTwistie
                // collapseTwistie");
                dojo.replaceClass(this._allTmplEditOption, "nstEditIconDisabled", "nstEditIcon");
                this._allTmplEditOption.title = this.resources.EDIT_SELECTED_PATTERN_DISABLED;
            }

        },

        _changeTmplCallback: function(selectorNum, newVal) {

        },

        editAllTmpl: function() {
            this._editAllTmpl(this._allTmplSelector.get("value"), 0);
        },

        createAllTmpl: function() {
            if (this._selectAll.checked == false) {
                return;
            }
            this._createAllTmpl(0);
        },

        _editAllTmpl: function(templateId, index) {
            if (index == 0 && this._allTmplSelector.get("disabled") == true) {
                return;
            }
            if (index > 0 && this.selectors[index - 1].tmplSelector.get("disabled") == true) {
                return;
            }
            // console.log(this.declaredClass + ": ", templateId);
            // console.log(this.declaredClass + ": ", index);
            this.selectedIndex = index;
            if (templateId >= 0) {
                templateId = templateId.toString();

                require([ "support/dialogs/ChassisNodeTemplate" ], dojo.hitch(this, function() {

                    var dialog = new support.dialogs.ChassisNodeTemplate({
                        id: this.id + "cp_cmmbaynodes_editchassisnodedialogall",
                        templateIDNum: templateId,
                        templateMode: "edit",
                        // templateInUse: "",
                        templateLaunchPoint: "wizard"

                    });
                    dialog.show();

                }));

            }
        },

        _createAllTmpl: function(index) {
            this.selectedIndex = index;

            require([ "support/dialogs/ChassisNodeTemplate" ], dojo.hitch(this, function() {
                var dialog = new support.dialogs.ChassisNodeTemplate({
                    id: this.id + "cp_cmmbaynodes_createchassisnodedialogall"
                });
                dialog.show();

            }));

        },
        showoverallTable: function() {
            if (this.overallTable == null) {
                this.overallTable = new dojox.grid.LazyTreeGrid({
                    id: this.id + "_overalltable",
                    treeModel: this.overallmodel,
                    structure: this.overallLayout,
                    autoWidth: false,
                    autoHeight: false,
                    autoRender: false,
                    height: "625px",
                    singleClickEdit: true,
                    columnReordering: false,
                    style: "width: 950px;",
                    noDataMessage: this.locResources.NO_DATA
                }).placeAt(this._nodeTable);
                this.overallTable.canSort = function(col) {
                    return false;
                };
            }
        },
        getLayout: function() {
            return [ {
                name: this.locResources.BAY_COL,
                field: "bayL",
                width: "17%",
                formatter: dojo.hitch(this, "_formatBayCol")
            }, {
                name: this.locResources.NODE_COL,
                field: "bayL",
                width: "33%",
                formatter: dojo.hitch(this, "_formatTemplateCol")
            }, {
                name: this.locResources.NODE_COL,
                field: "bayR",
                width: "33%",
                formatter: dojo.hitch(this, "_formatTemplateCol")
            }, {
                name: this.locResources.BAY_COL,
                field: "bayR",
                width: "17%",
                formatter: dojo.hitch(this, "_formatBayCol")
            } ];
        },

        _formatBayCol: function(value, rowIndex, cell) {
            if (this.buttons) {
                return this.buttons[value - 1];
            }

        },

        _formatTemplateCol: function(value, rowIndex, cell) {
            if (this.tmplStore) {
                var temp = this.selectors[value - 1];
                temp.showDisplay(this.selections[value].selected && this.selections[value].base);
                if (this.selections[value].selected) {
                    temp.setName(this.selections[value].name);
                    temp.showName(true);
                }

                // The grid likes to empty the selector container div when it reloads,
                // re-attach the selector to work around that
                temp.attachSelector();
                return temp;
            }
        },

        _handleButtonClick: function(value) {
            if (!this.selections[value].selected) {

                require([ "support/dialogs/ChassisNodePopup" ], dojo.hitch(this, function() {
                    var dialog = new support.dialogs.ChassisNodePopup({
                        id: this.id + "cp_cmmbaynodes_chassisnodepopupdialog" + value,
                        bayNum: value,
                        baySelections: this.selections
                    });
                    dialog.show();
                }));

            }
            else {
                this._handleRow({
                    bayNum: value,
                    formFactor: this.selections[value].formFactor,
                    type: this.selections[value].type
                });
            }
        },

        _handleRow: function(data) {
            if (!data || !data.bayNum || !data.type || !data.formFactor) {
                return;
            }
            var value = data.bayNum;
            var ff = data.formFactor;
            var type = data.type;

            var selector = this.selectors[value - 1];
            var btn = this.buttons[value - 1];
            if (!this.selections[value].selected) {
                var name = "";
                if (type == this.STORAGE_NODE) {
                    name = this.locResources.STORAGE_LABEL.replace("%1", ff).replace("%2", value);
                }
                else if (type == this.POWER_NODE) {
                    name = this.locResources.POWER_LABEL.replace("%1", ff).replace("%2", value);
                }

                // 1 Bay
                if (ff == 1 || ff == 2 || ff == 4) {
                    // No Room For 4 Slots
                    if (ff == 4 && value > 12) {
                        return;
                    }

                    btn.set("disabled", false);
                    btn.set("iconClass", "spDeleteIcon");
                    btn.set("title", this.locResources.REM_NODE_TYPE);
                    selector.setName(name);
                    selector.showDisplay(true);
                    this.selections[value].selected = true;
                    this.selections[value].type = type;
                    this.selections[value].formFactor = ff;
                    this.selections[value].base = true;
                    this.selections[value].name = name;

                    // 2 Bay
                    if (ff == 2 || ff == 4) {
                        // Find partner
                        var partnerValue = 0;
                        if (value % 2 == 0) {
                            partnerValue = value - 1;
                        }
                        else {
                            partnerValue = value + 1;
                        }
                        var partnerSelector = this.selectors[partnerValue - 1];
                        var partnerBtn = this.buttons[partnerValue - 1];
                        this._setCell(partnerSelector, partnerBtn, partnerValue, type, ff, name);

                        if (ff == 4) {
                            var friend1Value = (value > partnerValue) ? value + 1 : partnerValue + 1;
                            var friend2Value = friend1Value + 1;

                            // Setup friend 1
                            var friend1Selector = this.selectors[friend1Value - 1];
                            var friend1Btn = this.buttons[friend1Value - 1];
                            this._setCell(friend1Selector, friend1Btn, friend1Value, type, ff, name);
                            // Friend 2
                            var friend2Selector = this.selectors[friend2Value - 1];
                            var friend2Btn = this.buttons[friend2Value - 1];
                            this._setCell(friend2Selector, friend2Btn, friend2Value, type, ff, name);
                            // Free any locked cells next to friends if we need to
                            // ie disabled by pre-existing 4 bay selection
                            if (friend2Value < 13) {
                                var neighbor1Value = friend2Value + 1;
                                if (this.selections[neighbor1Value].formFactor == 4) {
                                    var neighbor2Value = neighbor1Value + 1;
                                    // Free neighbor 1
                                    var neighbor1Selector = this.selectors[neighbor1Value - 1];
                                    var neighbor1Btn = this.buttons[neighbor1Value - 1];
                                    this._freeCell(neighbor1Selector, neighbor1Btn, neighbor1Value);
                                    // Free neighbor 2
                                    var neighbor2Selector = this.selectors[neighbor2Value - 1];
                                    var neighbor2Btn = this.buttons[neighbor2Value - 1];
                                    this._freeCell(neighbor2Selector, neighbor2Btn, neighbor2Value);
                                }

                            }
                        }
                    }
                }
            }
            else {
                // 1 Bay
                if (ff == 1 || ff == 2 || ff == 4) {
                    this._freeCell(selector, btn, value);
                }
                // 2 Bay
                if (ff == 2 || ff == 4) {
                    // Find partner
                    var partnerValue = 0;
                    if (value % 2 == 0) {
                        partnerValue = value - 1;
                    }
                    else {
                        partnerValue = value + 1;
                    }
                    // Free Partner
                    var partnerSelector = this.selectors[partnerValue - 1];
                    var partnerBtn = this.buttons[partnerValue - 1];
                    this._freeCell(partnerSelector, partnerBtn, partnerValue);

                    if (ff == 4) {
                        var friend1Value = (value > partnerValue) ? value + 1 : partnerValue + 1;
                        var friend2Value = friend1Value + 1;

                        // Free friend 1
                        var friend1Selector = this.selectors[friend1Value - 1];
                        var friend1Btn = this.buttons[friend1Value - 1];
                        this._freeCell(friend1Selector, friend1Btn, friend1Value);

                        // Free friend 2
                        var friend2Selector = this.selectors[friend2Value - 1];
                        var friend2Btn = this.buttons[friend2Value - 1];
                        this._freeCell(friend2Selector, friend2Btn, friend2Value);
                    }
                }
            }

        },

        _freeCell: function(selector, btn, value) {
            selector.showDisplay(false);
            selector.tmplSelector.set("value", "-1");
            btn.set("iconClass", "spAddRowIcon");
            btn.set("disabled", false);
            btn.set("title", this.locResources.ADD_NODE_TYPE);
            this.selections[value].selected = false;
            this.selections[value].type = -1;
            this.selections[value].formFactor = -1;
            this.selections[value].base = false;
            this.selections[value].name = "";
        },

        _setCell: function(selector, btn, value, type, ff, name) {
            selector.showDisplay(false);
            selector.setName(name);
            selector.showName(true);
            btn.set("iconClass", "");
            btn.set("disabled", true);
            btn.set("title", "");
            this.selections[value].selected = true;
            this.selections[value].type = type;
            this.selections[value].formFactor = ff;
            this.selections[value].base = false;
            this.selections[value].name = name;
        },

        _getTemplateId: function(temp) {
            var tid = parseInt(temp);
            if (tid == "NaN") {
                return -1;
            }
            else {
                return tid;
            }
        },

        _generateCellName: function(ff, value) {
            var name = "";
            if (ff == 4) {
                name = this.locResources.STORAGE_LABEL.replace("%1", ff).replace("%2", value);
            }
            else if (ff == 1 || ff == 2) {
                name = this.locResources.POWER_LABEL.replace("%1", ff).replace("%2", value);
            }
            return name;
        },

        _generateTemplateData: function() {
            var savedData = [];
            for (var idx = 1; idx < 15; idx++) {
                // var id = this.selectors[idx-1].tmplSelector.get("value");
                var id = this.selections[idx].templateId;
                // selected will be true if there is a
                // 1-bay node in this bay or part of
                // a larger node in this bay
                var nodeInBay = this.selections[idx].selected;
                // base will be true if this bay is
                // the one that a node of any form
                // factor was added to - e.g. if
                // a 2-bay node occupies bays 3 and
                // 4, base is true for bay 3 and
                // false for bay 4
                var isBase = this.selections[idx].base;

                // do not add data for bays that are
                // empty
                if (nodeInBay) {
                    var idToPass = id;
                    if (isBase) {
                        // if there is a node in the
                        // bay but the ID is not a
                        // valid template ID, set
                        // the ID to "-2" so that
                        // services will persist
                        // this node
                        if (idToPass == "" || idToPass < 1) {
                            idToPass = "-2";
                        }
                    }
                    else {
                        // if this node is not the
                        // base node, get its ID
                        // from the previous node,
                        idToPass = savedData[savedData.length - 1].id;
                    }

                    // add this node to the array
                    savedData.push({
                        index: idx.toString(),
                        type: "cmmNode",
                        id: idToPass,
                        formFactor: this.selections[idx].formFactor.toString(),
                        base: isBase
                    });
                }
            }

            return savedData;
        },

        _setupNodeSelectors: function() {
            for (var idx = 1; idx < 15; idx++) {
                var tmplStore = this._regenerateSelectorStore(false);
                var temp = new support.widgets.CreateAndEditSelector({
                    id: this.id + "_selector_" + idx,
                    store: tmplStore,
                    headerText: this.selections[idx].name,
                    selectionValue: this.selections[idx].templateId,
                    index: idx,
                    width: this.SELECTOR_WIDTH
                });

                dojo.connect(temp, "editTmpl", this, function(value, index) {
                    this._editAllTmpl(value, index);
                });
                dojo.connect(temp, "createTmpl", this, function(index) {
                    this._createAllTmpl(index);
                });

                dojo.connect(temp, "changeValue", this, function(value, index) {
                    this.selections[index].templateId = value;
                });

                this.selectors[idx - 1] = temp;
            }
        },

        _setupBayButtons: function() {
            for (var idx = 1; idx < 15; idx++) {
                var value = idx;
                var name = this.resources.BAY_NUM.replace("%1", value);
                var className = (!this.selections[value].selected) ? "spAddRowIcon" : ((this.selections[value].base) ? "spDeleteIcon" : "");
                var addIcon = new dijit.form.Button({
                    iconClass: className,
                    id: this.id + "_btn_" + value,
                    label: name,
                    value: value,
                    disabled: (this.selections[value].selected && !this.selections[value].base),
                    title: (!this.selections[value].selected) ? this.locResources.ADD_NODE_TYPE : ((this.selections[value].base) ? this.locResources.REM_NODE_TYPE : ""),
                    onClick: dojo.hitch(this, this._handleButtonClick, value)
                });
                this.buttons[idx - 1] = addIcon;
            }
        },
        _setupSubscribers: function() {

            // Also set up a subscriber function to be notified when a new
            // SystemInfo
            // template is created.
            this._subscriptions[0] = this.subscribe("ChassisNodeTemplateComplete", function(data) {
                var preValue = this._allTmplSelector.get("value");
                this._refreshAllInfoSelector();
                // Set drop-down value
                if (this.selectedIndex == 0 && data) {
                    this._allTmplSelector.set("value", data);
                }
                else if (this.selectedIndex != 0 && preValue) {
                    this._allTmplSelector.set("value", preValue);
                }
                else {
                    this._allTmplSelector.set("value", "-1");
                }
                // Disable if select all not checked
                this._allTmplSelector.set("disabled", !this._selectAll.checked);
            });
            // 1
            this._subscriptions[1] = this.subscribe("ChassisNodeTemplateComplete", function(data) {
                this._handleNodeRefresh(1, data);
            });
            // 2
            this._subscriptions[2] = this.subscribe("ChassisNodeTemplateComplete", function(data) {
                this._handleNodeRefresh(2, data);
            });
            // 3
            this._subscriptions[3] = this.subscribe("ChassisNodeTemplateComplete", function(data) {
                this._handleNodeRefresh(3, data);
            });
            // 4
            this._subscriptions[4] = this.subscribe("ChassisNodeTemplateComplete", function(data) {
                this._handleNodeRefresh(4, data);
            });
            // 5
            this._subscriptions[5] = this.subscribe("ChassisNodeTemplateComplete", function(data) {
                this._handleNodeRefresh(5, data);
            });
            // 6
            this._subscriptions[6] = this.subscribe("ChassisNodeTemplateComplete", function(data) {
                this._handleNodeRefresh(6, data);
            });
            // 7
            this._subscriptions[7] = this.subscribe("ChassisNodeTemplateComplete", function(data) {
                this._handleNodeRefresh(7, data);
            });
            // 8
            this._subscriptions[8] = this.subscribe("ChassisNodeTemplateComplete", function(data) {
                this._handleNodeRefresh(8, data);
            });
            // 9
            this._subscriptions[9] = this.subscribe("ChassisNodeTemplateComplete", function(data) {
                this._handleNodeRefresh(9, data);
            });
            // 10
            this._subscriptions[10] = this.subscribe("ChassisNodeTemplateComplete", function(data) {
                this._handleNodeRefresh(10, data);
            });
            // 11
            this._subscriptions[11] = this.subscribe("ChassisNodeTemplateComplete", function(data) {
                this._handleNodeRefresh(11, data);
            });
            // 12
            this._subscriptions[12] = this.subscribe("ChassisNodeTemplateComplete", function(data) {
                this._handleNodeRefresh(12, data);
            });
            // 13
            this._subscriptions[13] = this.subscribe("ChassisNodeTemplateComplete", function(data) {
                this._handleNodeRefresh(13, data);
            });
            // 14
            this._subscriptions[14] = this.subscribe("ChassisNodeTemplateComplete", function(data) {
                this._handleNodeRefresh(14, data);
            });
        },

        _handleNodeRefresh: function(index, data) {
            var selector = this.selectors[index - 1].tmplSelector;
            var preValue = selector.get("value");
            // console.log(this.declaredClass + ": Index: " + index + " Selected Index: " +
            // this.selectedIndex + " NewData: " + data + " Predata:" + preValue);
            var tmplStore = this._regenerateSelectorStore(false);
            selector.setStore(tmplStore);
            // Set drop-down value
            if (this.selectedIndex == index && data) {
                selector.set("value", data);
            }
            else if (this.selectedIndex != index && preValue) {
                selector.set("value", preValue);
            }
            else {
                selector.set("value", "-1");
            }
            // disable if select all checked or no
            // items in store
            var disabled = this._selectAll.checked || (tmplStore._arrayOfAllItems == null || tmplStore._arrayOfAllItems.length == 0);
            selector.set("disabled", disabled);
        },

        resetNodeTable: function() {
            for (var idx = 1; idx < 15; idx++) {
                var selector = this.selectors[idx - 1];
                var btn = this.buttons[idx - 1];
                this._freeCell(selector, btn, idx);
            }
        },

        _presetSelections: function() {
            if (this.pageParams) {
                for (var idx = 1; idx < this.pageParams.length + 1; idx++) {
                    if (this.pageParams[idx - 1] && this.pageParams[idx - 1].id == "-1") {
                        continue;
                    }
                    var index = parseInt(this.pageParams[idx - 1].index);
                    var ff = parseInt(this.pageParams[idx - 1].formFactor);
                    var name = this._generateCellName(ff, index);

                    this.selections[index].selected = true;
                    this.selections[index].type = this.pageParams[idx - 1].type;
                    this.selections[index].templateId = this.pageParams[idx - 1].id;
                    this.selections[index].formFactor = ff;
                    this.selections[index].base = true;
                    this.selections[index].name = name;
                    if (this.selections[index].formFactor > 1) {
                        var baseNum = index;
                        index++;
                        for (; (index - baseNum) < this.selections[baseNum].formFactor; index++) {
                            this.selections[index].selected = true;
                            this.selections[index].type = this.selections[baseNum].type;
                            this.selections[index].templateId = this.selections[baseNum].templateId;
                            this.selections[index].formFactor = this.selections[baseNum].formFactor;
                            this.selections[index].base = false;
                            this.selections[index].name = name;
                            idx++;
                        }
                    }
                }

            }
        },

        _setDefinedTemplates: function(value) {
            // if we're setting the value of all the
            // node selectors to "-1", set them to
            // "-2" instead, so services will
            // persist node patterns for them
            var valueToSet = value;
            if (value == "-1") {
                valueToSet = "-2";
            }
            for (var idx = 1; idx < 15; idx++) {
                if (this.selections[idx].base) {
                    var selector = this.selectors[idx - 1];
                    selector.setValue(valueToSet);
                }
            }
        },

        _setPreDefinedTemplates: function() {
            for (var idx = 1; idx < 15; idx++) {
                if (this.selections[idx].base) {
                    var selector = this.selectors[idx - 1];
                    // console.log(this.declaredClass + ": set to " + this.selections[idx].templateId);
                    selector.setValue(this.selections[idx].templateId);
                }
            }
        },

        _toggleAddButtons: function() {
            for (var idx = 0; idx < this.buttons.length; idx++) {
                if (!this.selections[idx + 1].selected) {
                    this.buttons[idx].set("disabled", false);
                    this.buttons[idx].set("iconClass", "spAddRowIcon");
                    this.buttons[idx].set("title", this.locResources.ADD_NODE_TYPE);
                }
                else if (this.selections[idx + 1].base) {
                    this.buttons[idx].set("disabled", false);
                    this.buttons[idx].set("iconClass", "spDeleteIcon");
                    this.buttons[idx].set("title", this.locResources.REM_NODE_TYPE);
                }
                else {
                    this.buttons[idx].set("disabled", true);
                    this.buttons[idx].set("iconClass", "");
                    this.buttons[idx].set("title", "");
                }
            }
        },

        loadLearnedTemplates: function() {
            // Refresh selector stores
            this._refreshAllInfoSelector();
            if (this._selectAll.checked) {
                this._allTmplSelector.set("disabled", false);
            }
            for (var idx = 1; idx < 15; idx++) {
                this._handleNodeRefresh(idx, null);
            }

            // Update table
            this.resetNodeTable();
            this._presetSelections();
            this._toggleAddButtons();
        },

        _toggleSelectorsDisabled: function(enabled) {
            var state = (enabled) ? true : false;
            for (var idx = 0; idx < 14; idx++) {
                this.selectors[idx].tmplSelector.set("disabled", state);
                this.selectors[idx].toggleButtons(state);
                // If selectors are empty, keep it disabled even if we are trying to enable it
                if (state == false && this.selectors[idx].tmplSelector.store._arrayOfTopLevelItems.length < 1) {
                    this.selectors[idx].tmplSelector.set("disabled", true);
                    this.selectors[idx]._changeAllTmplCallback(-1);
                }
            }

        },

        _regenerateSelectorStore: function(mainSelector) {
            var tmplStore = new dojo.data.ItemFileWriteStore({
                url: this.REST_PATH + "template/list/cmmNode"
            });
            // if not generating a store for the main
            // (this._allTmplSelector) selector, the
            // No Pattern Defined option must have
            // an ID of -2, so that services code
            // can create a dummy node pattern for
            // added nodes that do not have patterns
            // assigned
            var item = {
                id: "-1",
                name: "&mdash; " + this.resources.NO_TEMP_SELECTED + " &mdash;"
            };
            if (!mainSelector) {
                item = {
                    id: "-2",
                    name: "&mdash; " + this.resources.NO_TEMP_SELECTED + " &mdash;"
                };
            }
            tmplStore.newItem(item);
            tmplStore.save();
            // fetch the store
            tmplStore.fetch();
            // if the store only has one item in it, and it's the one with id
            // "-1" or "-2", then remove that item
            var storeVals = tmplStore._arrayOfAllItems;
            if (storeVals != null && storeVals.length == 1 && (storeVals[0].id == "-1" || storeVals[0].id == "-2")) {
                // remove by redefining an empty store
                tmplStore = new dojo.data.ItemFileWriteStore({
                    data: {
                        items: ""
                    }
                });
            }

            this.tmplStore = tmplStore;

            return tmplStore;
        },

        unsubscribeSelectors: function() {
            for (var idx = 0; idx < this._subscriptions.length; idx++) {
                if (this._subscriptions[idx]) {
                    this.unsubscribe(this._subscriptions[idx]);
                }
            }
        },

        AfterPageSelected: function() {
            // !important
            // Last page of wizard so nothing to do here but function still needed for wizard
        }

    });

});