/*
 * Licensed Materials - Property of IBM
 * 
 * OCO Source Materials
 * 
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 * 
 * The source code for this program is not published or other- wise divested of its trade secrets,
 * irrespective of what has been deposited with the U.S. Copyright Office.
 */
define({
  root: {
    TITLE: "Integrated Management Module (IMM) and Server Firmware Settings (UEFI)",
    PAGE_DESC: "Select existing or create new category patterns as desired to include in this server pattern.",
    SYS_INFO: "System Information",
    SIT_TITLE: "System Information pattern controls",
    SIT_1: "Automatic system name generation",
    SIT_2: "Contact name",
    SIT_3: "Location description",
    MGMT: "Management",
    MGMT_v2: "Management Interface",
    MGMT_TITLE: "Management Interface pattern controls IMM Management Interface configurations",
    MGMT_1: "Automatic hostname generation",
    MGMT_2: "Management IP address assignment",
    MGMT_3: "Domain Name System (DNS) settings",
    MGMT_4: "Interface Speed settings",
    PSC: "Power Schedule And Capping",
    PSC_TITLE: "Power Schedule and Capping pattern controls",
    PSC_1: "Schedules for power off, power on, shutdown, and restart",
    PSC_2: "Power restore policy",
    PSC_3: "Active Energy Manager power capping",
    PAR: "Performance And Recovery",
    PAR_TITLE: "Performance and Recovery pattern controls",
    PAR_1: "Predefined operating modes",
    PAR_2: "Processor settings",
    PAR_3: "Memory settings",
    PAR_4: "Recovery Timers and related options",
    PERFORMANCE: "Performance",
    DEV: "Device",
    DEVICE: "Device And IO Ports",
    DEV_TITLE: "Devices and IO ports pattern controls",
    DEV_1: "Console redirection and COM ports",
    DEV_2: "PCIe Gen Speed",
    DEV_3: "Onboard Devices",
    DEV_4: "Adapter Option ROM",
    DEV_5: "Option ROM Execution Order",
    POWER: "Power",
    LEARNED: "Learned",
    LEARNED_SET: "Learned Settings",
    LEARNED_DESC: "Learned Settings pattern controls all other IMM and UEFI settings. Settings are learned from the " +
        "server selected in the General step.",
    EXNEW: "Extended settings patterns cannot be created from scratch because the settings have to be learned from a live server.",            
    EXIMM_SET: "Extended IMM",
    EXIMM_DESC: "Extended IMM settings pattern controls all other IMM settings. Extended settings patterns " +
        "are automatically created when a server pattern is created from an existing server. Extended " +
        "settings patterns cannot be created from scratch because the settings have to be learned from a live server.",
    EXUEFI_SET: "Extended UEFI",
    EXUEFI_DESC: "Extended UEFI settings pattern controls all other UEFI settings. Extended settings patterns " +
    	"are automatically created when a server pattern is created from an existing server. Extended " +
    	"settings patterns cannot be created from scratch because the settings have to be learned from a live server.",
    CAT: "Category",
    TEMP: "Pattern",
    TT_SELECT1: "Select a pattern to edit from the drop-down",
    TT_SELECT2: "To enable, choose &quot;Create a new pattern from an existing server&quot; on the General step.",    
    LEARNED_SETTINGS_INFO: "Firmware settings have been learned from \"%1 - %2\" " +
        "and learned patterns have been created.",
    LEARNED_SETTINGS_DETAILS: "These learned patterns will persist even if they are not selected and deployed with the server pattern.",   
    SYSINFO_NOTSAME_INFO: "The System Name naming scheme in the selected System Information pattern " + 
        "does not match the Hostname naming scheme in the selected Management Interface pattern.<br><br>" +
        "Edit pattern to change if desired.",
    MGMTINTERFACE_NOTSAME_INFO: "The Hostname naming scheme in the selected Management Interface pattern " + 
        "does not match the System Name naming scheme in the selected System Information pattern.<br><br>" +
        "Edit pattern to change if desired.",
    EDIT_DISABLED_MSG_EXT: "To enable, choose \"Create a new pattern from an existing server\" on the General step.",
    SYS_INFO_REQUIRED: "System Information pattern selection is required.",
    SYS_INFO_MESSAGE: "The selected Management Interface pattern defines a custom naming scheme that contains a location " +
        "element. You must also select a System Information pattern that defines the desired values for the location element.",
    PERF_WARNING_MSG: "The selected Performance and Recovery pattern has an invalid Memory Channel Mode setting for the selected pattern form factor.",
    PERF_WARNING_DETAILS: "Select a different Performance and Recovery pattern or edit the selected pattern to use a valid Memory Channel Mode." +
        " For scalable form factors, the valid Memory Channel Mode settings are Independent and Lockstep." +
        " For non-scalable form factors, the valid Memory Channel Mode settings are Independent, Mirroring, and Sparing.",
    PERF_SCALABLE_WARNING_MSG: "Some settings in the Performance and Recovery pattern are not valid for the selected form factor.",
    PERF_SCALABLE_WARNING_DETAILS: "The following settings will not be applied to the target server if this pattern is deployed: " +
        "<ul><li>QPI Link Frequency</li><li>Memory Speed</li><li>POST Watchdog Timer</li><li>Reboot System on NMI</li><li>Halt on Severe Error</li></ul>"
  },
  "en": true,
  "zh": true
});