/*
 * Licensed Materials - Property of IBM
 * 
 * OCO Source Materials
 * 
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 * 
 * The source code for this program is not published or other- wise divested of its trade secrets,
 * irrespective of what has been deposited with the U.S. Copyright Office.
 */
define({
  root: {
    USER_ASSISTANCE: "If desired you can modify adapter addressing and define additional adapters to match the hardware "
            + "you expect to configure with this pattern.",
    USER_ASSISTANCE_TOOLTIP: "If you intend to use IBM Fabric Manager (IFM) you can configure this pattern to use "
            + "virtual I/O adapter addressing."
            + "<p>If you are creating a pattern from an existing server, some adapter information may be automatically "
            + "learned. Optionally you can define additional adapters to match the hardware you expect to have in the "
            + "servers that will be configured by this pattern. This allows you to:"
            + "<ul>"
            + "<li>Configure adapter port settings for <span %1>supported adapters</span></li>"
            + "<li>If using virtual I/O adapter addressing, adding expected Fibre Channel adapters will allow you to "
            + "define SAN boot targets on the Boot step.</li>"
            + "</ul>",
    GRAPHIC_VIEW: "Graphic view",
    GRAPHIC_VIEW_CLOSE_TITLE: "Close graphic view",
    GRAPHIC_VIEW_OPEN_TITLE: "Open graphic view",
    IO_ADAPTER_ADDRESSING: "I/O adapter addressing",
    IO_ADAPTER_ADDRESSING_TOOLTIP: "Burned in addressing mode utilizes existing World Wide Name "
            + "(WWN) and Media Access Control (MAC) addresses from manufacturing."
            + "<p>Virtual addressing allows you to simplify management of LAN and SAN connections to speed deployment "
            + "and automatic failover by virtualizing WWN and MAC addresses.</p>"
            + "<p>When virtual addressing is enabled both Ethernet and Fibre Channel addresses will be allocated "
            + "regardless of defined adapters. Ethernet addresses are always assigned from the IBM MAC Addresses pool. "
            + "You can choose the pool from which Fibre Channel addresses are allocated.</p>"
            + "<p>Virtual addressing requires an IBM Fabric Manager (IFM) upgrade license be installed on each server that "
            + "is to be configured for virtual addressing. %1 can be used to install IFM Features on Demand options.</p>",
    PORT_NAME: "Port %1",
    PORT_NAME_NIC: "Port %1 &mdash; NIC",
    PORT_NAME_HBA: "Port %1 &mdash; HBA",
    PORT_DESCRIPTION_NIC: "Physical Ethernet port",
    PORT_DESCRIPTION_HBA: "Physical Fibre Channel port",
    PORT_DESCRIPTION_VFA: "Physical Virtual Fabric port",
    PORT_PNIC_ETHONLY_TITLE: "pNIC mode Ethernet only",
    PORT_PNIC_WITH_FCOE_TITLE: "pNIC mode with FCoE",
    PORT_PNIC_WITH_ISCSI_TITLE: "pNIC mode with iSCSI",
    PORT_VNIC_ETHONLY_TITLE: "vNIC mode Ethernet only",
    PORT_VNIC_WITH_FCOE_TITLE: "vNIC mode with FCoE",
    PORT_VNIC_WITH_ISCSI_TITLE: "vNIC mode with iSCSI",
    VPORT_NAME_NIC: "NIC",
    VPORT_NAME_HBA: "HBA",
    VPORT_NAME_NIC_FUNCTION: "Function %1 &mdash; NIC",
    VPORT_NAME_HBA_FUNCTION: "Function %1 &mdash; HBA",
    VPORT_DESCRIPTION_NIC: "Virtual Ethernet port",
    VPORT_DESCRIPTION_NIC_WITH_FCOE: "Virtual Fibre Channel port",
    VPORT_DESCRIPTION_NIC_WITH_ISCSI: "Virtual iSCSI port",
    CHANGE_VIA_PORT_TEMPLATE: "Change via parent port's &quot;%1&quot; pattern",
    CHANGE_VIA_PORT_TEMPLATE_DISABLED: "Disabled. Change via parent port's &quot;%1&quot; pattern",
    ADDRESSING_BURNED_IN_OPT: "Burned in",
    ADDRESSING_BURNED_IN_OPT_TITLE: "Use burned in I/O addressing",
    ADDRESSING_VIRTUAL_OPT: "Virtual",
    ADDRESSING_VIRTUAL_OPT_TITLE: "Use virtual I/O addressing",
    ADDRESSING_VIRTUAL_SUMMARY_TITLE: "Edit virtual address settings. Current settings:<br>Ethernet (MAC) address pool: %1<br>Fibre Channel (WWN) address pool: %2<br>Address subrange: Predefined domain %3",
    ADDRESSING_BURNED_IN: "Burned in Addresses",
    ADDRESSING_IBM_POOLS: "IBM Pools",
    ADDRESSING_VENDOR_POOLS: "Vendor Pools",
    ADDRESSING_MIXED_POOLS: "IBM and Vendor Pools",
    ADDRESS_POOL_DOMAIN: "%1 &mdash; Predefined domain %2",
    BANDWIDTH_PERCENTAGE: "%1%",
    GUIDANCE_FROM_SCRATCH: "Add at least one interconnect option.",
    GUIDANCE_FROM_EXISTING: "To change adapter, port, or virtual port configuration, select the row with the configuration "
            + "pattern you want to change and click Edit pattern.",
    COMPUTE_NODE_ITEM_NAME: "Compute Node",
    COLUMN_LOCATION: "Location",
    COLUMN_IOMODULE_BAY: "I/O Bay",
    COLUMN_CONFIG_TEMPLATE: "Configuration Pattern",
    COLUMN_IOADDRESSING: "I/O Addressing",
    COLUMN_MIN_BANDWIDTH: "Min Bandwidth",
    COLUMN_MAX_BANDWIDTH: "Max Bandwidth",
    COLUMN_VLAN: "VLAN",
    REMOVE_TEXT: "Are you sure you want to remove the adapters?",
    REMOVE_INFO: "This action will remove the following adapters and all their children and configuration details: %1.",
    REMOVE_INFO_ADDITIONAL: "This can result in loss of data, or loss of access to data.",
    BUTTON_ADV_SETTINGS: "Advanced Settings",
    BUTTON_ADV_SETTINGS_TITLE: "Display advanced adapter settings",
    BUTTON_EDIT_TITLE: "Edit or Assign a different pattern (select rows of the same type and modify the associated patterns)",
    BUTTON_CREATE_TITLE: "Create a new pattern (select rows of the same type and assign a new pattern)",
    BUTTON_ASSIGN: "Assign Pattern",
    BUTTON_ASSIGN_TITLE: "Choose a different pattern (select rows of the same type and assign a different pattern)",
    MENU_ITEM_REMOVE: "Remove Adapter",
    MENU_ITEM_REMOVE_TITLE: "Remove selected adapters",
    FORM_FACTOR_2S: "1 bay compute node",
    FORM_FACTOR_4S: "2 bay compute node",
    FORM_FACTOR_1SD: "1 bay dual compute node",
    FORM_FACTOR_PXU: "2 bay compute node &amp; I/O expansion node",
    FORM_FACTOR_2SC: "2 bay scalable compute node",
    COMPUTE_NODE_SCALED_PRIMARY: "Primary Scaled Compute Node",
    COMPUTE_NODE_SCALED: "Scaled Compute Node %1",
    EXPANSION_UNIT_ITEM_NAME: "I/O Expansion Unit",
    EXPANSION_UNIT_ITEM_DESCRIPTION: "I/O expansion unit",
    EMPTY_SLOT_DESCRIPTION: "No adapter defined",
    BUTTON_ADD_ADAPTER: "Add I/O Adapter %1",
    BUTTON_ADD_ADAPTER_OR_LOM: "Add I/O Adapter %1 or LOM",
    BUTTON_ADD_LOM: "Add LOM %1",
    BUTTON_ADD_ADAPTER1_TITLE: "Add an I/O adapter for the 1st expansion connector to the pattern definition.",
    BUTTON_ADD_ADAPTER1_OR_LOM_TITLE: "Add an I/O adapter or LOM for the 1st expansion connector to the pattern "
            + "definition. A compute node can have either a fabric connector installed or an I/O expansion "
            + "adapter installed, but not both. A fabric connector (also known as a periscope adapter) is "
            + "needed to use the integrated LAN-on-motherboard (LOM).",
    BUTTON_ADD_ADAPTER2_TITLE: "Add an I/O adapter for the 2nd expansion connector to the pattern definition.",
    BUTTON_ADD_ADAPTER3_TITLE: "Add an I/O adapter for the 3rd expansion connector to the pattern definition.",
    BUTTON_ADD_ADAPTER3_OR_LOM_TITLE: "Add an I/O adapter or LOM for the 3rd expansion connector to the pattern "
            + "definition. A compute node can have either a fabric connector installed or a an I/O expansion "
            + "adapter installed, but not both. A fabric connector (also known as a periscope adapter) is needed "
            + "to use the integrated LAN-on-motherboard (LOM).",
    BUTTON_ADD_ADAPTER4_TITLE: "Add an I/O adapter for the 4th expansion connector to the pattern definition.",
    BUTTON_ADD_ADAPTER_1SD: "Add an I/O adapter to the pattern definition.",
    BUTTON_ADD_LOM_1SD: "Add a LOM to the pattern definition. A compute node can have a fabric connector ("
        + "also known as a periscope adapter) installed to use the integrated LAN-on-motherboard (LOM).",
    EDIT_ASSIGN: "Edit/Assign",
    VIRTUAL_INFO_MSG: "Virtualization of addresses is only supported for the primary node of a scalable complex",
    VIRTUAL_MSG_DETAILS: "You have created a deployment pattern using virtualized I/O addresses.  "
        + "Virtualization of addresses is only supported for the primary node of a scalable complex.  "
        + "The virtual addresses will be applied to the primary node.  "
        + "All other nodes will continue to use the factory-set addresses."
  },
  "en": true,
  "zh": true
});